Package: ggbio
Version: 1.60.0
Title: Visualization tools for genomic data
Description: The ggbio package extends and specializes the grammar of
        graphics for biological data. The graphics are designed to
        answer common scientific questions, in particular those often
        asked of high throughput genomics data. All core Bioconductor
        data structures are supported, where appropriate. The package
        supports detailed views of particular genomic regions, as well
        as genome-wide overviews. Supported overviews include ideograms
        and grand linear views. High-level plots include sequence
        fragment length, edge-linked interval to data view, mismatch
        pileup, and several splicing summaries.
Authors@R: c(person("Tengfei", "Yin", role=c("aut"),
                 email="yintengfei@gmail.com"),
          person("Michael", "Lawrence", role=c("aut", "ths", "cre"),
                 email="lawremi@gmail.com"),
          person("Dianne", "Cook", role=c("aut", "ths")),
          person("Sanchit", "Saini", role="ctb"),
          person("Johannes", "Rainer", role="ctb"))
Depends: methods, BiocGenerics, ggplot2 (>= 1.0.0)
Imports: grid, grDevices, graphics, stats, utils, gridExtra, scales,
        reshape2, gtable, Hmisc, biovizBase (>= 1.29.2), Biobase,
        S4Vectors (>= 0.13.13), IRanges (>= 2.11.16), Seqinfo,
        GenomeInfoDb (>= 1.45.5), GenomicRanges (>= 1.61.1),
        SummarizedExperiment (>= 1.39.1), Biostrings (>= 2.77.2),
        Rsamtools (>= 2.25.1), GenomicAlignments (>= 1.45.1), BSgenome
        (>= 1.77.1), VariantAnnotation (>= 1.55.1), rtracklayer (>=
        1.69.1), GenomicFeatures (>= 1.61.4), OrganismDbi, ensembldb
        (>= 2.33.1), AnnotationDbi, AnnotationFilter, rlang
VignetteBuilder: knitr
Suggests: vsn, BSgenome.Hsapiens.UCSC.hg19, Homo.sapiens,
        TxDb.Hsapiens.UCSC.hg19.knownGene,
        TxDb.Mmusculus.UCSC.mm9.knownGene, knitr, BiocStyle, testthat,
        EnsDb.Hsapiens.v75, tinytex
URL: https://lawremi.github.io/ggbio/
BugReports: https://github.com/lawremi/ggbio/issues
License: Artistic-2.0
LazyLoad: Yes
Collate: AllClasses.R AllGenerics.R Cache-class.R GGbio-class.R
        Grob-class.R ideogram.R Tracked-class.R Plot-class.R
        ggplot-method.R theme.R Tracks-class.R geom_chevron-method.R
        geom_alignment-method.R geom_arch-method.R geom_arrow-method.R
        geom_arrowrect-method.R geom_rect-method.R
        geom_segment-method.R geom_bar-method.R layout_circle-method.R
        layout_karyogram-method.R layout_linear-method.R
        stat_aggregate-method.R stat_coverage-method.R
        stat_identity-method.R stat_mismatch-method.R
        stat_stepping-method.R stat_gene-method.R stat_table-method.R
        stat_bin-method.R stat_slice-method.R stat_reduce-method.R
        coord_genome-method.R autoplot-method.R hack.R
        plotGrandLinear.R plotRangesLinkedToData.R
        plotFragLength-method.R plotSpliceSum-method.R rescale-method.R
        scales.R utils.R zzz.R
biocViews: Infrastructure, Visualization
git_url: https://git.bioconductor.org/packages/ggbio
git_branch: RELEASE_3_23
git_last_commit: 41e5a61
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:24:33 UTC; biocbuild
Author: Tengfei Yin [aut],
  Michael Lawrence [aut, ths, cre],
  Dianne Cook [aut, ths],
  Sanchit Saini [ctb],
  Johannes Rainer [ctb]
Maintainer: Michael Lawrence <lawremi@gmail.com>

# INSTALL
[![R-CMD-check](https://github.com/lawremi/ggbio/workflows/R-CMD-check-and-coverage/badge.svg)](https://github.com/lawremi/ggbio/actions)
[![Codecov test
coverage](https://codecov.io/gh/lawremi/ggbio/branch/master/graph/badge.svg)](https://codecov.io/gh/lawremi/ggbio?branch=master)

    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("ggbio")

setGeneric("stat_mismatch", function(data, ...) standardGeneric("stat_mismatch"))

setMethod("stat_mismatch", "GRanges", function(data, ..., bsgenome,
                                                     xlab, ylab, main,
                                                     geom = c("segment", "bar"),
                                                     show.coverage = TRUE){
  geom <- match.arg(geom)
  args <- list(...)

  ## args <- force(args)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
  
  isPileupSum <- function(obj){
    if(is(obj, "GRanges")){
      all(c("read", "ref", "count", "depth", "match") %in% colnames(values(obj)))
    }else if(is(obj, "data.frame")){
      all(c("read", "ref", "count", "depth", "match") %in% colnames(obj))
    }else{
      FALSE
    }
  }
  if(length(data)){
  if(!isPileupSum(data))
    stop("For geom mismatch summary, data must returned from
                        biovizBase::pileupGRangesAsVariantTable function. Or is a GRanges
                        object including arbitrary columns: read, ref, count, depth,
                        match")



  
  ## df <- as.data.frame(data)
  df <- mold(data)
  df.unmatch <- df[!df$match, ]
  ## add two end point?
  pos <- min(df$start):max(df$end)
  idx <- ! (pos %in% df$start)
  if(sum(idx)){
    df.bg <- df[,c("seqnames", "start", "end", "width", "strand", "depth")]
    df.bg.extra <- data.frame(seqnames = unique(as.character(df.bg$seqnames)),
                              start = pos[idx],
                              end = pos[idx],
                              width = 1,
                              strand = "*",
                              depth = 0)
    df.bg <- rbind(df.bg, df.bg.extra)
  }else{
    df.bg <- df
  }
  df.bg <- df.bg[order(df.bg$start),]
  df.bg <- rbind(df.bg[1,], df.bg)
  df.bg <- rbind(df.bg, df.bg[nrow(df.bg),])
  df.bg[c(1, nrow(df.bg)),]$depth <- 0
  addLevels <- function(x){
    idx <- order(x$start, x$read)
    ## assumption: on the same chromosome
    x <- x[idx,]
    eds <- unlist(by(x$count, x$start, function(x){
      cumsum(x)
    }))
    eds <- as.numeric(eds)
    sts <- unlist(by(x$count, x$start, function(x){
      N <- length(x)
      c(0,cumsum(x)[-N])
    }))
    sts <- as.numeric(sts)
    x$eds <- eds
    x$sts <- sts
    x
  }
  df.unmatch <- addLevels(df.unmatch)
  idx <- order(df.bg$start)
  df.bg <- df.bg[idx,]
  ## p <- ggplot(df.bg)
  args.aes$x <- as.name("start")
  args.aes$y <- as.name("depth")
  aes.res <- do.call(aes, args.aes)
  args.non$fill <- I("gray70")
  args.res <- c(list(data = df.bg),
                list(aes.res),
                args.non)
  if(show.coverage)
    p <- list(do.call(ggplot2::geom_polygon, args.res))
  else
    p <- NULL
  DNABasesColor <- getBioColor("DNA_BASES_N")
  if(geom == "segment"){
    p <- c(p, list(ggplot2::geom_segment(data = df.unmatch, aes(x = start, y = sts,
                                           xend = start, yend = eds, color = read))),
           list(scale_color_manual(values = DNABasesColor)))
  }
  if(geom == "bar"){
    p <- c(p, list(ggplot2::geom_rect(data = df.unmatch, aes(xmin = start-0.5, ymin = sts,
                                           xmax = start+0.5, ymax = eds, color = read,
                                        fill = read))),
           list(scale_color_manual(values = DNABasesColor)),
           list(scale_fill_manual(values = DNABasesColor)))
  }
}else{
  p <- NULL
}
  ## p <- c(p, list(xlab("Genomic Coordinates")), list(ylab("Counts")))
  if(!missing(xlab))
    p <- c(p, list(ggplot2::xlab(xlab)))
  else
    p <- c(p, list(ggplot2::xlab("Genomic Coordinates")))

  if(!missing(ylab))
    p <- c(p, list(ggplot2::ylab(ylab)))
  else
    p <- c(p, list(ggplot2::ylab("Counts")))

  if(!missing(main))
    p <- c(p, list(labs(title = main)))
  p <- setStat(p)  
  p
})


setMethod("stat_mismatch", "BamFile", function(data, ...,  bsgenome, which,
                                               xlab, ylab, main,
                                               geom = c("segment", "bar"),  
                                               show.coverage = TRUE){
  if(missing(which)){
      ## stop("missing which is not supported yet")
      p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
             list(ggplot2::xlim(c(0, 1))))
      return(p)
  }
    
  geom <- match.arg(geom)
    if(missing(bsgenome)){
      stop("For geom mismatch.summary, please provide bsgenome(A BSgenome object)")
    }else
    if(!is(bsgenome, "BSgenome")){
      stop("bsgenome must be A BSgenome object")
    }
    data <- data$path
    pgr <- pileupAsGRanges(data, regions = which)
    if(length(pgr)){    
    pgr.match <- pileupGRangesAsVariantTable(pgr, bsgenome)
    p <- stat_mismatch(pgr.match, ..., show.coverage = show.coverage, geom = geom)
  }else{
    p <- NULL
  }
    if(!missing(xlab))
      p <- c(p, list(ggplot2::xlab(xlab)))
    else
      p <- c(p, list(ggplot2::xlab("Genomic Coordinates")))

    if(!missing(ylab))
      p <- c(p, list(ggplot2::ylab(ylab)))
    else
      p <- c(p, list(ggplot2::ylab("Counts")))

    if(!missing(main))
      p <- c(p, list(labs(title = main)))
  p <- setStat(p)
    p
    
  })

setGeneric("geom_arrowrect", function(data, ...) standardGeneric("geom_arrowrect"))

setMethod("geom_arrowrect", "GRanges", function(data, ...,
                                                  xlab, ylab, main,
                                                facets = NULL,
                                                  stat = c("stepping", "identity"),
                                                  rect.height = NULL,
                                                  arrow.head = 0.06,
                                                  arrow.head.rate = arrow.head,
                                                 arrow.head.fix = NULL,
                                                  group.selfish = TRUE){

  stat <- match.arg(stat)
  ## shape <- match.arg(shape)
  args <- list(...)
  args$facets <- facets

  args.aes <- parseArgsForAes(args)
  args.non <- remove_args(parseArgsForNonAes(args), "facets")

  facet <- build_facet(data, args)
  if(length(data)){  
    if(stat == "stepping"){
    if(is.null(rect.height)) rect.height <- 0.4
      
      grl <- splitByFacets(data, facets)
      res <- endoapply(grl, make_addStepping, args.aes, group.selfish)
      res <- unlist(res)
      df <- breakGrTo5polyDf(res, y = "stepping", rect.height = rect.height,
                             arrow.head = arrow.head, arrow.head.rate = arrow.head.rate, arrow.head.fix = arrow.head.fix)
      args.aes$x <- as.name(".temp.x")
      args.aes$y <- as.name(".temp.y")
      args.aes$group <- as.name(".id")
      aes.temp <- do.call(aes, args.aes)                    
      p <- do.call(geom_polygon, c(list(data = df), list(aes.temp), args.non))
      }
    if(stat == "identity"){
      if(!"y" %in% names(args.aes))
        stop("aes(y = ) is requried for stat identity")
      if(is.null(rect.height)){
         rect.height <- diff(range(values(data)[,quo_name(args.aes$y)]))/20
         if (rect.height == 0) rect.height <- 1L
      }
      df <- breakGrTo5polyDf(data, y = quo_name(args.aes$y), rect.height = rect.height,
                             arrow.head = arrow.head, arrow.head.rate = arrow.head.rate, arrow.head.fix = arrow.head.fix)
      args.aes$x <- as.name(".temp.x")
      args.aes$y <- as.name(".temp.y")
      args.aes$group <- as.name(".id")      
      aes.temp <- do.call(aes, args.aes)                    
      p <- do.call(geom_polygon, c(list(data = df), list(aes.temp), args.non))
    }}else{
      p <- NULL
    }
    p <- c(list(p) , list(facet))


  labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = ""))
  p <- c(p, labels)
  p
})


getArrowLen <- function(object, arrow.head.rate = 0.4){
  width(range(ranges(object))) * arrow.head.rate
}

breakGrTo5polyDf <- function(object, arrow.head = 0.02,
                             arrow.head.rate = arrow.head,
                             arrow.head.fix = NULL,
                             rect.height = 0.4, y){
  if(!length(arrow.head.fix)){
    ah <- getArrowLen(object, arrow.head.rate)
  }else{
    ah <- arrow.head.fix
  }
  df <- mold(object)
  df$.id <- seq_len(nrow(df))
  res <- do.call(rbind,lapply(1:5, function(i) df))
  res <- res[order(res$.id), ]
  lst <- lapply(1:nrow(df), function(i){
    x <- df[i,, drop = FALSE]
    std <- x$strand
    if(x$width > ah){
      if(std == "+"){
        .x <- c(x$start, x$end-ah, x$end)
        .x <- c(.x, rev(.x)[-1])
        .y <- c(rep(x[, y] - rect.height, 2), x[, y], rep(x[, y] + rect.height, 2))
      }
      if(std == "-"){
        .x <- c(x$start, x$start+ah, x$end)
        .x <- c(.x, rev(.x)[-3])
        .y <- c(x[, y], rep(x[, y] - rect.height, 2), rep(x[, y] + rect.height, 2))
      }
      if(std == "*"){
        .x <- c(x$start, x$end, x$end)
        .x <- c(.x, rev(.x)[-1])
        .y <- c(rep(x[, y] - rect.height, 2), x[, y], rep(x[, y] + rect.height, 2))
      }
  }else{
      if(std == "+"){
        .x <- c(x$start, x$start, x$end)
        .x <- c(.x, rev(.x)[-1])
        .y <- c(rep(x[, y] - rect.height, 2), x[, y], rep(x[, y] + rect.height, 2))
      }
      if(std == "-"){
        .x <- c(x$start, x$end, x$end)
        .x <- c(.x, rev(.x)[-3])
        .y <- c(x[, y], rep(x[, y] - rect.height, 2), rep(x[, y] + rect.height, 2))
      }
      if(std == "*"){
        .x <- c(x$start, x$end, x$end)
        .x <- c(.x, rev(.x)[-1])
        .y <- c(rep(x[, y] - rect.height, 2), x[, y], rep(x[, y] + rect.height, 2))
      }
  }
    data.frame(.temp.x = .x, .temp.y = .y)
  })
  temp <- do.call(rbind, lst)
  res <- cbind(res, temp)
  res
}

.supportedPlots <- c("gg", "trellis", "GGbio")
isSupportedPlots <- function(x){
  sapply(x, function(z){
    any(sapply(.supportedPlots, function(c){
      extends(class(z), c)
    }))
  })
}

setClass("Grob", contains = "VIRTUAL")
## setClass("ggplotGrob", contains = c("gtable", "grob", "Grob"))
## setClass("latticeGrob", contains = c("lattice", "grob", "Grob"))

## Grob creat instance of sub-class
setGeneric("Grob", function(x, ...) standardGeneric("Grob"))
setMethod("Grob", "gg", function(x){
  ## new("ggplotGrob", ggplotGrob(x))
  ggplotGrob(x)
})
setMethod("Grob", "gtable", function(x){
  ## new("ggplotGrob", x)
  x
})
setMethod("Grob", "trellis", function(x){
  ## new("latticeGrob", latticeGrob(x))
  grid::grob(p = x, cl = "lattice")
})
setMethod("Grob", "lattice", function(x){
  x
})

setMethod("Grob", "GGbio", function(x){
   ## new("ggplotGrob", ggplotGrob(x@ggplot))
   ggplotGrob(x@ggplot)
})


## setClass("GrobList", prototype = prototype(elementType = "Grob"),
##          contains = "list")

.validList <- function(object){
  if(all(sapply(object, is, object@elementType)))
    return(TRUE)
  else
    paste("Class must be", object@elementType)
}
## setValidity("GrobList", .validList)

## ## constructor for class 'grobList'
GrobList <- function(...){
  items <- list(...)
  items <- listOfGrobs(items)
  ## new("GrobList", items)
  items
}

reduceListOfPlots <- function(x){
  firstElementIsListOfGrobs <-
    length(x) == 1 && is.list(x[[1L]]) && !extends(class(x[[1]]), "gg")
  if (firstElementIsListOfGrobs)
    x <- x[[1]]
  x
}

## this return a list of 'grobs' from list of valided 'plots' which could have grobs returned
listOfGrobs <- function(x) {
  x <- reduceListOfPlots(x)
  lapply(x, Grob)
}

## context("Test Grob Class")
## require(lattice)
## require(testthat)
## require(ggplot2)
## require(gridExtra)
## x = 1:3
## p1 <- qplot(x = mpg, y = wt, data = mtcars)
## p2 <- xyplot(1:10 ~ 1:10)
## require(ggbio)
## p3 <- GGbio(p1)
## p <- plot(1:10, 1:10)
## test_that("test grob", {
##   expect_that(p1, is_a("gg"))
##   expect_that(p2, is_a("trellis"))
##   expect_that(x, is_a("integer"))
##   expect_that(Grob(p1), is_a("Grob"))
##   expect_that(Grob(p1), is_a("ggplotGrob"))  
##   expect_that(Grob(p2), is_a("Grob"))
##   expect_that(Grob(p2), is_a("latticeGrob"))
##   expect_that(Grob(p3), is_a("Grob"))
##   expect_that(Grob(p3), is_a("ggplotGrob"))  
##   expect_that(Grob(p), throws_error())    
##   expect_that(GrobList(p1, p2), is_a("GrobList"))
##   expect_that(GrobList(p1, p2, x), gives_warning())
##   expect_that(length(GrobList(p1, p2, x)), equals(2))
## })


## context("Test Tracked Object")
## test_that("Test Tracked", {
##   obj <- new("Tracked")
##   height(obj) <- 1
##   expect_that(obj, is_a("Tracked"))
##   expect_that(height(obj), is_a("unit"))
##   expect_that(mutable(obj), is_a("logical"))
##   expect_that(fixed(obj), is_a("logical"))
##   expect_that(bgColor(obj), is_a("character"))
##   expect_that(labeled(obj), is_a("logical"))
##   expect_that(hasAxis(obj), is_a("logical"))
## })

## context("Test Cache Class")
## test_that("Test Cache Class", {
##   obj <- new("Cache")
##   expect_that(obj, is_a("Cache"))
##   expect_that(Cache(), is_a("Cache"))
##   cached_xlim(obj) <- 1
##   expect_that(cached_xlim(obj), equals(c(1, 1)))
##   cached_xlim(obj) <- c(1, 2, 3)
##   expect_that(cached_xlim(obj), equals(c(1, 3)))

##   cached_ylim(obj) <- 1
##   expect_that(cached_ylim(obj), equals(c(1, 1)))
##   cached_ylim(obj) <- c(1, 2, 3)
##   expect_that(cached_ylim(obj), equals(c(1, 3)))    
## })

## context("Test Plot Class")
## test_that("test Plot", {
##   expect_that(Plot(p1), is_a("Plot"))
##   expect_that(Plot(p2), is_a("Plot"))  
##   expect_that(PlotList(p1, p2), is_a("PlotList"))
##   expect_that(PlotList(p1, p2, x), gives_warning())
##   expect_that(length(PlotList(p1, p2, x)), equals(2))
## })


## context("Test GGbio Class")
## test_that("test Plot", {
##   expect_that(Plot(p1), is_a("Plot"))
##   expect_that(Plot(p2), is_a("Plot"))
##   expect_that(Plot(p3), is_a("Plot"))    
##   expect_that(PlotList(p1, p2, p3), is_a("PlotList"))
##   expect_that(PlotList(p1, p2, p3, x), gives_warning())
##   expect_that(length(PlotList(p1, p2, p3, x)), equals(3))
## })

## simply wrapper
theme_genome <- function(){
  list(facet_grid(.~seqnames),
       theme_pack_panels(),
       scale_x_continuous(breaks = NULL))       
}


## setGeneric("coord_genome", function(data,...)
##            standardGeneric("coord_genome"))

## setMethod("coord_genome", "GRanges", function(data, space.skip = 0.1){
##   object <- transformToGenome(object, space.skip = space.skip)
##   object <- biovizBase:::rescaleGr(object)
## })

## For a class GGbio, all calls are stacked over each other
GGbio.gen <- setClass("GGbio",
                      slots = list(
                          data = "ANY",
                          ggplot = "gg_OR_NULL", #ggplot object
                          cmd = "list",
                          fetchable = "logical",
                          blank = "logical"),
                      prototype = list(ggplot = NULL, data = NULL,
                                       fetchable = FALSE, blank = FALSE),
                      contains = "Cache")



GGbio <- function(ggplot = NULL, data = NULL, fetchable = FALSE, blank = FALSE,...){
    args <- dots <- list(...)
    args.non <- parseArgsForNonAes(args)

    ## for circle() function hack
    if("trackWidth" %in% names(args.non) && is.numeric(args.non[["trackWidth"]])){
        trackWidth <- args.non[["trackWidth"]]

    }else{
        trackWidth <- 7
    }
    if("buffer" %in% names(args.non) && is.numeric(args.non[["buffer"]])){
        buffer <- args.non[["buffer"]]
    }else{
        buffer <- 2
    }
    if("radius" %in% names(args.non) && is.numeric(args.non[["radius"]])){
        radius <- args.non[["radius"]]
    }else{
        radius <- 30
    }
    args <- args[!names(args) %in% c("trackWidth", "radius", "buffer")]


    if(is(ggplot, "GGbio")){
        ggplot <- ggplot@ggplot
    }
    if(is.null(ggplot)){
        ggplot <- ggplot()
    }

    res <- do.call(new, c(list("GGbio",
                               ggplot = ggplot,
                               data = data,
                               fetchable = fetchable,
                               blank = blank),
                          args))



    ## for circle function hack with a class
    attr(res, "trackWidth") <- trackWidth
    attr(res, "radius") <- radius
    attr(res, "buffer") <- buffer
    res
}

## alias
ggbio <- GGbio




setReplaceMethod("$", "GGbio",
                 function(x, name, value) {
                     x@ggplot[[name]] <- value
                     x
                 })

setMethod("$", "GGbio",
          function(x, name) {
              x@ggplot[[name]]
          })


## combine command if circle presents
.layout_circle.geoms <- c("point","line", "link",
                          "ribbon","rect", "bar",
                          "segment","hist", "scale",
                          "heatmap", "ideogram", "text")

## FIXME, need geom_* for something like ideogram
.combineNames <- function(obj){
    cmd <- obj@cmd
    .nms <- names(cmd)
    idx <- "layout_circle" == .nms
    if(sum(idx) && sum(idx)!=length(cmd)){
        ## did the trick here, which combine the geom/stat/and layout together
        .geom <- grep("geom_", .nms, value = TRUE)
        idx.geom <- grep("geom_", .nms)
        if(length(.geom)){
            .geom <- gsub("geom_", "", .geom)
            ## .geom <- stringr::str_match(.geom, "geom_([a-z]+)")[, 2]
            if(length(.geom) > 1){
                warning("multiple geoms detected, last one used")
                .geom <- tail(.geom, 1)
                idx.geom <- which(idx.geom)
                idx.geom <- tail(idx.geom, 1)
            }else if(length(.geom) == 1){
                if(!.geom %in% .layout_circle.geoms)
                    stop(.geom, "is not supported for layout_circle yet.")
            }else{
                .geom <- NULL
            }}else{
                .geom <- NULL
            }
        .stat <- grep("stat_", .nms, value = TRUE)
        idx.stat  <- grep("stat_", .nms)
        if(length(.stat)){
            .stat <- gsub("stat_", "", .stat)
            ## .stat <- str_match(.stat, "stat_([a-z]+)")[, 2]
            if(length(.stat) > 1){
                warning("multiple stats detected, last one used")
                .stat <- tail(.stat, 1)
                idx.stat <- which(idx.stat)
                idx.stat <- tail(idx.stat, 1)
            }else if(length(.stat) == 1){
                if(!.stat %in% .layout_circle.stats)
                    stop(.stat, "is not supported for layout_circle yet.")
            }else{
                .stat <- NULL
            }}else{
                .stat <- NULL
            }
        ## to costruct the new call
        if(length(.geom)){
            .args <- argList(obj@cmd)
            args <- c(.args[[idx.geom]],
                      list(geom = .geom))
            if(!is.null(obj@data) & is.null(args$data))
                args$data <- obj@data
            obj@cmd <- do.call(circle, args)
        }
        p <- ggplot2::ggplot() + obj@cmd
        obj@ggplot <- p
    }
    obj
}


setMethod("show", "GGbio", function(object){
    object <- .combineNames(object)
    if(object@blank)
        message("No region (with chromosome name) specified, so no data found")
    print(object@ggplot)
})

argList <- function(cmd){
    lapply(cmd, function(x){
        args <- as.list(x)[-1]
    })
}

setMethod("+", c("GGbio"), function(e1, e2){

    if(is(e2, "circle")){
        args <- e2
        ## load default
        buffer <- attr(e1, "buffer")
        trackWidth <- attr(e1, "trackWidth")

        ## compute radius

        r.addon <- .radius(e2)
        t.addon <- .trackWidth(e2)

        if(is.null(t.addon)){
            t.addon <- trackWidth
        }
        if(is.null(r.addon)){
            r.cur <-  attr(e1, "radius") +  t.addon + buffer
            attr(e1, "radius") <- r.attr <- r.cur
        }else{
            r.cur <- r.addon
            attr(e1, "radius") <- r.attr <- max(attr(e1, "radius"),  r.cur + t.addon)
        }

        args$radius <- r.cur
        args$trackWidth <- t.addon

        if(!"data" %in% names(args)) {
            unnamed <- names(args) == ""
            if(any(unnamed)) {
                names(args)[which(unnamed)[1L]] <- "data"
            } else {
                stop("no data found")
            }
        }


        object <- do.call(layout_circle, args)
        e1@ggplot <- mapToGG(e1@ggplot, object)

        res <- ggplot_add(object, e1@ggplot, "circle")
        e1@ggplot <- res

        return(e1)
    }
    if(inherits(e2, "zoom")){
        xlim <- getLimits(e1)$xlim
        if(length(xlim))
            e1 <- e1 + .zoom(xlim, as.numeric(e2))
        else
            stop("fail to parse xlim")
        return(e1)
    }
    if(is(e2, "NextView")){
        xlim <- getLimits(e1)$xlim
        xlim.cur <- c(max(xlim), max(xlim) + abs(diff(xlim)))
        message("change limits to", xlim.cur)
        e1 <- e1 + ggbio::xlim(xlim.cur)
        return(e1)
    }
    if(is(e2, "PrevView")){
        xlim <- getLimits(e1)$xlim
        xlim.cur <- c(min(xlim) -abs(diff(xlim)), min(xlim))
        message("change limits to", xlim.cur)
        e1 <- e1 + ggbio::xlim(xlim.cur)
        return(e1)
    }
    if(!is(e2, "xlim")){
        args <- as.list(match.call()$e2)
        e2name <-  deparse(args[[1]])
        .tmp <- list(args)
        names(.tmp) <- e2name
        e1@cmd <- c(e1@cmd, .tmp)
        ## get data from object
        if(!is.null(attr(e2, "call")) && attr(e2, "call")){
            e2 <- attr(e2, "mc")
            if(!is.null(e1@data) & is.null(args$data))
                args$data <- e1@data

            object <- do.call(as.character(args[[1]]), args[-1])
            e1@ggplot <- mapToGG(e1@ggplot, object)
        }else if(is.call(e2)){
            call <- e2
            if(!is.null(e1@data) & is.null(args$data))
                call$data <- e1@data
            object <- eval(call, S4Vectors:::top_prenv(e2))
            e1@ggplot <- mapToGG(e1@ggplot, object)
        }else{
            object <- e2
        }

        res <- ggplot_add(object, e1@ggplot, e2name)
        e1@ggplot <- res

        return(e1)
    }else{
        if(!e1@fetchable){
            e1@ggplot <- e1@ggplot + e2
        }else{
            grl <- cached_which(e1)

            if(is(grl, "GRanges") && length(grl)){
                current.which <- grl[length(grl)]
                chr.default <- as.character(seqnames(current.which))
                new.which <- getGrFromXlim(e2, chr.default)
                idx <- needCache(e1, new.which)
                if(!length(idx)){
                    ## so need to update cache
                    ## point is to re-run the cmd with new which
                    e1 <- replaceArg(e1, list(which = new.which))
                    e1 <-eval(e1@cmd[[1]])
                }else{
                    zoomLevelMatched <- function(e1, e2){
                        g <- attr(e1, "geom")
                        .tk <- as.character(class(e1@data))
                        if(.tk %in% c("BSgenome", "VRanges")){
                            g2 <- zoomLevelToGeom(max(end(new.which)) - min(start(new.which)),
                                                  .tk)
                            return(g == g2)
                        }else{
                            return(TRUE)
                        }

                    }
                    zlm <- zoomLevelMatched(e1, e2)
                    ## use cached p
                    if(zlm){
                        id <- idx[1]                      #use either one
                        e1@ggplot <- e1@cached_item[[id]]@ggplot + e2

                    }else{
                        e1 <- replaceArg(e1, list(which = new.which))
                        e1 <-eval(e1@cmd[[1]])
                    }
                }
            }else{
                new.which <- getGrFromXlim(e2, chrDefault(e1@data, grl))
                e1 <- replaceArg(e1, list(which = new.which))
                e1 <-eval(e1@cmd[[1]])
                ## no cached copy and no current range
            }
        }
        return(e1)
    }
})

chrDefault <- function(data, which) {
    sn <- if (hasMethod("seqnames", class(data)))
              sn <- seqnames(data)
          else seqnames(crunch(data, which))
    sn <- unlist(sn)
    if (length(sn) > 0L)
        as.character(sn[1L])
}

## replace *single* arg
replaceArg <- function(p, args){
    .cmd <- lapply(p@cmd, function(cm){
        .args <- as.list(cm)
        .args[[names(args)]] <- args[[1]]
        as.call(.args)
        ## do.call(as.character(.fun), .arg)
    })
    p@cmd <- .cmd
    p
}

needCache <- function(p, new.which){
    current.which <- cached_which(p)

    suppressWarnings(idx <- subjectHits(findOverlaps(new.which, current.which, type = "within")))
}

getGrFromXlim <- function(xlim, chr.default = NULL){
    .xlim <- xlim$limits$x
    if("ori" %in% names(attributes(xlim))){
        return(attr(xlim, "ori"))
    }else if("chr" %in% names(attributes(xlim))){
        return(GRanges(attr(xlim, "chr"), IRanges(.xlim[1], .xlim[2])))
    }else{
        if(!length(chr.default))
            stop("no seqname found")
        return(GRanges(chr.default, IRanges(.xlim[1], .xlim[2])))
    }
}


setStat <- function(x){
    attr(x, "isStat") <- TRUE
    x
}

isStat <- function(x){
    res <- attr(x, "isStat")
    if(is.null(res))
        res <- FALSE
    res
}

## search for proto class, the data and mapping

mapToGG <- function(p, object){
    if(isStat(object) == TRUE){
        protos <- returnProto(object)
        p$mapping <- protos[[1]]$mapping
        p$data <- protos[[1]]$data
    }
    p
}

returnProto <- function(object){
    rapply(object, function(x) x, c("proto", "ggproto"), how = "unlist")
}


####
## navigation
####
.zoom <- function(xlim, fac = 2){
    mid <- mean(xlim)
    wd <- round(abs(diff(xlim)) * fac)
    xlim <- ggbio::xlim(c(mid - wd/2, mid + wd/2))

}

zoom_in <- function(fac = 1/2){
    if(fac > 1){
        fac <- 1 / fac
    }
    zoom(fac)
}

zoom_out <- function(fac = 2){
    if(fac < 1){
        fac <- 1 / fac
    }
    zoom(fac)
}


zoom <- function(fac = 1/2){
    class(fac) <- "zoom"
    fac
}

setClass("Nav", contains = "VIRTUAL")
setClass("NextView", contains = "Nav")
setClass("PrevView", contains = "Nav")

nextView <- function(unit = c("view", "gene", "exon", "utr")){
    unit <- match.arg(unit)

    switch(unit,
           view = {
               new("NextView")
           },
           gene = {
               stop("not implemented yet")
           },
           exon = {
               stop("not implemented yet")
           },
           utr = {
               stop("not implemented yet")
           })
}

prevView <- function(unit = c("view", "gene", "exon", "utr")){
    unit <- match.arg(unit)
    switch(unit,
           view = {
               new("PrevView")
           },
           gene = {
               stop("not implemented yet")
           },
           exon = {
               stop("not implemented yet")
           },
           utr = {
               stop("not implemented yet")
           })

}

setGeneric("geom_bar", function(data, ...) standardGeneric("geom_bar"))

setMethod("geom_bar", "ANY", function(data, ...){
  ggplot2::geom_bar(data  = data, ...)
})

## alignment should be convenient toggle with chevron...
setMethod("geom_bar", "GRanges", function(data,..., xlab, ylab, main){

  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  facet <- build_facet(data, args)
  if(length(data)){
    if(!"y" %in% names(args.aes)){
      if("score" %in% colnames(values(data))){
        message("use score as y by default")
        args.aes$y <- as.name("score")
      }else{
        stop("missing y values in aes(), or please provide a column named 'score'")
      }
    }
    .y <- quo_name(args.aes$y)
    if (missing(ylab))
      ylab <- .y
    args.aes <- remove_args(args.aes, "y")
    args.aes$xmin <- as.name("start")
    args.aes$xmax <- as.name("end")
    args.aes$ymin <- 0
    args.aes$ymax <- as.name(.y)
    aes.res <- do.call(aes, args.aes)
    p <- list(do.call(geom_rect, c(list(data = mold(data)), list(aes.res), args.non)))
  }else{
    p <- NULL
  }
  p <- c(p, list(facet))
  labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
  p <- c(p, labels)
  p
})

setGeneric("stat_identity", function(data, ...) standardGeneric("stat_identity"))

setMethod("stat_identity", "ANY", function(data, ...){
  ggplot2::stat_identity(data = data, ...)
})

setMethod("stat_identity", "GRanges", function(data, ..., geom = NULL){
  args <- list(...)
  gr.geoms <- c("chevron", "arrow", "arrowrect", "segment", "rect", "alignment")
  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
  facet <- .buildFacetsFromArgs(data, args.facets)
  if(is.null(geom))
    geom <- "segment"
  if(!geom %in% gr.geoms){
    args$geom <- geom
    data <- mold(data)
    args$data <- data
    p <- do.call(ggplot2::stat_identity, args)
  }else{
    .geom.fun <- getGeomFun(geom)
    args$stat <- "identity"
    args$data <- data
    p <- do.call(.geom.fun, args)
  }
  p <- c(list(p), list(facet))
  p <- setStat(p)  
  p
})


setMethod("stat_identity", "Rle", function(data, ...,
                                           xlab, ylab, main, geom = NULL){
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if(is.null(geom))
    geom <- "line"
  x <- 1:length(data)                
  y <- as.numeric(data)
  df <- data.frame(x = x, y = y)
  args.non$geom <- geom
  args.non$data <- df
  args.aes <- list(x = substitute(x),
                   y = substitute(y))
  p <- do.call(ggplot2::stat_identity, c(args.non, list(do.call(aes, args.aes))))
  labels <- Labels(xlab, ylab, main, fallback = c(x = "x", y = "y"))
  p <- c(p, labels)
  p <- setStat(p)  
  p
})


setMethod("stat_identity", "RleList", function(data, ...,
                                               xlab, ylab, main,
                                               geom = NULL, indName = "sample"){
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if(is.null(geom))
    geom <- "line"
  
  x <- do.call(c,lapply(elementNROWS(data),function(n) 1:n))
  y <- as.numeric(unlist(data))
  if(is.null(names(data)))
    nms <- rep(1:length(data), times = elementNROWS(data))
  else
    nms <- rep(names(data), times = elementNROWS(data))

  df <- data.frame(x = x, y = y, z = nms)
  colnames(df) <- c("x", "y", indName)

  facets <- as.formula(paste(indName, "~ .", sep = ""))
  facet <- facet_grid(facets)
  
  args.non$geom <- geom
  args.non$data <- df
  
    args.aes <- list(x = substitute(x),
                     y = substitute(y))
    p <- do.call(ggplot2::stat_identity, c(args.non, list(do.call(aes, args.aes))))

  labels <- Labels(xlab, ylab, main, fallback = c(x = "x", y = "y"))
  p <- c(p, labels)

  p <- c(list(p), list(facet))
  p <- setStat(p)
  p
})

setGeneric("geom_arch", function(data, ...) standardGeneric("geom_arch"))

setMethod("geom_arch", "data.frame", function(data, ..., 
                                              n = 25, max.height = 10){


  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if("y" %in% names(args.aes))
    y.name <- quo_name(args.aes$y)
  else
    y.name <- NULL
  
  ## check required argument
  if(!all(c("x", "xend") %in% names(args.aes)))
    stop("x, xend, are requried in aes(), need to be passed into geom_arch()")
  startX <- eval_tidy(args.aes$x, data)
  endX <- eval_tidy(args.aes$xend, data)
  if("height" %in% names(args.aes)){
  if(!is.numeric(args.aes$height)){
    h <- eval_tidy(args.aes$height, data)
  }else{
    if(length(args.aes$height) == 1)
      h <- rep(args.aes$height, length(startX))
    else
      stop("unequal length of heights specified")
  }}else{
     h <- rep(max.height, length(startX))
  }
  if("y" %in% names(args.aes))
    y <- eval_tidy(args.aes$y, data)
  else
    y <- rep(0, length(startX))
  args.aes2 <- remove_args(args.aes, c("x", "y", "group", "hjust", "xend", "yend"))
  xx<-c()
  yy<-c()
  for(i in 1:n){
    ang<-i*pi/(2*n)
    xx[i]<-cos(ang)
    yy[i]<-sin(ang)
  }
  ##takes the quarter of the curve calculated, flips a copy over the y axis
  ##reduces time spent in for loop
  xx<-c(1,xx,rev(-xx),-1)
  yy<-c(0,yy,rev(yy), 0)
  ##SETS UP DATAFRAME TO KEEP TRACK OF ALL POINTS TO DRAW ALL ARCHES
  junc <- rep(seq_along(startX), each = length(xx))
  startX <- rep(startX, each = length(xx))
  endX <- rep(endX, each = length(xx))
  h <- rep(h, each = length(xx))
  y <- rep(y, each = length(xx))
  jump <- abs(endX - startX)
  jumpAdj <- if (length(jump)) max(jump) / max(abs(h)) else NA
  apoint <- data.frame(xx = xx * (abs(startX - endX) / 2) + (startX + endX) / 2,
                       yy = yy * h + y, junc,
                       s = ((abs(h) - jump / jumpAdj)) /
                           if (length(jump)) max(jump) else NA)
  data$junc <- seq_len(nrow(data))
  apoint <- merge(apoint, data, by = "junc")
  args.aes <- list(x = as.name("xx"),
                  y = as.name("yy"),
                  group = as.name("junc"))
  
  aesres <- do.call(aes, c(args.aes, args.aes2))
  aesres <- remove_args(aesres, "height")
  if(nrow(apoint)){
    args.non <- remove_args(args.non, "facets")
    reslst <- c(list(data = apoint), list(aesres),args.non)
    p <- do.call(geom_line, reslst)
    if("ylab" %in% names(args.non)){
      ylab <- quo_name(args.non$ylab)
    }else if(length(y.name)){
      ylab <- y.name
    }else{
      ylab <- ""
    }
    p <- list(p, ggplot2::ylab(ylab))
  }else{
    p <- NULL
  }
  p
})

## that means span the range of two end 
setMethod("geom_arch", "GRanges", function(data, ...,
                                           xlab, ylab, main,
                                           facets = NULL, rect.height = 0,
                                              n = 25, max.height = 10
                                              ){

  args <- list(...)  
  args$facets <- facets
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.non$max.height <- max.height
  facet <- build_facet(data, args)

  ## note rect.height = 0.4 is default cross ggbio
  ## need to make sure they are connected by two nearest point of rectangle
  df <- mold(data)
  if("height" %in% names(args.aes))
    signs <- sign(eval_tidy(args.aes$height, df))
  else
    signs <- 1
  args.aes$x <- substitute(start)
  args.aes$xend <- substitute(end)
  if("y" %in% names(args.aes)){
    y <- eval_tidy(args.aes$y, df)
    df[,quo_name(args.aes$y)] <- df[,quo_name(args.aes$y)] + rect.height * signs
  }else{
    df$.y <- rep(0, nrow(df)) + rect.height * signs
    args.aes$y <- substitute(.y)
  }
  if(nrow(df)){
    args.res <- c(list(data = df),
                  args.non,
                  list(do.call(aes, args.aes)))
    p <- do.call(geom_arch, args.res)
    p <- c(list(p) , list(facet))
  }else{
    p <- NULL
  }
  labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
  p <- c(p, labels)
  p
})



## setMethod("geom_arch", "GRangesList", function(data, ..., 
##                                                xlab, ylab, main,
##                                                facets = NULL, rect.height = 0,
##                                                n = 25, max.height = 10
##                                                ){

##   if(any(elementNROWS(data) != 2))
##     stop("geom_arch only accept GRangesList which elementNROWS is 2, represent
##           linked intervals.")
##   args <- list(...)  
##   args$facets <- facets
##   args.aes <- parseArgsForAes(args)
##   args.non <- parseArgsForNonAes(args)
##   args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
##   ## facet <- .buildFacetsFromArgs(data, args.facets)
##   if(length(data)){
##       if(!biovizBase:::is_homo(data)){
##         data.new <- transformToGenome(data)
##         grl <- split(data.new, values(data.new)$.group)
##         data.new <- unlist(endoapply(grl, function(gr){
##           res <- GRanges("genome", gaps(ranges(gr)))
##           seqlengths(res) <- seqlengths(gr)
##           res
##       }))
##       }else{
##         data.new <- unlist(endoapply(data, function(gr){
##           gps <- gaps(gr, start = start(gr), end = end(gr))
##           gps <- gps[strand(gps)  == "*"]
##         }))
##       }
##     p <- geom_arch(data.new, ..., rect.height = rect.height, n = n, max.height = max.height)
##   }else{
##     p <- NULL
##   }
##   if(!missing(xlab))
##     p <- c(p, list(ggplot2::xlab(xlab)))
##   else
##     p <- c(p, list(ggplot2::xlab("Genomic Coordinates")))
##   if(!missing(ylab))
##     p <- c(p, list(ggplot2::ylab(ylab)))
##   if(!missing(main))
##     p <- c(p, list(labs(title = main)))
##   if(is_coord_truncate_gaps(data.new) | is_coord_genome(data.new)){
##     ss <- getXScale(data.new)
##     p <- c(p, list(scale_x_continuous(breaks = ss$breaks,
##                                 labels = ss$labels)))
##   }

##   p
## })

geom_arch_flip <- function(data, ..., n = 25, max.height = 10, bottom = TRUE){
  
  
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if("y" %in% names(args.aes))
    y.name <- quo_name(args.aes$y)
  else
    y.name <- NULL
  
  ## check required argument
  if(!all(c("x", "xend") %in% names(args.aes)))
    stop("x, xend, are requried in aes(), need to be passed into geom_arch()")
  startY <- eval_tidy(args.aes$y, data)
  endY <- eval_tidy(args.aes$yend, data)

  if("height" %in% names(args.aes)){
    if(!is.numeric(args.aes$height)){
      h <- eval_tidy(args.aes$height, data)
    }else{
      if(length(args.aes$height) == 1)
        h <- rep(args.aes$height, length(startY))
      else
        stop("unequal length of heights specified")
    }}else{
      h <- rep(max.height, length(startY))
    }
  if("x" %in% names(args.aes))
    x <- eval_tidy(args.aes$x, data)
  else
    x <- rep(0, length(startY))
  args.aes2 <- remove_args(args.aes, c("x", "y", "group", "hjust", "xend", "yend"))
  xx<-c()
  yy<-c()
  for(i in 1:n){
    ang<-i*pi/(2*n)
    xx[i]<-sin(ang)
    yy[i]<-cos(ang)
  }
  ##takes the quarter of the curve calculated, flips a copy over the y axis
  ##reduces time spent in for loop
  if(bottom){
    yy <- c(1,yy,rev(-yy),-1, 1)
    xx <- c(0,xx,rev(xx), 0, 0)
  }else{
    yy <- c(1,yy,rev(-yy),-1)
    xx <- c(0,xx,rev(xx), 0)
  }
  ##SETS UP DATAFRAME TO KEEP TRACK OF ALL POINTS TO DRAW ALL ARCHES
  junc <- rep(seq_along(startY), each = length(yy))
  startY <- rep(startY, each = length(yy))
  endY <- rep(endY, each = length(yy))
  h <- rep(h, each = length(yy))
  x <- rep(x, each = length(yy))
  jump <- abs(endY - startY)
  jumpAdj <- if (length(jump)) max(jump) / max(abs(h)) else NA
  apoint <- data.frame(yy = yy * (abs(startY - endY) / 2) + (startY + endY) / 2,
                       xx = xx * h + x, junc,
                       s = ((abs(h) - jump / jumpAdj)) /
                         if (length(jump)) max(jump) else NA)
  data$junc <- seq_len(nrow(data))
  apoint <- merge(apoint, data, by = "junc")
  args.aes <- list(x = as.name("xx"),
                   y = as.name("yy"),
                   group = as.name("junc"))
  args.aes2 <- remove_args(args.aes2, "height")
  aesres <- do.call(aes, c(args.aes, args.aes2))
  if(nrow(apoint)){
    reslst <- c(list(data = apoint), list(aesres),args.non)
    p <- do.call(geom_polygon, reslst)
    if("ylab" %in% names(args.non)){
      ylab <- quo_name(args.non$ylab)
    }else if(length(y.name)){
      ylab <- y.name
    }else{
      ylab <- ""
    }
    p <- list(p, ggplot2::ylab(ylab))
  }else{
    p <- NULL
  }
  p
}

geom_arch_flip2 <- function(data, ..., n = 25, max.height = 10, bottom = FALSE){
  
  
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if("y" %in% names(args.aes))
    y.name <- quo_name(args.aes$y)
  else
    y.name <- NULL
  
  ## check required argument
  if(!all(c("x", "xend") %in% names(args.aes)))
    stop("x, xend, are requried in aes(), need to be passed into geom_arch()")
  startY <- eval_tidy(args.aes$y, data)
  endY <- eval_tidy(args.aes$yend, data)
  
  if("height" %in% names(args.aes)){
    if(!is.numeric(args.aes$height)){
      h <- eval_tidy(args.aes$height, data)
    }else{
      if(length(args.aes$height) == 1)
        h <- rep(args.aes$height, length(startY))
      else
        stop("unequal length of heights specified")
    }}else{
      h <- rep(max.height, length(startY))
    }
  if("x" %in% names(args.aes))
    x <- eval_tidy(args.aes$x, data)
  else
    x <- rep(0, length(startY))
  args.aes2 <- remove_args(args.aes, c("x", "y", "group", "hjust", "xend", "yend"))
  xx<-c()
  yy<-c()
  for(i in 1:n){
    ang<-i*pi/(2*n)
    xx[i]<-sin(ang)
    yy[i]<-cos(ang)
  }
  ##takes the quarter of the curve calculated, flips a copy over the y axis
  ##reduces time spent in for loop
  if(bottom){
    yy <- c(1,yy,rev(-yy),-1, 1)
    xx <- c(0,xx,rev(xx), 0, 0)
  }else{
    yy <- c(1,yy,rev(-yy),-1)
    xx <- c(0,xx,rev(xx), 0)
  }
  ##SETS UP DATAFRAME TO KEEP TRACK OF ALL POINTS TO DRAW ALL ARCHES
  junc <- rep(seq_along(startY), each = length(yy))
  startY <- rep(startY, each = length(yy))
  endY <- rep(endY, each = length(yy))
  h <- rep(h, each = length(yy))
  x <- rep(x, each = length(yy))
  jump <- abs(endY - startY)
  jumpAdj <- if (length(jump)) max(jump) / max(abs(h)) else NA
  apoint <- data.frame(yy = yy * (abs(startY - endY) / 2) + (startY + endY) / 2,
                       xx = xx * h + x, junc,
                       s = ((abs(h) - jump / jumpAdj)) /
                         if (length(jump)) max(jump) else NA)
  data$junc <- seq_len(nrow(data))
  apoint <- merge(apoint, data, by = "junc")
  args.aes <- list(x = as.name("xx"),
                   y = as.name("yy"),
                   group = as.name("junc"))
  args.aes2 <- remove_args(args.aes2, "height")
  aesres <- do.call(aes, c(args.aes, args.aes2))
  if(nrow(apoint)){
    reslst <- c(list(data = apoint), list(aesres),args.non)
    p <- do.call(geom_path, reslst)
    if("ylab" %in% names(args.non)){
      ylab <- quo_name(args.non$ylab)
    }else if(length(y.name)){
      ylab <- y.name
    }else{
      ylab <- ""
    }
    p <- list(p, ggplot2::ylab(ylab))
  }else{
    p <- NULL
  }
  p
}

setClass("Plot", contains = "Tracked")

## abstract, so different methods could dispatch on diiferent types of graphics
## instance
setClass("ggplotPlot", contains = c("ggplot", "Plot"))
setClass("latticePlot", contains = c("trellis","Plot"))
setClass("ggbioPlot", contains = c("GGbio", "Plot"))
setClass("ideogramPlot", contains = c("Ideogram", "Plot"))


## Generic function to get subclas instance of 'Plot' class
setGeneric("Plot", function(x, ...) standardGeneric("Plot"))
setMethod("Plot", "gg", function(x){
  x <- ggbio(x)
  obj <- Plot(x)
  obj
})

## lattice doesn't now how to update itself yet, so mutalbe = FALSE
setMethod("Plot", "trellis", function(x, mutable = FALSE){
  idx <- names(attributes(x)) %in% c("fixed", "labeled", "bgColor", "hasAxis", "mutable", "height")
  if(sum(idx)){
    lst <- attributes(x)[idx]
    lst$mutable <- mutable
    obj <- do.call("new", c("latticePlot", list(x), lst))
  }else{
    obj <- new("latticePlot", x, mutable = mutable)
  }
  obj
})

setMethod("Plot", "GGbio", function(x){
  idx <- names(attributes(x)) %in% c("fixed", "labeled", "bgColor", "hasAxis", "mutable", "height")
  if(sum(idx)){
    lst <- attributes(x)[idx]
    obj <- do.call("new", c("ggbioPlot", list(x), lst))
  }else{
    obj <- new("ggbioPlot", x)
  }
  if("geom" %in% names(attributes(x))){
      attr(obj, "geom") <- attr(x, "geom")
  }
  obj
})

## be careful with Ideogram object
setMethod("Plot", "Ideogram", function(x){
    res <- new("ideogramPlot", x)
})



## compare to grobList, plotList return a list of original plot
## supported grobs only
setClass("PlotList", prototype = prototype(elementType = "Plot"),
         contains = "list")

setValidity("PlotList", .validList)

## validate via constructor
PlotList <- function(...){
  items <- list(...)
  items <- reduceListOfPlots(items)
  items <- lapply(items, Plot)
  new("PlotList", items)
}

## original list of plots
plotList <- function(...){
  items <- list(...)
  items <- reduceListOfPlots(items)
}




## add tracks + plot
setMethod("c", "PlotList",  function(x, ...){
        if (missing(x)) {
            args <- unname(list(...))
            x <- args[[1L]]
        } else {
            args <- unname(list(x, ...))
        }
        if (length(args) == 1L)
            return(x)
        arg_is_null <- sapply(args, is.null)
        if (any(arg_is_null))
            args[arg_is_null] <- NULL  # remove NULL elements by setting them to NULL!
        if (!all(sapply(args, is, class(x))))
            stop("all arguments in '...' must be ", class(x), " objects (or NULLs)")
        do.call(PlotList, unlist(args, recursive = FALSE))
})

## if raw data, generate plot
genPlots <- function(dots){
  lapply(dots, function(x){
    isPlot <- any(sapply(.supportedPlots, function(c){
      extends(class(x), c)
    }))
    if(!isPlot){
      res <- autoplot(x)
    }else{
      res <- x
    }
    res
  })
}




setMethod("[", c("PlotList", "numeric", "missing"),
          function(x, i, j, ...){
              i <- as.integer(i)
              nms <- names(x)
              x <- initialize(x, x@.Data[i])
              names(x) <- nms[i]
              x
          })

## TODO: exons label
## check (done)
## significant
##  log y, stat.col, stat.label, where is it.

setGeneric("plotRangesLinkedToData",
           function(data, ...) standardGeneric("plotRangesLinkedToData"))

setMethod("plotRangesLinkedToData", "RangedSummarizedExperiment",
          function(data, ...,
                   stat.y = seq_len(ncol(data)),
                   stat.ylab = names(assays(data)[stat.assay]),
                   stat.assay = 1L)
          {
            gr <- rowRanges(data)
            m <- assays(data, stat.assay)
            mcols(gr) <- cbind(mcols(gr), DataFrame(m))
            plotRangesLinkedToData(gr, stat.y = stat.y, stat.ylab = stat.ylab,
                                   ...)
          })

setMethod("plotRangesLinkedToData", "GenomicRanges_OR_GRangesList",
          function(data, ...,
                   stat.y = seq_len(ncol(mcols(data))),
                   stat.ylab, sig, sig.col = c("black", "red"),
                   stat.coord.trans = coord_trans(),
                   annotation = list(), width.ratio = 0.8,
                   theme.stat = theme_gray(), theme.align = theme_gray(),
                   linetype = 3, heights)
          {
            args <- list(...)
            args.aes <- parseArgsForAes(args)
            args.non <- parseArgsForNonAes(args)
            ## args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
            ## facet <- .buildFacetsFromArgs(data, args.facets)
            if(missing(heights))
              heights <- unit(c(2.5, 0.5, 1, rep(1, length(annotation))), "null")
            gr <- transformGRangesForEvenSpace(data)
            wd <- width(range(gr))
            ## we need to find midpoint first
            N <- length(gr)
            wid <- wd/N/2 * width.ratio
            df <- as.data.frame(gr)
            ## FIXME: need to allow specified by stat.y
            ## head(df)
            if (is.character(stat.y)){
              if (all(stat.y %in% colnames(mcols(gr)))) {
                stat.y <- match(stat.y, colnames(mcols(gr)))
              } else {
                stop("if 'stat.y' is character, it must match column names ",
                     "in mcols(data)")
              }
            }
            if (!is.numeric(stat.y))  {
              stop("'stat.y' must be a numeric or character index into the ",
                   "columns of mcols(data)")
            }
            stat.y <- stat.y + 5
            df.new <- melt(df, measure.vars = stat.y)  
            stat.label <- colnames(df)[stat.y]
            df.new$.ggbio.group <- factor(rep(stat.label, each = nrow(df)))
            p <- ggplot(df.new)
            args.aes.seg <- args.aes[!names(args.aes) %in%
                                     c("x", "xend", "color", "y")]
            args.aes.seg <-
              c(args.aes.seg,
                c(list(x = substitute(x.new-wid, list(wid = wid)),
                       xend = substitute(x.new+wid, list(wid = wid)),
                       color = substitute(.ggbio.group),
                       y = substitute(value))))
            
            args.aes.seg$yend <- args.aes.seg$y
            aes.res.seg <- do.call(aes, args.aes.seg)
            p <- p + do.call(ggplot2::geom_segment,
                               c(list(aes.res.seg), args.non))
            part <- PartitioningByWidth(rep(length(gr),
                                            nlevels(df.new$.ggbio.group)))
            df.dash <- data.frame(x = df.new[-end(part), "x.new"] + wid,
                                  xend = df.new[-start(part), "x.new"] - wid,
                                  y = df.new[-end(part), "value"],
                                  yend = df.new[-start(part), "value"],
                                  .ggbio.group = df.new[-end(part),
                                    ".ggbio.group"])
            args.dash.a <- args.aes[!names(args.aes) %in%  c("linetype", "y")]
            args.dash <- c(list(x = substitute(x),
                                y = substitute(y),
                                xend = substitute(xend),
                                yend = substitute(yend),
                                color = substitute(.ggbio.group)),
                           args.dash.a)
            p.stat <- p + do.call(ggplot2::geom_segment,
                                  c(list(data = df.dash),
                                    c(list(do.call(aes, args.dash)),
                                      linetype = linetype)))
            
            p.stat <- p.stat  +  theme.stat +
              theme(panel.grid.minor=element_blank()) +
              labs(colour = "group")
            p.stat <- p.stat + stat.coord.trans
            if(!missing(stat.ylab))
              p.stat <- p.stat + ylab(stat.ylab)
            ## link track
            df$midpoint <- (df$start + df$end)/2
            p.link <- ggplot(df)
            if(missing(sig)){
              args.link <- list(x = substitute(midpoint),
                                xend = substitute(x.new),
                                y = 0,
                                yend = 10)
              p.link <- p.link + ggplot2::geom_segment(do.call(aes, args.link)) +
                theme_null()    
            }else{
              args.link <- list(x = substitute(midpoint),
                                xend = substitute(x.new),
                                y = 0,
                                yend = 10,
                                color = as.name(sig))
              p.link <- p.link + ggplot2::geom_segment(do.call(aes, args.link)) +
                theme_null()        
              p.link <- p.link +
                scale_color_manual(values = c("FALSE" = sig.col[1],
                                     "TRUE" = sig.col[2])) 
            }
            p.link <- p.link + theme(legend.position = "none")
            
            ## grl <- GRangesList(data)
            if(missing(sig)){
              ## grl
              p.single <- autoplot(data, geom = "alignment") + theme.align +
                scale_y_continuous(breaks = NULL)
            }else{
              args.sig <- c(list(object = data),
                            list(do.call(aes, list(fill = as.name(sig),
                                                   color = as.name(sig)))),
                            list( geom = "alignment"))
              p.single <- do.call(autoplot, args.sig) +
                theme.align + scale_y_continuous(breaks = NULL)    
              p.single <- p.single +
                scale_color_manual(values = c("FALSE" = sig.col[1],
                                     "TRUE" = sig.col[2])) +
                  scale_fill_manual(values = c("FALSE" = sig.col[1],
                                      "TRUE" = sig.col[2])) +
                    theme(legend.position = "none")
            }
            p.link <- p.link +   theme(plot.margin = ggplot2::margin(0, 1, 0, 0.5, unit = "lines"),
                                       panel.spacing = unit(c(0, 0.25, 0, 0.25),
                                         "lines")
                                       ) 
            
            if(length(annotation)){
              ## annotation <- lapply(annotation, function(p) p + theme_bw())
              ## tracks(p.stat,p.link,p.single)
              args.tracks <- c(c(list(p.stat, p.link, p.single), annotation),
                               list(heights = heights))
            }else{
              args.tracks <- c(list(p.stat, p.link, p.single),
                               list(heights = heights))
            }
            do.call(tracks, args.tracks)
          })

## default show y axis of the first track and hide others
setMethod("plotFragLength", c("character", "GRanges"),
          function(data, model,
                   gap.ratio = 0.0025,
                   geom = c("segment", "point", "line"),
                   type = c("normal", "cut"),
                   heights = c(400, 100),
                   annotation = TRUE){
  ## default show it, but only keep first one
    show.axis.text.y <- FALSE
  ## geom <- match.arg(geom)
  type <- match.arg(type)
  message("Compute fragment length...")
  lst <- biovizBase:::getFragLength(data, model)
  message("Plotting...")
  gr.fraglength <- lst$gr
  if(type == "cut"){
    frag <- lst$fragLength
    reads <- lst$reads # combinded paried reads
    g.gap <- gaps(c(ranges(reads), ranges(model)))
    chr <- unique(as.character(seqnames(model)))
    cut.fun <- shrinkageFun(g.gap, maxGap(GRanges(chr, g.gap), gap.ratio))
    reads.cut <- cut.fun(reads)
    grl <- split(reads.cut, values(reads.cut)$mapid)
    grl.r <- range(grl)
    gr.res <- unlist(grl.r)
    names(gr.res) <- names(grl)
    values(gr.res)$.fragLength <- frag[names(gr.res)]
    gr.fraglength <- gr.res
    model <- cut.fun(model)
  }
  ## since model is always there
  ## so make sure it's overlaped
  gr.fraglength <- keepSeqlevels(gr.fraglength,
                                 unique(as.character(seqnames(gr.fraglength))))
  gr.fraglength <- subsetByOverlaps(gr.fraglength, range(model), type = "within")
    if(is(model, "GRanges"))
      model <- GRangesList(model)
    names(model) <- "1"
    p.exon <- autoplot(model) + ylab(" ") + theme_bw() +theme(panel.grid.minor=element_blank(),
                                             panel.grid.major=element_blank())
                                               ## scale_y_continuous(breaks = c(0),
                                               ##                   labels = " x")
                                               ## theme(axis.text.y = element_blank())

    df <- as.data.frame(gr.fraglength)
    p <- ggplot(df)
    if("segment" %in% geom){
      p <- p + geom_segment(aes(x = start,
                                y = .fragLength,
                                xend = end,
                                yend = .fragLength), color = "gray")

    if(annotation)
      p <- p + theme(panel.grid.minor=element_blank()) +  theme_bw()
    }
    if("point" %in% geom){
      p <- p + geom_point(aes(x = (start + end)/2, y = .fragLength), size = 1.2,
                          color = "gray30") +  theme_bw()
    if(annotation)      
     p <- p + theme(panel.grid.minor=element_blank())
    }
    if("line" %in% geom){
        p <- p + geom_line(aes(x = (start + end)/2, y = .fragLength),
                           linewidth = 1.2,
                          color = "gray30")  +  theme_bw()
    if(annotation)      
     p <- p + theme(panel.grid.minor=element_blank())
    }
    p <- p + ylab("Estimated Fragmeng Length") 
    if(annotation)
      tracks(p, p.exon, heights = heights, show.axis.text.y = show.axis.text.y)
    else{
      p <- p + xlab("Genomic Coordinates")
      p
    }
})

trans_seq <- function(unit = c("Mb", "kb", "bp")) {
    unit <- match.arg(unit)
    function(x) {
        res <- switch(unit, Mb = {x/1e6},
                            kb = {x/1000},
                            bp = {x})
        res
    }
}

trans_seq_rev <- function(unit = c("Mb", "kb", "bp")) {
    unit <- match.arg(unit)
    function(x) {
        res <- switch(unit, Mb = {x*1e6},
                            kb = {x*1000},
                            bp = {x})
        res
    }
}

trans_seq_format <- function(unit = c("Mb", "kb", "bp")) {
    unit <- match.arg(unit)
    function(x) {
        res <- switch(unit, Mb = {x/1e6},
                            kb = {x/1000},
                            bp = {x})
        paste(res, unit)
    }
}

.append_unit <- function(unit = "") {
    function(x) paste(x, unit)
}

scale_x_sequnit <- function(unit = c("Mb", "kb", "bp"), append = NULL) {
    unit <- match.arg(unit)
    if(is.null(append)) {
        scale_x_continuous(breaks = trans_breaks(trans_seq(unit),
                           trans_seq_rev(unit)),
                           labels = trans_format(trans_seq_format(unit),
                           math_format(.x)))
    } else {
        stopifnot(is.character(append))
        scale_x_continuous(labels = trans_format(.append_unit(append),
                           math_format(.x)))
    }
}

scale_fill_giemsa <- function(fill = getOption("biovizBase")$cytobandColor) {
    list(scale_fill_manual(values = fill))
}

## matrix
scale_fill_fold_change <- function() {
    scale_fill_gradient2(low = "blue", mid = "white", high = "red")
}

scale_by_xlim <- function(xlim, by.unit = TRUE) {
    if(by.unit)
        .d <- max(xlim)
    else
        .d <- diff(xlim)

    if(.d > 1e6)
        res <- scale_x_sequnit("Mb")
    else if (.d <= 1e6 & .d > 1e3)
        res <- scale_x_sequnit("kb")
    else
        res <- scale_x_sequnit("bp")

    res
}

setMethod("plotSpliceSum", c("character", "GRangesList"),
          function(data, model, ..., weighted = TRUE){
  freq <- biovizBase:::spliceSummary(data, model, weighted = weighted)
  autoplot(model, freq = freq, ...)
})
setMethod("plotSpliceSum", c("character", "TxDb"),
          function(data, model, which, ..., weighted = TRUE){
            exons <- exonsBy(model, by = "tx")
            exons <- subsetByOverlaps(exons, which)
            freq <- biovizBase:::spliceSummary(data, exons, weighted = weighted)
            autoplot(exons, freq = freq, ...)
          })

####============================================================
##  plotSpliceSum method from ggbio, R/plotSpliceSum-method.R
##
####------------------------------------------------------------
setMethod("plotSpliceSum", c("character", "EnsDb"),
          function(data, model, which, ..., weighted = TRUE){
              if(is(which, "GRanges")){
                  if(length(which) != 1)
                      stop("'which' has to be a single GRanges object.")
                  if(!is.na(genome(which))){
                      if(unname(genome(which)) != unique(unname(genome(model))))
                          stop(paste0("Genome versions do not fit! Argument 'which' has ",
                            unname(genome(which)), " argument 'model' ",
                            unname(unique(genome(which))), "!"))
                  }
                  ## Check if we've got the seqnames.
                  if(!(seqlevels(which) %in% seqlevels(model)))
                      stop(paste0(seqlevels(which), " does not match any seqlevel ",
                                  "in argument 'model'!"))
                  which <- GRangesFilter(which, type = "any")
              }
              exons <- exonsBy(model, by="tx", filter=which)
              ## Check if features are all on one chromosome.
              if(length(seqlevels(unlist(exons))) > 1)
                  stop(paste0("Got features from ", length(seqlevels(unlist(exons))),
                              " different chromosomes. Please adjust 'which' such that",
                              " only features from one chromosome are fetched."))
              freq <- biovizBase:::spliceSummary(data, exons, weighted = weighted)
              autoplot(exons, freq = freq, ...)
          })

###  hack at automaticaly generating method for IRanges and Granges
### to avoid get global .method, use a closure.
setOldClass("uneval")
.geoms.ggbio <- paste0("geom_", .ggbio.geom)
.stats.ggbio <- paste0("stat_", .ggbio.stat)
.geoms.ggplot <- paste0("geom_", .ggplot.geom)
.stats.ggplot <- paste0("stat_", .ggplot.stat)

.layouts <-  c("layout_circle", "layout_karyogram")

.gr.name.ggbio <- c(.geoms.ggbio, .stats.ggbio, .layouts)
.gr.name.ggbio <- setdiff(.gr.name.ggbio, c(.geoms.ggplot, .stats.ggplot))
.gr.name.ggplot <- c(.geoms.ggplot, .stats.ggplot)


for(method in .gr.name.ggbio){
  ## for IRanges
  ifun <- function(method){
    .method <- method
    if(hasMethod(.method, "GRanges") && !hasMethod(.method, "IRanges")){
      setMethod(.method, "IRanges", function(data, ...){
        .fun <- selectMethod(.method, signature = "GRanges")
        df <- values(data)
        values(data) <- NULL
        gr <- GRanges("chr_non", data)
        values(gr) <- df
        .fun(gr, ...)
      })
    }
  }
  ifun(method)

  ## for GRangesList

  gfun <- function(method){
    .method <- method
    if(hasMethod(.method, "GRanges") && !hasMethod(.method, "GRangesList")){
      setMethod(.method, "GRangesList", function(data, ...){
        .fun <- selectMethod(.method, signature = "GRanges")
        gr <- biovizBase:::flatGrl(data)
        .fun(gr, ...)
      })
    }
  }
  gfun(method)

  ## hacking for ggplot2-like API without using proto
  ## is data is missing, return a call and parse the data
  mfun <- function(method){
    .method <- method
      setMethod(.method, "missing", function(data,...){
          mc <- match.call()
          mc[-1L] <- list(...)
        return(mc)
      })
  }
  mfun(method)

  ufun <- function(method){
    .method <- method
    setMethod(.method, "uneval", function(data, ...){
      lst <- as.list(match.call())
      idx <- names(lst) != "data"
      aes.u <- unname(lst[!idx])
      res <- lst[idx]
      res <- c(res, aes.u)
      return(as.call(res))
    })
  }
  ufun(method)
}



for(method in .gr.name.ggplot){
  ## for IRanges
  ifun <- function(method){
    .method <- method
    if(hasMethod(.method, "GRanges")) {
      setMethod(.method, "IRanges", function(data, ...){
        .fun <- selectMethod(.method, signature = "GRanges")
        df <- values(data)
        values(data) <- NULL
        gr <- GRanges("chr_non", data)
        values(gr) <- df
        .fun(gr, ...)
      })
    }
  }
  ifun(method)

  ## for GRangesList

  gfun <- function(method){
    .method <- method
    if(hasMethod(.method, "GRanges")) {
      setMethod(.method, "GRangesList", function(data, ...){
        .fun <- selectMethod(.method, signature = "GRanges")
        gr <- biovizBase::flatGrl(data)
        .fun(gr, ...)
      })
    }
  }
  gfun(method)

  ## hacking for ggplot2-like API without using proto
  mfun <- function(method){
      .method <- method

      setMethod(.method, "missing", function(data, ...){
          method0 <- getFromNamespace(method, "ggplot2")
          args <- list(...)
          args.aes <- parseArgsForAes(args)
          args.non <- parseArgsForNonAes(args)
          args.non <- remove_args(args.non, "nbin")
          args <- c(args.non, list(args.aes))
          tm <- try({res <- do.call(method0, args)}, silent = TRUE)
          if(inherits(tm, "try-error")){
              res <-  match.call()
          }else{
              mc <- match.call()
              attr(res, "call") <- TRUE
              attr(res, "mc") <- mc
          }
        return(res)
      })
  }
  mfun(method)

  ufun <- function(method){
      .method <- method
      setMethod(.method, "uneval", function(data, ...){
          method0 <- getFromNamespace(method, "ggplot2")
          args <- list(...)
          args.non <- remove_args(args, "facets")
          args.aes <- data
          args <- c(args.non, list(args.aes))
          tm <- try({res <- do.call(method0, args)}, silent = TRUE)
          if(inherits(tm, "try-error")){
              res <- match.call()
          }else{
              mc <- match.call()
              attr(res, "call") <- TRUE
              attr(res, "mc") <- mc
          }
          return(res)
      })
  }
  ufun(method)
}

setGeneric("autoplot")

formals.qplot <- getFormalNames(qplot)
formals.facet_grid <- getFormalNames(facet_grid)
formals.facet_wrap <- getFormalNames(facet_wrap)
formals.facets <- union(formals.facet_grid, formals.facet_wrap)


.ggbio.geom <- c("rect", "chevron", "alignment", "arrowrect", "arrow",
                 "segment", "arch", "bar")
.ggbio.stat <- c("identity", "coverage", "stepping", "aggregate", "table",
                 "gene", "mismatch", "reduce", "bin", "slice")
.ggplot.geom <- c("rect", "segment", "bar")
.ggplot.stat <- c("identity", "bin")


## ======================================================================
##        For "Granges"
## ======================================================================

setMethod("autoplot", "GRanges", function(object, ..., chr,
                                          xlab, ylab, main,
                                          truncate.gaps = FALSE,
                                          truncate.fun = NULL,
                                          ratio = 0.0025,
                                          space.skip = 0.1,
                                          legend = TRUE,
                                          geom = NULL,
                                          stat = NULL,
                                          chr.weight = NULL,
                                          coord = c("default", "genome", "truncate_gaps"),
                                          layout = c("linear", "karyogram", "circle")
                                          ){

    .obj <- object
    if(!missing(chr))
        object <- subsetByChrs(object, chr)

    coord <- match.arg(coord)
    args <- list(...)

    if(coord == "genome"){
        object <- transformToGenome(object, space.skip = space.skip, chr.weight = chr.weight)
        object <- biovizBase:::rescaleGr(object)
    }
    formals.cur <- c("object", "stat", "geom", "legend",
                     "xlab", "ylab", "main")
    ## truncate
    if(truncate.gaps | coord == "truncate_gaps"){
        if(is.null(truncate.fun)){
            grl <- split(object, seqnames(object))
            lst <- endoapply(grl, function(gr){
                object.s <- reduce(gr, ignore.strand = TRUE)
                gps <- gaps(object.s, min(start(object.s)), max(end(object.s)))
                gps <- gps[strand(gps) == "*"]
                truncate.fun <- shrinkageFun(gps, maxGap(gps, ratio = ratio))
                res <- truncate.fun(gr)
                res
            })
            object <- unlist(lst)
        }else{
            object <- truncate.fun(object)
        }
    }
    ## ------------------------------
    ## geom/stat check
    ## ------------------------------
    ## if(is.null(geom) & layout = "circle")
    ##   geom <- "ideo"
    if(is.null(stat)){
        if(is.null(geom)){
            geom <- .ggbio.geom[1]
        }
    }else{
        if(!is.null(geom)){
            args$geom <- geom
        }
    }

    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)


    if((!is.null(geom) && geom %in% .ggbio.geom) |
       (!is.null(stat) && stat %in% .ggbio.stat)){
        args.non$data <- object
    }else{
        args.non$data <- mold(object)
        if(!"x" %in% names(args.aes))
            args.aes$x <- as.name("midpoint")
    }

    args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
    ## ------------------------------
    ## layout check
    ## ------------------------------
    layout <- match.arg(layout)
    ## treak with facet
    if(layout == "linear")
        facet <- .buildFacetsFromArgs(object, args.facets)
    else
        facet <- NULL

    if(layout == "linear" & coord == "genome")
        facet <- facet_null()

    ## use the default x
    ## since some of the geom or stat are not fully supported by all layout
    if(layout == "linear"){
        ## ------------------------------
        ##   get the right function
        ## ------------------------------
        aes.res <- do.call(aes, args.aes)
        ## args.res <- c(list(aes.res), args.non)
        .fun <- getDrawFunFromGeomStat(geom, stat)
        .xlim <- c(start(range(object, ignore.strand = TRUE)),
                   end(range(object, ignore.strand = TRUE)))
        p <- list(do.call(.fun, c(args.non, list(aes.res))))
        if(!is.null(stat) && stat != "aggregate")
            p <- c(p, list(scale_by_xlim(.xlim)))
        if(!legend)
            p <- c(p, list(theme(legend.position = "none")))
        if(missing(xlab)){
            xlab <- ""
        }
        p <- c(p, list(xlab(xlab)))
        ## tweak with default y lab
        if(!missing(ylab))
            p <- c(p,list(ylab(ylab)))
        ## if("x" %in% names(args.aes))
        args.aes <- args.aes[names(args.aes) %in% c("x", "y")]
        aes.res <- do.call(aes, args.aes)
        p <- do.call(ggplot, c(list(data = object),
                               list(aes.res))) + p
    }
    if(layout == "karyogram"){
        p <- plotStackedOverview(object, ...,  geom = geom)
        if(missing(xlab)){
            xlab <- ""
        }
        p <- p + ggplot2::xlab(xlab)
        ## FIXME: xlab/ylab/main
    }
    if(layout == "circle"){
        p <- ggplot(object) + circle(object, geom = geom, space.skip = space.skip, ...)
    }
    if(!missing(main))
        p <- p + labs(title = main)
    ## test scale
    if(is_coord_truncate_gaps(object) | is_coord_genome(object)){
        ss <- getXScale(object)
        p <- p + scale_x_continuous(breaks = ss$breaks,
                                    labels = ss$labels)
        if(metadata(object)$x.max < 1e8){
            sls <- seqlengths(.obj)
            sls <- sum(sls)
            if(!is.na(sls)){
                .xlim <- c(0, sls)
                p <- p + xlim(.xlim)
            }
        }
    }
    if(length(stat) && stat != "aggregate")
        p <- p + facet
    if(((!is.null(geom) && !geom %in% .ggbio.geom) & is.null(stat)) | coord == "genome")
        p <- p + facet
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    if(!is_coord_truncate_gaps(object) && !is_coord_genome(object)){
        p <- p + scale_by_xlim(getLimits(p)$xlim)
    }
    p
})

## ======================================================================
##        For "GRangesList"
## ======================================================================
setMethod("autoplot", "GRangesList", function(object, ...,
                                              xlab, ylab, main,
                                              indName = "grl_name",
                                              geom = NULL, stat = NULL,
                                              coverage.col = "gray50",
                                              coverage.fill = coverage.col,
                                              group.selfish = FALSE){



    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    args.non$group.selfish <- group.selfish
    if(is.null(geom) & is.null(stat))
        geom <- "alignment"
    if("type" %in% names(args.aes)){
        .type <- quo_name(args.aes$type)
    }else{
        .type <- NULL
    }

    if(geom == "alignment" && isGenemodel(object, type = .type)){
        aes.res <- do.call(aes, args.aes)
        args.non$data <- object
        args.res <- c(args.non, list(aes.res))
        p <- ggbio() + do.call(geom_alignment,
                               args.res)

    }else{
    args.non$geom <- geom
    gr <- flatGrl(object, indName)
    if(!"group" %in% names(args.aes))
        args.aes$group <- as.name(indName)
    aes.res <- do.call(aes, args.aes)
    args.non$object <- gr
    args.non <- remove_args(args.non, c("main.geom"))
    args.res <- c(args.non, list(aes.res))
    p <- do.call(autoplot, args.res)
    }
    if(missing(xlab)) {
        xlab <- ""
    }
    p <- p + ggplot2::xlab(xlab)
    if(!missing(ylab))
        p <- p + ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    p
})

## ======================================================================
##        For "IRanges"
## ======================================================================

setMethod("autoplot", "IRanges", function(object, ..., xlab, ylab, main){
    ## ok, for simple impmlementation, let's make it a GRanges.....:)
    df <- values(object)
    values(object) <- NULL
    gr <- GRanges("chr_non", object)
    values(gr) <- df
    p <- autoplot(gr, ...)
    if(!missing(xlab))
        p <- p + ggplot2::xlab(xlab)
    else
        p <- p + ggplot2::xlab("")
    if(!missing(ylab))
        p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main) +
            theme(strip.background = element_rect(colour = 'NA', fill = 'NA'))+
                theme(strip.text.y = element_text(colour = 'white'))
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    p
})


## ======================================================================
##        For "GAlignments"
## ======================================================================
setMethod("autoplot", "GAlignments", function(object, ...,
                                              xlab, ylab, main,
                                              which,
                                              geom = NULL, stat = NULL){

    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
    facet <- .buildFacetsFromArgs(object, args.facets)
    if(is.null(stat)){
        if(is.null(geom))
            geom <- "alignment"
#### going to be droped next release of bioc
        if("show.junction" %in% names(args.non)){
            message("show.junction is going to be dropped, geom:alignment will contain gaps")
            show.junction <- args.non$show.junction
            if(show.junction){
                geom <- "alignment"
            }else{
                geom <- "rect"
            }}
####
        if(geom == "gapped.pair"){
            message("geom:gapped.pair is going to be dropped next release,
             if geom = NULL, it's going to use grglist(object) and show as
             alignemnts")
            geom <- "alignment"
        }
    }else{
            args.non$stat <- stat
            args.non$geom <- geom
        }
    aes.res <- do.call(aes, args.aes)
    if(!is.null(geom)  && geom == "alignment"){
        args.non$object <- grglist(object)
        p <- do.call(autoplot, c(list(aes.res), args.non))
    }else{
        if(!missing(which))
            gr <- crunch(object, which)
        else
            gr <- crunch(object)
        args.non$object <- gr
        p <- do.call(autoplot, c(list(aes.res), args.non))
    }
    if(missing(xlab)) {
        xlab <- ""
    }
    p <- p + ggplot2::xlab(xlab)
    if(!missing(ylab))
        p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)
    p <- p + facet
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    p
})


## ======================================================================
##        For "BamFile"
## ======================================================================
## TODO
## 1. mismatch
## 2. simply summary
setMethod("autoplot", "BamFile", function(object, ..., which,
                                          xlab, ylab, main,
                                          bsgenome,
                                          geom = "line",
                                          stat = "coverage",
                                          method = c("raw", "estimate"),
                                          coord = c("linear", "genome"),
                                          resize.extra = 10,
                                          space.skip = 0.1,
                                          show.coverage = TRUE){

    mc <- as.list(match.call())[-1]
    mc <- lapply(mc, eval, envir = parent.frame(1))
    mc <- c(list(as.name("autoplot")), mc)
    cmd <- list(mc)
    names(cmd) <- "autoplot"

    coord <- match.arg(coord)
    if(missing(xlab))
        xlab <- NULL
    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)


    method <- match.arg(method)
    bf <- open(object)

    if(geom == "gapped.pair"){
        message("Read GAlignments from BamFile...")
        ga <- readGAlignments(bf, param = ScanBamParam(which = which),
                                  use.names = TRUE)
        message("plotting...")
        args.ga <- args[names(args) %in% "show.junction"]
        args <- c(args.ga, list(object = ga))
        p <- do.call(autoplot, args)
    }else{
        if(stat == "coverage"){
            if(method == "estimate"){
                if(missing(which)){
                    seq.nm <- names(scanBamHeader(object)[[1]])[1]
                }else{
                    if(is(which, "GRanges")){
                        seq.nm <- unique(as.character(seqnames(which)))
                    } else if(is(which, "character")){
                        seq.nm <- which
                    }else{
                        stop("which must be missing, GRanges or character(for seqnames)")
                    }
                }
                xlab <- ""
            }

            if(!missing(which))
                p <- ggplot() + stat_coverage(bf, ..., method = method, coord = coord,
                                              space.skip = space.skip,
                                              geom  =  geom, which = which)
            else
                p <- ggplot() + stat_coverage(bf, ..., method = method, coord = coord,
                                              space.skip = space.skip,
                                              geom  =  geom)
        }else if(stat == "mismatch"){
            if(geom %in% c("bar", "segment")){
                p <- ggplot() + stat_mismatch(bf, ..., bsgenome = bsgenome, which = which, geom = "bar")
            }else{
                p <- ggplot() + stat_mismatch(bf, ..., bsgenome = bsgenome, which = which)
            }
        }else{
            ga <- readGAlignments(bf, param = ScanBamParam(which = which),
                                      use.names = TRUE)
            gr <- crunch(ga, type = "raw")
            p <- autoplot(gr, ..., geom = geom, stat = stat)
        }
    }
    if(!"facet" %in% names(args.non) && method == "estimate" && coord != "genome"){
        f <- facet_wrap(~seqnames)
        p <- p + f
    }
    if(length(xlab) >=1){
        p <- p + ggplot2::xlab(xlab)
    }else{
        p <- p + ggplot2::xlab("")
    }
    if(!missing(ylab))
        p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)


    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    if(!missing(which) && is(which, "GRanges")){
        p <- cacheSet(p, which)
    }
    ## else{
    ##     p@blank <- TRUE
    ## }
    p@fetchable <- TRUE
    p@cmd <- cmd
    p
})

## ======================================================================
##        For "BamFileList"
## ======================================================================
## TODO
## 1. mismatch
## 2. simply summary
setMethod("autoplot", "BamFileList", function(object, ..., which,
                                              xlab, main, names = NULL){

    plst <- lapply(object, function(x){
        autoplot(x, ...)
    })

    if(!length(names)){
        nms <- names(plst)
        nms <- basename(nms)
        names(plst) <- nms
    }else{
        names(plst) <- names
    }
    if(missing(xlab))
        xlab <- ""

    if(missing(main))
        main <- ""

    if(missing(which)){
        tks <- tracks(plst, xlab = xlab, main = main)
    }else{
        tks <- tracks(plst, xlab = xlab, main = main, xlim = which)
    }

    tks
})

## ======================================================================
##  For "character" need to check if it's path including bamfile or not
## ======================================================================
setMethod("autoplot", "character", function(object, ..., xlab, ylab, main,
                                            which){

    ## FIXME: does it always work?
    mc <- as.list(match.call())[-1]
    mc <- lapply(mc, eval, envir = parent.frame(1))
    mc <- c(list(as.name("autoplot")), mc)
    cmd <- list(mc)
    names(cmd) <- "autoplot"

    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    if(!missing(which))
        args.non$which <- which

    .ext <- tools::file_ext(object)
    if(.ext == "bam"){
        message("reading in as Bamfile")
        obj <- BamFile(object)
    }else{
        message("reading in")
        obj <- import(object)
        if(!missing(which) && is(which, "GRanges"))
            obj <- subsetByOverlaps(obj, which)
    }
    if(is(obj, "GRanges")){
        if(missing(xlab))
            xlab <- ""
        if(!"geom" %in% names(args.non)){
            if("y" %in% names(args.aes) | "score" %in% colnames(values(obj))){
                args.non$geom <- "bar"
            }else{
                args.non$geom <- "rect"
            }}
    }
    args.non$object <- obj
    aes.res <- do.call(aes, args.aes)
    p <- do.call(autoplot, c(list(aes.res), args.non))
    if(!missing(xlab))
        p <- p + ggplot2::xlab(xlab)
    if(!missing(ylab))
        p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    if(!missing(which) && is(which, "GRanges")){
        p <- cacheSet(p, which)
    }
    ## else{
    ##     p@blank <- TRUE
    ## }

    p@fetchable <- TRUE
    p@cmd <- cmd

    p
})


## ======================================================================
##        For "TxDb" or "EnsDb"(Genomic Structure)
## ======================================================================
setMethod("autoplot", "TxDbOREnsDb", function(object, which, ...,
                                       xlab, ylab, main,
                                       truncate.gaps = FALSE,
                                       truncate.fun = NULL,
                                       ratio = 0.0025,
                                       mode = c("full", "reduce"), #mode is combination of geom and stat and more
                                       geom = c("alignment"),
                                       stat = c("identity", "reduce"),
                                       names.expr = "tx_name",
                                       label = TRUE){

    ## Do just some stuff required for EnsDb usage first.
    if(is(object, "EnsDb")){
        ## We don't have a column tx_name in EnsDb.
        if(names.expr == "tx_name")
            names.expr <- "tx_id"
        ## if which is a GRanges, "convert" that into a GRangesFilter
        if (!missing(which) && is(which, "GRanges"))
            which <- GRangesFilter(which)
    }else{
        if(!missing(which)){
            if(!is(which, "GRanges"))
                stop("which, if provided, must be a GRanges object.")
        }
    }

    ## FIXME: does it always work?
    mc <- as.list(match.call())[-1]
    mc <- lapply(mc, eval, envir = parent.frame(1))
    mc <- c(list(as.name("autoplot")), mc)
    cmd <- list(mc)
    names(cmd) <- "autoplot"


    stat <- match.arg(stat)
    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    args.non$data <- object
    args.non$truncate.gaps <- truncate.gaps
    args.non$truncate.fun <- truncate.fun
    args.non$ratio <- ratio
    args.non$geom <- geom
    args.non$stat <- stat
    args.non$names.expr <- names.expr
    args.non$label <- label
    if(!missing(which)){
        ## For AnnotationFilter: which has to be an AnnotationFilter object,
        ## an AnnotationFilterList or a formula with a filter expression.
        if(!is(which, "AnnotationFilter") & !is(which, "AnnotationFilterList")
           & !is(which, "formula") & !is(which, "GRanges"))
            stop("which, if provided, must be a GRanges object, ",
                 "an single object extending AnnotationFilter, an ",
                 "AnnotationFilterList combining such object, or a formula ",
                 "representing a filter expression.")
        args.non$which <- which
    }

    aes.res <- do.call(aes, args.aes)
    args.res <- c(args.non,list(aes.res))
    p <- ggplot() + do.call(geom_alignment, args.res)
    if(!missing(xlab))
        p <- p + xlab(xlab)
    else
        p <- p + ggplot2::xlab("")
    if(!missing(ylab))
        p <- p + ylab(ylab)
    else
        p <- p + ggplot2::ylab("")
    if(!missing(main))
        p <- p + labs(title = main)
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    if(!missing(which)){
        p <- cacheSet(p, which)
    }
    ## else{
    ##     p@blank <- TRUE
    ## }
    p@fetchable <- TRUE
    p@cmd <- cmd
    p
})


setMethod("autoplot", "OrganismDb",
          function(object, which, ...,
                   xlab, ylab, main,
                   truncate.gaps = FALSE,
                   truncate.fun = NULL,
                   ratio = 0.0025,
                   geom = c("alignment"),
                   stat = c("identity", "reduce"),
                   columns = c("TXNAME", "SYMBOL", "TXID", "GENEID"),
                   names.expr = "SYMBOL",
                   label = TRUE,
                   label.color = "gray40"){

    ## FIXME: does it always work?
    mc <- as.list(match.call())[-1]
    mc <- lapply(mc, eval, envir = parent.frame(1))
    mc <- c(list(as.name("autoplot")), mc)
    cmd <- list(mc)
    names(cmd) <- "autoplot"

    stat <- match.arg(stat)
    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    args.non$data <- object
    args.non$truncate.gaps <- truncate.gaps
    args.non$truncate.fun <- truncate.fun
    args.non$ratio <- ratio
    args.non$geom <- geom
    args.non$stat <- stat
    args.non$names.expr <- names.expr
    args.non$label <- label
    args.non$label.color <- label.color
    args.non$columns <- columns
    if(!missing(which)){
        if(!is(which, "GRanges"))
            stop("which if provided, must be GRagnes object")
        which <- range(which, ignore.strand = TRUE)
        args.non$which <-    which
    }

    aes.res <- do.call(aes, args.aes)
    args.res <- c(args.non,list(aes.res))
    p <- ggbio() + do.call(geom_alignment, args.res)

    if(!missing(xlab))
        p <- p + xlab(xlab)
    else
        p <- p + ggplot2::xlab("")
    if(!missing(ylab))
        p <- p + ylab(ylab)
    else
        p <- p + ggplot2::ylab("")
    if(!missing(main))
        p <- p + labs(title = main)
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)
    if(!missing(which)){
        p <- cacheSet(p, which)
    }
    ## else{
    ##     p@blank <- TRUE
    ## }

    p@fetchable <- TRUE
    p@cmd <- cmd
                                        #     p <- p + theme_bw()
    p

})
## ======================================================================
##        For "TabixFile"
## ======================================================================
setMethod("autoplot", c("TabixFile"), function(object, which, ...)
          {
              mc <- as.list(match.call())[-1]
              mc <- lapply(mc, eval, envir = parent.frame(1))
              mc <- c(list(as.name("autoplot")), mc)

              if (tolower(file_ext(file_path_sans_ext(path(object)))) == "vcf") {
                  data <- readVcf(object, genome=unname(genome(which)[1]),
                                  param=which)
              } else {
                  data <- import(object, which=which)
              }
              p <- autoplot(data, ...)
              p@fetchable <- TRUE
              p@cmd <- list(mc)
              p
          })


## ======================================================================
##        For "BSgenome"
## ======================================================================
setMethod("autoplot", c("BSgenome"), function(object,  which, ...,
                                              xlab, ylab, main,
                                              geom = NULL){

    if(length(which) && is(which, "GRanges")){
        .xlim <- c(min(start(which)), max(end(which)))
    }

    if(is.null(geom)){
        geom <- zoomLevelToGeom(diff(.xlim), "BSgenome")
    }else if(!geom %in% c("text", "segment", "point","rect")){
        stop("geom must be one of: ", paste("text", "segment", "point","rect"))
    }

    mc <- as.list(match.call())[-1]
    mc <- lapply(mc, eval, envir = parent.frame(1))
    mc <- c(list(as.name("autoplot")), mc)
    cmd <- list(mc)
    names(cmd) <- "autoplot"

    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    which <- biovizBase:::rectifySeqlevelsStyle(which, object)

    seqlevelsStyle(which) <- "UCSC"


    seqs <- getSeq(object, which, as.character = TRUE)
    seqs <- safeExplode(seqs)
    xs <- seq(start(which), length.out = width(which))
    df <- data.frame(x = xs, seqs = seqs)

    p <- ggplot(data = df, ...)


    if(!"color" %in% names(args.non))
        isDNABaseColor <- TRUE
    else
        isDNABaseColor <- FALSE
    baseColor <- getOption("biovizBase")$DNABasesColor
    fc <- baseColor[df$seqs]

    p <- switch(geom,
                text = {
                    if(isDNABaseColor){
                        args.aes$x <- as.name("x")
                        args.aes$y <- 0
                        args.aes$label <- as.name("seqs")
                        args.aes$color <- as.name("seqs")
                        aes.res <- do.call(aes, args.aes)
                        args.non$size <- 4
                        args.res <- c(list(aes.res), args.non)
                        ## p <- p + do.call(geom_text2,
                        ##                  c(args.res, list(hjust = 0, color = "white", fc = fc)))
                        p + do.call(geom_text, args.res) +
                            scale_color_manual(values = baseColor)

                    }else{
                        args.aes$x <- as.name("x")
                        args.aes$y <- 0
                        args.aes$label = as.name("seqs")
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)
                        p + do.call(geom_text, args.res)
                    }

                },
                segment = {
                    if(isDNABaseColor){
                        args.aes$x <- as.name("x")
                        args.aes$y <- -1
                        args.aes$xend <- as.name("x")
                        args.aes$yend <- 1
                        args.aes$color = as.name("seqs")
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)
                        p + do.call(ggplot2::geom_segment, args.res) +
                            scale_color_manual(values = baseColor)+
                                scale_y_continuous(limits = c(-10, 10))
                    }else{
                        args.aes$x <- as.name("x")
                        args.aes$y <- -1
                        args.aes$xend <- as.name("x")
                        args.aes$yend <- 1
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)

                        p + do.call(ggplot2::geom_segment, args.res) +
                            scale_y_continuous(limits = c(-10, 10))
                    }
                },
                point = {
                    if(isDNABaseColor){
                        args.aes$x <- as.name("x")
                        args.aes$y <- 0
                        args.aes$color = as.name("seqs")
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)
                        p + do.call(geom_point, args.res) +
                            scale_color_manual(values = baseColor)
                    }else{
                        args.aes$x <- as.name("x")
                        args.aes$y <- 0
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)
                        p + do.call(geom_point, args.res)
                    }

                },
                rect = {
                    if(isDNABaseColor){
                        args.aes$xmin <- as.name("x")
                        args.aes$ymin <- -1
                        args.aes$xmax <- substitute(x + 0.9)
                        args.aes$ymax <- 1
                        args.aes$color = as.name("seqs")
                        args.aes$fill = as.name("seqs")
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)
                        p + do.call(ggplot2::geom_rect, args.res) +
                            scale_y_continuous(limits = c(-10, 10))+
                                scale_color_manual(values = baseColor)+
                                    scale_fill_manual(values = baseColor)
                    }else{
                        args.aes$xmin <- as.name("x")
                        args.aes$ymin <- -1
                        args.aes$xmax <- substitute(x + 0.9)
                        args.aes$ymax <- 1
                        aes.res <- do.call(aes, args.aes)
                        args.res <- c(list(aes.res), args.non)
                        p + do.call(ggplot2::geom_rect, args.res) +
                            scale_y_continuous(limits = c(-10, 10))
                    }},
                    none = {
                        p + annotate("text", x = mean(df$x), y = 0,
                                     label = "zoom in to show data", color = "gray 60") + xlim(.xlim)
                    })


    if(missing(xlab)){
        xlab <- ""
    }
    p <- p + xlab(xlab)
    ## tweak with default y lab
    if(missing(ylab)){
        ylab = ""
    }
    p <- p + ylab(ylab)

    p <- p + scale_y_continuous(breaks = NULL)
    if(!missing(main))
        p <- p + labs(title = main)

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    if(!missing(which)){
        p <- cacheSet(p, which)
    }
    attr(p, "geom") <- geom
    p@fetchable <- TRUE
    p@cmd <- list(mc)

    p
})


## ======================================================================
##        For "Rle"
## ======================================================================
## geom: ... color = I("red"), doesn't work
## FIXME: idenity
setMethod("autoplot", "Rle", function(object, ...,
                                      xlab, ylab, main,
                                      binwidth, nbin = 30,
                                      geom = NULL,
                                      stat = c("bin", "identity", "slice"),
                                      type = c("viewSums","viewMins",
                                          "viewMaxs", "viewMeans")){

    stat <- match.arg(stat)
    type <- match.arg(type)

    args <- list(...)

    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    args.non$data <- object
    args.non$geom <- geom

    if(stat == "identity"){
        aes.res <- do.call(aes, args.aes)
        args.res <- c(list(aes.res), args.non)
        p <- ggplot() + do.call(stat_identity, args.res)
    }
    if(stat == "bin"){
        args.non$nbin <- nbin
        args.non$type <- type
        aes.res <- do.call(aes, args.aes)
        if(!missing(binwidth))
            args.non$binwidth <- binwidth
        args.res <- c(list(aes.res), args.non)
        p <- ggplot() + do.call(stat_bin, args.res)
    }
    if(stat == "slice"){
        aes.res <- do.call(aes, args.aes)
        args.res <- c(list(aes.res), args.non)
        p <- ggplot() + do.call(stat_slice, args.res)
    }

    if(!missing(xlab))
        p <- p + ggplot2::xlab(xlab)
    else
        p <- p + ggplot2::xlab("")
    if(!missing(ylab))
        p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
})


## ======================================================================
##        For "RleList"
## ======================================================================
## 1. facet by list
## 2. support as what has been supported in Rle.
setMethod("autoplot", "RleList", function(object, ...,
                                          xlab , ylab, main,
                                          nbin = 30,
                                          binwidth,
                                          facetByRow = TRUE,
                                          stat = c("bin", "identity", "slice"),
                                          geom = NULL,
                                          type = c("viewSums","viewMins",
                                              "viewMaxs", "viewMeans")){
    stat <- match.arg(stat)

    type <- match.arg(type)
    ## if(stat == "slice" &&
    ##    type %in% c("viewMaxs", "viewMeans", "viewMins", "viewSums") && missing(lower))
    ##   stop("please at least specify the value of lower, you could pass
    ##         extra parameters to slice too")

    ## args <- as.list(match.call(call = sys.call(sys.parent(2)))[-1])
    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    args.non$data <- object
    args.non$geom <- geom
    if(stat == "identity"){
        aes.res <- do.call(aes, args.aes)
        args.res <- c(list(aes.res), args.non)
        p <- ggplot() + do.call(stat_identity, args.res)
    }
    if(stat == "bin"){
        args.non$nbin <- nbin
        aes.res <- do.call(aes, args.aes)
        if(!missing(binwidth))
            args.non$binwidth <- binwidth
        args.res <- c(list(aes.res), args.non)
        p <- ggplot() + do.call(stat_bin, args.res)
    }
    if(stat == "slice"){
        aes.res <- do.call(aes, args.aes)
        args.res <- c(list(aes.res), args.non)
        p <- ggplot() + do.call(stat_slice, args.res)
    }
    if(!missing(xlab))
        p <- p + ggplot2::xlab(xlab)
    else
        p <- p + ggplot2::xlab("")
    if(!missing(ylab))
        p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
    ## if(facetByRow)
    ##   facets <- listName ~ .
    ## else
    ##   facets <- . ~ listName
})



##======================================================================
##  For ExpressionSet/eSet??
##======================================================================

.ggpcp <- function(data, vars = names(data), ...){
    scaled <- as.data.frame(lapply(data[, vars], scales::rescale))
    data[names(scaled)] <- scaled
    data$ROWID <- 1:nrow(data)
    molten <- reshape2::melt(data, m = vars)
    ggplot(molten, aes(x = .data[["variable"]], y = .data[["value"]], group = .data[["ROWID"]]),
           ...)
}

## setGeneric("phenoPlot", "")
## phenoPlot <- function(){

## }

setMethod("autoplot", "ExpressionSet", function(object, ...,
                                                type = c("heatmap","none",
                                                    "scatterplot.matrix", "pcp", "MA", "boxplot",
                                                    "mean-sd"),
                                                ## "NUSE", "RLE"),
                                                test.method = "t",
                                                rotate = FALSE,
                                                pheno.plot = FALSE,
                                                main_to_pheno = 4.5,
                                                padding = 0.2){

    args <- list(...)
    type <- match.arg(type)
    df.exp <- exprs(object)
    df <- as.data.frame(df.exp)
    if(type == "scatterplot.matrix"){
        stop("scatterplot.matrix is not supported yet")
    }
    if(type == "heatmap"){
        ## add pheno type data
        if(!pheno.plot){
            colnames(df.exp) <- rownames(pData(object))
            p <- autoplot(df.exp, ...) + ylab("Features") + xlab("Samples")
        }else{
            colnames(df.exp) <- rownames(pData(object))
            p <- autoplot(t(df.exp), ...) + xlab("Features") + ylab("Samples")
            pd <- pData(object)
            s <- list(theme(axis.text.y = element_blank(),
                            axis.ticks.y = element_blank()) ,
                      theme(legend.position = "top",
                            plot.margin = ggplot2::margin(padding, 1, padding, 0.5, unit = "lines")),
                      guides(fill = guide_legend(byrow = FALSE, ncol =  1,
                                 title.theme = element_blank())))


            N <- ncol(pd)
            hts <- rep(1/N, N)
            hts <- c(hts, main_to_pheno)
            l <- lapply(1:N, function(i){
                autoplot(as.matrix(pd[, i, drop  = FALSE])) + s
            })
            ry <- c(rep(TRUE, N), FALSE)
            l <- c(l, list(p))
            return(grid::grid.draw(do.call(alignPlots, c(l, list(vertical = FALSE, remove.y.axis = ry,
                                                 widths = hts)))))
        }
    }
    if(type == "pcp"){
        p <- .ggpcp(df) + geom_line(...) + xlab("Sample Name")
    }
    if(type == "boxplot"){
        p <- .ggpcp(df) + geom_boxplot(aes(group=variable), ...)+ xlab("Sample Name")
    }
    if(type == "MA"){
        stop("not impleenmted yet")
    }
    ## if(type == "NUSE"){
    ##   require(affyPLM)
    ##   message("fit PLM model...")
    ##   dataPLM <- fitPLM(object)
    ##   message("compute NUSE(Normalized Unscaled Standard Error)...")
    ##   res <- getNR(dataPLM, type = "NUSE")
    ##   res.m <- melt(res)
    ##   colnames(res.m) <- c("probe", "sampleNames", "value")
    ##   message("plotting...")
    ##   p <- ggplot(res.m, aes(x = sampleNames, y = value)) + geom_boxplot(...)
    ## }
    ## if(type == "RLE"){
    ##   require(affyPLM)
    ##   message("fit PLM model...")
    ##   dataPLM <- fitPLM(object)
    ##   message("compute RLE(Relative Log Expression)...")
    ##   res <- getNR(dataPLM, type = "RLE")
    ##   res.m <- melt(res)
    ##   colnames(res.m) <- c("probe", "sampleNames", "value")
    ##   message("plotting...")
    ##   p <- ggplot(res.m, aes(x = sampleNames, y = value)) + geom_boxplot(...)
    ## }
    if(type == "mean-sd"){
        require("vsn")
        rk <- TRUE
        if("ranks" %in% names(args))
            rk <- args$ranks
        res <- vsn::meanSdPlot(object, ranks = rk, plot = FALSE)
        if(rk)
            xlabs <- "rank(mean)"
        else
            xlabs <- "mean"
        p <- qplot(x = res$px, y = res$py, geom = "point") +
            geom_point(aes(x = res[[1]], y = res$sd), color = "red") +
                xlab(xlabs) + ylab("sd")
        p
    }
    ## if(type == "volcano"){
    ##   require(genefilter)
    ##   if(!"fac" %in% names(args))
    ##     stop("argument fac must be provided to make t-test,
    ##           check genefilter::rowttests for details")

    ##   message("genefilter::rowttests used")
    ##   tt <- rowttests(object, args$fac)
    ##   p <- qplot(tt$dm, -log10(tt$p.value), geom = "point") +
    ##     xlab(expression(mean~log[2]~fold~change)) +
    ##       ylab(expression(-log[10](p)))

    ## }
    if(type == "none"){
        df.l <- mold(object)
        p <- qplot(data = df.l, ...)
    }
    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
})

##======================================================================
##  For GenomicRangesList, for circular view
##======================================================================
## TODO for circular layout first
## need to name the aes list otherwise following the order
## setMethod("autoplot", "GenomicRangesList", function(object, args = list(),
##                                                     trackWidth,
##                                                     radius = 10,
##                                                     grid = FALSE,
##                                                     trackSkip = 1,
##                                                     layout = c("circle")){

##   layout <- match.arg(layout)
##   message("Take 'genome' coordinate transformation")
##   if(layout == "circle"){
##   if(missing(trackWidth)){
##     trackWidth <- rep(5, length(object))
##     idx <- which(unlist(lapply(args, function(arg){
##       arg$geom == "link"
##     })))
##     trackWidth[1] <- 1
##   }else{
##     if(length(trackWidth) > length(object)){
##       warning("Unequal lengths of trackWidth, removing extra track width")
##       trackWidth <- trackWidth[1:length(object)]

##     }
##     if(length(trackWidth) < length(object)){
##       warning("Unequal lengths of trackWidth, adding default 5 to  extra track width")
##       trackWidth <- c(trackWidth, rep(5, length(object) - length(trackWidth)))
##     }
##   }
##     if(length(trackSkip) == 1){
##       trackSkip <- rep(trackSkip, length(object))
##     }else{
##       if(length(trackSkip) != length(object))
##         stop("trackSkip must be of length 1 or of the same length
##               as object")
##     }

##     if(length(radius) == 1){
##       radius <- radius + c(0, cumsum(trackWidth)[-length(trackWidth)]) +
##         cumsum(trackSkip)
##     }else{
##       if(length(radius) != length(object))
##         stop("radius must be of length 1 showing innermost radius or of the same length
##               as object")
##     }


##     if(length(grid) == 1){
##       grid <- rep(grid, length(object))
##     }else{
##       if(length(grid) != length(object))
##         stop("grid must of length 1 or of the same length
##               as object")
##     }

##     p <- ggplot()

##     for(i in 1:length(object)){
##       p <- p + do.call(circle, c(list(data = object[[i]]), radius = radius[i],
##                                         trackWidth = trackWidth[i], grid = grid[i],
##                                         args[[i]]))
##     }}
##     p
## })

##======================================================================
##  For VCF
##======================================================================
setMethod("autoplot", "VRanges", function(object, ...,which = NULL,
                                          arrow = TRUE, indel.col = "gray30",
                                          geom = NULL,
                                          xlab, ylab, main){


    if(length(which) && is(which, "GRanges")){
        .xlim <- c(min(start(which)), max(end(which)))
    }else{
        .xlim <- c(min(start(object)), max(end(object)))
    }

    if(is.null(geom)){
        geom <- zoomLevelToGeom(diff(.xlim), "VRanges")
    }else if(!geom %in% c("text", "rect")){
        stop("geom must be one of: ", paste("text", "rect"))
    }

    message(geom, " geom is used")
    mc <- as.list(match.call())[-1]
    mc <- lapply(mc, eval, envir = parent.frame(1))
    mc <- c(list(as.name("autoplot")), mc)
    cmd <- list(mc)
    names(cmd) <- "autoplot"

    args <- list(...)

    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args) ## FIXME: args.non unused

    md <- mold(object)

    if(length(md)){

        baseColor <- getOption("biovizBase")$DNABasesColor
        fc1 <- baseColor[md$alt]
        fc1[is.na(fc1)] <- indel.col
        fc2 <- baseColor[md$ref]
        fc2[is.na(fc2)] <- indel.col
        if(geom == "text"){

            ## p <- ggplot() +
            ##     geom_text2(data = md, aes(x = start, y = 1.75, label = alt),
            ##                color = "white", fc = fc1, hjust = 0) +
            ##                    geom_text2(data = md, aes(x = start, y = 1.25, label = ref),
            ##                               color = "white", fc = fc2, hjust = 0) +
            ##                                   scale_color_manual(values = baseColor)

            p <- ggbio() +
                geom_text(data = md, aes(x = start, y = 1.75, label = alt,
                              color = alt)) +
                                  geom_text(data = md, aes(x = start, y = 1.25, label = ref, color = ref)) +
                                scale_color_manual(values = baseColor)



        }
        if(geom == "rect"){
            md.rect <- md
            indel <- width(object) > 1 | width(alt(object)) > 1
            md.rect$ref[indel] <- "Indel"
            md.rect$alt[indel] <- "Indel"
            md.rect$ref <- factor(md.rect$ref, levels = c("A", "C", "G", "T", "Indel"))
            md.rect$alt <- factor(md.rect$alt, levels = c("A", "C", "G", "T", "Indel"))

            p <- ggplot(md.rect) +
                 ggplot2::geom_segment(aes(x = midpoint-0.5, y = 1.25,
                                          xend = midpoint-0.5, yend = 1.35, color = ref)) +
                 ggplot2::geom_rect(aes(xmin = midpoint - 0.5, ymin = 1.25,
                                        xmax = midpoint + 0.5, ymax = 1.35, fill = ref), color = NA) +
                 ggplot2::geom_segment(aes(x = midpoint, y = 1.65,
                                           xend = midpoint, yend = 1.75, color = alt)) +
                 ggplot2::geom_rect(aes(xmin = midpoint - 0.5, ymin = 1.65,
                                        xmax = midpoint + 0.5, ymax = 1.75, fill = alt), color = NA) +
                 scale_fill_manual(values = c(baseColor, "Indel" = indel.col)) +
                 scale_color_manual(values = c(baseColor, "Indel" = indel.col))
        }
        if(geom == "none"){
            p <- ggplot() + annotate("text", x = mean(.xlim), y = 0,
               label = "zoom in to show data", color = "gray 60") + xlim(.xlim) +
                   ggplot2::ylab("")
        }

        if(arrow && geom != "none"){
            p <- p + ggplot2::geom_segment(data = md, aes(x = midpoint, xend = midpoint), y = 1.4,
                                           yend = 1.6, arrow = arrow(length = unit(0.3,"strwidth", "A")))
        }
        if('sampleNames' %in% colnames(md) && geom != "none"){
            p <- p + facet_grid (sampleNames ~ .)
        }

        if(missing(xlab))
            xlab <- ""
        p <- p + ggplot2::xlab(xlab)
        if(missing(ylab))
            ylab <- ""
        p <- p + ggplot2::ylab(ylab)
        if(!missing(main))
            p <- p + labs(title = main)

        if(!is(p, "GGbio"))
            p <- GGbio(p, data = object)

    }else{
        p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
               list(ggplot2::xlim(c(0, 1))))
    }
    if(length(which)){
        p <- cacheSet(p, which)
    }
    p <- p + xlim(.xlim)
    attr(p, "geom") <- geom
    p@fetchable <- TRUE
    p@cmd <- list(mc)
    if(geom != "none")
        p <- p + ylim(1, 2)
    p + theme(axis.text.y=element_blank(),
             axis.ticks=element_blank())
})


setMethod("autoplot", "VCF", function(object, ...,
                                      xlab, ylab, main,
                                      assay.id,
                                      type = c("default", "geno", "info", "fixed"),
                                      full.string = FALSE,
                                      ref.show = TRUE,
                                      genome.axis = TRUE,
                                      transpose = TRUE){

    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    type <- match.arg(type)
    hdr <- metadata(object)[["header"]]
    if(type == "default"){
        vr <- as(object, "VRanges")
        p <- autoplot(vr,  ...)
    }

    if(type == "geno"){
        nms <- rownames(geno(hdr))
        message(paste(nms, collapse = ","), " could be used for 'geno' type")
        if(missing(assay.id)){
            if("GT" %in% nms){
                message("use GT for type geno as default")
                gt <- geno(object)[["GT"]]
            }else{
                nm <- nms[1]
                message("use ", nm, " for type geno as default")
                gt <- geno(object)[[nm]]
            }}else{
                if(is.numeric(assay.id))
                    nm <- nms[assay.id]
                if(is.character(assay.id)){
                    if(!assay.id %in% nms){
                        stop(assay.id, " is not in ", nms)
                    }
                    nm <- assay.id
                }
                gt <- geno(object)[[nm]]
            }
        sts <- start(rowRanges(object))
        idx <- !duplicated(sts)
        ## is this a right thing to do ?
        if(sum(!idx))
            message("Index: ", paste(which(!idx), collapse = ","),
                    " snp with duplicated start position may be masked by each other")
        ## gt <- gt[idx,]
        rownames(gt) <- start(rowRanges(object))
        ## rownames(gt) <- start(rowRanges(object)[idx])

        if(!"colour" %in% names(args.aes) && !"colour" %in% names(args.non) &&
           !"color" %in% names(args.aes) && !"color" %in% names(args.non))
            args.aes$color <- as.name("value")
        if(!"colnames.label" %in% names(args.non)){
            if(transpose)
                args.non$colnames.label <- FALSE
            else
                args.non$colnames.label <- TRUE
        }
        if(genome.axis){
            gt <- t(gt)
            args.aes$x <- substitute(as.numeric(colnames))
            aes.args <- do.call(aes, args.aes)
            p <- do.call(autoplot, c(list(object = gt),
                                     list(aes.args),
                                     args.non))
        }else{
            if(transpose)
                gt <- t(gt)
            aes.args <- do.call(aes, args.aes)
            p <- do.call(autoplot, c(list(object = gt),
                                     list(aes.args),
                                     args.non))
        }

    }
    if(type == "info"){
        colClasses <- function(x){
            sapply(info(x)@listData, class)
        }
        cls <- colClasses(object)
        idx.cls <- which(cls %in% c("numeric", "integer", "character", "factor"))
        temp <- granges(object)
        values(temp) <- info(object)
        df <- mold(temp)

        if(!"y" %in% names(args.aes)){
            hdr.i <- rownames(info(hdr))
            if(missing(assay.id)){
                if("AF" %in% hdr.i){
                    message("use AF for type info as default")
                    args.aes$y <- as.name("AF")
                }else{
                    nm <- hdr.i[idx[1]]
                    message("use ", nm, " for type info as default")
                    args.aes$y <- as.name(nm)
                }
            }else{
                if(is.numeric(assay.id))
                    assay.id <- hdr.i[assay.id]
                message("use ", assay.id, " for type info as default")
                args.aes$y <- as.name(assay.id)
            }
        }
        if(!"x" %in% names(args.aes)){
            args.aes$x <- as.name("start")
        }
        if(!"colour" %in% names(args.aes) && !"colour" %in% names(args.non) &&
           !"color" %in% names(args.aes) && !"color" %in% names(args.non) ){
            args.non$colour <- "black"
        }
        message("Other options for potential mapping(only keep numeric/integer/character/factor variable): ")

        p <- ggplot(data = df) + do.call(ggplot2::geom_bar, c(list(stat = "identity"),
                        list(do.call(aes, args.aes)),
                        args.non))
    }
    if(type == "fixed"){
        temp <- granges(object)
        fix <- fixed(object)
        fix <- fix[, !colnames(fix) %in% c("ALT", "REF")]
        values(temp) <- fix
        fix <- temp
        values(fix)$ALT <- as.character(unlist(alt(object)))
        values(fix)$REF <- as.character(ref(object))
        fix2 <- fix
        type2 <- vector("character", length  = length(fix))
        idx <- width(values(fix)$ALT) > 1
        type2[idx] <- "I"
        type2[!idx] <- as.character(values(fix[!idx])$ALT)
        values(fix)$type <- type2

        if(!"color" %in% names(args.non))
            isDNABaseColor <- TRUE
        else
            isDNABaseColor <- FALSE
        baseColor <- getOption("biovizBase")$DNABasesColor
        .i <- "black"
        names(.i) <- "I"
        baseColor <- c(baseColor, .i)
        ir <- IRanges(start = start(fix), width = width(values(fix)$ALT))
        if(!full.string)
            width(ir[idx,]) <- 1
        steps <- disjointBins(ir)
        values(fix)$stepping <- steps
        values(fix)$value <- values(fix)$ALT
        values(fix)$group <- "ALT"
        fix2 <- addStepping(fix2)
        idx <- width(values(fix2)$REF) > 1
        ir <- IRanges(start = start(fix), width = width(values(fix2)$REF))
        if(!full.string)
            width(ir[idx,]) <- 1
        steps <- disjointBins(ir)
        values(fix2)$stepping <- steps
        type2 <- vector("character", length  = length(fix2))
        type2[idx] <- "I"
        type2[!idx] <- as.character(values(fix[!idx])$REF)
        values(fix2)$type <- type2
        values(fix2)$value <- values(fix2)$REF
        values(fix2)$group <- "REF"
        .nms <- colnames(values(fix))
        fix <- c(fix, fix2[, .nms])
        if(ref.show){
            facet <- facet_grid(group ~ ., scales = "free_y")
        }else{
            fix <- fix[values(fix)$group == "ALT"]
            facet <- NULL
        }
        if(!full.string){
            ## only show SNP
            df <- mold(fix)
            p <- ggplot() + geom_text(data = df, ...,
                                      aes(x = start, label = type, color = type,
                                          y = stepping))
        }else{
            df <- mold(fix)
            df$type <- factor(df$type, levels = c(names(baseColor)))
            p <- ggplot() + geom_text(data = df, ...,
                                      aes(x = start, label = value, color = type,
                                          y = stepping))

        }
        p <- p + scale_color_manual(values = baseColor, guide="none") +
            scale_y_continuous(breaks=NULL, labels=NULL) + facet
    }
    if(missing(xlab))
        xlab <- ""
    p <- p + ggplot2::xlab(xlab)
    if(missing(ylab))
        ylab <- ""
    p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
})



colorizeArgs <- function(args.non, args.aes){
    if(!"colour" %in% names(args.aes) && !"colour" %in% names(args.non) &&
       !"color" %in% names(args.non) && !"color" %in% names(args.aes)){
        if("fill" %in% names(args.aes)){
            args.aes$color <- args.aes$fill
        }else if("fill" %in% names(args.non)){
            args.non$color <- args.non$fill
        }else{
            args.non$color <- "black"
        }
    }
    list(args.aes = args.aes, args.non = args.non)
}

setMethod("autoplot", "matrix", function(object, ...,
                                         xlab, ylab, main,
                                         geom = c("tile", "raster"),
                                         axis.text.angle = NULL,
                                         hjust = 0.5,
                                         na.value = NULL,
                                         rownames.label = TRUE,
                                         colnames.label = TRUE,
                                         axis.text.x = TRUE,
                                         axis.text.y = TRUE){


    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)

    if(!"x" %in% names(args.aes))
        args.aes$x <- as.name("x")

    if(!"y" %in% names(args.aes))
        args.aes$y <- as.name("y")

    if(!"fill" %in% names(args.aes))
        args.aes$fill <- as.name("value")

    if(!"width" %in% names(args.aes))
        args.aes$width <- 1

    if(!"height" %in% names(args.aes))
        args.aes$height <- 1

    ## args2 <- colorizeArgs(args.non, args.aes)
    ## args.aes <- args2$args.aes
    ## args.non <- args2$args.non
    aes.args <- do.call(aes, args.aes)
    max.c <- 10
    geom <- match.arg(geom)
    df <- mold(object)

    if(geom == "raster"){
        aes.args <- remove_args(aes.args, c("height", "width"))
        p <- ggplot(data = df) + do.call(geom_raster, c(args.non, list(aes.args)))
        p <- p + theme_noexpand()
        if("rownames" %in% colnames(df) && rownames.label){
            y.lab <- rownames(object)
            y <- seq_len(nrow(object))
            p <- p + scale_y_continuous(breaks = y, labels = y.lab, expand = c(0, 0))
        }
        if("colnames" %in% colnames(df) && colnames.label){
            x.lab <- colnames(object)
            if(max(sapply(x.lab, nchar))>max.c){
                if(is.null(axis.text.angle))
                    axis.text.angle <- -90
            }
            x <- seq_len(ncol(object))
            p <- p + scale_x_continuous(breaks = x, labels = x.lab, expand = c(0, 0))
        }

    }
    if(geom == "tile"){
        p <- ggplot(data = df) + do.call(geom_tile, c(args.non, list(aes.args)))
        p <- p + theme_noexpand()
        if("rownames" %in% colnames(df) && rownames.label){
            y.lab <- rownames(object)
            y <- seq_len(nrow(object))
            p <- p + scale_y_continuous(breaks = y, labels = y.lab, expand = c(0, 0))
        }
        if("colnames" %in% colnames(df) && colnames.label){
            x.lab <- colnames(object)
            if(max(sapply(x.lab, nchar))> max.c){
                if(is.null(axis.text.angle))
                    axis.text.angle <- -90
            }
            x <- seq_len(ncol(object))
            idx <- match(x, df$x)
            x <- eval_tidy(args.aes$x, df)[idx]
            x <- eval_tidy(args.aes$x, df)[idx]
            p <- p + scale_x_continuous(breaks = x, labels = x.lab, expand = c(0, 0))
        }
        p
    }
    if(!axis.text.x)
        p <- p + scale_x_continuous(breaks = NULL, labels = NULL, expand = c(0, 0))
    if(!axis.text.y)
        p <- p + scale_y_continuous(breaks = NULL, labels = NULL, expand = c(0, 0))
    if(missing(xlab))
        xlab <- ""
    p <- p + ggplot2::xlab(xlab)
    if(missing(ylab))
        ylab <- ""
    p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)
    if(is.null(axis.text.angle))
        axis.text.angle <- 0
    p <- p + theme(axis.text.x=element_text(angle = axis.text.angle, hjust = hjust))
    if(!is.null(na.value)){
        p <-  p + scale_fill_discrete(na.value = na.value)
    }
    p
})

setMethod("autoplot", "Views", function(object, ...,
                                        xlab, ylab, main,
                                        geom = c("raster", "tile", "line"),
                                        axis.text.angle = NULL,
                                        hjust = 0,
                                        na.value = NULL,
                                        facets = row ~ .){

    geom <- match.arg(geom)
    p <- switch(geom,
                raster = {
                    p <- ggplot(object, aes(group = row, x = x, y = y, fill = value)) +
                        geom_raster(...)
                    p <- p + theme_noexpand()
                    if(!is.null(names(object))){
                        y.lab <- names(object)
                        y <- seq_len(length(object))
                        p <- p + scale_y_continuous(breaks = y, labels = y.lab, expand = c(0, 0))
                    }
                    p
                },
                tile = {
                    p <- ggplot(object, aes(group = row, x = x, y = y, fill = value)) +
                        geom_tile(...)
                    p <- p + theme_noexpand()
                    if(!is.null(names(object))){
                        y.lab <- names(object)
                        y <- seq_len(length(object))
                        p <- p + scale_y_continuous(breaks = y, labels = y.lab, expand = c(0, 0))
                    }
                    p
                },
                line = {
                    p <- ggplot(object, aes(group = row, x = x, y = value)) +
                        geom_line(...)
                    if(!is.null(facets)){
                        p <- p + facet_grid(facets)
                        p <- p + theme_pack_panels()
                    }
                    p
                })
    if(missing(xlab))
        xlab <- ""
    p <- p + ggplot2::xlab(xlab)
    if(missing(ylab))
        ylab <- ""
    p <- p + ggplot2::ylab(ylab)
    if(!missing(main))
        p <- p + labs(title = main)
    if(is.null(axis.text.angle))
        axis.text.angle <- 0
    p <- p + theme(axis.text.x=element_text(angle = axis.text.angle, hjust = hjust))
    if(!is.null(na.value)){
        p <-  p + scale_fill_discrete(na.value = na.value)
    }

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
})


setMethod("autoplot", "Seqinfo", function(object, ideogram = FALSE, ... ){
    obj <- biovizBase:::.transformSeqinfo(object)
    p <- ggplot() + layout_karyogram(obj, geom = NULL)
    if(length(obj) == 1 && ideogram){
        p <- plotIdeogram(obj, as.character(seqnames(obj)), ...)
    }

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
})


## RangedSummarizedExperiment
setMethod("autoplot", "RangedSummarizedExperiment", function(object, ...,
                                                       type = c("heatmap", "link",
                                                           "pcp", "boxplot",
                                                           "scatterplot.matrix"),
                                                       pheno.plot = FALSE,
                                                       main_to_pheno = 4.5,
                                                       padding = 0.2,
                                                       assay.id = 1){

    type <- match.arg(type)
    ays <- assays(object)
    stopifnot(length(assay.id) == 1 || length(assay.id) <= length(ays))
    if(length(ays) > 1)
        message("Assay index: ", assay.id, " used")
    res <- ays[[assay.id]]
    if(type == "heatmap"){
        res <- ays[[assay.id]]
        if(!pheno.plot){
            colnames(res) <- colnames(object)
            p <- autoplot(res, ...) + ylab("Features") + xlab("Samples")
        }else{
            colnames(res) <- colnames(object)
            p <- autoplot(t(res), ...) + xlab("") + ylab("Samples")
            pd <- colData(object)
            s <- list(theme(axis.text.y = element_blank(),
                            axis.ticks.y = element_blank()) ,
                      theme(legend.position = "top",
                            plot.margin = ggplot2::margin(padding, 1, padding, 0.5, unit = "lines")),
                      guides(fill = guide_legend(byrow = FALSE, ncol =  1,
                                 title.theme = element_blank())))

            N <- ncol(pd)
            hts <- rep(1/N, N)
            hts <- c(hts, main_to_pheno)
            l <- lapply(1:N, function(i){
                autoplot(as.matrix(pd[, i, drop  = FALSE])) + s
            })
            ry <- c(rep(TRUE, N), FALSE)
            l <- c(l, list(p))
            return(grid::grid.draw(do.call(alignPlots, c(l, list(vertical = FALSE, remove.y.axis = ry,
                                                 widths = hts)))))
        }

    }
    if(type == "link"){
        ## res <- rowRanges(object)
        ## values(res) <- assay(object)
        ## plotRangesLinkedToData(res[seqnames(res) == "chr1"],
        ## stat.col = seq_len(length(values(res))))
        stop("not implemented yet")
    }
    if(type == "pcp"){
        df <- as.data.frame(res)
        p <- .ggpcp(df) + geom_line(...) + xlab("Sample Name")
    }
    if(type == "boxplot"){
        df <- as.data.frame(res)
        p <- .ggpcp(df, ...) + geom_boxplot(aes(group=variable))+ xlab("Sample Name")
    }
    if(type == "scatterplot.matrix"){
        stop("scatterplot.matrix is not supported yet")
    }

    if(!is(p, "GGbio"))
        p <- GGbio(p, data = object)

    p
})

setGeneric("stat_bin", function(data, ...) standardGeneric("stat_bin"))
setMethod("stat_bin", "ANY", function(data, ...){
  ggplot2::stat_bin(data = data, ...)
})


stat_bin_geom_bar <- function(args.aes, args.non) {
    args.non$stat <- "identity"
    aes.args <- do.call(aes, args.aes)
    p <- do.call(geom_bar, c(list(aes.args), args.non))
}

stat_bin_geom_heatmap <- function(args.aes, args.non, binwidth) {
    args.aes$xmin <- substitute(x - binwidth / 2, list(binwidth = binwidth))
    args.aes$xmax <- substitute(x + binwidth / 2, list(binwidth = binwidth))
    args.aes$ymin <- 0
    args.aes$ymax <- 5
    args.aes$color <- as.name("y")
    args.aes$fill <- as.name("y")
    args.aes <- args.aes[!names(args.aes) %in% c("x", "y")]
    aes.args <- do.call(aes, args.aes)
    p <- do.call(geom_rect, c(list(aes.args), args.non))
}

setMethod("stat_bin", "Rle", function(data, ..., binwidth, nbin = 30,
                                      xlab, ylab, main, geom = c("bar", "heatmap"),
                                      type = c("viewSums","viewMins",
                                        "viewMaxs", "viewMeans")){

  geom <- match.arg(geom)
  type <- match.arg(type)
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if(!"x" %in% names(args.aes))
    args.aes$x <- substitute(x)
  
  if(!"y" %in% names(args.aes))
    args.aes$y <- substitute(y)
  
  if(geom == "bar"){
    args.non$stat <- "identity"
  }
  if(missing(binwidth)){
    binwidth <- length(data)/nbin
    message("Default use binwidth: range/", nbin)
  }
  vs <- Views(data, start = seq(from = 1, to = length(data), by = binwidth),
              width = binwidth)
  x <- seq(from = 1, to = length(data), by = binwidth) + binwidth/2
  y <- switch(type, viewMaxs = viewMaxs(vs),
                      viewMins = viewMins(vs), 
                      viewSums =  viewSums(vs),
                      viewMeans = viewMeans(vs))
  args.non$data <- data.frame(x = x, y = y)
  if(geom == "bar")
    p <- stat_bin_geom_bar(args.aes, args.non)
  if(geom == "heatmap")
    p <- stat_bin_geom_heatmap(args.aes, args.non, binwidth)
  labels <- Labels(xlab, ylab, main, fallback = c(x = "x", y = "y"))
  p <- c(p, labels)
  p
})


setMethod("stat_bin", "RleList", function(data, ..., binwidth, nbin = 30,
                                      xlab, ylab, main,
                                      indName = "sample",
                                      geom = c("bar", "heatmap"),
                                      type = c("viewSums","viewMins",
                                        "viewMaxs", "viewMeans")){

  geom <- match.arg(geom)
  type <- match.arg(type)
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  if(!"x" %in% names(args.aes))
    args.aes$x <- substitute(x)
  
  if(!"y" %in% names(args.aes))
    args.aes$y <- substitute(y)
  
  if(geom == "bar"){
    args.non$stat <- "identity"
  }

  ## facets <- as.formula(paste(indName, "~ .", sep = ""))
  ## facet <- facet_grid(facets)
  
    mn <- mean(unlist(lapply(data, length)))
  if(missing(binwidth)){
      binwidth <- mn/nbin
      message("Default use binwidth: range/", nbin)
    }
  vs <- lapply(data, function(x) {
      Views(x, start = seq(from = 1, to = length(x), by = binwidth),
            width = binwidth)
  })
  x <- lapply(data, function(x) {
      seq(from = 1, to = length(x), by = binwidth) + binwidth/2
  })
  y <- switch(type, viewMaxs = lapply(vs, viewMaxs),
                    viewMins = lapply(vs, viewMins),
                    viewSums = lapply(vs, viewSums),
                    viewMeans = lapply(vs, viewMeans))
  if(is.null(names(x)))
      nms <- rep(1:length(x), times = elementNROWS(x))
  else
      nms <- rep(names(x), times = elementNROWS(x))
  df <- data.frame(x = unlist(x), y = unlist(y), listName = nms)
  colnames(df) <- c("x", "y", indName)
  if(is.null(names(x)))
    levels(df[, indName]) <- 1:length(x)
  else
    levels(df[, indName]) <- unique(names(x))

  facets <- as.formula(paste(indName, "~ .", sep = ""))

  args$row <- facets
  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
  facet <- do.call(facet_grid, args.facets)
  
  args.non$data <- df
  if(geom == "bar")
    p <- stat_bin_geom_bar(args.aes, args.non)
  if(geom == "heatmap")
    p <- stat_bin_geom_heatmap(args.aes, args.non, binwidth)
  labels <- Labels(xlab, ylab, main, fallback = c(x = "x", y = "y"))
  p <- c(p, labels)
  p <- c(list(p), list(facet))
  p <- setStat(p)
  p
})

## For transcripts support three mode?
setGeneric("geom_alignment", function(data, ...) standardGeneric("geom_alignment"))


## alignment should be convenient toggle with chevron...
setMethod("geom_alignment", "GRanges", function(data,...,
                                                xlab, ylab, main,
                                                facets = NULL,
                                                stat = c("stepping", "identity"),
                                                range.geom = c("rect", "arrowrect"),
                                                gap.geom = c("chevron", "arrow", "segment"),
                                                rect.height = NULL,
                                                group.selfish = TRUE){


    stat <- match.arg(stat)
    args <- list(...)
    args$facets <- facets
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    facet <- build_facet(data, args)
    args.non <- remove_args(args.non, c("facets"))

    es <- ifelse("extend.size" %in% names(args.non), args.non$extend.size, 0)

    if(is.null(rect.height)) rect.height <- 0.4
    args.non$rect.height <- rect.height
    range.geom <- match.arg(range.geom)
    gap.geom <- match.arg(gap.geom)

    main.fun <- switch(range.geom,
                       rect = geom_rect,
                       arrowrect = geom_arrowrect)

    gap.fun <- switch(gap.geom,
                      chevron = geom_chevron,
                      arrow = geom_arrow,
                      segment = geom_segment)

    if(length(data)){
        if(stat == "stepping"){
            args.aes <- remove_args(args.aes, c("xmin", "xmax", "ymin", "ymax", "data"))
            args.non <- remove_args(args.non, c("xmin", "xmin", "ymin", "ymax", "data"))
            grl <- splitByFacets(data, facets)
            res <- endoapply(grl, make_addStepping, args.aes, group.selfish, extend.size = es)
            res <- unlist(res)
            df <- mold(res)

            gpn <- ifelse("group" %in% names(args.aes), quo_name(args.aes$group), "stepping")

            args.aes <- remove_args(args.aes, "group")
            ## plot gaps

            gps <- getGaps(res, group.name = gpn, facets)
            if(length(gps)){
                gps <- keepSeqlevels(gps, names(seqlengths(res)))
                args.remove <- c("x", "y", "xend", "yend", "label.type", "label.size", "label.color", "size", "fill", "color", "colour")
                args.gaps <- remove_args(args.aes, args.remove)

                args.gaps.extra <- args.non[names(args.non) %in%
                                            c("offset", "chevron.height",
                                              "inherit.aes")]
                args.gaps$y <- as.name("stepping")
                aes.lst <- do.call("aes", args.gaps)
                gps.lst <- c(list(aes.lst), list(data = gps, stat = "identity"), args.gaps.extra)
                p <- list(do.call(gap.fun, gps.lst))
            }else{
                p <- NULL
            }
            ## plot main
            args.aes$y <- as.name("stepping")
            args.aes <- remove_args(args.aes, "size")
            args.non$stat = "identity"
            aes <- do.call(ggplot2::aes, args.aes)
            args.res <- c(list(data = res), list(aes),
                          args.non)

            p <- c(p, list(do.call(main.fun,args.res)))
            p <- .changeStrandColor(p, args.aes)
            .df.sub <- group_df(df, gpn)
            y_scale <- scale_y_continuous_by_group(.df.sub, gpn, group.selfish)
            p <- c(p, y_scale)
        }

        if(stat == "identity"){
            stop("stat identity is nor supported for geom alignment")
        }}else{
            p <- NULL
        }
    p <- c(list(p), list(facet))
    labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = ""))
    p <- c(p, labels)
    p
})




setMethod("geom_alignment", "TxDbOREnsDb",
          function(data, ..., which,
                   columns = c("tx_id", "tx_name", "gene_id"),
                   names.expr = "tx_name",
                   facets = NULL, truncate.gaps = FALSE,
                   truncate.fun = NULL, ratio = 0.0025){

    args <- list(...)
    ## args$facets <- facets
    args$names.expr <- names.expr
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    aes.args <- do.call(aes, args.aes)

    if(is(data, "EnsDb")){
        columns <- sub(columns, pattern="tx_name",
                       replacement="gene_name", fixed=TRUE)
    }

    if(missing(which)){
        ## stop("missing which is not supported yet")
        p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
               list(ggplot2::xlim(c(0, 1))))
        return(p)
    }


    gr <- crunch(data, which, truncate.gaps = truncate.gaps,
                 truncate.fun = truncate.fun, ratio = ratio,
                 columns = columns)

    grl <- split(gr, gr$tx_id)

    ## getting label
    df <- mold(gr)
    .df.sub <- do.call(rbind, lapply(grl, function(g){
        ## FIXME: check if the id is unique
        mold(g)[1, columns]
    }))
    rownames(.df.sub) <- NULL

    if(is.expression(names.expr)){
        .labels <- eval(names.expr, .df.sub)
    }else if(is.character(names.expr)){

        if(length(names.expr) == nrow(.df.sub) &&
           !(names.expr %in% colnames(.df.sub))){
            .labels <- names.expr
        }else{
            .labels <- sub_names(.df.sub, names.expr)
        }
    }else{
        .labels <- sub_names(.df.sub, names.expr)
    }

    names(grl) <- .labels

    p <- do.call(geom_alignment, c(list(data = grl),
                                   args.non,
                                 list(aes.args)))

    ## if(is_coord_truncate_gaps(gr)){
    ##     gr <- gr[values(gr)$type %in% c("utr", "cds")]
    ##     ss <- getXScale(gr)
    ##     p <- c(p, list(scale_x_continuous(breaks = ss$breaks,
    ##                                       labels = ss$labels)))
    ## }else{
    ##     if(is.null(.xlim)){
    ##         if(length(which) && is(which, "GRagnes")){
    ##             .xlim <- c(start(range(which, ignore.strand = TRUE)),
    ##                        end(range(which, ignore.strand = TRUE)))
    ##             p <- c(p, list(scale_by_xlim(.xlim)))
    ##         }
    ##     }else{
    ##         p <- c(p, list(scale_by_xlim(.xlim)))
    ##     }
    ##     if(missing(xlim)){
    ##         xlim <- .xlim
    ##     }
    ##     p <- c(p, list(coord_cartesian(xlim = xlim)))
    ## }
    ## p <- setStat(p)
    p
})

## setMethod("geom_alignment", "TxDb",
##           function(data, ..., which,
##                    columns = c("tx_id", "tx_name", "gene_id"),
##                    names.expr = "tx_name",
##                    facets = NULL, truncate.gaps = FALSE,
##                    truncate.fun = NULL, ratio = 0.0025){

##     args <- list(...)
##     ## args$facets <- facets
##     args.aes <- parseArgsForAes(args)
##     args.non <- parseArgsForNonAes(args)
##     aes.args <- do.call(aes, args.aes)

##     if(missing(which)){
##         ## stop("missing which is not supported yet")
##         p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
##                list(ggplot2::xlim(c(0, 1))))
##         return(p)
##     }


##     gr <- crunch(data, which, truncate.gaps = truncate.gaps,
##                  truncate.fun = truncate.fun, ratio = ratio,
##                  columns = columns)

##     grl <- split(gr, gr$tx_id)

##     ## getting label
##     df <- mold(gr)
##     .df.sub <- do.call(rbind, lapply(grl, function(g){
##         ## FIXME: check if the id is unique
##         mold(g)[1, columns]
##     }))
##     rownames(.df.sub) <- NULL

##     if(is.expression(names.expr)){
##         .labels <- eval(names.expr, .df.sub)
##     }else if(is.character(names.expr)){

##         if(length(names.expr) == nrow(.df.sub) &&
##            !(names.expr %in% colnames(.df.sub))){
##             .labels <- names.expr
##         }else{
##             .labels <- sub_names(.df.sub, names.expr)
##         }
##     }else{
##         .labels <- sub_names(.df.sub, names.expr)
##     }

##     names(grl) <- .labels

##     p <- do.call(geom_alignment, c(list(data = grl),
##                                    args.non,
##                                  list(aes.args)))

##     ## if(is_coord_truncate_gaps(gr)){
##     ##     gr <- gr[values(gr)$type %in% c("utr", "cds")]
##     ##     ss <- getXScale(gr)
##     ##     p <- c(p, list(scale_x_continuous(breaks = ss$breaks,
##     ##                                       labels = ss$labels)))
##     ## }else{
##     ##     if(is.null(.xlim)){
##     ##         if(length(which) && is(which, "GRagnes")){
##     ##             .xlim <- c(start(range(which, ignore.strand = TRUE)),
##     ##                        end(range(which, ignore.strand = TRUE)))
##     ##             p <- c(p, list(scale_by_xlim(.xlim)))
##     ##         }
##     ##     }else{
##     ##         p <- c(p, list(scale_by_xlim(.xlim)))
##     ##     }
##     ##     if(missing(xlim)){
##     ##         xlim <- .xlim
##     ##     }
##     ##     p <- c(p, list(coord_cartesian(xlim = xlim)))
##     ## }
##     ## p <- setStat(p)
##     p
## })


setMethod("geom_alignment", "OrganismDb",
          function(data, ..., which,
                   columns = c("TXNAME", "SYMBOL", "TXID", "GENEID"),
                   names.expr = "SYMBOL",
                   facets = NULL,
                   truncate.gaps = FALSE,
                   truncate.fun = NULL, ratio = 0.0025
                   ){


    .cols <- c("TXNAME", "SYMBOL", "TXID", "GENEID")
    columns <- unique(c(.cols, columns))
    args <- list(...)
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    aes.args <- do.call(aes, args.aes)

    if(missing(which)){
        p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
               list(ggplot2::xlim(c(0, 1))))
        return(p)
    }else{
        which <- range(which, ignore.strand = TRUE)
    }

    txdb <- OrganismDbi::getTxDbIfAvailable(data)

    gr <- crunch(txdb, which, truncate.gaps = truncate.gaps,
                     truncate.fun = truncate.fun, ratio = ratio,
                 columns = c("tx_id", "tx_name", "gene_id"))


    grl <- split(gr, gr$tx_id)

    ks <- names(grl)

    lbs <- select(data, ks, columns, "TXID")


    ## getting label
    df <- mold(gr)
    values(gr) <- cbind(values(gr), lbs[match(gr$tx_id, lbs$TXID), ])
    grl <- split(gr, gr$tx_id)

    .df.sub <- do.call(rbind, lapply(grl, function(g){
        ## FIXME: check if the id is unique
        mold(g)[1, c("tx_id", "tx_name", "gene_id")]
    }))
    rownames(.df.sub) <- NULL
    .df.new <- lbs[match(.df.sub$tx_id, lbs$TXID), ]
    .df.sub <- cbind(.df.sub, .df.new)

    if(is.expression(names.expr)){
        .labels <- eval(names.expr, .df.sub)
    }else if(is.character(names.expr)){

        if(length(names.expr) == nrow(.df.sub) &&
           !(names.expr %in% colnames(.df.sub))){
            .labels <- names.expr
        }else{
            .labels <- sub_names(.df.sub, names.expr)
        }
    }else{
        .labels <- sub_names(.df.sub, names.expr)
    }

    names(grl) <- .labels
    p <- do.call(geom_alignment, c(list(data = grl,
                                        names.expr = names.expr),
                                   args.non,
                                 list(aes.args)))

})


.transformTextToSpace <- function(x = character(), limits = NULL,
                                  fixed = 80, size = 1 ){
    if(!length(limits))
        stop("pleast provide your limits of current viewed coordinate")
    nchar(x) * size / fixed * diff(limits)
}


## For bam file show individual aligments

setMethod("geom_alignment", "BamFile", function(data,..., which,
                                                what = c("rname", "strand", "pos", "qwidth", "seq"),
                                                xlab, ylab, main,
                                                facets = NULL){
    bi <- biovizBase:::scanBamGRanges(fl, which = which, what = what)
    bt <- biovizBase::addStepping(bt)
    names(bt) <- NULL

    d <- as.data.frame(bt)

    qplot(x = start, y = stepping, label = df, geom = "text", data = d)

})

setMethod("geom_alignment", "GRangesList", function(data, ..., which = NULL,
                                                    cds.rect.h = 0.25,
                                                    exon.rect.h = cds.rect.h,
                                                    utr.rect.h = cds.rect.h/2,
                                                    xlab, ylab, main,
                                                    facets = NULL,
                                                    geom = "alignment",
                                                    stat = c("identity", "reduce"),
                                                    range.geom = "rect",
                                                    gap.geom = "arrow",
                                                    utr.geom = "rect",
                                                    names.expr = NULL,
                                                    label = TRUE,
                                                    label.color = "gray40",
                                                    label.size = 3,
                                                    arrow.rate = 0.015,
                                                    length = unit(0.1, "cm")){



    stat <- match.arg(stat)
    gap.fun <- getGeomFun(gap.geom)
    range.fun <- getGeomFun(range.geom)
    utr.fun <- getGeomFun(utr.geom)


    args <- list(...)
    ## args$facets <- facets
    args.aes <- parseArgsForAes(args)
    args.non <- parseArgsForNonAes(args)
    ## args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
    ## facet <- .buildFacetsFromArgs(data, args.facets)

    .type <- if("type" %in% names(args.aes)) quo_name(args.aes$type) else NULL

    if(!isGenemodel(data, type = .type)){
        gr <- flatGrl(data)
        if(!"group" %in% names(args.aes))
            args.aes$group <- as.name("grl_name")
        if("type" %in% names(args.aes)){
            args.aes <- remove_args(args.aes, "type")
        }
        aes.res <- do.call(aes, args.aes)

        p <- do.call(geom_alignment, c(list(data = gr),
                                   args.non,
                                 list(aes.res)))
        return(p)

    }

    message("Constructing graphics...")
    .xlim <- NULL
    if(length(which) && is(which, "GRanges")){
        which <- range(which, ignore.strand = TRUE)
        data <- subsetByOverlaps(data, which)
    }

    mids <- unlist(lapply(data, function(g){
        r <- range(g, ignore.strand = TRUE)
        start(r) + width(r)/2
    }))

    gr <- stack(data, "..sample..")
    values(gr)$..inner.. <- rep(1:length(data), times = elementNROWS(data))


    if("type" %in% names(args.aes)){
        .type <- quo_name(args.aes$type)
        args.aes <- remove_args(args.aes, "type")
    }else{
        .type <- "type"
    }

    if(length(gr)){

        if(length(which) && is(which, "GRanges")){
            .xlim <- c(min(start(which)), max(end(which)))
        }else{
            .xlim <- c(min(start(gr)), max(end(gr)))
        }
        ## adding buffer between features to avoid overlap
        if("extend.size" %in% names(args.non)){
            es <- args.non$extend.size
        }else{
            es <- diff(.xlim)/1000 * 20
        }
        if(geom == "alignment" && stat == "reduce"){
            .gr.ori <- gr
            .gr <- addStepping(gr, group.name = "..inner..", group.selfish = FALSE, extend.size = es)
            message("reduce alignemnts...")
            ## compute labels
            gr <- stack(endoapply(split(gr, values(gr)[[.type]]), function(g){
                res <- reduce(g, ignore.strand = TRUE)
            }), .type)
            gr$stepping <- .lvs <- 1
        }else{
            gr <- addStepping(gr, group.name = "..inner..", group.selfish = FALSE, extend.size = es)
        }


        df <- mold(gr)


        if(label){
            if(stat == "reduce"){
                ## only transcripts with symbol or geneid
                cnms <- colnames(values(.gr.ori))
                idx <- cnms %in% c("SYMBOL", "GENEID", "gene_id")
                if(sum(idx)){
                    .df.sub <- do.call(rbind,
                                       lapply(split(.gr.ori,
                                                    values(.gr.ori)[,which(idx)[1]]),
                           function(g){
                               if (length(g) == 0L)
                                   return(NULL)
                               r <- range(g, ignore.strand = TRUE)
                               mid <- start(r) + width(r)/2
                               d <- values(g)[1, idx, drop = FALSE]
                               d$midpoint <- mid
                               d$stepping <- 1
                               d
                           }))
                    .df.sub <- as.data.frame(.df.sub)
                    if(length(names.expr)){
                        .labels <- ggbio:::sub_names(.df.sub, names.expr)
                        .df.sub$.labels <- .labels
                    }else{
                        label <- FALSE
                    }
                }else{
                    label <- FALSE
                }

            }else{
             column <- c("tx_id", "stepping", "..sample..", "..inner..")
             idx <- column %in% colnames(df)
             if(sum(idx)){
                 column <- column[idx]
             names.expr <- "..sample.."
            .df.sub <- df[, column]
            .df.sub <- .df.sub[!duplicated(.df.sub$..inner..),]
            .df.sub$midpoint <- mids[.df.sub$..inner..]
             .labels <- ggbio:::sub_names(.df.sub, names.expr)
             .lvs <- max(.df.sub$stepping)
            .df.lvs <- unique(df$stepping)
            .df.sub$.labels <- .labels
         }else{
             label <- FALSE
         }

         }
        }
        ## cds
        gr.cds <- gr[values(gr)[[.type]] %in% c("cds", "CDS")]
        ## exons
        gr.exons <- gr[values(gr)[[.type]] %in% c("exon", "EXON")]
        args.cds.non <- args.non
        args.cds.non$rect.height <- cds.rect.h
        args.exon.non <- args.cds.non
        args.exon.non$rect.height <- exon.rect.h
        args.exon <- remove_args(args.aes, "y")
        args.exon$y <- as.name("stepping")
        aes.res <- do.call(aes, args.exon)
        p <- NULL
        if (length(gr.cds) > 0L) {
            ## plot cds
            args.cds.res <- c(list(data = gr.cds),
                              list(aes.res),
                              args.cds.non,
                              list(stat = "identity"))
            p <- do.call(range.fun, args.cds.res)
        }
        if (length(gr.exons) > 0L) {
            ## plot exons
            ## input gr.exons
            args.exon.res <- c(list(data = gr.exons),
                               list(aes.res),
                               args.exon.non,
                               list(stat = "identity"))
            p <- c(p, list(do.call(range.fun, args.exon.res)))
        }
        ## utrs
        gr.utr <- gr[values(gr)[[.type]] == "utr"]
        args.utr <- remove_args(args.aes, "y")
        args.utr$y <- as.name("stepping")
        aes.res <- do.call(aes, args.utr)
        args.utr.non <- args.cds.non
        args.utr.non$rect.height <- utr.rect.h

        if(range.geom == "arrowrect" && utr.geom == range.geom){
            if(!"arrow.head" %in% names(args.utr.non)){
                args.utr.non$arrow.head <- 0.06
            }
            arrow.head.fix <- getArrowLen(gr.cds, arrow.head.rate = args.non$arrow.head)
            args.utr.non <- remove_args(args.non, "arrow.rate")
            args.utr.non$arrow.head.fix <- arrow.head.fix
        }

        if(length(gr.utr)){
            args.utr.res <- c(list(data = gr.utr),
                              list(aes.res),
                              args.utr.non,
                              list(stat = "identity"))
            p <- c(p, list(do.call(utr.fun, args.utr.res)))
        }
        if(stat == "reduce"){
            .grl <- endoapply(data, function(g){
                range(g, ignore.strand = TRUE)
            })
            grr <- reduce(unlist(.grl))
            .gr$..sample.. <- rep(subjectHits(findOverlaps(.grl, grr)),
                                  times = elementNROWS(data))
            exonic <- .gr[values(.gr)[[.type]] %in% c("utr", "cds", "exon")]
            df.gaps <- getGaps(exonic, group.name = "..sample..")
            df.gaps$stepping <- 1
            ## let's figure out strand
            stds <- unique(as.character(strand(.gr)))
            strand(df.gaps) <- ifelse(length(stds) == 1, stds, "*")
            ## FIXME: fix reduced strand
          } else {
            exonic <- gr[values(gr)[[.type]] %in% c("utr", "cds", "exon")]
            df.gaps <- getGaps(exonic, group.name = "..inner..")
          }

        args.aes.gaps <- remove_args(args.aes, c("x", "y", "fill"))
        aes.res <- do.call(aes, args.aes.gaps)

        if(!"arrow.rate" %in%  names(args.non)){
            if(!is.list(which)){
                arrow.rate <- 0.018 * diff(.xlim)/
                    (end(range(ranges(df.gaps))) - start(range(ranges(df.gaps))))
                args.non$arrow.rate <- arrow.rate
            }
        }

        aes.res$y <- as.name("stepping")
        args.non.arrow <- args.non
        args.non.arrow$length <- length
        args.gaps.res <- c(list(data = df.gaps),
                           list(aes.res),
                           args.non.arrow,
                           list(stat = "identity"))
        if(length(df.gaps)){
            p <- c(p , list(do.call(gap.fun, args.gaps.res)))
        }
        if(label){
            aes.label <- do.call(aes, list(label = substitute(.labels),
                                           x = substitute(midpoint),
                                           y = substitute(stepping +
                                               cds.rect.h*1.2)))

            args.label.res <- remove_args(args.non, c("arrow.rate", "fill"))
            args.label.res$size <- label.size
            args.label.lst <- list(data = .df.sub,
                                   vjust = 0,
                                   aes.label,
                                   color = label.color,
                                   inherit.aes = FALSE)
            args.label.res[names(args.label.lst)] <- args.label.lst
            p <- c(p , list(do.call(geom_text, args.label.res)))
            ggplot() + p
        }
        p <- c(p , list(scale_y_continuous(breaks = NULL)))

    }else{
        p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
               list(ggplot2::xlim(c(0, 1))))
    }

    labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = ""))
    p <- c(p, labels)
##    p <- setStat(p)
    return(p)
})

setGeneric("isGenemodel", function(data, ...) standardGeneirc("isGenemodel"))
setMethod("isGenemodel", "GRanges", function(data, type = NULL){

    if(is.null(type))
        type <- "type"
    if(type %in% colnames(values(data))){
        geneFeatureTerms <- c("cds", "exon", "utr", "gap")
        idx <- tolower(values(data)[[type]]) %in% geneFeatureTerms
        if (any(!idx)) {
          message(paste0('\"', unique(values(data)[[type]][!idx]), '\"',
                         collapse=", "),
                  " not in any of the valid gene feature terms ",
                  paste0('\"', geneFeatureTerms, '\"', collapse=", "))
        }
        return(any(idx))
    }else{
        return(FALSE)
    }

})

setMethod("isGenemodel", "GRangesList", function(data, type = NULL){
    data <- stack(data)
    isGenemodel(data, type = type)
})

setMethod("isGenemodel", "ANY", function(data, type = NULL){
    return(FALSE)
})


## ####============================================================
## ##  geom_alignment method from ggbio, R/geom_alignment-method.R
## ##
## ####------------------------------------------------------------
## setMethod("geom_alignment", "EnsDb",
##           function(data, ..., which,
##                    columns = c("tx_id", "gene_name", "gene_id"),
##                    names.expr = "tx_id",
##                    facets = NULL, truncate.gaps = FALSE,
##                    truncate.fun = NULL, ratio = 0.0025){

##               args <- list(...)
##               ## args$facets <- facets
##               args.aes <- parseArgsForAes(args)
##               args.non <- parseArgsForNonAes(args)
##               aes.args <- do.call(aes, args.aes)

##               if(missing(which)){
##                   ## stop("missing which is not supported yet")
##                   p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
##                          list(ggplot2::xlim(c(0, 1))))
##                   return(p)
##               }

##               ## The crunch method for EnsDb ensures that tx_id is provided.
##               gr <- crunch(data, which, truncate.gaps = truncate.gaps,
##                            truncate.fun = truncate.fun, ratio = ratio,
##                            columns = columns)

##               grl <- split(gr, gr$tx_id)

##               ## getting label
##               df <- mold(gr)
##               .df.sub <- do.call(rbind, lapply(grl, function(g){
##                   ## FIXME: check if the id is unique
##                   mold(g)[1, columns]
##               }))
##               rownames(.df.sub) <- NULL

##               if(is.expression(names.expr)){
##                   .labels <- eval(names.expr, .df.sub)
##               }else if(is.character(names.expr)){

##                   if(length(names.expr) == nrow(.df.sub) &&
##                      !(names.expr %in% colnames(.df.sub))){
##                       .labels <- names.expr
##                   }else{
##                       .labels <- sub_names(.df.sub, names.expr)
##                   }
##               }else{
##                   .labels <- sub_names(.df.sub, names.expr)
##               }

##               names(grl) <- .labels

##               p <- do.call(geom_alignment, c(list(data = grl),
##                                              args.non,
##                                              list(aes.args)))
##               p
##           })

setGeneric("getLimits", function(obj, ...) standardGeneric("getLimits"))

setMethod("getLimits", "GGbio", function(obj) {
    .getLimits(obj@ggplot)
})

setMethod("getLimits", "ggplotPlot", function(obj) {
    .getLimits(obj)
})

setMethod("getLimits", "ggbioPlot", function(obj) {
    .getLimits(obj@ggplot)
})

# SPECIAL operator to get values from the list(b) and
# assign those values to variables(created from (a) in the
# calling environment)
"%<->%" <- function(a, b) {
    lapply(seq_len(length(a)), function(x) {
              assign(a[x], b[[x]], envir = parent.frame(3))
    })
    invisible(b)
}

.getLimits <- function(obj) {
    x <- y <- xmin <- ymin <- xmax <- ymax <- xend <- yend <- NULL
    names <- c("x", "y", "xmin", "ymin", "xmax", "ymax", "xend", "yend")
    mapped_list <- lapply(names ,function(x) {
        if (!is.null(obj$mapping[[x]]) && length(obj$data))
            eval_tidy(obj$mapping[[x]], obj$data)
    })
    # assign values of mapped_list to x,y,xmin etc
    names %<->% mapped_list

    # get limits from layer
    layer <- suppressWarnings(getLimitsFromLayer(obj))

    xlim <- suppressWarnings(c(min(c(layer$xmin, x, xmin), na.rm = TRUE),
                               max(c(layer$xmax,x, xmax, xend), na.rm = TRUE)))
    ylim <- suppressWarnings(c(min(c(layer$ymin, y, ymin), na.rm = TRUE),
                               max(c(layer$ymax, y, ymax, yend), na.rm = TRUE)))

    res <- list(xlim = xlim, ylim = ylim)

    if (any(unlist(res) %in% c(Inf, -Inf)))
        res <- evalLan(obj)

    if (length(obj$coordinates$limits$x) == 2)
        res$xlim <- obj$coordinates$limits$x

    if (length(obj$coordinates$limits$y) == 2)
        res$ylim <- obj$coordinates$limits$y

    scales <- suppressWarnings(getLimitsFromScales(obj))
    scales <- as.list(scales)
    scales <- lapply(scales, function(x) {
                        if (x %in% c(-Inf, Inf)) {
                            NULL
                        } else {
                            x
                        }
                    })
    if (!is.null(scales$xmin) & !is.null(scales$xmax))
        res$xlim <- c(scales$xmin, scales$xmax)
    if (!is.null(scales$ymin) & !is.null(scales$ymax))
        res$ylim <- c(scales$ymin, scales$ymax)
    res
}

getLimitsFromScales <- function(obj) {
    scal <- obj$scales$scales
    lst <- lapply(scal, function(x) {
      x <- scal[[1]]
      if (!is.null(x$limits)) {
          limits <- x$limits
          res <- NULL
          if (any(x$aesthetics %in% c("x", "xmin", "xmax", "xend", "xintercept",
                                      "xmin_final", "xmax_final"))) {
              res <- data.frame(xmin = limits[1], xmax = limits[2],
                                ymin = NA, ymax = NA)
          }
          if (any(x$aesthetics %in% c("y", "ymin", "ymax", "yend", "yintercept",
                                      "ymin_final", "ymax_final"))) {
              res <- data.frame(ymin = limits[1], ymax = limits[2],
                                xmin = NA, xmax = NA)
          }
      } else {
          res <- NULL
      }
      res
    })
    lst <- lst[!is.null(lst)]
    res <- do.call("rbind", lst)
    res <- data.frame(xmin = min(res$xmin, na.rm = TRUE),
                      xmax = max(res$xmax, na.rm = TRUE),
                      ymin = min(res$ymin, na.rm = TRUE),
                      ymax = max(res$ymax, na.rm = TRUE))
    res
}

getLimitsFromLayer <- function(obj) {
    layers <- obj$layers
    lst <- lapply(layers, function(layer) {
        if (length(obj$data) | length(layer$data)) {
            if(length(layer$data))
                dt <- layer$data
            else
                dt <- obj$data

            if (!is.null(layer$mapping)) {
                x <- y <- xmin <- ymin <- xmax <- ymax <- xend <- yend <- NULL
                names <- c("x", "y", "xmin", "ymin", "xmax", "ymax", "xend", "yend")
                mapped_list <- lapply(names ,function(x) {
                    if (!is.null(layer$mapping[[x]]))
                        eval_tidy(layer$mapping[[x]], dt)
                })
                 # assign values of mapped_list to x,y,xmin etc
                names %<->% mapped_list

                res <- data.frame(xmin = min(c(x, xmin), na.rm = TRUE),
                                  xmax = max(c(x, xmax, xend), na.rm = TRUE),
                                  ymin = min(c(y, ymin), na.rm = TRUE),
                                  ymax = max(c(y, ymax, yend), na.rm = TRUE))
            } else {
                res <- NULL
            }
      } else {
          res <- NULL
      }
    })
    lst <- lst[!is.null(lst)]
    res <- do.call("rbind", lst)
    res
}

evalLan <- function(obj) {
    x <- obj$mapping$x
    y <- obj$mapping$y
    xlim <- ylim <- NULL
    if (is_quosure(x) & is_quosure(y)) {
        xlim <- range(eval_tidy(x))
        ylim <- range(eval_tidy(y))
    }
    list(xlim = xlim, ylim = ylim)
}

getGeomFun <- function(geom) {
    match.fun(paste("geom_", geom, sep = ""))
}
getStatFun <- function(stat) {
    match.fun(paste("stat_", stat, sep = ""))
}
getDrawFunFromGeomStat <- function(geom, stat) {
    ## how about allways start from geom??
    if (!is.null(stat)) {
      .fun <- getStatFun(stat)
    } else {
      .fun <- getGeomFun(geom)
    }
    .fun
}

.changeStrandColor <- function(p, args, fill = TRUE) {
    strandColor <- getOption("biovizBase")$strandColor
    isStrand.color <- FALSE
    isStrand.fill <- FALSE
    ## default with no color
    idx <- c("color", "colour") %in% names(args)
    if ((any(idx))) {
        nms <- c("color", "colour")[idx][1]
        if (quo_name(args[[nms]]) == "strand")
            isStrand.color <- TRUE
    }
    if (("fill" %in% names(args))) {
        if (quo_name(args$fill) == "strand")
            isStrand.fill <- TRUE
    }
    if (isStrand.color)
        p <- c(list(p), list(scale_color_manual(values = strandColor)))
    if (fill) {
        if (isStrand.fill)
            p <- c(p, list(scale_fill_manual(values = strandColor)))
    }
    p
}

## need to consider a length 1 facets formula
.buildFacetsFromArgs <- function(object, args) {
    isOneSeq <- length(unique(as.character(seqnames(object)))) == 1
    args.facets <- args
    args.facets$facets <- strip_formula_dots(args$facets)
    facets <- args.facets$facets
    facet.logic <- NULL

    if (length(facets)) {
        biovizBase:::.checkFacetsRestrict(facets, object)
        if (is(facets, "GRanges")) {
            args.facets$facets <- substitute(~.bioviz.facetid)
            if (!("scales" %in% names(args.facets)))
                args.facets$scales <- "free"
        } else {
            if (!("scales" %in% names(args.facets)))
                args.facets <- c(args.facets, list(scales = "fixed"))
            allvars <- all.vars(as.formula(args.facets$facets))
        }
    } else {
        if (!("scales" %in% names(args.facets)))
            args.facets <- c(args.facets, list(scales = "fixed"))
        args.facets$facets <- substitute(~seqnames)
        allvars <- all.vars(as.formula(args.facets$facets))
    }

    if (isOneSeq & biovizBase:::isFacetByOnlySeq(args.facets$facets)) {
        facet <- NULL
        return(facet)
    }

    facet.logic <- ifelse(any(c("nrow", "ncol") %in% names(args.facets)),
                          TRUE, FALSE)

    if (facet.logic)
        facet <- do.call(facet_wrap, args.facets)
    else {
        names(args.facets) <- ifelse(names(args.facets) == "facets", "rows",
                                     names(args.facets))
        facet <- do.call(facet_grid, args.facets)
    }
    facet
}

sub_names <- function(data, name.expr) {
    .res <- c()
    for (i in seq_len(nrow(data))) {
      res <- data[i,]
      res <- as.list(res)
      res <- lapply(res, function(x) {
        if (is.numeric(x))
            return(as.character(as.name(x)))
        else
            return(as.character(x))
      })
      subfun <- function(res, name.expr) {
          nm <- names(res[1])
          val <- res[[1]]
          name.expr <- gsub(nm, val, name.expr)
          if (!length(res) == 1)
            subfun(res[-1], name.expr)
          else
            return(name.expr)
      }
      .res <- c(.res, subfun(res, name.expr))
    }
    .res
}

setGeneric("subsetByChrs", function(obj, ...) starndardGeneric("subByChr"))

setMethod("subsetByChrs", "GRanges", function(obj, subchr) {
    if (missing(subchr))
        subchr <- as.character(seqnames(obj)[1])
    res <- obj[seqnames(obj) %in% subchr]
    res <- keepSeqlevels(res, subchr)
    res
})

setMethod("subsetByChrs", "Seqinfo", function(obj, subchr){
  if (missing(subchr))
      subchr <- as.character(seqnames(obj)[1])
  res <- obj[subchr]
  res
})

ggsave <- function (filename, plot = last_plot(),
                    device = NULL, path = NULL, scale = 1,
                    width = NA, height = NA, units = c("in", "cm", "mm"),
                    dpi = 300, limitsize = TRUE, ...) {
    # take backup of original plot
    original_last_plot <- plot

    if (!is(plot, "ggplot") && !is(plot, "Tracks"))
        stop("plot should be a ggplot2 plot or tracks object")

    # for compatibility with ggplot2::ggsave convert derivative plot to grob
    if (is(plot, "Tracks"))
        plot <- as(plot, "grob")

    tryCatch(
        {
            ggplot2::ggsave(filename, plot, device, path, scale, width,
                            height, units, dpi, limitsize, ...)
        },
        finally = {
            # this ensures last plot point to correct plot
            # even if ggplot2::ggsave fails during run-time
            ggplot2::set_last_plot(original_last_plot)
        }
    )
}

## combineAes(keep, lost)
combineAes <- function(keep, lose) {
    keep.nms <- names(keep)
    lose.nms <- names(lose)

    nms <- intersect(lose.nms, keep.nms)

    if (length(nms))
        return(c(keep, lose[setdiff(lose.nms, keep.nms)]))
    else
        return(c(keep, lose))
}

zoomLevelToGeom <- function(zoomLevel, track = c("BSgenome", "VRanges")) {
    track <- match.arg(track)
    .level1 <- 100 # text
    .level2 <- 500 # rect
    .level3 <- 2000 # segment
    geom <- switch(track,
                   "BSgenome" = {
                       if (zoomLevel < .level1) {
                           g <- "text"
                       } else if (zoomLevel >= .level1 && zoomLevel < .level2) {
                           g <- "rect"
                       } else if (zoomLevel >= .level2 && zoomLevel < .level3) {
                           g <- "segment"
                       } else {
                           g <- "none"
                       }
                   },
                   "VRanges" = {
                       if (zoomLevel < .level1) {
                           g <- "text"
                       } else if (zoomLevel >= .level1 && zoomLevel < .level3) {
                           g <- "rect"
                       } else {
                           g <- "none"
                       }
                   })
    geom
}

by2 <- function(...) {
    ans <- by(...)
    class(ans) <- "list"
    ans
}

# returns NULL_OR_list
# if x, y and main are missing then NULL will be returned.
Labels <- function(x, y, main, fallback) {
    labels <- c()
    xflag <- yflag <- mainflag <- FALSE
    if (!missing(fallback)) {
        if ("x" %in% names(fallback) && missing(x)) {
            xflag <- TRUE
            x <- fallback[["x"]]
        }
        if ("y" %in% names(fallback) && missing(y)) {
            yflag <- TRUE
            y <- fallback[["y"]]
        }
        if ("main" %in% names(fallback) && missing(main)) {
            mainflag <- TRUE
            main <- fallback[["main"]]
        }
    }

    # When flag is TRUE, label must be created
    if (!missing(x) || xflag) {
        stopifnot(is.character(x))
        labels <- c(labels, list(xlab(x)))
    }
    if (!missing(y) || yflag) {
        stopifnot(is.character(y))
        labels <- c(labels, list(ylab(y)))
    }
    if (!missing(main) || mainflag) {
        stopifnot(is.character(main))
        labels <- c(labels, list(labs(title = main)))
    }
    return(labels)
}

remove_args <- function(args, remove) {
    args[!names(args) %in% remove]
}

build_facet <- function(data, args) {
    args <- subsetArgsByFormals(args, facet_grid, facet_wrap)
    .buildFacetsFromArgs(data, args)
}

make_addStepping <- function(gr, args, group.selfish, ...) {
    if("group" %in% names(args)) {
        addStepping(gr, group.name = quo_name(args$group),
                    group.selfish = group.selfish, ...)
    } else {
        addStepping(gr, ...)
    }
}

group_df <- function(df, group) {
    .df.sub <- df[, c("stepping", group)]
    .df.sub <- .df.sub[!duplicated(.df.sub$stepping),]
}

scale_y_continuous_by_group <- function(df, group, group.selfish) {
     if(group != "stepping" & group.selfish) {
      list(scale_y_continuous(breaks = df$stepping,
                              labels = as.character(df[, group])))
    } else {
      list(scale_y_continuous(breaks = NULL))
    }
}

"%||%" <- function(a, b) {
    if (!is.null(a)) a else b
}

## TODO::
## Let's load a RefSeq data
## naming the interval
## two mode? packed, full with name (default)
## reduce is just a stat transformation at lower level
setGeneric("geom_rect", function(data, ...) standardGeneric("geom_rect"))

setMethod("geom_rect", "ANY", function(data, ...){
    ggplot2::geom_rect(data = data, ...)
})

## alignment should be convenient toggle with chevron...
setMethod("geom_rect", "GRanges", function(data,...,
                                           xlab, ylab, main,
                                           facets = NULL,
                                           stat = c("stepping", "identity"),
                                           rect.height = NULL,
                                           group.selfish = TRUE){


  ## make this by hand
  args <- list(...)
  args$facets <- facets
  args.aes <- parseArgsForAes(args)
  args.non <- remove_args(parseArgsForNonAes(args), "facets")
  es <- ifelse("extend.size" %in% names(args.non), args.non$extend.size, 0)
  facet <- build_facet(data, args)
  stat <- match.arg(stat)
  if(length(data)){
  if(stat == "stepping"){
    if(is.null(rect.height)) rect.height <- 0.4
    grl <- splitByFacets(data, facets)
    res <- endoapply(grl, make_addStepping, args.aes, group.selfish, extend.size = es)
    df <- mold(unlist(res))

    args.aes <- remove_args(args.aes, c("xmin", "xmax", "ymin", "ymax", "data"))
    args.non <- remove_args(args.non, c("xmin", "xmax", "ymax", "ymax", "data", "facets"))
    gpn <- ifelse("group" %in% names(args), quo_name(args$group), "stepping")
    args.aes <- remove_args(args.aes, c("group", "size"))
    ## overcome 1 pixel problem
    args.aes.seg <- remove_args(args.aes, c("fill", "y", "xend", "yend", "x"))
    args.aes.seg <- c(args.aes.seg, list(x = substitute(start),
                                 xend = substitute(start),
                                 y = substitute(stepping - rect.height),
                                 yend = substitute(stepping + rect.height)))
    aes.res.seg <- do.call(aes, args.aes.seg)
    args.non.seg <- remove_args(args.non, "fill")
    args.res.seg <- c(list(data = df), list(aes.res.seg), args.non.seg)
    p <- list(do.call(ggplot2::geom_segment, args.res.seg))
    args.aes <- c(args.aes, list(xmin = substitute(start),
                                 xmax = substitute(end),
                                 ymin = substitute(stepping - rect.height),
                                 ymax = substitute(stepping + rect.height)))
    aes.res <- do.call(aes, args.aes)
    aes.res <- remove_args(aes.res, "y")
    args.res <- c(list(data = df), list(aes.res), args.non)
    p <- c(p, list(do.call(ggplot2::geom_rect, args.res)))
    p <- .changeStrandColor(p, args.aes)
    .df.sub <- group_df(df, gpn)
    ## FIXME:
    y_scale <- scale_y_continuous_by_group(.df.sub, gpn, group.selfish)
    p <- c(p, y_scale)
  }
  
  if(stat == "identity"){
    if(!"y" %in% names(args.aes)){
      if(!all(c("ymin","ymax", "xmin", "xmax") %in% names(args.aes))){
        stop("aes(xmin =, xmax= , ymin =, ymax= ) is required for stat 'identity',
              you could also specify aes(y =) only as alternative")
      }else{
        args.aes.seg <- args.aes
        args.aes.seg$x <- args.aes$xmin
        args.aes.seg$xend <- args.aes$xmax
        args.aes.seg$y <- args.aes$ymin
        args.aes.seg$yend <- args.aes$ymax
      }
    }else{
      .y <- quo_squash(args.aes$y)
      if(is.null(rect.height)){
         rect.height <- diff(range(values(data)[,as.character(.y)]))/20
      }
      args.aes.seg <- args.aes
      mapping <- list(y = .y, rect.height = rect.height)
      args.aes.seg$x <- as.name("start")
      args.aes.seg$xend <- as.name("start")
      args.aes.seg$y <- substitute(y + rect.height, mapping)
      args.aes.seg$yend <- substitute(y - rect.height , mapping)
      
      args.aes$xmin <- as.name("start")
      args.aes$xmax <- as.name("end")
      args.aes$ymin <- substitute(y + rect.height, mapping)
      args.aes$ymax <- substitute(y - rect.height , mapping)
    }
    df <- mold(data)

    ## overcome 1 pixel problem
    args.aes.seg <- remove_args(args.aes.seg, c("group", "size", "fill", "xmin", "xmax", "ymin", "ymax"))
    aes.res.seg <- do.call(aes, args.aes.seg)
    args.non.seg <- remove_args(args.non, "fill")
    args.res.seg <- c(list(data = df), list(aes.res.seg), args.non.seg)
    p <- list(do.call(ggplot2::geom_segment, args.res.seg))

    args.aes <- remove_args(args.aes, c("group", "size", "y"))
    aes.res <- do.call(aes, args.aes)

    args.res <- c(list(data = df), list(aes.res), args.non)
    p <- c(p, list(do.call(ggplot2::geom_rect, args.res)))
    p <- .changeStrandColor(p, args.aes)
  }
  }else{
    p <- NULL
  }

  p <- c(list(p), list(facet))

  if(identical(stat, "stepping"))
    labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = ""))
  else labels <- Labels(xlab, ylab, main, fallback = c(x = ""))

  p <- c(p, labels)
  p
})

## ..score..
setGeneric("stat_table", function(data, ...) standardGeneric("stat_table"))

setMethod("stat_table", "GRanges", function(data, ..., xlab, ylab, main,
                                            geom = NULL, stat = NULL){

  args <- list(...)
  
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)

  if(length(data)){
    tab <- table(paste(seqnames(data), start(data), end(data), strand(data), sep = ":"))
    key_mat <- matrix(unlist(strsplit(names(tab), ":", fixed=TRUE)), 4)
    gr <- GRanges(key_mat[1,],
                  IRanges(as.integer(key_mat[2,]), as.integer(key_mat[3,])),
                  key_mat[4,], score = as.integer(tab),
                  seqlengths = seqlengths(data))
    seqinfo(gr) <- seqinfo(data)
    args.non$data <- gr
    
    .ggbio.geom <- c("rect", "chevron", "alignment", "arrowrect", "arrow", "segment", "arch")
    .ggbio.stat <- c("identity", "coverage", "stepping", "aggregate")

    ## if(is.null(stat)){
    ## }
    ## ------------------------------
    ## geom/stat check
    ## ------------------------------
    if(is.null(stat) & is.null(geom)){
      stat <- "stepping"
      args.non$geom <- "rect"
      args.non$stat <- stat
      if(!"color" %in% names(args.aes) && !"colour" %in% names(args.aes))
        args.aes$color <- args.aes$fill <- as.name("score")
      .fun <- stat_stepping
    }else{
      .fun <- getDrawFunFromGeomStat(geom, stat)
      if(!is.null(geom)){
        if(geom != "arch"){
          if(is.null(stat)){
            args.non$stat <- stat <- "identity"
          }else{
            args.non$geom <- geom
          }}}
    }
    aes.res <- do.call(aes, args.aes)
    args.res <- c(args.non, list(aes.res))
    p <- do.call(.fun, args.res)
  }else{
    p <- NULL
  }

  labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
  p <- c(p, labels)
  p <- setStat(p)
  p
})  


setMethod("stat_table", "GRangesList", function(data, ..., 
                                                xlab, ylab, main,
                                                facets = NULL, 
                                                geom = NULL){
  
  args <- list(...)

  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  aes.res <- do.call(aes, args.aes)
  gr <- flatGrl(data)
  args.non$data <- gr
  p <- do.call(stat_table, c(list(aes.res), args.non))
  labels <- Labels(xlab, ylab, main, fallback =
                   c(x = "Genomic Coordinates", y = "Score"))
  p <- c(p, labels)
  p <- setStat(p)  
  p
})

setGeneric("layout_karyogram", function(data,...)
           standardGeneric("layout_karyogram"))
setMethod("layout_karyogram", "GRanges",
          function(data,..., xlab, ylab, main,
                   facets = seqnames ~ .,
                   cytobands = FALSE,
                   geom = "rect", stat = NULL, ylim = NULL,
                   rect.height = 10
                   ) {

            ## geom <- match.arg(geom)
            args <- list(...)
            args.aes <- parseArgsForAes(args)
            args.non <- parseArgsForNonAes(args)
            if(is.null(ylim)){
              ## compute y lim from data
              if("y" %in% names(args.aes)){
                .y <- values(data)[, quo_name(args.aes$y)]
                .y.r <- range(.y)
                .ideo.range <- expand_range(.y.r, mul = 0.05)
              }else{
                .ideo.range <- c(0, rect.height)
              }
            }else{
              if("y" %in% names(args.aes)){
                .y <- values(data)[, quo_name(args.aes$y)]
                .y <- scales::rescale(.y, to = ylim)
                .y.r <- range(.y)
                .ideo.range <- expand_range(.y.r, mul = 0.05)
                values(data)[, quo_name(args.aes$y)] <- .y
              }else{
              .ideo.range <- ylim
            }
            }

            ## check facets
            if(cytobands){
              geom <- NULL
              cytobandColor <- getOption("biovizBase")$cytobandColor
              if(!isIdeogram(data))
                stop("Need cytoband information, please check the getIdeogram function")
              df <- mold(data)
              df.rect <- subset(df, gieStain != "acen")
              df.tri <- subset(df, gieStain == "acen")
              df.tri.p <- df.tri[substr(df.tri$name, 1, 1) == "p",]
              df.tri.q <- df.tri[substr(df.tri$name, 1, 1) == "q",]

              ## main
              p.ideo <- list(do.call(ggplot2::geom_rect, c(list(data = df.rect),
                                              list(do.call(aes,list(xmin = as.name("start"),
                                                                    ymin =.ideo.range[1],
                                                                    xmax = as.name("end"),
                                                                    ymax = .ideo.range[2],
                                                                    fill = as.name("gieStain")))),
                                                           list(color = NA, alpha = 0.7))))

              ## draw line
              df.p <- df.rect[substr(df.rect$name, 1, 1) == "p",]
              df.q <- df.rect[substr(df.rect$name, 1, 1) == "q",]

              if(nrow(df.p)){

                df.p.d <- do.call(rbind, by(df.p, df.p$seqnames, function(dd){
                  data.frame(x = min(dd$start),
                             y = .ideo.range[1],
                             y2 = .ideo.range[2],
                             xend = max(dd$end),
                             yend = .ideo.range[1],
                             yend2 = .ideo.range[2],
                             seqnames = unique(dd$seqnames))
                }))


                p.ideo <- c(p.ideo, list(do.call(ggplot2::geom_segment, c(list(data = df.p.d),
                                                                          list(aes(x = x, y = y, xend = xend, yend = yend)),
                                                                          list(color = "black",
                                                                               alpha = 1, linewidth = 0.3)))))
                p.ideo <- c(p.ideo, list(do.call(ggplot2::geom_segment, c(list(data = df.p.d),
                                                                          list(aes(x = x, y = y2, xend = xend, yend = yend2)),
                                                                          list(color = "black",
                                                                               alpha = 1, linewidth = 0.3)))))
                p.ideo <- c(p.ideo, list(do.call(ggplot2::geom_segment, c(list(data = df.p.d),
                                                                          list(aes(x = x, y = y, xend = x, yend = y2)),
                                                                          list(color = "black",
                                                                               alpha = 1, linewidth = 0.3)))))




              }

              if(nrow(df.q)){
                df.q.d <- do.call(rbind, by(df.q, df.q$seqnames, function(dd){
                  data.frame(x = min(dd$start),
                             y = .ideo.range[1],
                             y2 = .ideo.range[2],
                             xend = max(dd$end),
                             yend = .ideo.range[1],
                             yend2 = .ideo.range[2],
                             seqnames = unique(dd$seqnames))
                }))


                p.ideo <- c(p.ideo, list(do.call(ggplot2::geom_segment, c(list(data = df.q.d),
                                                                          list(aes(x = x, y = y, xend = xend, yend = yend)),
                                                                          list(color = "black",
                                                                               alpha = 1, linewidth = 0.3)))))
                p.ideo <- c(p.ideo, list(do.call(ggplot2::geom_segment, c(list(data = df.q.d),
                                                                          list(aes(x = x, y = y2, xend = xend, yend = yend2)),
                                                                          list(color = "black",
                                                                               alpha = 1, linewidth = 0.3)))))

                p.ideo <- c(p.ideo, list(do.call(ggplot2::geom_segment, c(list(data = df.q.d),
                                                                          list(aes(x = xend, y = y, xend = xend, yend = y2)),
                                                                          list(color = "black",
                                                                               alpha = 1, linewidth = 0.3)))))





              }





              df.tri.p2 <- with(df.tri.p,
                                data.frame(x=start,
                                           y=rep(0, nrow(df.tri.p)),
                                           xend=start,
                                           yend=rep(10, nrow(df.tri.p)),
                                           height=abs(start - end),
                                           seqnames=seqnames, strand=strand,
                                           name=name, gieStain=gieStain))
              
              df.tri.q2 <- with(df.tri.q,
                                data.frame(x=end,
                                           y=rep(0, nrow(df.tri.q)),
                                           xend=end,
                                           yend=rep(10, nrow(df.tri.q)),
                                           height=-abs(start - end),
                                           seqnames=seqnames, strand=strand,
                                           name=name, gieStain=gieStain))

              ## border
              if(nrow(df.tri.p2) > 0L)
                  p.ideo <- c(p.ideo,
                              list(geom_arch_flip2(df.tri.p2,
                                                   aes(x = x,
                                                       y = y ,
                                                       xend = xend,
                                                       yend = yend,
                                                       height = height),
                                                   color = "black",
                                                   linewidth = 0.5),
                                   geom_arch_flip(df.tri.p2,
                                                  aes(x = x,
                                                      y = y ,
                                                      xend = xend,
                                                      yend = yend,
                                                      height = height,
                                                      fill = gieStain))))
              
              ## q
              if(nrow(df.tri.p2) > 0L)
                  p.ideo <- c(p.ideo,
                               list(geom_arch_flip2(df.tri.q2,
                                                    aes(x = x,
                                                        y = y ,
                                                        xend = xend,
                                                        yend = yend,
                                                        height = height),
                                                    color = "black",
                                                    linewidth = 0.5),
                                    geom_arch_flip(df.tri.q2,
                                                   aes(x = x,
                                                       y = y ,
                                                       xend = xend,
                                                       yend = yend,
                                                       height = height,
                                                       fill = gieStain))))

              p.ideo <- c(p.ideo,
                          list(theme(axis.text.y = element_blank(),
                                    axis.title.y=element_blank(),
                                    axis.ticks = element_blank(),
                                    panel.grid.minor = element_line(colour = NA),
                                    panel.grid.major = element_line(colour = NA)),
                               scale_fill_manual(values = cytobandColor)),
                          list(facet_grid(seqnames ~ .)))


            }else {
              ideo.gr <- getIdeoGR(data)
              extra.factor <- setdiff(all.vars(as.formula(facets)), c("seqnames", "."))
              if(length(extra.factor)){
                lst <- lapply(unique(values(data)[,extra.factor]), function(i){
                  values(ideo.gr)[, extra.factor] <- i
                  ideo.gr
                })
                ideo.gr <- do.call(c, lst)
              }
              names(ideo.gr) <- NULL
              df <- as.data.frame(ideo.gr)
              aes.ideo <- do.call(aes, list(xmin = substitute(start),
                                            ymin = .ideo.range[1],
                                            xmax = substitute(end),
                                            ymax = .ideo.range[2]))
              p.ideo <- do.call(ggplot2::geom_rect, c(list(data = df),
                                                      list(aes.ideo),
                                                      list(fill = "white", color = "black")))
            }
            if(!is.null(geom)){
              df <- mold(data)
            if(geom == "rect"){

              ## check xmin, ymin, ymax, y
              args.aes.rect <- combineAes(args.aes, list(xmin = substitute(start),
                                       xmax = substitute(end),
                                       ymin = .ideo.range[1],
                                       ymax = .ideo.range[2]))
                 y <- .ideo.range[1]
              yend <- .ideo.range[2]
              
              if ("ymin" %in% args.aes)
                  y <- args.aes$ymin
              if ("ymax" %in% args.aes)
                  yend <- args.aes$ymax

              args.aes.seg <- combineAes(args.aes, list(x = substitute(start),
                                               xend = substitute(start),
                                               y = y,
                                               yend = yend))

              args.aes.seg <- remove_args(args.aes.seg, "fill")
              ## this hack is to get over 1-pixel problem
              p.addon <- do.call(ggplot2::geom_segment,
                                 c(list(data = df), list(do.call(aes, args.aes.seg)),args.non))

              p.addon <- c(list(p.addon), list(do.call(ggplot2::geom_rect,
                          c(list(data = df), list(do.call(aes, args.aes.rect)),args.non))))
            }else{
              .drawFun <- getDrawFunFromGeomStat(geom, stat)
              aes.res <- do.call(aes, args.aes)
              args.res <- c(list(data = df), list(aes.res), args.non)
              p.addon <- do.call(.drawFun, args.res)
            }
            p <- list(p.addon , facet_grid(facets))
          }else{
            p <- list(p.ideo,  facet_grid(facets))
          }
            o <- theme(axis.text.y = element_blank(),
                      axis.title.y=element_blank(),
                      axis.ticks = element_blank(),
                      panel.grid.minor = element_line(colour = NA),
                      panel.grid.major = element_line(colour = NA),
                      strip.text.y=element_text(angle=0))
            p <- list(p, list(o), list(scale_x_sequnit()))
          })



## ## ======================================================================
## ##        For "Overview"
## ## ======================================================================
plotStackedOverview <- function(obj, ..., xlab, ylab, main, geom = "rect",
                         cytobands = FALSE, rescale = TRUE, rescale.range = c(0, 10)){
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  facets <- seqnames ~ .
  if(missing(obj)){
    obj <- getIdeogram(cytobands = cytobands)
    cat("-------get following seqnames------\n")
    message(paste(seqnames(seqinfo(obj)), collapse = "\n"))
    ## obj <- keepSeqlevels(obj, unique(seqnames()))
    idx <- order(seqlengths(obj), decreasing = TRUE)
    nms <- names(seqlengths(obj))[idx]
    obj <- keepSeqlevels(obj, nms)
    p <- ggplot() + layout_karyogram(obj, cytobands = cytobands, facets = facets, geom =  NULL)
  }else{
  if(!is(obj, "GRanges"))
    stop("only GRanges supported now")
  ## tweak with y
  if(rescale){
  if("y" %in% names(args.aes)){
    values(obj)[, quo_name(args.aes$y)] <-
      rescale(values(obj)[, quo_name(args.aes$y)],rescale.range)

  }}
  p <- ggplot() + layout_karyogram(obj, cytobands = cytobands, facets = facets, geom = NULL)
  args.non$geom <- geom
  args.non$facets <- facets
  if(!cytobands){
    args.res <- c(list(data = obj), list(do.call(aes, args.aes)),args.non)
    p <- p + do.call(layout_karyogram,args.res)
  }
}
  if(!missing(xlab))
    p <- p + xlab(xlab)
  if(!missing(ylab))
    p <- p + ggplot2::ylab(ylab)
  if(!missing(main))
    p <- p + labs(title = main)

  p
}

plotKaryogram <- plotStackedOverview

## FIXME: more flexible name.expr arguments
setGeneric("stat_gene", function(data, ...) standardGeneric("stat_gene"))
setMethod("stat_gene", "TxDb", function(data, ...){
  .Deprecated("geom_alignment")
  geom_alignment(data, ...)
})

setGeneric("geom_chevron", function(data, ...) standardGeneric("geom_chevron"))

setMethod("geom_chevron", "GRanges", 
          function(data, ...,
                   xlab, ylab, main,
                   offset = 0.1, facets = NULL,
                   stat = c("stepping", "identity"),
                   chevron.height.rescale = c(0.1, 0.8),
                   group.selfish = TRUE){

            stat <- match.arg(stat)
            
            args <- list(...)
            args$facets <- facets
            
            args.aes <- parseArgsForAes(args)            
            args.non <- remove_args(parseArgsForNonAes(args), "facets")
            facet <- build_facet(data, args)
            if(length(data)) {
            if(stat == "stepping"){
              group.name <- NULL
              if("group" %in% names(args.aes))
                group.name <- quo_name(args.aes$group)
              if(!"stepping" %in% colnames(values(data))){
                if(length(group.name))
                  data <- addStepping(data, group.name = group.name,
                                      group.selfish = group.selfish)
                else
                  data <- addStepping(data)
              }
              aes.lst <- args.aes
              data.new <- breakGr(data)
              names(data.new) <- NULL
              df <- as.data.frame(data.new)
              
              if(!is.numeric(offset)){
                offset <- as.character(offset)
                if(offset %in% colnames(values(data)))    
                  ydf <- getY2(df, offset, chevron.height.rescale)
                else
                  stop("offset must be a numeric value or one of the colnames")
              }else{
                ydf <- do.call("rbind", lapply(df$.bioviz.chevron, getY, offset))
              }
              df <- cbind(df, ydf)
              args <- c(aes.lst, list(x = substitute(start),
                                      xend = substitute(end),
                                      y = substitute(stepping + y.offset),
                                      yend = substitute(stepping + yend.offset)))

              args.res <- c(list(data = df), list(do.call(aes, args)),
                            args.non)
              p <- c(list(do.call(ggplot2::geom_segment, args.res)), list(ggplot2::ylab("")))

              gpn <- ifelse("group" %in% names(args.aes), quo_name(args.aes$group), "stepping")
              
              .df.sub <- group_df(df, gpn)
              y_scale <- scale_y_continuous_by_group(.df.sub, gpn, group.selfish)
              p <- c(p, y_scale)
            }
            if(stat == "identity"){
              if(!"y" %in% names(args.aes)){
                if(!all(c("y","yend", "x", "xend") %in% names(args.aes))){
                  stop("aes(x =, xend= , y =, yend= ) is required for stat 'identity',
              you could also specify aes(y =) only as alternative")
                }
              }else{
                .y <- args.aes$y
                args.aes$x <- as.name("start")
                args.aes$xend <- as.name("end")
                args.aes$y <- substitute(y + offset,
                                            list(y = .y, offset = as.name("y.offset")))
                args.aes$yend <- substitute(yend + offset ,
                                            list(yend = .y, offset = as.name("yend.offset")))

              }
              
              data.new <- breakGr(data)
              names(data.new) <- NULL
              df <- as.data.frame(data.new)
              if(!is.numeric(offset)){
                offset <- as.character(offset)
                if(offset %in% colnames(values(data)))    
                  ydf <- getY2(df, offset, chevron.height.rescale)
                else
                  stop("offset must be a numeric value or one of the colnames")
              }else{
                ydf <- do.call("rbind", lapply(df$.bioviz.chevron, getY, offset))
              }
              df <- cbind(df, ydf)
              .y <- args.aes$y
              .yend <- args.aes$yend
              args.aes$y <- substitute(y + y.offset, list(y = .y))
              args.aes$yend <- substitute(yend + yend.offset, list(yend = .yend))
              args.res <- c(list(data = df), list(do.call(aes, args.aes)), args.non)
              p <- c(list(do.call(ggplot2::geom_segment, args.res)),
                     list(ggplot2::ylab("")))

            }}else{
              p <- NULL
            }
            p <- c(list(p) , list(facet))
            labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
            p <- c(p, labels)
            p
          })


getY <- function(n, offset){
  switch(n,
          {
            y.offset <- 0
            yend.offset <- offset
            data.frame(y.offset = y.offset,
                      yend.offset = yend.offset)
          },
          {
            y.offset <- offset
            yend.offset <- 0
            data.frame(y.offset = y.offset,
                      yend.offset = yend.offset)
          })
}

getY2 <- function(df, offset, chevron.height.rescale){
  res <- df[,offset]
  os <- rescale(res, chevron.height.rescale)
  lst <- lapply(1:nrow(df), function(i){
    n <- df[i,".bioviz.chevron"]
    switch(n,
            {
              y.offset <- 0
              yend.offset <- os[i]
              data.frame(y.offset = y.offset,
                        yend.offset = yend.offset)
            },
            {
              y.offset <- os[i]
              yend.offset <- 0
              data.frame(y.offset = y.offset,
                        yend.offset = yend.offset)
            })
  })
  do.call("rbind", lst)
}

## 
breakGr <- function(gr){
  mids <- start(gr) + width(gr)/2
  res1 <- res2 <- gr
  end(res1) <- mids
  values(res1)$.bioviz.chevron <- 1
  start(res2) <- mids
  values(res2)$.bioviz.chevron <- 2
  res <- c(res1, res2)
}

if (!isClass("unit")) setOldClass("unit")
if (!isClass("simpleUnit")) setOldClass(c("simpleUnit", "unit"))
if (!isClass("gtable")) setOldClass("gtable")
if (!isClass("theme")) setOldClass("theme")
if (!isClass("gTree")) setOldClass("gTree")
if (!isClass("grob")) setOldClass("grob")
setClassUnion("theme_OR_NULL", c("theme", "NULL"))
setClassUnion("numericORunit", c("numeric", "unit"))
setClassUnion("numeric_OR_NULL", c("numeric", "NULL"))

setClassUnion("GRanges_OR_NULL", c("GRanges", "NULL"))

setClassUnion("TxDbOREnsDb", c("TxDb", "EnsDb"))
## setClassUnion("GRangesORANY", c("GRanges", "ANY"))
## setClassUnion("GRangesORBasicFilterORlistORNULL",
setClassUnion("GRanges_OR_BasicFilter_OR_list_OR_NULL",
              c("GRanges", "AnnotationFilter", "AnnotationFilterList",
                "formula", "list", "NULL"))
setClassUnion("BasicFilterORlist",
              c("AnnotationFilter", "AnnotationFilterList", "formula", "list"))

setOldClass(c("ggplot2::ggplot", "ggplot", "ggplot2::gg", "gg"))
setClassUnion("ggplot_OR_NULL", c("ggplot", "NULL"))
setClassUnion("gg_OR_NULL", c("gg", "NULL"))

setOldClass("grob")
setOldClass("trellis")
setOldClass("lattice")

## ======================================================================
##        For "Granges"
## ======================================================================
setMethod("rescale", signature(x = "numeric"), function(x, to = c(0, 1),
                                 from = range(x, na.rm = TRUE)){
  scales::rescale(x, to = to , from = from)
})

setMethod("rescale", "gg", function(x, xlim, ylim, sx = 1, sy = 1){
  if(!missing(xlim) & sx != 1)
    stop("You can only rescale by one of xlim or sx")
  if(!missing(ylim) & sy != 1)
    stop("You can only rescale by one of ylim or sy")
  if(!missing(xlim))
    res <- x + coord_cartesian(xlim = xlim)
    ## res <- x + scale_x_continuous(limits = xlim)
  if(!missing(ylim))
    res <- x + coord_cartesian(ylim = ylim)    
    ## res <- x + scale_x_continuous(limits = ylim)
  if(sx != 1){
    xlim <- .getLimits(x)$xlim
    xlim.mean <- mean(xlim)
    extra.new <- diff(xlim) * sx/2
    xlim <- c(xlim.mean - extra.new, xlim.mean + extra.new)
    res <- x + coord_cartesian(xlim = xlim)
  }
  if(sy != 1){
    ylim <- .getLimits(x)$ylim
    ylim.mean <- mean(ylim)
    extra.new <- diff(ylim) * sy/2
    ylim <- c(ylim.mean - extra.new, ylim.mean + extra.new)
    res <- x + coord_cartesian(ylim = ylim)
  }
  res
})

## TODO:
## 1. Txdb
## 2. Solve the seqinfo issues

plot(1:10)
library(ggbio)
library(ggplot2)
p <- ggplot(data = mtcars)
class(p)
p  <- p + geom_point(aes(x = mpg, y = wt), color = "red")
p
N <- 100
library(GenomicRanges)
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                start = sample(1:300, size = N, replace = TRUE),
                width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))

seqlengths(gr) <- c(400, 500, 700)
values(gr)$to.gr <- gr[sample(1:length(gr), size = length(gr))]
grr <- GRanges(c("chr1", "chr1", "chr2"), IRanges(1, 50))

autoplot(gr, facets = grr)
ggbio() + geom_rect(gr)

ggplot() + circle(gr, geom = "ideo", fill = "gray70") +
     circle(gr, geom = "bar", aes(fill = score, y = score)) +
     circle(gr, geom = "point", color = "red", grid = TRUE, aes(y = score)) +
     circle(gr, geom = "link", linked.to = "to.gr", r = 0, )


## doesn't pass gr to the ggplot
ggplot() + layout_circle(gr, geom = "ideo", fill = "gray70", radius = 7, trackWidth = 3) +
  layout_circle(gr, geom = "bar", radius = 10, trackWidth = 4, aes(fill = score, y = score)) +
  layout_circle(gr, geom = "point", color = "red", radius = 14,
                trackWidth = 3, grid = TRUE, aes(y = score)) +
  layout_circle(gr, geom = "link", linked.to = "to.gr", radius = 6,
                trackWidth = 1)

p <- ggplot(gr) + layout_circle() + geom_bar(aes(fill = score, y = score))
p
library(grid)
p <- ggplot() + geom_rect(gr)
p
genPlots(list(p, p, gr, txdb))
tracks(p)
p + xlim(100, 200)
p <- ggplot(gr) + geom_rect(which = gr)


tracks(p = p, p2 = p) + xlim(1, 3)

gr1 <- GRanges("chr1", IRanges(1, 3))
gr2 <- GRanges("chr1", IRanges(c(2, 4, 1), c(3, 5, 2)))
countOverlaps(gr2, gr1, type = "within")
cached_item(p1)

## test cache ability
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
data(genesymbol, package = "biovizBase")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
gr1 <- genesymbol["ALDOA"]
gr1
gr2 <- GRanges("chr16", IRanges(30074491, 30075733))
gr3 <- GRanges("chr12", IRanges(30074491, 30081733))

p1 <- autoplot(txdb, which = genesymbol["ALDOA"])
p1
## this should work
myfunc <- function(x, ...){
  autoplot(x, ...)
}
ylab = "asdfasdf"
p1 <- myfunc(txdb, xlab = "lalaal", ylab = ylab)
p.tx <- autoplot(txdb)
p <- p.tx + xlim(gr1)
p
p + xlim(gr2)
p + xlim(gr3)

## fixme:
## Need to add a marker called null graphics need to sync xlim wiht
tracks(gr1, p1)
tracks(txdb, xlim = gr1)
library(grid)
getGrFromXlim(xlim(gr1))
p1

tracks(p1)
library(grid)
p1
p1 + xlim(gr1)
p1
p3 <- p1 + xlim(gr3)
p3
class( xlim(gr3))
ggbio:::cached(p1)
res <- xlim(gr2)
res <- xlim_car(res)

## test bamfile
fl <- "~/Datas/seqs/ENCODE/cshl/wgEncodeCshlLongRnaSeqGm12878CellPapAlnRep1.bam"
fl1 <- "~/Datas/seqs/ENCODE/cshl/wgEncodeCshlLongRnaSeqK562CellPapAlnRep1.bam"

library(Rsamtools)
bf <- BamFile(fl)
p <- autoplot(bf)
p <- p + xlim(gr1)
p
p + xlim(gr2)

library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(Rsamtools)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
fl <- "~/Datas/seqs/ENCODE/cshl/wgEncodeCshlLongRnaSeqGm12878CellPapAlnRep1.bam"
bf <- BamFile(fl)
tks <- tracks(coverage = bf, model = txdb, xlim = gr1)
tks
ggsave("~/Desktop/tks.jpg")
bfl <- BamFileList(c(fl, fl1))

autoplot(bfl)


## subset tracks
p <- ggplot(data = mtcars)
p1  <- p + geom_point(aes(x = mpg, y = wt), color = "red")
p2  <- p + geom_point(aes(x = mpg, y = wt), color = "blue")
p3  <- p + geom_point(aes(x = mpg, y = wt), color = "green")

tks <- tracks(p1 = p1, p2 = p2, p3 = p3)
names(tks@grobs[c(1, 3)])
tk <- tks[c(1, 3)]
tk
names(tk@grobs)
tk <- tks[1:2]
names(tk@grobs)
tk@label


## TODO: make a better looking txbd
library(ggbio)
p <- qplot(data = mtcars, x = mpg,  y = wt, facets = cyl ~ .)
p1 <- qplot(data = mtcars, x = mpg,  y = wt)
tracks(p1 = p, p2 = p1)


##
library(ggbio)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
data(genesymbol, package = "biovizBase")
p <- autoplot(txdb, which = genesymbol["BRCA1"])
data(genesymbol, package = "biovizBase")
p <- autoplot(txdb, which = genesymbol["BRCA1"])
library(GenomeInfoDb)  # for keepSeqlevels()
autoplot(keepSeqlevels(genesymbol[1:100], "chr1"))
class(p)
is

##



library(ggbio)
library(ggplot2)
library(GenomicRanges)

gr = GRanges("1", IRanges(1:5, 1:5))

set.seed(1)
gr$e = runif(5)
gr$l = runif(5, -1, 0)
gr$u = runif(5, 1, 2)

p = autoplot(gr, geom = "pointrange", aes_string(y = "e", ymin = "l", ymax = "u"))

t = tracks(p, p, p)
t
t = tracks(p, p, p, title = "title")
t = tracks(p, p, p, title = "")
t = tracks(p1 = p, p2 = p, p3 = p, title = "title", xlab = "xlab")
print(t)

df1 <- data.frame(time = 1:100, score = sin((1:100)/20)10)
p1 <- qplot(data = df1, x = time, y = score, geom = "line")
df2 <- data.frame(time = 30:120, score = sin((30:120)/20)10, value = rnorm(120-30 + 1))
p2 <- ggplot(data = df2, aes(x = time, y = score)) +
  geom_line() + geom_point(size = 4, aes(color = value))

plot two tracks with a label - this looks OK

tracks (p1, p2, main="myTitle")

plot two labelled tracks - this look OK

tracks (p1=p1, p2=p2)

adding title to the plot with labelled tracks messes up alignment of the labels with the plot

tracks (p1=p1, p2=p2, main="myTitle")

## support VRanges
# construction
library(ggbio)
library(GenomicRanges)
library(VariantAnnotation)
vr <- VRanges(seqnames = c("chr1", "chr2"),
              ranges = IRanges(c(1, 10), c(5, 20)),
              ref = c("T", "A"), alt = c("C", "T"),
              refDepth = c(5, 10), altDepth = c(7, 6),
              totalDepth = c(12, 17), sampleNames = letters[1:2],
              hardFilters =
                FilterRules(list(coverage = function(x) totalDepth > 10)),
              softFilterMatrix =
                FilterMatrix(matrix = cbind(depth = c(TRUE, FALSE)),
                             FilterRules(depth = function(x) altDepth(x) > 6)),
              tumorSpecific = c(FALSE, TRUE))

## simple accessors
vr
ref(vr)
as(vr, "data.frame")
library(biovizBase)
mold(vr)
altDepth(vr)
vr$tumorSpecific
called(vr)

data("genesymbol", package = "biovizBase")
genesymbol["BRCA1"]
param <- ScanVcfParam(which = GRanges("17", IRanges(41196313, 41277500)))
vcf <- readVcf("/Users/tengfei/Documents/Data/sbgtest/1000G_phase1.snps.high_confidence.b37.vcf.gz",
               genome = "hg19", param = param)
vcf
vr <- as(vcf, "VRanges")
library(biovizBase)
md <- mold(vr[1:10])
head(md)
library(grid) # needed for arrow function
library(gridExtra)
head(md)
p <- ggplot(data.frame(x = range(md$midpoint),
                  y = c(1, 2))) + geom_blank( aes(x = x, y = y)) +
  ggplot2::geom_segment(data = md, aes(x = midpoint, xend = midpoint), y = 1.4,
               yend = 1.6, arrow = arrow(length = unit(0.2,"strwidth", "A"))) +
  annotate("text", x = md$midpoint, y = 1.75, label = md$alt) +
  annotate("text", x = md$midpoint, y = 1.25, label = md$ref) +
  theme_alignment()  +
  theme(aspect.ratio = 1/10)
p
class(p)


library(ggbio)
tracks(list(p))
tracks(p = p)
ggbio:::.supportedPlots
extends(class(p), 'gg')
tracks(p = ggbio(p))

library(ggbio)
library(IRanges)
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500), seq(10, 0.001, length = 500))
xVector <- dnorm(1:5e3, mean = 1e3, sd = 200)
xRle <- Rle(xVector)
v1 <- Views(xRle, start = sample(.4e3:.6e3, size = 50, replace = FALSE), width =1000)
autoplot(v1)

## let's add  more ideogram data
library(biovizBase)
?getIdeogram
hg19 <- getIdeogram(genome = "hg19")
hg19

## ggbio

p <- plotGrandLinear(gr.snp, aes(y = pvalue), color = c("#7fc97f", "#fdc086"))
vline.df <- p@ggpplot$data
vline.df <- do.call(rbind, by(vline.df, vline.df$seqnames, function(dd){
  data.frame(start = min(dd$start),
             end = max(dd$end))
}))
## compute gap
gap <- (vline.df$start[-1] + vline.df$end[-nrow(vline.df)])/2
p + geom_vline(xintercept = gap, alpha = 0.5, color = 'gray70') + theme(panel.grid = element_blank())
theme_gray()

library(ggplot2)
library(proto)




qplot(wt, mpg, data = mtcars, label = rownames(mtcars), size = wt) +
  geom_text2(colour = "red", fc = c("black", "red"))
library(grid)

library(BiocManager)
BiocManager::install("FDb.UCSC.snp137common.hg19")
## load the library
library(FDb.UCSC.snp137common.hg19)
## list the contents that are loaded into memory
ls(’package:FDb.UCSC.snp137common.hg19’)
## show the db object that is loaded by calling its name
FDb.UCSC.snp137common.hg19
## extract features for use in annotating data
snp137common <- features(FDb.UCSC.snp137common.hg19)
met <- metadata(FDb.UCSC.snp137common.hg19) ## need to fetch genome


library(GenomicRanges)
snp.gr <- GRanges("chr17", IRanges(41224057,41244883))
data(genesymbol)
gr <- GRanges("chr17", IRanges(41196312, 41277500))
gr

library(VariantAnnotation)
fl = "/Users/tengfei/Documents/Data/sbgtest/17-1409-CEU.vcf.gz"
vcf.brca1 <- readVcf(fl, genome = "hg19", param = ScanVcfParam(which = gr))

vcf.brca1


library(ggbio)
autoplot(vcf.brca1)
?readVcf

writeVcf(vcf.brca1, "/Users/tengfei/Documents/Data/sbgtest/17-1409-CEU-brca1.vcf.gz", index = TRUE)




library(biovizBase)

genesymbol

library(ggbio)
library(biovizBase)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
data(genesymbol, package = "biovizBase")
wh <- genesymbol[c("BRCA1", "NBR1")]
temp <- crunch(txdb, which = wh)
temp2 <- crunch(txdb, which = wh)
temp3 <- temp2
names(values(temp3))[4] <- "model"
temp2
temp.l <- split(temp2, temp2$tx_name)
temp.l


autoplot(temp.l, geom = "alignment")
ggbio() + geom_alignment(temp.l, aes(type = type))
ggbio() + geom_alignment(temp.l[1:3])
ggbio() + geom_alignment(temp.l)
p2 <- ggbio() + geom_alignment(temp.l, stat = "reduce")
p1 <- ggbio() + geom_alignment(temp.l, aes(type = model))
p1
names(temp.l)
height(p1) <- 20
height(p2) <- 1
tracks(p1, p2) ## to make it look perfect
height(p2)
names(temp.l)
wh

ggplot() + geom_alignment(txdb, which = wh)
ggplot(txdb) + geom_alignment(which = wh)
ggplot(txdb) + geom_alignment(which = wh, names.expr = "tx_id(gene_id)")
ggplot(txdb) + geom_alignment(which = wh, names.expr = "tx_id:::gene_id")
ggplot() + geom_alignment(data = txdb, which = wh, names.expr = "gene_id")
ggplot(txdb) + geom_alignment(which = wh)

autoplot(txdb, which = wh)
autoplot(txdb, which = wh, names.expr = "tx_id:::gene_id")
autoplot(txdb, which = wh, names.expr = "tx_id:::gene_id", stat = "reduce")


library(Homo.sapiens)
library(ggbio)
data(genesymbol, package = "biovizBase")
wh <- genesymbol[c("BRCA1", "NBR1")]

ggplot() + geom_alignment(Homo.sapiens, which = wh)
ggplot() + geom_alignment(Homo.sapiens, which = wh, names.expr = "SYMBOL(TXNAME)")
ggplot() + geom_alignment(Homo.sapiens, which = wh, stat = "reduce")

ggplot() + geom_alignment(Homo.sapiens, which = wh, names.expr = "SYMBOL(GENEID)",
                          stat = "reduce")


autoplot(Homo.sapiens, which  = wh)
p <- autoplot(Homo.sapiens, which  = wh, label.color = "gray40", color = "brown",
          fill = "brown")
p <- autoplot(Homo.sapiens, which = wh, stat = "reduce")
autoplot(Homo.sapiens, which  = wh, label.color = "gray40", gap.geom = "")

p + zoom() ## fix me, arrow cannot be re-drawned
p + prevView()
p + nextView()

setGeneric("layout_circle", function(data,...) standardGeneric("layout_circle"))

setMethod("layout_circle",  "GRanges",
          function(data, ..., geom = c("point","line", "link", "ribbon","rect", "bar",
                                       "segment","hist", "scale",  "heatmap",
                                "ideogram", "text"), linked.to,
                          radius = 10, trackWidth = 5,
                          space.skip = 0.015, direction = c("clockwise", "anticlockwise"),
                          link.fun = function(x, y, n = 30) bezier(x, y, evaluation = n),
                   rect.inter.n = 60, rank,  ylim = NULL,
                   scale.n = 60, scale.unit = NULL, scale.type = c("M", "B", "sci"),
                   grid.n = 5, grid.background = "gray70", grid.line = "white",
                   grid = FALSE,
                   chr.weight = NULL){

  args <- dots <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.parsed <- c(args.aes, args.non)
  scale.type <- match.arg(scale.type)
  geom <- match.arg(geom)
  ## rank
  if(!missing(rank)){
    radius <- radius + rank * trackWidth
  }

  drawGrid <- function(){
    data <- getIdeoGR(data)
    res <- transformToRectInCircle(data, y = character(),
                     space.skip = space.skip, trackWidth = trackWidth, radius = radius,
                     direction = direction, n = rect.inter.n, mul = 0, chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    idx <- order(df$.biovizBase.group, df$.int.id)
    df <- df[idx, ]
    args.aes <-   args.non <- list()
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$group <- as.name(".biovizBase.group")
    args.non$fill <- args.non$color <- grid.background
    args.tot <- c(list(data = df), list(do.call(aes, args.aes)),args.non)
    res <- do.call(geom_polygon, args.tot)
    p <- list(res)
    data <- rep(data, grid.n)
    values(data)$.grid.level <- rep(1:grid.n, each = length(data)/grid.n)
    res <- transformToSegInCircle(data, y = ".grid.level",
                    space.skip = space.skip, trackWidth = trackWidth,
                                  n = rect.inter.n,
                    radius = radius, direction = direction, chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    args.aes <-   args.non <- list()
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$group <- as.name(".biovizBase.group")
    aes <- do.call("aes", args.aes)
    args.non$color <- grid.line
    args.tot <- c(list(data = df), list(aes), args.non)
    res <- do.call(geom_path, args.tot)
    p <- c(p ,list(res))
  }
  if(grid)
    p.grid <- drawGrid()
  ## idoegram parse seqlengths
  if(geom == "ideogram"){
    data <- getIdeoGR(data)
    res <- transformToRectInCircle(data,
                                   y = if (!is.null(args.aes$y))
                                       quo_name(args.aes$y),
                                   space.skip = space.skip,
                                   trackWidth = trackWidth, radius = radius,
                                   direction = direction,
                                   n = rect.inter.n, chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    idx <- order(df$.biovizBase.group, df$.int.id)
    df <- df[idx, ]
    args.aes <- args.aes[names(args.aes) != "label"]
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$group <- as.name(".biovizBase.group")


    if("fill" %in% names(args.aes)){
      if(!"color" %in% names(args.parsed) && !"colour" %in% names(args.parsed)) {
        args.aes$color <- args.aes$fill
      }
    }
    aes <- do.call("aes", args.aes)
    if(!"color" %in% names(args.parsed) && !"colour" %in% names(args.parsed)){
      col <- I("black")
      args.non$color <- col
    }
    args.tot <- c(list(data = df, aes), args.non)
    res <- do.call(geom_polygon, args.tot)
    p <- list(res)

  }

  if(geom == "text"){
    obj <- transformToGenome(data, space.skip, chr.weight = chr.weight)
    if("label" %in% names(args.aes)){
      lbs <- quo_name(args.aes$label)
      if(!lbs %in% c(colnames(mold(obj[1,])),"start", "end", "seqnames","width"))
        stop("label must be one of column names")
    }else{
      stop("missing label argument in aes()")
    }
    obj <- transformToCircle(obj,
                             y = if(!is.null(args.aes$y)) quo_name(args.aes$y),
                             radius= radius, ylim = ylim,
                             trackWidth = trackWidth,
                             direction = direction)
    ## compute angle
    if("angle" %in% names(args.aes)){
      ags <- eval_tidy(args.aes$angle, data)
      ags <-  - values(obj)$.circle.angle * 180 / pi + ags
      values(obj)$.processed.angle <- ags
      args.aes$angle <- as.name(".processed.angle")
    }else{
      ags <-  - values(obj)$.circle.angle * 180/pi
      values(obj)$.processed.angle <- ags
      args.aes$angle <- as.name(".processed.angle")
    }
    if("angle" %in% names(dots)){
      ags <-  - values(obj)$.circle.angle * 180 / pi +
        as.numeric(paste(as.character(dots$angle), collapse = ""))
      values(obj)$.processed.angle <- ags
      args.aes$angle <- as.name(".processed.angle")
    }
    names(obj) <- NULL
    df <- as.data.frame(obj)
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    aes <- do.call("aes", args.aes)
    args.tot <- c(list(data = df, aes), args.non)
    res <- do.call(geom_text, args.tot)
    p <- list(res)

  }

  if(geom == "point"){
    obj <- transformToGenome(data, space.skip, chr.weight = chr.weight)
    if(!"y" %in% names(args.aes)){
      .y <- 1
      warning("y is missing in aes(), use equal y")
    }else{
      .y <- quo_name(args.aes$y)
    }
    obj <- transformToCircle(obj, y = .y, radius= radius, trackWidth = trackWidth, ylim = ylim,
                     direction = direction)
    names(obj) <- NULL
    df <- as.data.frame(obj)
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    aes <- do.call("aes", args.aes)
    args.tot <- c(list(data = df, aes), args.non)
    res <- do.call(geom_point, args.tot)
    p <- list(res)
  }

  if(geom == "line"){
    if(!"y" %in% names(args.aes))
      stop("y is missing in aes()")
    obj <- transformToGenome(data, space.skip, chr.weight = chr.weight)
    obj <- transformToCircle(obj,
                             y = if (!is.null(args.aes$y))
                                 quo_name(args.aes$y), ylim = ylim,
                             radius = radius, trackWidth = trackWidth,
                             direction = direction)
    names(obj) <- NULL
    df <- as.data.frame(obj)
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$group <- as.name("seqnames")
    aes <- do.call("aes", args.aes)
    args.tot <- c(list(data = df, aes), args.non)
    res <- do.call(geom_path, args.tot)
    p <- list(res)
  }

  if(geom == "segment"){
      res <- transformToSegInCircle(data,
                                    y = if (!is.null(args.aes$y))
                                        quo_name(args.aes$y),
                                    space.skip = space.skip,
                                    trackWidth = trackWidth,
                                    radius = radius, direction = direction,
                                    chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$group <- as.name(".biovizBase.group")
    aes <- do.call("aes", args.aes)
    args.tot <- c(list(data = df), list(aes), args.non)
    res <- do.call(geom_path, args.tot)
    p <- list(res)
  }

  if(geom == "heatmap"){
      res <- biovizBase:::transformToSegInCircle2(data,
                                                  y = if (!is.null(args.aes$y))
                                                      quo_name(args.aes$y),
                                                  space.skip = space.skip,
                                                  trackWidth = trackWidth,
                                                  radius = radius,
                                                  direction = direction,
                                                  chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$group <- as.name(".biovizBase.group")
    aes <- do.call("aes", args.aes)
    args.tot <- c(list(data = df), list(aes), args.non)
    res <- do.call(geom_path, args.tot)
    p <- list(res)
  }

  if(geom == "scale"){
    ## like ideogram
    res <- getIdeoGR(data)
    res <- getScale(res, scale.unit, n = scale.n, scale.type)
    values(res)$.biovizBase.group <- seq_len(length(res))
    res0 <- res
    values(res0)$scale.y <- 0
    values(res0)$.biovizBase.group <- seq_len(length(res0))
    res <- c(res, res0)
    res <- transformToGenome(res, space.skip, chr.weight = chr.weight)
    res <- transformToCircle(res, y = "scale.y", radius= radius, trackWidth = trackWidth,
                             ylim = ylim,
                     direction = direction)
    names(res) <- NULL
    df <- as.data.frame(res)
    idx <- order(df$.biovizBase.group)
    df <- df[idx, ]
    N <- nrow(df)
    res <- df[seq(1, N-1, by = 2),]
    res[,c(".circle.xend", ".circle.yend")] <-
      df[seq(2, N, by = 2), c(".circle.x", ".circle.y")]
    args.aes$y <- as.name(".circle.y")
    args.aes$x <- as.name(".circle.x")
    args.aes$yend <- as.name(".circle.yend")
    args.aes$xend <- as.name(".circle.xend")
    ## aes <- do.call("aes", args.aes)
    args.aes.text <- args.aes[!names(args.aes) %in% c("xend", "yend")]
    if("angle" %in% names(args.aes)){
      ags <- eval_tidy(args.aes$angle, data)
      ags <- 90 - res$.circle.angle * 180 / pi + ags
      res$.processed.angle <- ags
      args.aes.text$angle <- as.name(".processed.angle")
    }else{
      ags <- 90 - res$.circle.angle * 180/pi
      res$.processed.angle <- ags
      args.aes.text$angle <- as.name(".processed.angle")
    }
    args.aes.text$label <- as.name("text.major")
    if(!"hjust" %in% c(names(args.non), names(args.aes.text)))
      args.non$hjust <- 0
    if(!"size" %in% c(names(args.non), names(args.aes.text)))
      args.non$size <- 3

    aes <- do.call("aes", args.aes)
    aes.text <- do.call("aes", c(args.aes.text))
    args.tot <- c(list(data = res), list(aes.text), args.non)
    res.text <- do.call(geom_text, args.tot)
    res.seg <- do.call(ggplot2::geom_segment,c(list(data = res), list(aes)))
    p <- c(list(res.text), list(res.seg))
  }

  if(geom == "rect"){
      res <- transformToRectInCircle(data,
                                     y = if (!is.null(args.aes$y))
                                         quo_name(args.aes$y),
                                     space.skip = space.skip,
                                     trackWidth = trackWidth, radius = radius,
                                     direction = direction, n = rect.inter.n,
                                     chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    idx <- order(df$.biovizBase.group, df$.int.id)
    df <- df[idx, ]
    args.aes.p <- args.aes
    args.aes.p$y <- as.name(".circle.y")
    args.aes.p$x <- as.name(".circle.x")
    args.aes.p$group <- as.name(".biovizBase.group")
    aes.p <- do.call("aes", args.aes.p)
    if(!"color" %in% names(args.parsed) && !"colour" %in% names(args.parsed)){
      args.non$color <- "black"
    }
    if(!"fill" %in% names(args.parsed)){
      args.non$fill <- "black"
    }
    args.tot <- c(list(data = df, aes.p), args.non)
    res <- do.call(geom_polygon, args.tot)
    p <- list(res)
  }

  if(geom == "bar"){
      res <- transformToBarInCircle(data,
                                    y = if (!is.null(args.aes$y))
                                        quo_name(args.aes$y),
                                    space.skip = space.skip,
                                    trackWidth = trackWidth, radius = radius,
                                    direction = direction, n = rect.inter.n,
                                    chr.weight = chr.weight)
    names(res) <- NULL
    df <- as.data.frame(res)
    idx <- order(df$.biovizBase.group, df$.int.id)
    df <- df[idx, ]
    args.aes.p <- args.aes
    args.aes.p$y <- as.name(".circle.y")
    args.aes.p$x <- as.name(".circle.x")
    args.aes.p$group <- as.name(".biovizBase.group")
    aes.p <- do.call("aes", args.aes.p)
    if(!"color" %in% names(args.aes) & !"color" %in% names(args.non)){
      args.non$color <- "black"
    }
    if(!"fill" %in% names(args.aes) & !"fill" %in% names(args.non)){
      args.non$fill <- "black"
    }
    args.tot <- c(list(data = df, aes.p), args.non)
    res <- do.call(geom_polygon, args.tot)
    p <- list(res)
  }

  if(geom == "link"){
    res <- transformToLinkInCircle(data, space.skip = space.skip, linked.to = linked.to,
                     link.fun = link.fun, trackWidth = trackWidth, radius = radius,
                     direction = direction, chr.weight = chr.weight)
    args.aes$y <- as.name("y")
    args.aes$x <- as.name("x")
    args.aes$group <- as.name(".biovizBase.group")
    aes <- do.call("aes", args.aes)
    args.tot <- c(list(data = res, aes), args.non )
    res <- do.call(geom_path, args.tot)
    p <- list(res)

  }
  if(geom == "ribbon"){
    stop("geom(ribbon) is not implemented yet")
  }
  if(geom == "hist"){
    stop("geom(hist) is not implemented yet")
  }
  if(grid)
    p <- c(p.grid, p)
  p <- c(p, list(theme_null(), theme(aspect.ratio = 1)))
  p
})



## layout_circle <- function(...){
##     .Deprecated("circle")
##     message("layout_circle() is now a lower level component to transform a linear object")
##     circle(...)
## }



circle <- function(...){
    args <- list(...)
    class(args) <- "circle"
    args
}

.radius <- function(args){
    idx <- names(args) %in% c("r", "radius")
    if(sum(idx)){
        return(args[[which(idx)[1]]])
    }else{
        return(NULL)
    }

}

.trackWidth <- function(args){
    idx <- names(args) == "trackWidth"
    if(sum(idx)){
        return(args[[which(idx)[1]]])
    }else{
        return(5)
    }
}

setGeneric("geom_segment", function(data, ...) standardGeneric("geom_segment"))

setMethod("geom_segment", "ANY", function(data, ...){
    ggplot2::geom_segment(data  = data, ...)
})

setMethod("geom_segment", "GRanges", function(data,..., xlab, ylab, main,
                                           facets = NULL,
                                           stat = c("stepping", "identity"),
                                           group.selfish = TRUE){

  args <- list(...)
  args$facets <- facets
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.non <- remove_args(args.non, "facets")
  facet <- build_facet(data, args)
  
  stat <- match.arg(stat)
  es <- ifelse("extend.size" %in% names(args.non), args.non$extend.size, 0)
  if(length(data)){
  if(stat == "stepping"){
    grl <- splitByFacets(data, facets)
    res <- endoapply(grl, make_addStepping, args.aes, group.selfish, extend.size = es)
    df <- mold(unlist(res))

    args.aes <- remove_args(args.aes, c("x", "xend", "y", "yend", "data"))
    args.non <- remove_args(args.non, c("x", "xend", "yend", "yend", "data"))
    gpn <- ifelse("group" %in% names(args), quo_name(args$group), "stepping")
    args.aes <- remove_args(args.aes, "group")
    args.aes <- c(args.aes, list(x = substitute(start),
                                 xend = substitute(end),
                                 y = substitute(stepping),
                                 yend = substitute(stepping)))

    args.aes <- remove_args(args.aes, c("size", "fill"))
    aes.res <- do.call(aes, args.aes)
    args.res <- c(list(data = df), list(aes.res), args.non)
    p <- list(do.call(ggplot2::geom_segment,args.res))
    p <- .changeStrandColor(p, args.aes)
    .df.sub <- group_df(df, gpn)
    y_scale <- scale_y_continuous_by_group(.df.sub, gpn, group.selfish)
    p <- c(p, y_scale)
  }
  
  if(stat == "identity"){
    if(!"y" %in% names(args.aes)){
      if(!all(c("y","yend", "x", "xend") %in% names(args.aes))){
        stop("aes(x =, xend= , y =, yend= ) is required for stat 'identity',
              you could also specify aes(y =) only as alternative")
      }
    }else{
      .y <- args.aes$y
      args.aes$x <- as.name("start")
      args.aes$xend <- as.name("end")
      args.aes$y <- args.aes$yend <- .y
    }
    df <- mold(data)
    args.aes <- remove_args(args.aes, c("group", "size", "fill"))
    
    aes.res <- do.call(aes, args.aes)
    args.res <- c(list(data = df), list(aes.res),args.non)
    p <- list(do.call(ggplot2::geom_segment,args.res))
    p <- .changeStrandColor(p, args.aes)
  }
  }else{
    p <- NULL
  }
  p <- c(list(p) , list(facet))
  labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
  p <- c(p, labels)
  p
})

setGeneric("layout_linear", function(data,...)
           standardGeneric("layout_linear"))

setMethod("layout_linear", "GRanges", function(data, ...){
  p <- autoplot(data, ...)
  p <- facet_grid(scales = "free_x", space = "free_x") +
          scale_x_continuous(breaks = NULL, expand = c(0, 0))
  p
})

## FIXME: add ..coverage.., and a new way
setGeneric("stat_coverage", function(data, ...) standardGeneric("stat_coverage"))

setMethod("stat_coverage", "GRanges", function(data, ...,xlim,
                                               xlab, ylab, main,
                                               facets = NULL,
                                               geom = NULL){


  if(is.null(geom))
    geom <- "area"
  data <- keepSeqlevels(data, unique(as.character(seqnames(data))))
  args <- list(...)
  args$facets <- facets
  args$geom <- geom
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
  facet <- .buildFacetsFromArgs(data, args.facets)
  if(length(data)){
  grl <- splitByFacets(data, facets)
  if(missing(xlim))
    xlim <- c(min(start(ranges(data))),
              max(end(ranges(data))))
  if(!length(facets))
    facets <- as.formula(~seqnames)
  facets <- strip_formula_dots(facets)
  ## need to get variables from all mapping not just facet
  allvars <- unique(c(all.vars(as.formula(facets)),
                      vapply(args.aes, quo_name, character(1L))))
  ## getting variables need to be kept for aesthetic mapping
  allvars.extra <- allvars[!allvars %in% c(".", "seqnames", "strand", "coverage")]
  lst <- lapply(grl, function(dt){
    vals <- coverage(keepSeqlevels(dt, unique(as.character(seqnames(dt)))))
    if(any(is.na(seqlengths(dt)))){
      seqs <- xlim[1]:max(end(dt))
      vals <- vals[[1]][seqs]
      vals <- as.numeric(vals)
      vals <- c(vals, rep(0, xlim[2]-max(end(dt))))
      seqs <- xlim[1]:xlim[2]
    }else{
      seqs <- xlim[1]:xlim[2]
      vals <- vals[[1]][seqs]
      vals <- as.numeric(vals)
    }
    if(geom == "area" | geom == "polygon"){
      seqs <- c(seqs, rev(seqs))
      vals <- c(vals, rep(0, length(vals)))
     }
    if(length(unique(values(dt)$.id.name))){
      res <- data.frame(coverage = vals, seqs = seqs,
                        seqnames =
                        as.character(seqnames(dt))[1],
                        .id.name = unique(values(dt)$.id.name))
    }else{
      if("strand" %in% all.vars(facets))
        res <- data.frame(coverage = vals, seqs = seqs,
                          seqnames =
                          as.character(seqnames(dt))[1],
                          strand = unique(as.character(strand(dt))))
      else
        res <- data.frame(coverage = vals, seqs = seqs,
                          seqnames =
                          as.character(seqnames(dt))[1])


    }

    for(v in allvars.extra){
      res[,v] <- rep(unique(values(dt)[, v]), nrow(res))
    }
      res
  })
  res <- do.call(rbind, lst)

  if(!"y"  %in% names(args.aes))
    args.aes$y <- as.name("coverage")

  if(!"x"  %in% names(args.aes))
    args.aes$x <- as.name("seqs")

  aes <- do.call(aes, args.aes)
  if(geom  == "area" | geom == "polygon")
    args.non$geom <- "polygon"
  args.non <- remove_args(args.non, "facets")
  args.res <- c(list(data = res),
                list(aes),
                args.non)
  p <- do.call(stat_identity, args.res)
}else{
  p <- NULL
}

  p <- .changeStrandColor(p, args.aes)
  p <- c(list(p) , list(facet))
  labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = "Coverage"))
  p <- c(p, labels)
  p <- setStat(p)
  p
})


setMethod("stat_coverage", "GRangesList", function(data, ..., xlim,
                                                   xlab, ylab, main,
                                                   facets = NULL,
                                               geom = NULL){
  args <- list(...)
  args$facets <- facets
  args.aes <- parseArgsForAes(args)
  if(!"y" %in% names(args.aes))
    args.aes$y <- as.name("coverage")
  args.non <- parseArgsForNonAes(args)
  if(!is.null(geom))
    args.non$geom <- geom
  aes.res <- do.call(aes, args.aes)
  gr <- flatGrl(data)
  args.non$data <- gr
  p <- do.call(stat_coverage, c(list(aes.res), args.non))
  labels <- Labels(xlab, ylab, main, fallback = c(x = "Genomic Coordinates", y = "Coverage"))
  p <- c(p, labels)
  p <- setStat(p)
  p
})


setMethod("stat_coverage", "BamFile", function(data, ..., maxBinSize = 2^14, xlim,
                                               which,
                                               xlab, ylab, main,
                                               facets = NULL,
                                               geom = NULL,
                                               method = c("estimate", "raw"),
                                               space.skip = 0.1,
                                               coord = c("linear", "genome")){


  coord <- match.arg(coord)


  if(missing(which) ){
      if(method != "estimate"){
          p <- c(list(geom_blank()),list(ggplot2::ylim(c(0, 1))),
                 list(ggplot2::xlim(c(0, 1))))
          return(p)
      }else{
          seq.nm <- names(scanBamHeader(data)$target)
      }
  }else{
      if(is(which, "GRanges")){
          seq.nm <- unique(as.character(seqnames(which)))
      } else if(is(which, "character")){
          seq.nm <- which
      }else{
          stop("which must be missing, GRanges or character(for seqnames)")
      }
  }



  args <- list(...)
  args.aes <- parseArgsForAes(args)
  if(!"y" %in% names(args.aes)){
    args.aes$y <- as.name("score")
  }else{
      idx <- grepl("coverage", as.list(args.aes$y))
    if(any(idx)){
        args.aes$y[[which(idx)]] <- as.name("score")
    }
  }
  if(!"x" %in% names(args.aes)){
    args.aes$x <- as.name("midpoint")
  }
  args.non <- parseArgsForNonAes(args)
  args$facets <- facets
  args.non <- args.non[!names(args.non) %in% c("method", "maxBinSize", "data", "which")]


  if(is.null(geom))
    geom <- "line"
  args.non$geom <- geom
  method <- match.arg(method)

  res <- switch(method,
                estimate = {
                  message("Estimating coverage...")
                  res <- estimateCoverage(data, maxBinSize = maxBinSize)
                  if(!missing(which) && is(which, "GRanges"))
                    res <- subsetByOverlaps(res, which)
                  res
                },
                raw = {
                  if(missing(which))
                    stop("method 'raw' require which argument")
                  message("Parsing raw coverage...")
                  res <- crunch(data, which = which)
                })
  res.ori <- res

  if(method == "estimate"){
  message("Constructing graphics...")
  res <- res[seqnames(res) %in% seq.nm]

  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
  facet <- .buildFacetsFromArgs(res, args.facets)
  res <- keepSeqlevels(res, unique(as.character(seqnames(res))))


  if(coord == "genome"){
    res <- transformToGenome(res, space.skip = space.skip)
    res.ori <- res <- biovizBase:::rescaleGr(res)
  }

  if(geom == "area"){
    grl <- splitByFacets(res, facets)
    res <- endoapply(grl, function(gr){
      gr <- sort(gr)
      .gr1 <- gr[1]
      values(.gr1)$score <- 0
      .grn <- gr[length(gr)]
      values(.grn)$score <- 0
      c(gr,.gr1, .grn)
    })
    res <- unlist(res)
  }
  res <- mold(res)
  aes.res <- do.call(aes, args.aes)
  args.res <- c(list(data = res),
                list(aes.res),
                args.non)

  p <- c(list(do.call(stat_identity, args.res)), list(facet))
}
  if(method == "raw"){
    p <- stat_coverage(res, ..., geom = geom, facets = facets)
  }

  labels <- Labels(xlab, ylab, main, fallback = c(x = "Genomic Coordinates", y = "Coverage"))
  p <- c(p, labels)
  if(is_coord_genome(res.ori)){
    ss <- getXScale(res.ori)
    p <- c(p, list(scale_x_continuous(breaks = ss$breaks,
                                labels = ss$labels)))
  }
  if(coord == "genome"){
    facet <- facet_null()
    p <- c(p, list(facet))
  }
  p <- setStat(p)
  p
})

plotGrandLinear <- function(obj, ..., facets, space.skip = 0.01, geom = NULL,
                            cutoff = NULL, cutoff.color = "red",
                            cutoff.size = 1, legend = FALSE, xlim, ylim, 
                            xlab, ylab, main,
                            highlight.gr = NULL,
                            highlight.name = NULL,
                            highlight.col = "red",
                            highlight.label = TRUE,
                            highlight.label.size = 5,
                            highlight.label.offset = 0.05,
                            highlight.label.col = "black",
                            spaceline = FALSE){

  if(is.null(geom))
    geom <- "point"

  
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  two.color <- c("#0080FF", "#4CC4FF")
  ## two.color <- c("gray20", "gray50")  
  .is.seq <- FALSE
  if(!"colour" %in% names(args.aes)){
    if(!any(c("color", "colour") %in% names(args.non))){
      .color <- two.color
      args.aes$color <- as.name("seqnames")
       .is.seq <- TRUE      
    }else{
      if(length(args.non$color) > 1){
        .color <- args.non$color
        args.aes$color <- as.name("seqnames")
       .is.seq <- TRUE
        args.non <- args.non[!names(args.non) %in% c("colour", "color")]
      }
    }
  }else{
    if(quo_name(args.aes$colour) == "seqnames")
      args.aes$colour <- as.name("seqnames")
  }


  if(!"y" %in% names(args.aes))
    stop("need to provide y")
  
  args.non$coord <- "genome"
  args.non$space.skip <- space.skip
  args.non$geom <- geom
  args.non$object <- obj


  aes.res <- do.call(aes, args.aes)
  p <- do.call(autoplot, c(list(aes.res), args.non))

  if(!legend)
    p <- p + theme(legend.position = "none")

  if(!missing(ylab))
    p <- p + ylab(ylab) 
  if(!is.null(cutoff))
    p <-  p + geom_hline(yintercept = cutoff, color = cutoff.color,
                         size = cutoff.size)

  chrs <- names(seqlengths(obj))
  if(.is.seq){
    N <- length(chrs)
    cols <- rep(.color, round(N/length(.color)) + 1)[1:N]
    names(cols) <- chrs
    p <- p + scale_color_manual(values = cols)
  }
  
  if(!missing(facets)){
    args$facets <- facets
    args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
    facet <- .buildFacetsFromArgs(obj, args.facets)
    p <- p + facet
  }
  p <- p +  theme(panel.grid.minor=element_blank())
  ## highlights
  
  if(!is.null(highlight.gr)){
    idx <- findOverlaps(obj, highlight.gr)
    .h.pos <- lapply(split(queryHits(idx), subjectHits(idx)), function(id){
      gr <- GRanges(as.character(seqnames(p@data))[id][1],
                    IRanges(start = min(start(p@data[id])),
                              end = max(end(p@data[id]))))
      val <- max(as.numeric(values(p@data[id])[,quo_name(args.aes$y)])) 
      val <- val * (1 + highlight.label.offset)
      values(gr)$val <- val
      gr
    })
    .h.pos <- suppressWarnings(do.call("c", unname(.h.pos)))
    if(length(.h.pos)){
    if(is.null(highlight.name)){
      highlight.name <- names(highlight.gr)
    }else{
      highlight.name <- values(highlight.gr)[,highlight.name]
    }
    p <- p +  geom_point(data = mold(p@data[queryHits(idx)]),
                 do.call(aes, list(x = substitute(midpoint),
                                   y = args.aes$y)),
                         color = highlight.col)

    if(!is.null(highlight.name)){
   
  
      seqlevels(.h.pos, pruning.mode="coarse") <- seqlevels(obj)
      suppressWarnings(seqinfo(.h.pos) <- seqinfo(obj))
      .trans <- transformToGenome(.h.pos, space.skip = space.skip)
      values(.trans)$mean <- (start(.trans) + end(.trans))/2
      values(.trans)$names <- highlight.name
      p <- p + geom_text(data = mold(.trans), size = highlight.label.size,
                         vjust = 0, color = highlight.label.col,
                         do.call(aes, list(x = substitute(mean),
                                           y = as.name("val"),
                                           label = as.name("names"))))
    }

    }}
  if(spaceline){
    vline.df <- p@ggplot$data
    vline.df <- do.call(rbind, by(vline.df, vline.df$seqnames, function(dd){
      data.frame(start = min(dd$start),
                 end = max(dd$end))
    }))
    ## compute gap
    gap <- (vline.df$start[-1] + vline.df$end[-nrow(vline.df)])/2
    p <- p + geom_vline(xintercept = gap, alpha = 0.5, color = 'gray70') + theme(panel.grid = element_blank())
  }
  if(!missing(main))
    p <- p + labs(title = main)
  if(!missing(xlim))
    p <- p + xlim(xlim)
  if(!missing(ylim))
    p <- p + ylim(ylim)
  if(missing(xlab))
    xlab <- ""
  p <- p + ggplot2::xlab(xlab)
  p
}

## Ideogram has a special response to +xlim() method
setClass("Ideogram", contains = c("GGbio"),
         slots = list(xlabel = "logical",
             cytoband = "logical",
             subchr = "character_OR_NULL",
             aspect.ratio = "numeric",
             color = "character",
             fill = "character",
             alpha = "numeric",
             size = "numeric",
             zoom.region = "numeric_OR_NULL",
             zoom.offset = "numeric"))

Ideogram <- function(obj, subchr = NULL, which = NULL, xlabel = FALSE, cytobands = TRUE,
                     color = "red", fill = "red", alpha = 0.7,
                     zoom.region = NULL,
                     zoom.offset = 0.2, size = 1,
                     aspect.ratio = 1/20, ..., genome){
    if(missing(obj)){
        utils::data("ideoCyto", package = "biovizBase", envir = environment())
        ideo_cyto <- get("ideoCyto", envir = environment())
        if(genome %in% names(ideo_cyto)){
          obj <- ideo_cyto[[genome]]
        }else{
          obj <- getIdeogram(genome = genome, subchr = subchr, cytobands = cytobands)
        }
    }
    ## do we need subchr here
    obj.ori <- obj
    if(!length(subchr)){
        subchr <- sort(unique(as.character(seqnames(obj))))[1]
        message("use ", subchr, " automatically")
        obj <- obj[seqnames(obj) == subchr]
        obj <- keepSeqlevels(obj, subchr)
    } else {
        obj <- selectChromosome(obj, subchr)
    }
    if(!biovizBase::isIdeogram(obj))
        cytobands <- FALSE

    p <- ggplot() + layout_karyogram(obj, cytobands = cytobands, geom = NULL)
    p <- adjustZoom(obj, p, zoom.region, zoom.offset, color, fill, size, alpha)
    p <- applyTheme(p, xlabel, subchr, aspect.ratio)

    new("Ideogram", ggbio(p, data = obj.ori, ...), subchr = subchr, xlabel = xlabel,
        cytoband = cytobands, color = color, fill = fill, alpha = alpha,
        zoom.offset = zoom.offset, size = size, aspect.ratio = aspect.ratio,
        zoom.region=zoom.region)
}

setMethod("print", "Ideogram", function(x){
    ## essentially a karyogram with single chrom
    obj <- x@data
    xlabel <- x@xlabel
    subchr <- x@subchr
    aspect.ratio <- x@aspect.ratio
    color <- x@color
    fill <- x@fill
    alpha <- x@alpha
    size <- x@size
    zoom.region <- x@zoom.region
    zoom.offset <- x@zoom.offset
    cytoband <- x@cytoband
    obj <- selectChromosome(obj, subchr)
    if(!biovizBase::isIdeogram(obj))
        cytobands <- FALSE

    p <- ggplot() + layout_karyogram(obj, cytobands = cytoband, geom = NULL)
    p <- adjustZoom(obj, p, zoom.region, zoom.offset, color, fill, size, alpha)
    p <- applyTheme(p, xlabel, subchr, aspect.ratio)
    x@ggplot <- p
    x
})

setMethod("show", "Ideogram", function(object){
    object <- print(object)
    print(object@ggplot)
})

plotIdeogram <- function(obj, subchr = NULL, zoom.region = NULL, which = NULL,
                         xlab, ylab, main, xlabel = FALSE,
                         color = "red", fill = "red", alpha = 0.7,
                         zoom.offset = 0.2, size = 1,
                         cytobands = TRUE, aspect.ratio = 1/20, genome){
    if(!is.null(which) && is(which, "GRanges")){
        if(length(which) > 1){
            message("only first region used")
            which <- which[1]
        }
        subchr <- as.character(seqnames(which))
        zoom.region <- c(start(which), end(which))
    }

    p <- Ideogram(obj,
                  xlabel = xlabel,
                  subchr = subchr,
                  aspect.ratio = aspect.ratio,
                  color = color,
                  fill = fill,
                  alpha = alpha,
                  size = size,
                  zoom.region = zoom.region,
                  zoom.offset = zoom.offset,
                  genome = genome,
                  cytobands = cytobands)

    if(!missing(xlab)){
        p <- p + ggplot2::xlab(xlab)
        attr(p, "xlab") <- xlab
    }else{
        attr(p, "xlab") <- ""
    }
    if(!missing(ylab)){
        p <- p + ggplot2::ylab(ylab)
        attr(p, "ylab") <- ylab
    }else{
        p <- p + ggplot2::ylab(subchr)
    }
    if(!missing(main)){
        p <- p + labs(title = main)
        attr(p, "main") <- main
    }else{
        attr(p, "main") <- ""
    }
    p
}

setMethod("+", c("Ideogram"), function(e1, e2){
    if(inherits(e2, "xlim")){
        if("chr" %in% names(attributes(e2))){
            subchr <- attr(e2, "chr")
            if(length(subchr))
                e1@subchr <- subchr
        }
    }
    if(inherits(e2, "cartesian")){
        zoom.region <- e2$limits$x
    }else{
        zoom.region <- NULL
    }
    if(length(zoom.region)){
        e1@zoom.region <- zoom.region
    }
    e1 <- print(e1)
    e1
})

selectChromosome <- function(obj, subchr) {
    if(length(subchr)) {
        obj <- obj[seqnames(obj) == subchr]
        obj <- keepSeqlevels(obj, subchr)
    } else {
        subchr <- sort(unique(as.character(seqnames(obj))))[1]
        message("use ", subchr, " automatically")
        obj <- obj[seqnames(obj) == subchr]
        obj <- keepSeqlevels(obj, subchr)
    }
    if(length(unique(as.character(seqnames(obj)))) > 1)
        stop("Mulptiple chromosome information found")
    obj
}

adjustZoom <- function(obj, plot, zoom.region, zoom.offset, color, fill, size, alpha) {
    if(length(zoom.region)) {
        if(length(zoom.region) != 2)
            stop("zoom.region must be a numeric vector of length 2")
        zoom.df <- data.frame(x1 = zoom.region[1],
                              x2 = zoom.region[2],
                              y1 = 0 - zoom.offset,
                              y2 = 10 + zoom.offset,
                              seqnames = unique(as.character(seqnames(obj))))
        plot <- plot + ggplot2::geom_rect(data = zoom.df,
                                    do.call(aes, list(xmin = substitute(x1),
                                                      xmax = substitute(x2),
                                                      ymin = substitute(y1),
                                                      ymax = substitute(y2))),
                                    color = color, fill = fill, size = size,
                                    alpha = alpha)
    } else {
        plot
    }
}

applyTheme <- function(plot, xlabel, subchr, aspect.ratio) {
    plot <- plot + theme_alignment(grid = FALSE, ylabel = TRUE, border = FALSE) +
            scale_y_continuous(breaks = 5, labels = subchr) +
            theme(strip.background = element_rect(colour = 'NA', fill = 'NA')) +
            theme(strip.text.y = element_text(colour = 'white')) + theme(legend.position = "none") +
            ggplot2::xlab("")
    plot <- plot + theme(aspect.ratio = aspect.ratio, axis.ticks.y = element_blank())
    if(!xlabel)
        plot <- plot + theme(axis.text.x = element_blank(), axis.ticks.x = element_blank())
    plot
}

setGeneric("stat_stepping", function(data, ...) standardGeneric("stat_stepping"))

setMethod("stat_stepping", "GRanges", function(data, ...,
                                               xlab, ylab, main,
                                               facets = NULL,
                                               geom = c("rect",
                                                 "alignment", "segment")){


  geom <- match.arg(geom)
  args <- list(...)
  args$facets <- facets
  args$stat <- "stepping"
  args$data <- data
  if(length(data)){
    p <- switch(geom,
                rect = do.call(geom_rect, args),
                alignment = do.call(geom_alignment, args),
                segment = do.call(geom_segment, args))

  }else{
    p <- NULL
  }
  labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = ""))
  p <- c(p, labels)
  p <- setStat(p)
  p
})

theme_null <- function(){theme_bw() + theme(
                axis.text.x=element_blank(),
                axis.text.y=element_blank(), 
                axis.ticks=element_blank(), 
                axis.title.x=element_blank(), 
                axis.title.y=element_blank(), 
                legend.background=element_rect(fill="white", colour=NA), 
                legend.key=element_rect(colour="white"), 
                panel.background=element_blank(), 
                panel.border=element_blank(), 
                panel.grid.major=element_blank(), 
                panel.grid.minor=element_blank(), 
                plot.background=element_blank(),
                strip.background = element_blank(),
                strip.text.y = element_blank(),
                strip.text.x = element_blank()
                )}



## TODO: with axis?

theme_alignment <-   function (ylabel = FALSE, base_size = 12,
                               base_family = "", 
                               axis = TRUE, border = TRUE, grid = TRUE) 
{
  res <- theme_gray() + 
    theme(
      axis.line = element_blank(),
      axis.text.y = {if(ylabel)
                       element_text(family = base_family, size = base_size * 0.8,
                                    lineheight = 0.9, hjust = 1)
      else
        element_blank()},
      axis.title.x = element_text(family = base_family, size = base_size, vjust = 1),
      axis.title.y = element_text(family = base_family, size = base_size,
        angle = 90, vjust = 0.5, colour = "white"),
      axis.ticks.length = unit(0.3, "lines"),
      axis.text = element_text(margin=margin_auto(0.5, unit = "lines")),
      panel.background = element_blank(),
      panel.border = {if(border)
                        element_rect(fill = NA, colour = "grey50")
      else
        element_blank()},
      panel.grid.major = {if(grid)
                            element_line(colour = "grey90", linewidth = 0.2)
      else
        element_blank()},
      panel.grid.minor = element_blank(),
      panel.spacing = unit(0.25, "lines"),
      strip.background = element_rect(fill = "grey80", colour = "grey50"), 
      strip.text.x = element_text(family = base_family, size = base_size * 0.8),
      strip.text.y = element_text(family = base_family, 
        size = base_size * 0.8, angle = -90),
      plot.background = element_rect(colour = NA), 
      plot.title = element_text(family = base_family, size = base_size * 
        1.2),
      plot.margin = unit(c(1, 1, 0.5, 0.5), "lines")) 
  if(!ylabel){
    res <- list(res, list(scale_y_continuous(breaks = NULL)))
  }
  res
}

theme_pack_panels <- function(strip.bg = FALSE, strip.text.y = TRUE){
  res <- theme(panel.background = element_blank(),
              panel.grid.major = element_blank(),
              panel.grid.minor = element_blank(),
              axis.text.y = element_blank(),
              strip.background = if(strip.bg){
                element_rect(fill = "grey80", colour = NA)
              }else{
                element_blank()
              },
              strip.text.y = if(strip.text.y){element_text(angle = 0)}else{element_blank()},
              panel.spacing = grid::unit(0, "lines"))
  res <- c(list(res),
           list(scale_y_continuous(breaks = NULL)))
                       }

theme_noexpand <- function(){
  c(list(scale_x_continuous(expand = c(0, 0))),
  list(scale_y_continuous(expand = c(0, 0))))
}



theme_clear <- function(grid.y = FALSE,
                        grid.x.minor = FALSE,
                        grid.x.major = FALSE,
                        panel.background.fill = "white",
                        panel.border.color = NA,
                        axis.ticks.x = FALSE,
                        axis.ticks.y = TRUE,
                        grid.color = "gray95",
                        axis.line.color = "gray80"){

  res <- theme_gray() + theme(panel.background = element_rect(fill = NA, color = NA),
               panel.border = element_rect(fill = NA, color = panel.border.color))
  if(!grid.y)
    res <- res + theme(panel.grid.major.y = element_blank(),
                       panel.grid.minor.y = element_blank())
  
  if(!grid.x.minor)
    res <- res + theme(panel.grid.minor.x = element_blank())
  
  if(!grid.x.major)
    res <- res + theme(panel.grid.major.x = element_blank())
  else
    res <- res + theme(panel.grid.major.x = element_line(color = grid.color))

  if(!axis.ticks.x)
    res <- res + theme(axis.ticks.x = element_blank())
  else
    res <- res + theme(axis.ticks.x = element_line(colour = "grey50"))
  if(!axis.ticks.y)
    res <- res + theme(axis.ticks.y = element_blank())
  else
    res <- res + theme(axis.ticks.x = element_line(colour = "grey50"))
  
   res <-  res + theme(axis.line = element_line(color = axis.line.color))
  
  res
}


theme_tracks_sunset <- function(bg = "#fffedb", alpha = 1, ...){
  res <- theme_clear(grid.x.major = FALSE, ...)
  attr(res, "track.plot.color") <- sapply(bg, scales::alpha, alpha)
  attr(res, "track.bg.color") <- bg
  attr(res, "label.text.color") <- "white"
  attr(res, "label.bg.fill") <- "#a52a2a"
  res
}


theme_tracks_fancy <- function(bg = c("white", "#F2C545"), alpha = 0.3,
                              label.bg.fill = c("gray80", "darkblue"),
                              label.text.color = "white"){
  res <- theme_clear(grid.x.major = FALSE)
  attr(res, "track.plot.color") <- sapply(bg, scales::alpha, alpha)
  attr(res, "label.bg.fill") <- label.bg.fill
  attr(res, "label.text.color") <- label.text.color
  res
}

setGeneric("stat_aggregate", function(data, ...) standardGeneric("stat_aggregate"))

setMethod("stat_aggregate", "GRanges", function(data, ..., xlab, ylab, main, by, FUN,
                                                maxgap=-1L, minoverlap=0L,
                                                type=c("any", "start", "end", "within", "equal"),
                                                select=c("all", "first", "last", "arbitrary"),
                                                y = NULL,
                                                window = NULL, facets = NULL, 
                                                method = c("mean", "median","max",
                                                  "min", "sum", "count", "identity"),
                                                geom = NULL){




  type <- match.arg(type)
  select <- match.arg(select)
  
  if(is.null(geom))
    geom <- "bar"

  if(is.null(window))
    window <- as.integer(width(range(ranges(data)))/20)

  args <- list(...)
  args$facets <- facets
  args$geom <- geom
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.non <- remove_args(args.non, "facets")
  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)

  if(!length(y) && "y" %in% names(args.aes))
    y <- quo_name(args.aes$y)
    
  if(!("scales" %in% names(args.facets)))
    args.facets$scales <- "free_x"
  facet <- .buildFacetsFromArgs(data, args.facets)
  grl <- splitByFacets(data, facets)

  args.extra <- args[!names(args) %in% c("start", "by", "FUN",
                                        "end", "data", "width", "delta",
                                        "simplify", "type", "geom", "window")]

  method <- match.arg(method)


  if(geom %in% c("boxplot"))
    method <- "identity"

  if(missing(FUN)){
    if(!(method %in% c("count", "identity")) & is.null(y))
      stop("need to provide y value for method ", method)
    .FUN <- switch(method,
                   identity = {
                     function(x){
                       x
                   }
                   },
                   mean = {
                     function(x){
                         mean(values(x)[, y])
                     }
                   },
                   median = {
                     function(x){
                       median(values(x)[, y])
                     }
                   },
                   max = {
                     function(x){
                       max(values(x)[, y])
                     }
                   },
                   min = {
                     function(x){
                       min(values(x)[, y])
                     }
                   },
                   sum = {
                     function(x){
                       sum(values(x)[, y])
                     }
                   },
                   count = {
                     function(x){
                       length(x)
                     }
                   })
  }else{
    .FUN <- FUN
  }


  lst <- lapply(grl, function(dt){
        snm <- unique(seqnames(dt))
        seqs <- seq(from = min(start(dt)), to = max(end(dt)), by = window)
        .by <- IRanges(start = seqs,
                       width = window)
        if(select != "all"){
          hits <- findOverlaps(ranges(dt), .by, 
                               maxgap = maxgap, minoverlap = minoverlap,
                               type = type, select = select)
          res <- rep(NA, length(.by))
          names(res) <- c(1:length(.by))
          res2 <- unlist(lapply(split(dt, hits), .FUN))
          res[names(res2)] <- res2
        }else{
          hits <- findOverlaps(ranges(dt), .by, maxgap = maxgap, minoverlap = minoverlap,
                               type = type, select = select)
          res <- rep(NA, length(.by))
          names(res) <- c(1:length(.by))
          res2 <- unlist(lapply(base::by(as.data.frame(hits), subjectHits(hits), function(x){
            x[,1]
          }), function(id){
            x <- dt[id]
            .FUN(x)
          }))
          res[names(res2)] <- res2          
        }
      if(!geom %in% c("boxplot")){
        df <- as.data.frame(.by)
        df$.value <- res
        df$.mid <- start(.by) + width(.by)/2
        df$seqnames <-snm
      }else{
        if(select != "all"){
        grq <- GRanges(snm, .by)
        idx <- findOverlaps(dt, grq, maxgap = maxgap, minoverlap = minoverlap,
                               type = type, select = select)
        values(dt)$.mid <- start(grq[idx]) + width(grq[idx])
        df <- as.data.frame(dt)
      }else{
        grq <- GRanges(snm, .by)
        idx <- findOverlaps(dt, grq, maxgap = maxgap, minoverlap = minoverlap,
                               type = type, select = select)
        dt <- dt[queryHits(idx)]
        values(dt)$.mid <- start(grq[subjectHits(idx)]) +
          width(grq[subjectHits(idx)])
        df <- as.data.frame(dt)
      }
      }
       df 
  })
  res <- do.call(rbind, lst)
  if(".value" %in% colnames(res)  && all(is.na(res$.value))){
    stop("no hits found, please tweak with parametters select and type.")
  }
  if(!geom %in% c("boxplot", "bar")){
    args.aes$x <- substitute(.mid)
    args.aes$y <- substitute(.value)
  }else{
    ## args.aes$x <- substitute(as.factor(.mid))
    args.aes$x <- substitute(factor(.mid))
    if(geom == "boxplot"){
    if(!"y" %in% names(args.aes))
      stop("for geom boxplot, y must be provied in aes()")
  }else{
    args.aes$y <- substitute(.value)
  }
  }
  aes.res <- do.call(ggplot2::aes, args.aes)
  args.res <- c(list(data = res),
                list(aes.res),
                args.non)
  if(!geom %in% c("boxplot")){
    p <- do.call(ggplot2::stat_identity, args.res)
   }else{
     args.res <- args.res[!names(args.res) %in% "geom"]
     p <- do.call(stat_boxplot, args.res)
   }
  p <- c(list(p) , list(facet))
  labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
  p <- c(p, labels)
  p <- ggbio:::setStat(p)
  p
})

## FIXME: the group.selfish doesn't work
setGeneric("geom_arrow", function(data, ...) standardGeneric("geom_arrow"))

setMethod("geom_arrow", "GRanges", function(data, ...,
                                            xlab, ylab, main, 
                                            angle = 30,
                                            length = unit(0.12, "cm"),
                                            type = "open", 
                                            stat = c("stepping", "identity"),
                                            facets = NULL, arrow.rate = 0.03,
                                            group.selfish = TRUE){



  ## remove width = 1
  idx <- width(data) > 1
  data <- data[idx]
  stat <- match.arg(stat)
  ## shape <- match.arg(shape)
  arrow.r <- max(1L, round(width(range(ranges(data))) * arrow.rate, 0))

  args <- list(...)
  args$facets <- facets
  
  args.aes <- parseArgsForAes(args)
  args.non <- remove_args(parseArgsForNonAes(args), c("fill", "facets"))


  facet <- build_facet(data, args)

  if(length(data)){
    ## small arrow
    if(stat == "stepping"){
      if(!"stepping" %in% colnames(values(data))){
        grl <- splitByFacets(data, facets)
        res <- endoapply(grl, make_addStepping, args.aes, group.selfish)
        data <- unlist(res)
      }
      df <- mold(data)
      lst <- apply(df, 1, function(x){
        x <- as.data.frame(t(x))
        x.s <- as.numeric(as.character(x$start))
        x.e <- as.numeric(as.character(x$end))
        N <- (x.e - x.s) %/% arrow.r
        N <- ifelse(N <= 2, 2, N )
        res <- approx(c(x.s, x.e),
                      rep(as.numeric(as.character(x$stepping)), 2),n = N)
        res.df <- do.call(rbind,lapply(1:N, function(i){
          x
        }))
        res.df$temp.x <- res$x
        .res <- res.df[-N,]
        .res$temp.x2 <- res.df[-1, "temp.x"]
        .res
      })
      res <- do.call(rbind,lst)
      res$stepping <- as.numeric(res$stepping)
      args.aes$x <- as.name("temp.x")
      args.aes$xend <- as.name("temp.x2")
      args.aes$y <- args.aes$yend <- as.name("stepping")

      ## need to split to two direction/maybe three?
      p <- by2(res, res$strand, function(x){
        s <- unique(as.character(x$strand))
        aes.temp <- do.call(aes, args.aes)
        aes.temp <- remove_args(aes.temp, "fill")
        if (identical(s, "+")) {
            args.non$arrow <- arrow(length = length, ends = "last",
                                    type = type, angle = angle)
        } else if (identical(s, "-")) {
            args.non$arrow <- arrow(length = length, ends = "first",
                                    type = type, angle = angle)
        }
        p <- do.call(ggplot2::geom_segment, c(list(data = x), list(aes.temp), args.non))
        p
      })
    }
    if(stat == "identity"){
    if(!"y" %in% names(args.aes)){
      if(!all(c("x","xend", "y", "yend") %in% names(args.aes))){
        stop("aes(x =, xend= , y =, yend= ) is required for stat 'identity',
              you could also specify aes(y =) only as alternative")
      }
    }else{
      .y <- args.aes$y
      args.aes$x <- as.name("start")
      args.aes$xend <- as.name("end")
      args.aes$y <-  args.aes$yend <- .y
    }
      
      df <- mold(data)

    lst <- lapply(split(df, seq_len(nrow(df))), function(x){
        x.s <- x$start
        x.e <- x$end
        N <- (x.e - x.s) %/% arrow.r
        N <- ifelse(N <= 2, 2, N )
        res <- approx(c(x.s, x.e ),
                      rep(0, 2),n = N)
        res.df <- x[rep(1L, N),]
        res.df$start <- res$x
        .res <- res.df[-N,]
        .res$end <- res.df[-1L, "start"]
        .res
      })
      res <- do.call(rbind,lst)

      p <- by2(res, res$strand, function(x){
        s <- unique(as.character(x$strand))        
        p <- switch(s,
                    "+" = {
                      args.non$arrow <- arrow(length = length, ends = "last",
                                              type = type, angle = angle)
                      aes.temp <- do.call(aes, args.aes)
                      do.call(ggplot2::geom_segment, c(list(data = x), list(aes.temp), args.non))
                      
                    },
                    "-" = {
                      args.non$arrow <- arrow(length = length, ends = "first",
                                              type = type, angle = angle)
                      aes.temp <- do.call(aes, args.aes)
                      do.call(ggplot2::geom_segment, c(list(data = x), list(aes.temp), args.non))
                    },
                    "*" = {
                      aes.temp <- do.call(aes, args.aes)                    
                      do.call(ggplot2::geom_segment, c(list(data = x), list(aes.temp), args.non))
                    })
        p
      })
    }
  }else{
    p <- NULL
  }
    p <- c(list(p) , list(facet))

  labels <- Labels(xlab, ylab, main, fallback = c(x = ""))
  p <- c(p, labels)
  p

})

setClass("Cache",
            slots = list(
              cached = "logical",
              cached_xlim = "numeric_OR_NULL",
              cached_ylim = "numeric_OR_NULL",
              ## That's bad; would be better to have something like GRanges_OR_BasicFilter_OR_NULL,
              ## but that's not working as we're also adding stuff extending BasicFilter.
              cached_which = "GRanges_OR_BasicFilter_OR_list_OR_NULL",
              cached_item = "list"
              ),
         prototype = list(cached = TRUE,
                          cached_xlim = 1,
                          cached_ylim = NULL,
                          cached_which = NULL,
             cached_item = list()
             ))

## cached always equal TRUE
## only for 'fetchable' object, set it to FALSE
Cache <- function(..., cached = TRUE, cached_xlim = NULL, cached_ylim = NULL,
                  cached_which = NULL, cached_item = list()){
  new("Cache", cached = cached,
      cached_xlim = cached_xlim,
      cached_ylim = cached_ylim,
      cached_which = cached_which,
      cached_item = cached_item, ...)
}

setGeneric("cached", function(x, ...) standardGeneric("cached"))
setMethod("cached", "Cache", function(x){
  x@cached
})
setGeneric("cached<-", function(x, value) standardGeneric("cached<-"))
setReplaceMethod("cached", c("Cache", "logical"), function(x, value){
  x@cached <- value
  x
})


setGeneric("cached_xlim", function(x, ...) standardGeneric("cached_xlim"))
setMethod("cached_xlim", "Cache", function(x){
  x@cached_xlim
})
setGeneric("cached_xlim<-", function(x, value) standardGeneric("cached_xlim<-"))
setReplaceMethod("cached_xlim", c("Cache", "numeric"), function(x, value){
  if(length(value) == 1)
    value <- rep(value, 2)
  if(length(value) > 1)
    value <- range(value)
  x@cached_xlim <- value
  x
})


setGeneric("cached_ylim", function(x, ...) standardGeneric("cached_ylim"))
setMethod("cached_ylim", "Cache", function(x){
  x@cached_ylim
})
setGeneric("cached_ylim<-", function(x, value) standardGeneric("cached_ylim<-"))
setReplaceMethod("cached_ylim", c("Cache", "numeric"), function(x, value){
  if(length(value) == 1)
    value <- rep(value, 2)
  if(length(value) > 1)
    value <- range(value)
  x@cached_ylim<- value
  x
})

setGeneric("cached_item", function(x, ...) standardGeneric("cached_item"))
setMethod("cached_item", "Cache", function(x){
  x@cached_item
})
setGeneric("cached_item<-", function(x, value) standardGeneric("cached_item<-"))
setReplaceMethod("cached_item", c("Cache", "list"), function(x, value){
  x@cached_item <- value
  x
})

setGeneric("addItem", function(x, ...) standardGeneric("addItem"))
setMethod("addItem", c("Cache"), function(x, ...){
  x@cached_item <- c(x@cached_item, list(...))
  x
})



setGeneric("cached_which", function(x, ...) standardGeneric("cached_which"))
setMethod("cached_which", "Cache", function(x){
  x@cached_which
})
setGeneric("cached_which<-", function(x, value) standardGeneric("cached_which<-"))
setReplaceMethod("cached_which", c("Cache", "GRanges_OR_BasicFilter_OR_list_OR_NULL"), function(x, value){
  x@cached_which<- value
  x
})


setGeneric("addWhich", function(x, value, ...) standardGeneric("addWhich"))
setMethod("addWhich", c("Cache", "GRanges"), function(x, value){
  if(is.null(x@cached_which)){
    x@cached_which <- value
  }else{
    x@cached_which <- c(x@cached_which, value)
  }
  x
})
setMethod("addWhich", c("Cache", "BasicFilterORlist"), function(x, value){
  if(is.null(x@cached_which)){
    x@cached_which <- value
  }else{
      if(is(x@cached_which, "GRanges"))
          stop("Shouldn't mix GRanges with BasicFilter objects!")
      x@cached_which <- c(x@cached_which, value)
  }
  x
})

## cacheSet cache item and which at the same time, make sure the lengths equals
setGeneric("cacheSet", function(x, value, ...) standardGeneric("cacheSet"))
setMethod("cacheSet", c("Cache", "GRanges"), function(x, value){
  x <- addItem(x, x)
  x <- addWhich(x, value)
  x
})
setMethod("cacheSet", c("Cache", "BasicFilterORlist"), function(x, value){
  x <- addItem(x, x)
  x <- addWhich(x, value)
  x
})

setGeneric("rescale", function(x, ...) standardGeneric("rescale"))

setGeneric("plotFragLength", function(data, model, ...)
           standardGeneric("plotFragLength"))


setGeneric("plotSpliceSum", function(data, model, ...)
           standardGeneric("plotSpliceSum"))

setGeneric("xlim",function(obj, ...) standardGeneric("xlim"))
setGeneric("xlim<-", function(x, value) standardGeneric("xlim<-"))

getGeneric("[")

setClassUnion("character_OR_expression_OR_NULL",
              c("expression", "character_OR_NULL"))

setClass("Tracks", representation(grobs = "PlotList", # working plots, not reall 'Grob'
                                 plot = "list", # original plots passed into tracks
                                 backup = "list", # backup of the whole tracks object
                                 heights = "numericORunit",
                                 xlim = "numeric",
                                 ylim = "list",
                                 xlab = "character_OR_NULL",
                                 main = "character_OR_expression_OR_NULL",
                                 main.height =  "numericORunit",
                                 scale.height =  "numericORunit",
                                 xlab.height =  "numericORunit",
                                 theme = "theme_OR_NULL",
                                 fixed = "logical",
                                 labeled = "logical",
                                 mutable = "logical",
                                 hasAxis = "logical",
                                 padding = "numericORunit",
                                 label.bg.color = "character",
                                 label.bg.fill = "character",
                                 label.text.color = "character",
                                 label.text.cex = "numeric",
                                 label.text.angle = "numeric",
                                 track.plot.color = "character_OR_NULL",
                                 track.bg.color = "character_OR_NULL",
                                 label.width = "unit"))

.tracks.theme <- setdiff(slotNames("Tracks"), c("backup", "grobs"))

tracks <- function(..., heights, xlim, xlab = NULL, main = NULL,
                   title = NULL,
                   theme = NULL,
                   track.plot.color = NULL,
                   track.bg.color = NULL,
                   main.height = unit(1.5, "lines"),
                   scale.height = unit(1, "lines"),
                   xlab.height = unit(1.5, "lines"),
                   padding = unit(-1, "lines"),
                   label.bg.color =  "white",
                   label.bg.fill = "gray80",
                   label.text.color = "black",
                   label.text.cex = 1,
                   label.text.angle = 90,
                   label.width = unit(2.5, "lines")) {

    if (is.numeric(padding) && !is.unit(padding))
        padding <- unit(padding, "lines")

    if (is.numeric(main.height) && !is.unit(main.height))
        main.height <- unit(main.height, "lines")

    if (is.numeric(scale.height) && !is.unit(scale.height))
        scale.height <- unit(scale.height, "lines")

    if (is.numeric(xlab.height) && !is.unit(xlab.height))
        xlab.height <- unit(xlab.height, "lines")

    if (!is.null(title) && is.null(main))
        main <- title

    args <- list(...)
    dots <- reduceListOfPlots(args)
    ## return plots if not
    dots <- genPlots(dots)

    plotList <- do.call(plotList, dots)

    ## convert to Plot object with extra slots
    PlotList <- do.call(PlotList, dots)

    fixed <- vapply(PlotList, fixed, logical(1L))
    mutable <- vapply(PlotList, mutable, logical(1L))
    hasAxis <- vapply(PlotList, hasAxis, logical(1L))
    labeled <- vapply(PlotList, labeled, logical(1L))
    isIdeo <- vapply(PlotList, is, "Ideogram", FUN.VALUE = logical(1L))
    isBlank <- vapply(PlotList, function(x) x@blank, logical(1L))

    ## get height
    if (missing(heights)) {
        heights <- getHeight(PlotList)
    } else {
        heights <- parseHeight(heights, length(PlotList))
    }

    ## ylim
    ylim <- lapply(PlotList[!fixed & !isIdeo & !isBlank], function(grob) {
        scales::expand_range(getLimits(grob)$ylim, mul = 0.05)
    })

    wh <- NULL

    ## xlim
    if (missing(xlim)) {
      ### FIXME: this should just try to call range(unlist(x)) on each arg
      ###        and then call range(do.call(c, unname(r))) on the successful
      ###        results.
        idx <- vapply(args, function(x) is(x, "GenomicRanges_OR_GRangesList"), logical(1L))
        if (any(idx)) {
            grs <- args[idx]
            grs <- unlist(do.call(c, unname(grs)))
            chrs <- unique(as.character(seqnames(grs)))
            if (length(chrs) > 1) {
                stop("seqnames of passed GRanges has to be the same for tracks")
            }
            ir <- reduce(ranges(grs))
            wh <- GRanges(chrs, ir)
        }
        xid <- !fixed & !isIdeo & !isBlank
        if (sum(xid)) {
            lst <- lapply(PlotList[xid], function(obj) {
                res <- getLimits(obj)
                data.frame(xmin = res$xlim[1], xmax = res$xlim[2])
            })
            res <- do.call(rbind, lst)
            xlim <- c(min(res$xmin), max(res$xmax))
            xlim <- scales::expand_range(xlim, mul = 0.1)
        } else {
            xlim <- c(0, 1)
        }
    } else {
      if (is(xlim, "IRanges")) {
          xlim <- c(start(xlim), end(xlim))
      }
      if (is(xlim,"GRanges")) {
          wh <- xlim
          xlim <- c(start(ranges(reduce(xlim, ignore.strand = TRUE))),
                    end(ranges(reduce(xlim, ignore.strand = TRUE))))
      }
      if (is.numeric(xlim)) {
          xlim <- range(xlim)
      }
    }

    ## sync xlim when construct them??
    if (!is.null(wh)) {
        PlotList <- lapply(PlotList, function(x) {
            x + xlim(wh)
        })
        PlotList <- do.call(PlotList, PlotList)
    }

    ## plot background
    N <- length(PlotList)
    if (is.null(track.plot.color)) {
        if (is.null(track.bg.color))
            track.plot.color <- vapply(PlotList, bgColor, character(1L))
        else
            track.plot.color <- rep(track.bg.color, length(PlotList))
    }
    stopifnot(length(track.plot.color) == N | length(track.plot.color) == 1)

    ## backup: record a state
    backup <- list(grobs = PlotList, plot = plotList, heights = heights,
                   xlim = xlim, ylim = ylim, xlab = xlab, main = main,
                   main.height = main.height, scale.height = scale.height,
                   xlab.height = xlab.height, theme = theme, mutable = mutable,
                   hasAxis = hasAxis, fixed = fixed, padding = padding,
                   labeled = labeled, label.bg.color = label.bg.color,
                   label.bg.fill = label.bg.fill,
                   label.text.color = label.text.color,
                   label.text.angle = label.text.angle,
                   track.plot.color = track.plot.color,
                   track.bg.color = track.bg.color,
                   label.text.cex = label.text.cex,
                   label.width = label.width)
    track_args <- list(backup = backup)
    track_args <- c("Tracks", track_args, backup)
    tracks <- do.call(new, track_args)
    ggplot2:::set_last_plot(tracks)
    tracks
}


setMethod("summary", "Tracks", function(object) {
    cat("-------------------------------------------\n")
    cat("Tracks contains: ", length(object@grobs), " graphic objects\n")
    cat("-------------------------------------------\n")
    cat("xlim:", object@xlim, "\n")
    cat("heights", object@heights, "\n")
    cat("fixed", object@fixed, "\n")
    cat("track.plot.color", object@track.plot.color, "\n")
    cat("-------------------------------------------\n")
})

setAs("Tracks", "grob", function(from) {
    grobs <- from@grobs
    N <- length(grobs)
    .scale.grob <- grobs[[N]] + xlim(from@xlim)

    if (any(from@labeled))
        nms <- names(from@grobs)
    else
        nms <- NULL

    lst <- lapply(seq_len(N), function(i) {
        if (i %in% which(from@mutable))
            grobs[[i]] <- grobs[[i]] + from@theme

        grobs[[i]] <- grobs[[i]] + ggplot2::xlab("") + labs(title = "")
        padding <- as.numeric(from@padding)
        grobs[[i]] <- grobs[[i]] +
          theme(plot.margin = ggplot2::margin(padding, 1, padding, 0.5, unit = "lines"))

        if (i %in% which(!from@hasAxis))
            grobs[[i]] <- grobs[[i]] + theme(axis.text.x = element_blank(),
                                             axis.ticks.x = element_blank())

        if (i %in% which(!from@fixed)) {
            s <- coord_cartesian(xlim = from@xlim)
            grobs[[i]] <- grobs[[i]] + s
        }

        grobs[[i]]
    })

    if (!is.null(nms))
        names(lst) <- nms

    if(any(from@labeled))
        do.call(alignPlots,
                c(lst, list(heights = from@heights,
                            padding = from@padding,
                            label.bg.color =  from@label.bg.color,
                            label.bg.fill = from@label.bg.fill,
                            label.text.color = from@label.text.color,
                            label.text.angle = from@label.text.angle,
                            label.text.cex = from@label.text.cex,
                            label.width = from@label.width,
                            track.plot.color = from@track.plot.color,
                            track.bg.color = from@track.bg.color,
                            main = from@main,
                            xlab = from@xlab,
                            main.height = from@main.height,
                            scale.height = from@scale.height,
                            xlab.height = from@xlab.height,
                            .scale.grob = .scale.grob
                            )))
    else
        do.call(alignPlots,
                c(lst, list(heights = from@heights,
                            padding = from@padding,
                            track.plot.color = from@track.plot.color,
                            track.bg.color = from@track.bg.color,
                            main = from@main,
                            xlab = from@xlab,
                            main.height = from@main.height,
                            scale.height = from@scale.height,
                            xlab.height = from@xlab.height,
                            .scale.grob = .scale.grob
                            )))
})

print.Tracks <- function(x) {
    grid.newpage()
    grid.draw(as(x, "grob"))
    ggplot2:::set_last_plot(x)
}

setMethod("show", "Tracks", function(object) {
    print(object)
    ggplot2:::set_last_plot(object)
})

setMethod("+", signature = c("Tracks", "ANY"), function(e1, e2) {
    N <- length(e1@grobs)
    .theme <- intersect(names(attributes(e2)), .tracks.theme)
    idx <- vapply(e1@grobs, mutable, logical(1L))
    for (i in seq_len(N)[idx]) {
        e1@grobs[[i]] <- e1@grobs[[i]] + e2
    }
    if (length(.theme)) {
        for (z in seq_len(length(.theme))) {
            slot(e1, .theme[z]) <- attr(e2, .theme[z])
        }
    }
    e1
})

setMethod("+", signature = c("Tracks", "theme"), function(e1, e2) {
    N <- length(e1@grobs)
    .theme <- intersect(names(attributes(e2)), .tracks.theme)
    idx <- vapply(e1@grobs, mutable, logical(1L))
    for (i in seq_len(N)[idx]) {
        e1@grobs[[i]] <- e1@grobs[[i]] + e2
    }
    if (length(.theme)) {
        for (z in seq_len(length(.theme))) {
            slot(e1, .theme[z]) <- attr(e2, .theme[z])
        }
    }
    e1@theme <- e2
    e1
})

setOldClass("zoom")
setMethod("+", signature = c("Tracks", "zoom"), function(e1, e2) {
    xlim <- e1@xlim
    e1@xlim <- .zoom(xlim, as.numeric(e2))$limits$x
    N <- length(e1@grobs)
    for (i in seq_len(N)) {
        e1@grobs[[i]] <- e1@grobs[[i]] + e2
    }
    e1
})

setOldClass("position_c")
setMethod("+", signature = c("Tracks", "position_c"), function(e1, e2) {
    if ("x" %in% e2$aesthetics) {
        if (!is.null(e2$limits))
            e1@xlim <- e2$limits
    }
    N <- length(e1@grobs)
    for (i in seq_len(N)) {
        e1@grobs[[i]] <- e1@grobs[[i]] + e2
    }
    e1
})

setOldClass("cartesian")
setMethod("+", signature = c("Tracks", "cartesian"), function(e1, e2) {
    if (!is.null(e2$limits$x))
        e1@xlim <- e2$limits$x
    if (!is.null(e2$limits$y)) {
        for (i in seq_len(length(e1@ylim))) {
            if (!fixed(e1@grobs[[i]]) && !is(e1@grobs[[i]], "Ideogram"))
                e1@ylim[[i]] <- e2$limits$y
        }
    }
    N <- length(e1@grobs)
    for (i in seq_len(N)) {
        if (!fixed(e1@grobs[[i]]))
            e1@grobs[[i]] <- e1@grobs[[i]] + e2
    }
    e1
})

xlim_car <- function(x) {
    class(x) <- c(class(x), "xlim")
    x
}

setMethod("xlim", "numeric", function(obj, ...) {
    if (length(list(...)))
        obj <- c(obj, ...)
    if (length(obj) > 2) {
        obj <- range(obj)
    }
    res <- ggplot2::coord_cartesian(xlim = obj)
    xlim_car(res)
})

setMethod("xlim", "IRanges", function(obj, ...) {
    xlim <- c(start(obj), end(obj))
    res <- ggplot2::coord_cartesian(xlim = xlim)
    xlim_car(res)
})

setMethod("xlim", "GRanges", function(obj, ...) {
    xlim <- c(start(ranges(reduce(obj, ignore.strand = TRUE))),
              end(ranges(reduce(obj, ignore.strand = TRUE))))
    res <- ggplot2::coord_cartesian(xlim = xlim)
    chr <- unique(as.character(seqnames(obj)))
    attr(res, "chr") <- chr
    attr(res, "ori") <- obj
    xlim_car(res)
})

setMethod("xlim", "Tracks", function(obj, ...) {
    obj@xlim
})

setReplaceMethod("xlim", c("Tracks", "IRanges"), function(x, value) {
    xlim <- c(start(value), end(value))
    x@xlim <- xlim
    lapply(1:length(x@grobs), function(i) {
        ylim <- x@ylim[[i]]
        s <- coord_cartesian(xlim = x@xlim, ylim = ylim)
        if (i %in% which(!x@fixed))
            x@grobs[[i]] <- x@grobs[[i]] + s
    })
    x
})

setReplaceMethod("xlim", c("Tracks", "GRanges"), function(x, value) {
    xlim <- c(start(ranges(reduce(value, ignore.strand = TRUE))),
              end(ranges(reduce(value, ignore.strand = TRUE))))
    x@xlim <- xlim
    lapply(1:length(x@grobs), function(i) {
        ylim <- x@ylim[[i]]
        s <- coord_cartesian(xlim = x@xlim, ylim = ylim)
        if (i %in% which(!x@fixed))
            x@grobs[[i]] <- x@grobs[[i]] + s
    })
    x
})

setReplaceMethod("xlim", c("Tracks", "numeric"), function(x, value) {
    xlim <- range(value)
    x@xlim <- xlim
    lapply(1:length(x@grobs), function(i) {
        ylim <- x@ylim[[i]]
        s <- coord_cartesian(xlim = x@xlim, ylim = ylim)
        if (i %in% which(!x@fixed))
            x@grobs[[i]] <- x@grobs[[i]] + s
    })
    x
})

setGeneric("reset", function(obj, ...) standardGeneric("reset"))
setMethod("reset", "Tracks", function(obj) {
    nms <- setdiff(slotNames(obj), "backup")
    for (nm in nms) {
        slot(obj, nm) <- obj@backup[[nm]]
    }
    xlim(obj) <- obj@xlim
    obj
})

setGeneric("backup", function(obj, ...) standardGeneric("backup"))
setMethod("backup", "Tracks", function(obj) {
    nms <- setdiff(slotNames(obj), "backup")
    for (nm in nms) {
        obj@backup[[nm]] <- slot(obj, nm)
    }
    obj
})

gtable_filter_grobs <- function(g, type) {
    rowSums(vapply(type, function(t) startsWith(g$layout$name, t),
                   logical(length(g$layout$name)))) > 0L
}

addLabel <- function(grobs, nms, lbs,
                     label.bg.color =  "white",
                     label.bg.fill = "gray80",
                     label.text.color = "black",
                     label.text.angle = 90,
                     label.text.cex = 1,
                     label.width = unit(2.5, "lines"),
                     direction = c("row", "col")) {
    direction <- match.arg(direction)
    if (length(label.text.angle) == 1)
        label.text.angle <- rep(label.text.angle, len = length(grobs))
    if (length(label.text.color) == 1)
        label.text.color <- rep(label.text.color, len = length(grobs))
    if (length(label.text.cex) == 1)
        label.text.cex <- rep(label.text.cex, len = length(grobs))
    if (length(label.bg.color) == 1)
        label.bg.color <- rep(label.bg.color, len = length(grobs))
    if (length(label.bg.fill) == 1)
        label.bg.fill <- rep(label.bg.fill, len = length(grobs))

    lapply(seq_len(length(grobs)), function(i) {
        if (identical(direction, "row")) {
            rot <- label.text.angle[i]
            width <- unit.c(label.width, unit(1, "null"))
            height <- unit(1, "null")
            l <- 2
            t <- 1
        } else {
            rot <- (90 - label.text.angle[i]) %% 360
            width <- unit(1, "null")
            height <- unit.c(label.width, unit(1, "null"))
            l <- 1
            t <- 2
        }

        grob <- grobs[[i]]

        if (lbs[i]) {
            rect <- rectGrob(gp = gpar(fill = label.bg.fill[i],
                             col = label.bg.color[i]))
            label <- textGrob(nms[i], rot = rot,
                              gp = gpar(col = label.text.color[i],
                              cex = label.text.cex[i]))
            x.grob <- grobTree(gTree(children = gList(rect, label)))
        } else {
            x.grob <- ggplot2::zeroGrob()
        }

        gt <- gtable(widths = width, heights = height)
        gt <- gtable_add_grob(gt, x.grob, l = 1, t = 1)
        gt <- gtable_add_grob(gt, grob, l = l, t = t)
    })
}

## TODO: adust due to left/right legend
alignPlots <- function(..., vertical = TRUE, widths = NULL,
                       heights = NULL, height = NULL, width = NULL,
                       padding = NULL,
                       track.plot.color = NULL,
                       track.bg.color = NULL,
                       label.bg.color =  "white",
                       label.bg.fill = "gray80",
                       label.text.color = "black",
                       label.text.angle = 90,
                       label.text.cex = 1,
                       label.width = unit(2.5, "lines"),
                       main.height = unit(1.5, "lines"),
                       scale.height = unit(1, "lines"),
                       xlab.height = unit(1, "lines"),
                       main = NULL,
                       xlab = NULL,
                       remove.y.axis = FALSE,
                       remove.x.axis = FALSE,
                       .scale.grob = NULL
                       ) {

  if (is.numeric(scale.height) && !is.unit(scale.height))
    scale.height <- unit(scale.height, "lines")

  if (is.numeric(main.height) && !is.unit(main.height))
    main.height <- unit(main.height, "lines")

  if (!is.null(height) && is.null(heights))
    heights <- height

  if (!is.null(width) && is.null(widths))
    widths <- width

  ggl <- list(...)

  if (length(ggl)) {
      if (length(ggl) == 1  && !is.ggplot(ggl[[1]]) && is.list(ggl[[1]])) {
        ggl <- ggl[[1]]
      }
  } else {
      return(ggplot())
  }

  label.name <- names(ggl)
  N <- length(ggl)

  if (length(track.plot.color) == 1) {
      track.plot.color <- rep(track.plot.color, N)
  }

  ## add a plot with axis and remove later
  if (vertical) {
    idx.fix <- which(!vapply(ggl, fixed, logical(1L)) & !vapply(PlotList, is, "Ideogram", FUN.VALUE = logical(1L)))[1]
    if (is.na(idx.fix))
        idx.fix <- length(ggl)
    ggl <- c(ggl, list(.scale.grob))
  }

    ## parse grobs
    ## a little slow
    grobs <- do.call(GrobList, ggl)

    if (vertical)
        grobs <- do.call(uniformAroundPanel, grobs)
    else
        grobs <- do.call(uniformAroundPanel, c(grobs,list(direction = "col")))

    .nms <- names(grobs)

    ## change background color
    grobs <- lapply(seq_len(length(grobs)), function(i) {
        ## better figure out a better idea
        .grob <- grobs[[i]]
        .col <- track.plot.color[i]
        gt.temp <- grobs[[i]]$grobs[[1]]$children[[1]]$children$layout
        ## edit background
        gt.temp$grobs[[1]] <- editGrob(gt.temp$grobs[[1]], gp = gpar(alpha = 0))
        idx <- which(gtable_filter_grobs(gt.temp, "guide-box"))
        if (length(idx) == 1L) {
            if (gtable_filter_grobs(gt.temp$grobs[[idx]]$grobs[[1]], "background")[1L]) {
                gt.temp$grobs[[idx]]$grobs[[1]]$grobs[[1]] <-
                    editGrob(gt.temp$grobs[[idx]]$grobs[[1]]$grobs[[1]],
                             gp = gpar(alpha = 0))
            }
        }
        grobs[[i]]$grobs[[1]]$children[[1]]$children$layout <- gt.temp
        grobs[[i]]$grobs[[1]] <- editGrob(grobs[[i]]$grobs[[1]], "bgColor",
                                          grep = TRUE, global = TRUE,
                                          gp  = gpar(fill = .col, col = .col))
        grobs[[i]]
    })

    names(grobs) <- .nms

    if (vertical) {
        g.last <- grobs[[length(grobs)]]
        grobs <- grobs[-length(grobs)]
        g <- g.last$grobs[[1]]$children[[1]]$children$layout
        g.s <- scaleGrob(g)
        if (length(track.bg.color)) {
            rect.grob <- rectGrob(gp=gpar(col = track.bg.color, fill = track.bg.color))
            g.s <- grobTree(gTree(children = gList(rect.grob, g.s)))
        }
        grobs <- c(grobs, list(g.s))
        if (length(main)) {
            text.grob <- textGrob(main)
            if (length(track.bg.color)) {
                rect.grob <- rectGrob(gp=gpar(col = track.bg.color, fill = track.bg.color))
                text.grob <- grobTree(gTree(children = gList(rect.grob, text.grob)))
            }
            grobs <- c(list(text.grob), grobs)
        }

        if (length(xlab)) {
            text.grob <- textGrob(xlab)
            if (length(track.bg.color)) {
                rect.grob <- rectGrob(gp=gpar(col = track.bg.color, fill = track.bg.color))
                text.grob <- grobTree(gTree(children = gList(rect.grob, text.grob)))
            }
            grobs <- c(grobs, list(text.grob))
        }
    }

    if (any(remove.y.axis)) {
        for (i in which(remove.y.axis))
            grobs[[i]] <- removeYAxis(grobs[[i]])
    }

    if (any(remove.x.axis)) {
        for (i in which(remove.x.axis))
            grobs[[i]] <- removeXAxis(grobs[[i]])
    }

    ## FIXME:
    lbs <- vapply(grobs, labeled, logical(1L))
    nms <- names(lbs)

    label_args <- list(grobs, nms, lbs,
                       label.bg.color =  label.bg.color,
                       label.bg.fill = label.bg.fill,
                       label.text.color = label.text.color,
                       label.text.cex = label.text.cex,
                       label.text.angle = label.text.angle,
                       label.width = label.width)

    if (!vertical)
        label_args <- c(label_args, list(direction = "col"))

    if (any(!is.null(nms)))
        grobs <- do.call(addLabel, label_args)

    ## reduce to normal grob
    grobs_back <- grobs
    grobs <- lapply(grobs, function(g) {
        if (is(g, "Grob")) {
            suppressWarnings(class(g) <- g@.S3Class)
            return(g)
        } else {
            return(g)
        }
    })

    if (vertical) {
        if (!length(widths)) {
            widths <- unit(1, "null")
        } else if (is.numeric(widths) && !is.unit(widths)) {
            widths <- unit(widths, "null")
        } else if (!is.unit(widths)) {
            stop("widths must be unit or numeric value")
        }
        if (!length(heights)) {
            heights <- unit(rep(1, N), "null")
        } else if (is.numeric(heights) && !is.unit(heights)) {
            heights <- unit(heights, "null")
        } else if (!is.unit(heights)) {
            stop("heights must be unit or numeric value")
        }
        ## TODO check main later
        if (length(main))
            heights <- unit.c(main.height, heights)
        if (vertical)
            heights <- unit.c(heights, scale.height)
        if (length(xlab))
            heights <- unit.c(heights, xlab.height)
            tab <- gtable(widths, heights)
            for (i in 1:length(grobs)) {
            tab <- gtable_add_grob(tab, grobs[[i]], t = i, r = 1, l  = 1)
        }
        if (length(track.bg.color)) {
            rect.grob <- rectGrob(gp=gpar(col = track.bg.color,
                                  fill = track.bg.color))
            tab <- grobTree(gTree(children = gList(rect.grob, tab)))
        }
    } else {
        if (!length(widths)) {
            widths <- unit(rep(1, N), "null")
        } else if (is.numeric(widths) && !is.unit(widths)) {
            widths <- unit(widths, "null")
        } else if (!is.unit(width)) {
            stop("widths must be unit or numeric value")
        }

        if (!length(heights)) {
            heights <- unit(1, "null")
        } else if (is.numeric(heights) && !is.unit(heights)) {
            heights <- unit(heights, "null")
        } else if (!is.unit(heights)) {
            stop("heights must be unit or numeric value")
        }
        tab <- gtable(widths, heights)
        for (i in 1:N) {
            tab <- gtable_add_grob(tab, grobs[[i]], l = i, t = 1, b = 1)
        }
    }
    tab
}

spaceAroundPanel <- function(gtable, types = c("t", "l", "b", "r")) {
    spaces <- list()
    # get panel positions for gtable$layout
    panel_position <- gtable_filter_grobs(gtable, "panel")

    for (type in types) {
        all_type_values <- gtable$layout[[type]]

        if (type %in% c("b", "r")) {
            # Find the maximum panel value and compare it to other values
            # of gtable$layout[['type']]. It provides values that are
            # outside of the maximum panel value.
            max_panel_value <- max(gtable$layout[panel_position, ][[type]])
            position <- which(all_type_values > max_panel_value)
        } else if (type %in% c("t", "l")) {
            # why minimum ?
            min_panel_value <- min(gtable$layout[panel_position, ][[type]])
            position <- which(all_type_values < min_panel_value)
        }

        # To remove duplicate position values
        unique_position <- unique(gtable$layout[[type]][position])

        # get heights and width associated with unique_position
        # from the gtable
        if (length(position) && type %in% c("t", "b"))
            res <- sum(gtable$height[unique_position])
        else if (length(position) && type %in% c("l", "r"))
            res <- gtable$width[unique_position]
        else
            res <- unit(0, "inches")

        spaces[[type]] <- res
    }
    spaces
}

## return uniformed grobs
uniformAroundPanel <- function(..., direction = c("row", "col")) {
    dir <- match.arg(direction)
    args <- list(...)

    if (length(args) == 1 && is(args[[1]], "GrobList"))
        grobs <- args[[1]]
    else
        grobs <- lapply(args, function(p) Grob(p))

    get_uniform_grobs <- function(spaces, p1, max1, p2, max2, FUN) {
        for (i in 1:length(grobs)) {
            gt <- gtable(unit(1, "null"), unit(1, "null"), name = "panel.ori")
            rect.grob <- rectGrob(gp = gpar(fill = NA, color = NA), name = "bgColor")
            grobs[[i]] <- FUN(grobs[[i]], max1 - spaces[[i]][[p1]], pos = 0)
            grobs[[i]] <- FUN(grobs[[i]], max2 - spaces[[i]][[p2]], pos = -1)
            all.grob <- grobTree(gTree(children = gList(rect.grob, grobs[[i]])))
            grobs[[i]] <- gtable_add_grob(gt, all.grob, 1, 1)
          }
        grobs
    }

    if (dir == "row") {
        spaces <- lapply(grobs, spaceAroundPanel, c("l", "r"))
        low <- unit(-0.35, "cm")
        for (x in spaces) {
            if (length(x$r) > 3L && as.numeric(x$r[4L]) < as.numeric(low))
                low <- x$r[4L]
        }
        spaces <- lapply(spaces, function(x) {
            if (length(x$r) < 4L)
                x$r <- unit.c(x$r, low)
            x$l <- sum(x$l)
            x$r <- sum(x$r)
            x
        })
        lmax <- do.call(max, lapply(spaces, function(x) x$l))
        rmax <- do.call(max, lapply(spaces, function(x) x$r))
        grobs <- get_uniform_grobs(spaces, "l", lmax, "r", rmax, gtable_add_cols)
    } else if (dir == "col") {
      spaces <- lapply(grobs, spaceAroundPanel, c("t", "b"))
      tmax <- do.call(max, lapply(spaces, function(x) x$t))
      bmax <- do.call(max, lapply(spaces, function(x) x$b))
      grobs <- get_uniform_grobs(spaces, "t", tmax, "b", bmax, gtable_add_rows)
    }
    grobs
}

align.plots <- alignPlots

scaleGrob <- function(gtable){
    idx <- gtable_filter_grobs(gtable, "axis-b")
    idx <- unique(c(gtable$layout[idx, "t"], gtable$layout[idx, "b"]))
    res <- gtable[idx,]
    res
}

removeAxis <- function(g, remove, p1, p2) {
    if (g$name == "panel.ori") {
        gr <- g$grobs[[1]]$children[[1]]$children$layout
        gr <- removeAxis(gr, remove, p1, p2)
    } else {
        idx <- gtable_filter_grobs(g, remove)
        idx <- sort(unique(c(g$layout[[p1]][idx], g$layout[[p2]][idx])))
        idx <- setdiff(seq_len(ncol(g)), idx)
        g <- g[,idx]
    }
    g
}

removeXAxis <- function(gtable) {
    remove <- c("xlab", "axis-b", "title")
    removeAxis(gtable, remove, "t", "b")
}

removeYAxis <- function(gtable) {
    remove <- c("ylab", "axis-l")
    removeAxis(gtable, remove, "l", "r")
}

getHeight <- function(dts) {
    hts <- do.call(unit.c, lapply(dts, height))
    hts
}

parseHeight <- function(hts, n) {
    if (length(hts) != n && length(hts) != 1)
        stop("Heights must be of length 1 or numbers of graphics")
    if (is.numeric(hts) && !is.unit(hts)) {
        if (length(hts) == 1)
            res <- rep(unit(1, "null"), n)
        if (length(hts) == n)
            res <- unit(hts, "null")
    } else if (is.unit(hts)) {
        res <- hts
    }
    res
}

## combining
## do something fun here, make combination method for Tracks
## support
## 1. c(Tracks, Tracks)
## 2. Tracks + Tracks
## 3. Tracks(Tracks, Tracks)
## 4. Tracks + plot (not yet)
setMethod("+", signature = c("Tracks", "Tracks"), function(e1, e2) {
    e1 <- c(e1, e2)
    e1
})

setMethod("c", "Tracks",  function(x, ...) {
    if (missing(x)) {
        args <- unname(list(...))
        x <- args[[1L]]
    } else {
        args <- unname(list(x, ...))
    }

    if (length(args) == 1L)
        return(x)

    arg_is_null <- vapply(args, is.null, FUN.VALUE = logical(1L))
    isClassValid <- vapply(args, is, class(x), FUN.VALUE = logical(1L))

    if (any(arg_is_null))
        args[arg_is_null] <- NULL  # remove NULL elements by setting them to NULL!
    if (!all(isClassValid))
        stop("all arguments in '...' must be ", class(x), " objects (or NULLs)")

    lst <- lapply(args, function(x) {
        x@grobs
    })
    ## FIXME: how to keep other attributes?
    res <- do.call(tracks, do.call(c, lst))
    res
})

setMethod("cbind", "Tracks",  function(...) {
    args <- list(...)
    isTrack <- vapply(args, is, "Tracks", FUN.VALUE = logical(1L))
    if (all(isTrack)) {
        lst <- lapply(args, as, "grob")
        res <- do.call(cbind, lst)
    } else {
        stop("need to be of class Tracks")
    }
    grid.draw(res)
})

setMethod("rbind", "Tracks",  function(...) {
    args <- list(...)
    isTrack <- vapply(args, is, "Tracks", FUN.VALUE = logical(1L))
    if (all(isTrack)) {
        lst <- lapply(args, as, "grob")
        res <- do.call(rbind, lst)
    } else {
        stop("need to be of class Tracks")
    }
    grid.draw(res)
})

setMethod("[", c("Tracks", "numeric", "missing", "ANY"),
          function(x, i, j, ..., drop=TRUE) {
              i <- as.integer(i)
              initialize(x,
                  grobs = x@grobs[i],
                  plot = x@plot[i],
                  labeled = x@labeled[i],
                  heights = x@heights[i],
                  xlim = x@xlim,
                  ylim = x@ylim,
                  xlab = x@xlab,
                  main = x@main,
                  main.height = x@main.height,
                  scale.height = x@scale.height,
                  xlab.height = x@xlab.height,
                  theme = x@theme,
                  mutable = x@mutable[i],
                  hasAxis = x@hasAxis[i],
                  fixed = x@fixed[i],
                  padding = x@padding,
                  label.bg.color = x@label.bg.color[i],
                  label.bg.fill = x@label.bg.fill[i],
                  label.text.color = x@label.text.color[i],
                  label.text.angle = x@label.text.angle[i],
                  track.plot.color = x@track.plot.color[i],
                  track.bg.color = x@track.bg.color[i],
                  label.text.cex = x@label.text.cex[i],
                  label.width = x@label.width)
          })

ggbioGrob <- function(x) {
    if (is(x, "GGbio"))
        ggplot2::ggplotGrob(x@ggplot)
    else
        ggplot2::ggplotGrob(x)
}

getLegendGrob <- function(plot) {
    gtable <- ggbioGrob(plot)
    gtable <- gtable_filter(gtable, "guide-box")
}

arrangeGrobByParsingLegend <- function(..., nrow = NULL, ncol = NULL,
                                       widths = c(4, 1), legend.idx = NULL) {
    lst <- list(...)
    if (length(lst) == 1 && is.list(lst[[1]]))
        lst <- lst[[1]]

    legends <- lapply(lst, getLegendGrob)

    plots <- lapply(lst, function(x) {
        x <- x + theme(legend.position = "none", aspect.ratio = 1)
        ggbioGrob(x)
    })

    if (!is.null(legend.idx))
        legends <- legends[legend.idx]
    legends <- do.call(gridExtra::arrangeGrob, c(legends, list(ncol = 1)))
    plots <- do.call(gridExtra::arrangeGrob, c(plots, list(nrow = nrow, ncol = ncol)))
    print(gridExtra::grid.arrange(plots, legends, ncol = 2, widths = widths))
}

ggbio_ggplot <- function(data, mapping = aes(), ...,
                         environment = parent.frame()) {
    gg <- ggplot(mapping = mapping, ..., environment=environment)
    GGbio(gg, data = data)
}

ggbio_ggplot_mold <- function(data, mapping = aes(), ...,
                              environment = parent.frame()) {
    gg <- ggplot(mold(data), mapping, ..., environment=environment)
    GGbio(gg, data = data)
}

ggplot.Vector <- ggbio_ggplot_mold
ggplot.Seqinfo <- ggbio_ggplot_mold
ggplot.matrix <- ggbio_ggplot_mold # highly questionable
ggplot.ExpressionSet <- ggbio_ggplot_mold
ggplot.RsamtoolsFile <- ggbio_ggplot
ggplot.character <- ggbio_ggplot # highly questionable
ggplot.TxDbOREnsDb <- ggbio_ggplot
ggplot.BSgenome <- ggbio_ggplot
ggplot.GAlignments <- ggbio_ggplot
ggplot.VCF <- ggbio_ggplot

ggplot.SummarizedExperiment <- function(data, mapping = aes(), assay.id = 1L,
                                        ..., environment = parent.frame()) {
    df <- mold(data, assay.id=assay.id)
    g <- ggplot(df, mapping, ..., environment=environment)
    g <- GGbio(g, data = data)
    g
}

## FIXME: add ..coverage.., and a new way
setGeneric("stat_slice", function(data, ...) standardGeneric("stat_slice"))

get_coordinate_by_type <- function(type, vs, na.rm, islist = FALSE) {
   values <- switch(type,
            viewMaxs = list(x = viewWhichMaxs(vs, na.rm = na.rm), y = viewMaxs(vs, na.rm = na.rm)),
            viewMins = list(x = viewWhichMins(vs, na.rm = na.rm), y = viewMins(vs, na.rm = na.rm)),
            viewSums = list(x = start(vs) + width(vs)/2, y = viewSums(vs, na.rm = na.rm)),
            viewMeans = list(x = start(vs) + width(vs)/2, y = viewMeans(vs, na.rm = na.rm)))
    if (islist) {
        values[["xmin"]] <- start(vs)
        values[["xmax"]] <- end(vs)
    }
    values
}

map_coordinate_by_geom <- function(geom, args.aes, args.non, vs, islist = FALSE) {
    values <- list()
    if (islist) {
        values[["xmin"]] <- as.name("xmin")
        values[["xmax"]] <- as.name("xmax")
    } else {
        values[["xmin"]] <- start(vs)
        values[["xmax"]] <- end(vs)
    }

    if (geom == "segment") {
        args.aes$x <- as.name("x")
        args.aes$xend <- as.name("x")
        args.aes$y <- 0
        args.aes$yend <- as.name("y")
    }
    if (geom == "rect") {
        args.aes$xmin <- values[["xmin"]]
        args.aes$xmax <- values[["xmax"]]
        args.aes$ymin <- 0
        args.aes$ymax <- 5
        args.aes <- args.aes[!names(args.aes) %in% c("x", "y")]
    }
    if (geom == "heatmap") {
        args.non$geom <- "rect"
        args.aes$xmin <- values[["xmin"]]
        args.aes$xmax <- values[["xmax"]]
        args.aes$ymin <- 0
        args.aes$ymax <- 5
        args.aes <- args.aes[!names(args.aes) %in% c("x", "y")]
        args.aes$color <- as.name("y")
        args.aes$fill <- as.name("y")
    }
    if (geom == "bar") {
        args.non$geom <- "rect"
        args.aes$xmin <- values[["xmin"]]
        args.aes$xmax <- values[["xmax"]]
        args.aes$ymin <- 0
        args.aes$ymax <- as.name("y")
        args.aes <- args.aes[!names(args.aes) %in% c("x", "y")]
    }
    if (geom %in% c("bar", "rect")) {
        if(!"color" %in% names(args.aes) &&
        !"color" %in% names(args.non) &&
        !"colour" %in% names(args.aes) &&
        !"colour" %in% names(args.non)) {
            args.non$color <- "grey20"
        }
    }
    list(args.aes = args.aes, args.non = args.non)
}

setMethod("stat_slice", "Rle", function(data, ...,
                                        xlab, ylab, main,
                                        na.rm = FALSE,
                                        geom = NULL,
                                        lower=-Inf, upper=Inf,
                                        includeLower=TRUE, includeUpper=TRUE,
                                        rangesOnly = FALSE,                                       
                                        type = c("viewSums","viewMins",
                                        "viewMaxs", "viewMeans")){



  type <- match.arg(type)

  if(is.null(geom))
    geom <- "segment"
  
  args <- list(...)
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  
  if(!"x" %in% names(args.aes))
    args.aes$x <- substitute(x)
  
  if(!"y" %in% names(args.aes))
    args.aes$y <- substitute(y)

  args.non$geom <- geom  
  vs <- slice(data, upper = upper, lower = lower, includeLower = includeLower,
              includeUpper = includeUpper, rangesOnly = rangesOnly)
  values <- get_coordinate_by_type(type, vs, na.rm)
  df <- data.frame(x = values[["x"]], y = values[["y"]])
  values <- map_coordinate_by_geom(geom, args.aes, args.non, vs)
  args.aes <- values[["args.aes"]]
  args.non <- values[["args.non"]]
  args.non$data <- df
  aes.args <- do.call(aes, args.aes)
  res.args <- c(list(aes.args), args.non)
  p <- do.call(ggplot2::stat_identity, res.args)
    if(!missing(xlab))
    p <- c(p, list(ggplot2::xlab(xlab)))
  else
    p <- c(p, list(ggplot2::xlab("x")))

  if(!missing(ylab))
    p <- c(p, list(ggplot2::ylab(ylab)))
  else
    p <- c(p, list(ggplot2::ylab("y")))
  if(!missing(main))
    p <- c(p, list(labs(title = main)))
  p <- setStat(p)  
  p
})


setMethod("stat_slice", "RleList", function(data, ...,
                                        xlab, ylab, main,
                                            indName = "sample",
                                        na.rm = FALSE,
                                        geom = NULL,
                                        lower=-Inf, upper=Inf,
                                        includeLower=TRUE, includeUpper=TRUE,
                                        rangesOnly = FALSE,                                       
                                        type = c("viewSums","viewMins",
                                        "viewMaxs", "viewMeans")){

  type <- match.arg(type)

  if(is.null(geom))
    geom <- "segment"
  args <- list(...)

  args.aes <- parseArgsForAes(args)
  
  if(!"x" %in% names(args.aes))
    args.aes$x <- as.name("x")
  
  if(!"y" %in% names(args.aes))
    args.aes$y <- as.name("y")
  
  args.non <- parseArgsForNonAes(args)
  args.non$geom <- geom
  vs <- slice(data, upper = upper, lower = lower, includeLower = includeLower,
              includeUpper = includeUpper, rangesOnly = rangesOnly)
  values <- get_coordinate_by_type(type, vs, na.rm, islist = TRUE)
  x <- values[["x"]]
  if (is.null(names(x)))
      nms <- rep(1:length(x), times = elementNROWS(x))
  else
      nms <- rep(names(x), times = elementNROWS(x))
  df <- data.frame(x = unlist(values[["x"]]), y = unlist(values[["y"]]), listName = nms,
                    xmin = unlist(values[["xmin"]]), xmax = unlist(values[["xmax"]]))
  colnames(df) <- c("x", "y", indName, "xmin", "xmax")

  if(is.null(names(x)))
    levels(df[, indName]) <- 1:length(x)
  else
    levels(df[, indName]) <- unique(names(x))

  facets <- as.formula(paste(indName, "~ .", sep = ""))

  args$rows <- facets
  args.facets <- subsetArgsByFormals(args, facet_grid, facet_wrap)
  facet <- do.call(facet_grid, args.facets)

  values <- map_coordinate_by_geom(geom, args.aes, args.non, vs, islist = TRUE)
  args.aes <- values[["args.aes"]]
  args.non <- values[["args.non"]]

  args.non$data <- df
  aes.args <- do.call(aes, args.aes)
  res.args <- c(list(aes.args), args.non)
  p <- do.call(ggplot2::stat_identity, res.args)
    if(!missing(xlab))
    p <- c(p, list(ggplot2::xlab(xlab)))
  else
    p <- c(p, list(ggplot2::xlab("x")))

  if(!missing(ylab))
    p <- c(p, list(ggplot2::ylab(ylab)))
  else
    p <- c(p, list(ggplot2::ylab("y")))
  if(!missing(main))
    p <- c(p, list(labs(title = main)))
  p <- c(list(p), list(facet))
  p <- setStat(p)
  p
})

## TODO:ideogram need to be fixed
setClass("Tracked", slots = c(mutable = "logical", fixed = "logical",
                      labeled = "logical", hasAxis = "logical",
                      bgColor = "character", height = "numericORunit"),
         prototype = list(mutable = TRUE, fixed = FALSE, labeled = TRUE,
           hasAxis = FALSE, bgColor = "white", height = unit(1, "null")))


Tracked <- function(mutable = TRUE, fixed = FALSE, labeled = TRUE,
                    hasAxis = FALSE, bgColor = "white", height = unit(1, "null")){
  new("Tracked", mutable = mutable, fixed = fixed, labeled = labeled,
      hasAxis = hasAxis, bgColor = bgColor, height = height)
}

## background color
setGeneric("bgColor",  function(x) standardGeneric("bgColor"))
setGeneric("bgColor<-",  function(x, value) standardGeneric("bgColor<-"))
setMethod("bgColor", "Tracked", function(x){
  x@bgColor
})
setReplaceMethod("bgColor", c("Tracked", "character"), function(x, value){
  x@bgColor <- value
  x
})

setMethod("bgColor", "gg", function(x){
  bg <- attr(x, "bgcolor")
  if(is.null(bg))
    return("white")
  else
    return(bg)
})

setReplaceMethod("bgColor", c("gg", "character"), function(x, value){
  attr(x, "bgcolor") <- value
  x
})

setMethod("bgColor", "GGbio", function(x){
  bg <- attr(x, "bgcolor")
  if(is.null(bg))
    return("white")
  else
    return(bg)
})

setReplaceMethod("bgColor", c("GGbio", "character"), function(x, value){
  attr(x, "bgcolor") <- value
  x
})

setMethod("bgColor", "gtable", function(x){
  bg <- attr(x, "bgcolor")
  if(is.null(bg))
    return("white")
  else
    return(bg)
})

setReplaceMethod("bgColor", c("gtable", "character"), function(x, value){
  attr(x, "bgcolor") <- value
  x
})


## fixed
setMethod("fixed", "Tracked", function(x){
  x@fixed
})
setReplaceMethod("fixed", c("Tracked", "logical"), function(x, value){
  x@fixed <- value
  x
})

setMethod("fixed", "gg", function(x){
  res <- attr(x, "fixed")
  if(is.null(res))
    return(FALSE)
  else
    return(res)
})

setReplaceMethod("fixed", c("gg", "logical"), function(x, value){
  attr(x, "fixed") <- value
  x
})

setMethod("fixed", "GGbio", function(x){
  res <- attr(x, "fixed")
  if(is.null(res))
    return(FALSE)
  else
    return(res)
})

setReplaceMethod("fixed", c("GGbio", "logical"), function(x, value){
  attr(x, "fixed") <- value
  x
})


## labeled
setGeneric("labeled",  function(x) standardGeneric("labeled"))
setGeneric("labeled<-",  function(x, value) standardGeneric("labeled<-"))
setMethod("labeled", "Tracked", function(x){
  x@labeled
})
setReplaceMethod("labeled", c("Tracked", "logical"), function(x, value){
  x@labeled <- value
  x
})

setMethod("labeled", "Ideogram", function(x){
  x@labeled
})

setReplaceMethod("labeled", c("Ideogram", "logical"), function(x, value){
  attr(x, "labeled") <- value
  x
})

setMethod("labeled", "gtable", function(x){
  bg <- attr(x, "labeled")
  if(is.null(bg))
    return(TRUE)
  else
    return(bg)
})

setReplaceMethod("labeled", c("gtable", "logical"), function(x, value){
  attr(x, "labeled") <- value
  x
})

setMethod("labeled", "gg", function(x){
  bg <- attr(x, "labeled")
  if(is.null(bg))
    return(TRUE)
  else
    return(bg)
})

setReplaceMethod("labeled", c("gg", "logical"), function(x, value){
  attr(x, "labeled") <- value
  x
})

setMethod("labeled", "GGbio", function(x){
  bg <- attr(x, "labeled")
  if(is.null(bg))
    return(TRUE)
  else
    return(bg)
})

setReplaceMethod("labeled", c("GGbio", "logical"), function(x, value){
  attr(x, "labeled") <- value
  x
})



setOldClass("text")
setMethod("labeled", "text", function(x){
  bg <- attr(x, "labeled")
  if(is.null(bg))
    return(TRUE)
  else
    return(bg)
})

setMethod("labeled", "gTree", function(x){
  bg <- attr(x, "labeled")
  if(is.null(bg))
    return(TRUE)
  else
    return(bg)
})

## mutable
setGeneric("mutable",  function(x) standardGeneric("mutable"))
setGeneric("mutable<-",  function(x, value) standardGeneric("mutable<-"))
setMethod("mutable", "Tracked", function(x){
  x@mutable
})
setReplaceMethod("mutable", c("Tracked", "logical"), function(x, value){
  x@mutable <- value
  x
})
setMethod("mutable", "gg", function(x){
  mt <- attr(x, "mutable")
  if(is.null(mt))
    return(TRUE)
  else
    return(mt)
})

setReplaceMethod("mutable", c("gg", "logical"), function(x, value){
  attr(x, "mutable") <- value
  x
})

setMethod("mutable", "GGbio", function(x){
  mt <- attr(x, "mutable")
  if(is.null(mt))
    return(TRUE)
  else
    return(mt)
})

setReplaceMethod("mutable", c("GGbio", "logical"), function(x, value){
  attr(x, "mutable") <- value
  x
})


## hasAxis
setGeneric("hasAxis",  function(x) standardGeneric("hasAxis"))
setGeneric("hasAxis<-",  function(x, value) standardGeneric("hasAxis<-"))
setMethod("hasAxis", "Tracked", function(x){
  x@hasAxis
})
setReplaceMethod("hasAxis", c("Tracked", "logical"), function(x, value){
  x@hasAxis <- value
  x
})
setMethod("hasAxis", "gg", function(x){
  mt <- attr(x, "hasAxis")
  if(is.null(mt))
    return(FALSE)
  else
    return(mt)
})

setReplaceMethod("hasAxis", c("gg", "logical"), function(x, value){
  attr(x, "hasAxis") <- value
  x
})

setMethod("hasAxis", "GGbio", function(x){
  mt <- attr(x, "hasAxis")
  if(is.null(mt))
    return(FALSE)
  else
    return(mt)
})

setReplaceMethod("hasAxis", c("GGbio", "logical"), function(x, value){
  attr(x, "hasAxis") <- value
  x
})


## height of tracked object
setGeneric("height",  function(x) standardGeneric("height"))
setGeneric("height<-",  function(x, value) standardGeneric("height<-"))
setMethod("height", "Tracked", function(x){
  ht <- x@height
  if(is.numeric(ht)  && !is.unit(ht)){
    ht <- unit(mt, "null")
  }
  ht
})
setReplaceMethod("height", c("Tracked", "numericORunit"), function(x, value){
  if(is.numeric(value) && !is.unit(value))
    value <- unit(value, "null")
  x@height <- value
  x
})
setMethod("height", "gg", function(x){
  ht <- attr(x, "height")
  if(is.null(ht))
    return(unit(1, "null"))
  else if(is.numeric(ht)  && !is.unit(ht)){
    return(unit(mt, "null"))
  }else if(is.unit(ht)){
    return(ht)
  }else{
    stop("height attribute must be numeric or ")
  }
})

setReplaceMethod("height", c("gg", "numericORunit"), function(x, value){
  if(length(value) != 1)
    stop("height value can only be of length 1.")
  if(is.numeric(value) && !is.unit(value))
    value <- unit(value, "null")
  attr(x, "height") <- value
  x
})

setMethod("height", "GGbio", function(x){
  ht <- attr(x, "height")
  if(is.null(ht))
    return(unit(1, "null"))
  else if(is.numeric(ht)  && !is.unit(ht)){
    return(unit(mt, "null"))
  }else if(is.unit(ht)){
    return(ht)
  }else{
    stop("height attribute must be numeric or ")
  }
})

setReplaceMethod("height", c("GGbio", "numericORunit"), function(x, value){
  if(length(value) != 1)
    stop("height value can only be of length 1.")
  if(is.numeric(value) && !is.unit(value))
    value <- unit(value, "null")
  attr(x, "height") <- value
  x
})

setGeneric("stat_reduce", function(data, ...) standardGeneric("stat_reduce"))

setMethod("stat_reduce", "GRanges", function(data, ...,
                                               xlab, ylab, main,
                                               drop.empty.ranges = FALSE,
                                               min.gapwidth = 1L,
                                               facets = NULL,
                                               geom = NULL){


  data <- reduce(data, drop.empty.ranges = drop.empty.ranges,
                 min.gapwidth = min.gapwidth)
  args <- list(...)
  args$facets <- facets
  args$geom <- geom
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.non$data <- data
  aes.res <- do.call(aes, args.aes)
  args.res <- c(list(aes.res), args.non)
  p <- list(do.call(stat_stepping, args.res))

  labels <- Labels(xlab, ylab, main, fallback = c(x = "", y = ""))
  p <- c(p, labels)
  p <- setStat(p)
p
})

setMethod("stat_reduce", "IRanges", function(data, ...,
                                               xlab, ylab, main,
                                               drop.empty.ranges = FALSE,
                                               min.gapwidth = 1L,
                                             with.inframe.attrib=FALSE,
                                               facets = NULL,
                                               geom = NULL){


  data <- reduce(data, drop.empty.ranges = drop.empty.ranges,
                 min.gapwidth = min.gapwidth,
                 with.inframe.attrib = with.inframe.attrib)
  df <- values(data)
  values(data) <- NULL
  data <- GRanges("chr_non", data)
  values(data) <- df

  args <- list(...)
  args$facets <- facets
  args$geom <- geom
  args.aes <- parseArgsForAes(args)
  args.non <- parseArgsForNonAes(args)
  args.non$data <- data
  aes.res <- do.call(aes, args.aes)
  args.res <- c(list(aes.res), args.non)
  p <- list(do.call(stat_stepping, args.res))

  labels <- Labels(xlab, ylab, main, fallback = c(x = "Position", y = ""))
  p <- c(p, labels)
  p <- setStat(p)
  p
})


setMethod("stat_reduce", "TxDbOREnsDb", function(data, ...){
  p <- geom_alignment(data, ..., stat = "reduce")
  p <- setStat(p)
  p
})

\name{plotStackedOverview}
\alias{plotStackedOverview}
\alias{plotKaryogram}
\title{Plot stacked overview}
\usage{
plotStackedOverview(obj, ..., xlab, ylab, main, geom = "rect",
                         cytobands = FALSE, rescale = TRUE,
                         rescale.range = c(0, 10))
plotKaryogram(obj, ..., xlab, ylab, main, geom = "rect",
                         cytobands = FALSE, rescale = TRUE,
                         rescale.range = c(0, 10))
}
\description{
  Plot stacked overview for genome with or without cytobands. It's a
  wrapper around \code{layout_karyogram}.
}
\arguments{
  \item{obj}{
    a \code{GRanges} object, which could contain extra
    information about cytobands. If it's missing, will ask user to
    provide species information and download proper data set from UCSC.
    If you want an accurate genome mapping, please provide
    \code{seqlengths} with this \code{GRanges} object,otherwise it will
    emit a warning and use data space to estimate the chromosome space
    which is very rough.
  }
  \item{...}{
    arguments passed to graphic functions to control aesthetics. For
    example, if you use geom "point", you need to provide "y" in
    \code{aes()}, and if can also pass \code{color, fill, size} etc. to
    control graphics.
  }
  \item{xlab}{
    label for x
  }
  \item{ylab}{
    label for y
  }
  \item{main}{
    title for plot.
  }
  \item{geom}{
    geom plotted on the stacked layout. Default is "rect", which showing
    interval data as rectangles. It automatically figures out boundary
    so you don't have to provide information in \code{aes}, users could specify other supported
    geom works for \code{data.frame}.
  }
  \item{cytobands}{
    logical value. Default is \code{FALSE}. If \code{TRUE}, plotting cytobands, this
    require your data have arbitrary column as \code{name} and
    \code{gieStain}. the easiest way is to use \code{getIdeogram} to get
    your data. Notice for this function, when cytobands is \code{TRUE},
    it will only plot cytobands without overlaying your data. If you
    really need to overlay extra data on cytobands, please plus
    \code{layout_karyogram} for that purpose.
  }
  \item{rescale}{
    logical value. Default is \code{TRUE}, which rescale your data into
    the \code{rescale.range}, this make sure your data will not be
    plotted outside the stacked overview box.
  }
  \item{rescale.range}{
    Numeric range of length 2. Default is (0, 10), because stacked
    layout draws a white background as chromosome space and this space
    is of height 10. We hide the y-axis since we don't need it for
    stacked overview. Sometime users may want to leave some margin for
    their data, they can use this arguments to control the rescale.
  }
}
\details{
  Stacked overview is just a arbitrary layout for karyogram
  layout, it use facets seqnaems ~ . as default to stack the genome. For
  accurate mapping, you need to provide \code{seqlengths} information in
  your \code{GRanges} object. Otherwise, data space will be computed for
  stacked overview chromosome background, this is _NOT_ the actual
  chromosome space!.
}
\value{
  A \code{ggplot} object.
}
\author{Tengfei Yin}
\examples{
\dontrun{
library(biovizBase)
data(hg19IdeogramCyto, package = "biovizBase")
library(GenomicRanges)

## you can also get ideogram by biovizBase::getIdeogram

## make shorter and clean labels
old.chrs <- seqnames(seqinfo(hg19IdeogramCyto))
new.chrs <- gsub("chr", "", old.chrs)
## lst <- as.list(new.chrs)
names(new.chrs) <- old.chrs
library(GenomeInfoDb)  # for renameSeqlevels() and keepSeqlevels()
new.ideo <- renameSeqlevels(hg19IdeogramCyto, new.chrs)
new.ideo <- keepSeqlevels(new.ideo, c(as.character(1:22) , "X", "Y"))
new.ideo


## sample data
data(darned_hg19_subset500, package = "biovizBase")
idx <- is.na(values(darned_hg19_subset500)$exReg)
values(darned_hg19_subset500)$exReg[idx] <- "unknown"

## you need to add seqlengths for accruate mapping
chrnames <- unique(as.character(seqnames(darned_hg19_subset500)))
data(hg19Ideogram, package = "biovizBase")
seqlengths(darned_hg19_subset500) <- seqlengths(hg19Ideogram)[sort(chrnames)]


dn <- darned_hg19_subset500
values(dn)$score <- rnorm(length(dn))

## plotStackedOverview is a simple wrapper around this functions to
   create a stacked layout
plotStackedOverview(new.ideo, cytobands = TRUE)

plotStackedOverview(dn)
plotStackedOverview(dn, aes(color = exReg, fill = exReg))
## this will did the trick for you to rescale the space
plotStackedOverview(dn, aes(x = midpoint, y = score), geom = "line")
plotStackedOverview(dn, aes(x = midpoint, y = score), geom = "line", rescale.range = c(4, 6))
## no rescale
plotStackedOverview(dn, aes(x = midpoint, y = score), geom = "line", rescale = FALSE,
                    xlab = "xlab", ylab = "ylab", main  = "main") + ylab("ylab")

## no object? will ask you for species and query the data on the fly
plotStackedOverview()
plotStackedOverview(cytobands = TRUE)
}
}

\name{scale_fill_giemsa}
\alias{scale_fill_giemsa}
\title{scale filled color to customized giemsa color.}
\description{
  scale filled color to customized giemsa color.
}
\usage{
scale_fill_giemsa(fill = getOption("biovizBase")$cytobandColor)
}
\arguments{
  \item{fill}{
    a character vector to indicate colors, and names of vector mapped to
    gieStain name.
  }
}
\value{
  a list.
}
\examples{
getOption("biovizBase")$cytobandColor
library(biovizBase)
data(hg19IdeogramCyto)
p1 <- autoplot(hg19IdeogramCyto, layout = "karyogram", aes(fill  =
gieStain))
p1
p1 + scale_fill_giemsa()
}
\author{Tengfei Yin}

\name{scale_fill_fold_change}
\alias{scale_fill_fold_change}
\title{scale color for fold change values}
\description{
  In biology, lots of data are scaled to value around 0, and people like
  to show them as blue-white-red scale color, where negative value are
  blue, 0 is white and positive value is red, and they are scaled for
  continuous variables.
}
\usage{
scale_fill_fold_change()
}
\value{
  a list.
}
\examples{
p1 <- autoplot(volcano - 150)
p1
p1 + scale_fill_fold_change()
}
\author{Tengfei Yin}

\name{arrangeGrobByParsingLegend}
\alias{arrangeGrobByParsingLegend}
\title{Arrange grobs by parse their legend.}
\description{
Arrange grobs and parse their legend, then put it together on the
right.
}
\usage{
arrangeGrobByParsingLegend(..., nrow = NULL, ncol = NULL,
                           widths = c(4, 1), legend.idx = NULL)
}
\arguments{
  \item{...}{ggplot graphics.}
  \item{nrow}{number of row for layout.}
  \item{ncol}{number of columns for layout}
  \item{widths}{width ratio for plot group and legend group.}
  \item{legend.idx}{legend index you want to keep.}  
}
\value{
  a 
}
\examples{
library(ggplot2)
p1 <- qplot(x = mpg, y= cyl, data = mtcars, color = carb)
p2 <- qplot(x = mpg, y= cyl, data = mtcars, color = wt)
p3 <- qplot(x = mpg, y= cyl, data = mtcars, color = qsec)
p4 <- qplot(x = mpg, y= cyl, data = mtcars, color = gear)
arrangeGrobByParsingLegend(p1, p2, p3, p4)
arrangeGrobByParsingLegend(p1, p2, p3, p4, ncol = 1)
arrangeGrobByParsingLegend(p1, p2, p3, p4, legend.idx = 2)
}
\author{Tengfei Yin}

\name{ggsave}
\alias{ggsave}
\title{Save a ggplot object or tracks with sensible defaults}
\usage{
  ggsave(filename, plot = last_plot(),
    device = default_device(filename), path = NULL,
    scale = 1, width = par("din")[1],
    height = par("din")[2], units = c("in", "cm", "mm"),
    dpi = 300, limitsize = TRUE, ...)
}
\arguments{
  \item{filename}{file name/filename of plot}

  \item{plot}{plot to save, defaults to last plot
  displayed}

  \item{device}{device to use, automatically extract from
  file name extension}

  \item{path}{path to save plot to (if you just want to set
  path and not filename)}

  \item{scale}{scaling factor}

  \item{width}{width (defaults to the width of current
  plotting window)}

  \item{height}{height (defaults to the height of current
  plotting window)}

  \item{units}{units for width and height when either one
  is explicitly specified (in, cm, or mm)}

  \item{dpi}{dpi to use for raster graphics}

  \item{limitsize}{when \code{TRUE} (the default),
  \code{ggsave} will not save images larger than 50x50
  inches, to prevent the common error of specifying
  dimensions in pixels.}

  \item{...}{other arguments passed to graphics device}
}
\description{
  ggsave is a convenient function for saving a plot.  It
  defaults to saving the last plot that you displayed, and
  for a default size uses the size of the current graphics
  device.  It also guesses the type of graphics device from
  the extension.  This means the only argument you need to
  supply is the filename.
}
\details{
  \code{ggsave} currently recognises the extensions eps/ps,
  tex (pictex), pdf, jpeg, tiff, png, bmp, svg and wmf
  (windows only).
}

\name{Grob-class}
\alias{Grob-class}
\alias{Grob}
\alias{Grob-method}
\alias{Grob,gg-method}
\alias{Grob,gtable-method}
\alias{Grob,trellis-method}
\alias{Grob,lattice-method}
\alias{Grob,GGbio-method}
\alias{GrobList-class}
\alias{ggplotGrob-class}
\alias{latticeGrob-class}
\alias{GrobList}
\title{Grob getter}
\description{
  'Grob' class is a container for 'grob' based object defined with grid
  system. Generic function \code{Grob} gets grob object supported by grid system, and make an instance of
  subclass of class 'Grob'.

  'GrobList' is a container of list of 'Grob' object.
}
\usage{
\S4method{Grob}{gg}(x)
\S4method{Grob}{gtable}(x)
\S4method{Grob}{trellis}(x)
\S4method{Grob}{lattice}(x)
\S4method{Grob}{GGbio}(x)
}
\arguments{
  \item{x}{
    object of class: gg, gtable, trellis, lattice, GGbio.
  }
}
\value{
  A \code{Grob} object.
}
\author{Tengfei Yin}

\name{stat_mismatch}
\alias{stat_mismatch}
\alias{stat_mismatch,missing-method}
\alias{stat_mismatch,uneval-method}
\alias{stat_mismatch,GRanges-method}
\alias{stat_mismatch,BamFile-method}
\title{Calculate mismatch summary}
\description{
  Calculate mismatch summary  
}
\usage{
## for GRanges
\S4method{stat_mismatch}{GRanges}(data, ..., bsgenome, 
              xlab, ylab, main,
              geom = c("segment", "bar"),
              show.coverage = TRUE)
## for BamFile
\S4method{stat_mismatch}{BamFile}(data, ..., bsgenome, which,
              xlab, ylab, main,
              geom = c("segment", "bar"),
              show.coverage = TRUE)
}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{BamFile} object.
  }
  \item{...}{
    Extra parameters such as aes() passed to \code{geom_rect},
    \code{geom_alignment}, or \code{geom_segment}.
  }
  \item{bsgenome}{
    \code{BSgenome} object.
  }
  \item{which}{
    \code{GRanges} object to subset the data.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{geom}{
    The geometric object to use display the data. 
  }
  \item{show.coverage}{
    whether to show coverage as background or not.
  }
}
\value{
  A 'Layer'.
}
\author{Tengfei Yin}

\name{stat_table}
\alias{stat_table}
\alias{stat_table,missing-method}
\alias{stat_table,uneval-method}
\alias{stat_table,GRanges-method}
\alias{stat_table,GRangesList-method}
\title{Tabulate a GRanges object}
\description{
  Tabulate a GRanges object  
}
\usage{
\S4method{stat_table}{GRanges}(data, ..., xlab, ylab, main,
            geom = NULL,stat = NULL)
\S4method{stat_table}{GRangesList}(data, ..., xlab, ylab, main,
            facets = NULL, geom = NULL)

}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters such as aes() passed to \code{geom_rect},
    \code{geom_alignment}, or \code{geom_segment}.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{facets}{
    Faceting formula to use. 
  }
  \item{geom}{
    The geometric object to use display the data. 
  }
  \item{stat}{
    The geometric object to use display the data. 
  }
}
\value{
  A 'Layer'.
}
\examples{
##  load
set.seed(1)
N <- 100
require(ggbio)
require(GenomicRanges)
##  simul
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))

gr <- c(gr[seqnames(gr) == "chr1"][sample(1:10, size = 1e4, replace = TRUE)],gr)

##  default
ggplot(gr) + stat_table()
ggplot(gr) + stat_table(geom = "segment", mapping = aes(y = ..score.., color = ..score..))
ggplot(gr) + stat_table(mapping = aes(color = score))
}
\author{Tengfei Yin}

\name{scale_x_sequnit}
\alias{scale_x_sequnit}
\title{scale x by unit}
\description{
  scale x by unit 'Mb','kb', 'bp'.
}
\usage{
scale_x_sequnit(unit = c("Mb", "kb", "bp"), append = NULL)
}
\arguments{
  \item{unit}{
    unit to scale x. Default is Mb. 
  }
  \item{append}{
    default \code{NULL}. If pass a character, it disalbe unit and arbitrarily append a
    text behind the original x scale numbers. 
  }

}
\value{
  'position_c'
}
\examples{
library(ggplot2)
p <- qplot(x = seq(1, to = 10000, length.out = 40), y = rnorm(40), geom
= "point")
## default mb
p + scale_x_sequnit()
p + scale_x_sequnit("kb")
p + scale_x_sequnit("bp")
}
\author{Tengfei Yin}

\name{stat_stepping}
\alias{stat_stepping}
\alias{stat_stepping,missing-method}
\alias{stat_stepping,uneval-method}
\alias{stat_stepping,GRanges-method}
\title{Calculate stepping levels}
\description{
  Calculate stepping levels.
}
\usage{
\S4method{stat_stepping}{GRanges}(data, ..., xlab, ylab, main,
              facets = NULL,
              geom = c("rect", "alignment", "segment"))
}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters such as aes() passed to \code{geom_rect},
    \code{geom_alignment}, or \code{geom_segment}.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{facets}{
    Faceting formula to use.
  }
  \item{geom}{
    The geometric object used to display the data. For 'stepping', could
    be one of 'rect', 'alignment', 'segment'.
  }
}
\value{
  A 'Layer'.
}
\examples{

set.seed(1)
N <- 50

require(GenomicRanges)
##  simul
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))

##  default 
ggplot(gr) + stat_stepping()
## or
ggplot() + stat_stepping(gr)

##  facet_aes
ggplot(gr) + stat_stepping(mapping = aes(color = strand, fill = strand),
                                 facets = sample ~ seqnames)

##  geom_segment
ggplot(gr) + stat_stepping(mapping = aes(color = strand),
                         geom = "segment", xlab = "Genomic coord", ylab = "y", main = "hello")


##  geom_alignment
## ggplot(gr) + stat_stepping(geom = "alignment")

##  geom_alignment_group
##  ggplot(gr) + stat_stepping(mapping = aes(group = pair),geom = "alignment")
}
\author{Tengfei Yin}

\name{stat_gene}
\alias{stat_gene}
\alias{stat_gene,TxDb-method}
\title{Calculate gene structure}
\description{
  Calculate gene structure.
}
\usage{
\S4method{stat_gene}{TxDb}(data, ...)
}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters such as aes() passed to \code{geom_alignment}.
  }
}
\value{
  A 'Layer'.
}
\seealso{\code{\link{geom_alignment}}}
\examples{
\dontrun{
## loading package
## Deprecated
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
data(genesymbol, package = "biovizBase")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene

## made a track comparing full/reduce stat.
p1 <- ggplot() + geom_alignment(txdb, which = genesymbol["RBM17"])
p1 <- ggplot() + stat_gene(txdb, which = genesymbol["RBM17"])
## or 
p1 <- ggplot(txdb) + stat_gene(which = genesymbol["RBM17"])

p1 <- ggplot(txdb) + stat_gene(which = genesymbol["RBM17"])
p2 <- ggplot(txdb) + stat_gene(which = genesymbol["RBM17"], stat =
"reduce")
p2 <- ggplot(txdb) + stat_gene(which = genesymbol["RBM17"], stat = "reduce")
## ggplot(txdb) + geom_alignment(which = genesymbol["RBM17"]) + stat_reduce()
## ggplot(txdb) + geom_alignment(which = genesymbol["RBM17"])
tracks(full = p1, reduce = p2, heights = c(3, 1))

## change y labels
ggplot(txdb) + stat_gene(which = genesymbol["RBM17"], names.expr =
"tx_id:::gene_id")
}
}
\author{Tengfei Yin}

\name{Plot}
\alias{Plot}
\alias{Plot-class}
\alias{ggplotPlot-class}
\alias{latticePlot-class}
\alias{ggbioPlot-class}
\alias{Plot,gg-method}
\alias{Plot,trellis-method}
\alias{Plot,GGbio-method}
\alias{Plot,Ideogram-method}
\title{Plot class}
\description{
  genealize a graphic object to a Plot object.
}
\usage{
  \S4method{Plot}{gg}(x)
  \S4method{Plot}{trellis}(x, mutable = FALSE)
  \S4method{Plot}{GGbio}(x)
  \S4method{Plot}{Ideogram}(x)
}
\arguments{
  \item{x}{
    object of gg, GGbio, trellis, Ideogram.
  }
  \item{mutable}{
    whether a plot repsonse to \code{+} method or not.
  }
}
\value{
  A Plot object.
}
\author{Tengfei Yin}

\name{geom_chevron}
\alias{geom_chevron}
\alias{geom_chevron,GRanges-method}
\alias{geom_chevron,missing-method}
\alias{geom_chevron,uneval-method}
\title{Chevron geoms for GRanges object}
\description{
  Break normal intervals stroed in \code{GRanges} object and show them
  as chevron, useful for showing model or splice summary.
}
\usage{
\S4method{geom_chevron}{GRanges}(data, ..., xlab, ylab, main,
             offset = 0.1,
             facets = NULL,
             stat = c("stepping", "identity"),
             chevron.height.rescale = c(0.1, 0.8),
             group.selfish = TRUE)
}
\arguments{
  \item{data}{
    A GRanges object.
  }
  \item{...}{
    Extra parameters passed to autoplot function.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{offset}{
    A nunmeric value or characters. If it's numeric value, indicate how
    much you want the chevron to wiggle, usually the rectangle for
    drawing \code{GRanges} is of height unit 1, so it's better between
    -0.5 and 0.5 to make it nice looking. Unless you specify offset as
    one of those columns, this will use height of the chevron to
    indicate the columns. Of course you could use size of the chevron to
    indicate the column variable easily, please see the examples.
  }
  \item{facets}{
    faceting formula to use.
  }
  \item{stat}{
    character vector specifying statistics to use. "stepping" with
    randomly assigned stepping levels as y varialbe. "identity" allow
    users to specify \code{y} value in \code{aes}.
  }
  \item{chevron.height.rescale}{
    A numeric vector of length 2. When the offset parameters is a
    character which is one of the data columns, this parameter rescale
    the offset.
  }
  \item{group.selfish}{
    Passed to \code{addStepping}, control whether to show each group as
  unique level or not. If set to \code{FALSE}, if two groups are not
  overlapped with each other, they will probably be layout in the same
  level to save space.
  }  
}
\value{
  A 'Layer'.
}
\details{
  To draw a normal GRanges as Chevron, we need to provide a special geom for
this purpose. Chevron is popular in gene viewer or genomoe browser,
when they try to show isoforms or gene model.\code{geom_chevron},
just like any other \code{geom_*} function in ggplot2, you can pass
aes() to it to use height of chevron or width
of chevron to show statistics summary.
}

\examples{
set.seed(1)
N <- 100
require(GenomicRanges)

## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))



## ======================================================================
##  default
##
##  ======================================================================
ggplot(gr) + geom_chevron()
## or
ggplot() + geom_chevron(gr)


## ======================================================================
##  facetting and aesthetics
## ======================================================================
ggplot(gr) + geom_chevron(facets = sample ~ seqnames, mapping = aes(color = strand))


## ======================================================================
##  stat:identity
## ======================================================================
ggplot(gr) + geom_chevron(stat = "identity", mapping = aes(y = value))


## ======================================================================
##  stat:stepping
## ======================================================================
ggplot(gr) + geom_chevron(stat = "stepping", mapping = aes(group = pair))


## ======================================================================
##  group.selfish controls when 
## ======================================================================
ggplot(gr) + geom_chevron(stat = "stepping", mapping = aes(group = pair), group.selfish = FALSE,
                        xlab = "xlab", ylab = "ylab", main = "main")

p <- qplot(x = mpg, y = cyl, data = mtcars)

## ======================================================================
##  offset
## ======================================================================
gr2 <- GRanges("chr1", IRanges(c(1, 10, 20), width = 5))
gr2.p <- gaps(gr2)
## resize to connect them
gr2.p <- resize(gr2.p, fix = "center", width = width(gr2.p)+2)

ggplot(gr2) + geom_rect() + geom_chevron(gr2.p)


## notice the rectangle height is 0.8
## offset = 0 just like a line
ggplot(gr2) + geom_rect() + geom_chevron(gr2.p, offset = 0)


## equal height
ggplot(gr2) + geom_rect() + geom_chevron(gr2.p, offset = 0.4)


## ======================================================================
##  chevron.height
## ======================================================================
values(gr2.p)$score <- c(100, 200)
ggplot(gr2) + geom_rect() + geom_chevron(gr2.p, offset = "score")
## chevron.height
ggplot(gr2) + geom_rect() + geom_chevron(gr2.p, offset = "score",
                                         chevron.height.rescale = c(0.4, 10))
 
}
\author{Tengfei Yin}

\name{plotGrandLinear}
\alias{plotGrandLinear}
\title{Manhattan for GWAS}
\description{
A Manhattan plot is special scatter plot used to visualize data with a
large number of data points, with a distribute of some higher-magnitude
values. For example, in the GWAS(genome-wide association studies). Here
we mainly focus on GWAS Manhattan plots. X-axis is genomic coordinates
and Y-axis is negative logarithm of the associated P-value for each
single nucleotide polymorphism. So higher the value, more stronger the
association they are.
}
\usage{
plotGrandLinear(obj, ..., facets, space.skip = 0.01, geom = NULL,
                 cutoff = NULL, cutoff.color = "red", cutoff.size = 1,
                 legend = FALSE, xlim, ylim, xlab, ylab, main,
                 highlight.gr = NULL, highlight.name = NULL,
                 highlight.col = "red", highlight.label = TRUE,
                 highlight.label.size = 5, highlight.label.offset =
                 0.05, highlight.label.col = "black", spaceline =
                 FALSE)

}
\arguments{
  \item{obj}{
    \code{GRanges} object which contains extra p value, before users
    pass this object, they need to make sure the pvalue has been changed
    to -log10(p).
  }
  \item{...}{
    extra arguments passed. such as color, size, alpha.
  }
  \item{facets}{
    facets formula, such as group ~ .
  }
  \item{space.skip}{
    numeric value for skip ratio, between chromosome spaces.default is 0.01.
  }
  \item{geom}{
    geometric object, defualt is "point".
  }
  \item{cutoff}{
    A numeric vector which used as cutoff for Manhattan plot.
  }
  \item{cutoff.color}{
    A character specifying the color used for cutoff. Default is "red".
  }
  \item{cutoff.size}{
    A numeric value which used as cutoff line size.
  }
  \item{legend}{
    A logical value indicate whether to show legend or not. Default is
    FALSE which disabled the legend.
  }
  \item{xlim}{
    limits for x scale.
  }
  \item{ylim}{
    limits for y scale.
  }
  \item{xlab}{
    Label for xscale.
  }
  \item{ylab}{
    Label for yscale.
  }
  \item{main}{
    title.
  }
  \item{highlight.gr}{
    a \code{GRanges} object, this wil highlight overlapped region with
    provided intervals.
  }
  \item{highlight.name}{
    if \code{NULL}, using rownames of \code{GRanges} object provided by
    argument \code{highlight.gr}, otherwise use
    character to indicate column used as labeled names.
  }
  \item{highlight.col}{
    highlight colors.
  }
  \item{highlight.label}{
    logical value, label the highlighted region of not.
  }
  \item{highlight.label.size}{
    highlight label size.
  }
  \item{highlight.label.offset}{
    highlight label offset.
  }
  \item{highlight.label.col}{
    highlight label color. 
  }
  \item{spaceline}{show line between chromosomes.
  
  }
  
  
}
\value{
  Return a ggplot object. 
}
\details{
  Please use seqlengths of the object and space.skip arguments to
  control the layout of the coordiant genome transformation.

  aes(y = ...) is requried.

  aes(color = ) is used to mapping to data variables, if just pass
  "color" without aes(), then will recycle the color to represent each
  chromosomes.please see the example below.
  
}
\examples{
##  load
library(ggbio)
data(hg19IdeogramCyto, package = "biovizBase")
data(hg19Ideogram, package = "biovizBase")
library(GenomicRanges)

##  simul_gr
library(biovizBase)
gr <- GRanges(rep(c("chr1", "chr2"), each = 5),
              IRanges(start = rep(seq(1, 100, length = 5), times = 2),
                      width = 50))
autoplot(gr)

##  coord:genome
autoplot(gr, coord = "genome")
gr.t <- transformToGenome(gr)
head(gr.t)

##  is
is_coord_genome(gr.t)
metadata(gr.t)$coord


##  simul_snp
chrs <- as.character(levels(seqnames(hg19IdeogramCyto)))
seqlths <- seqlengths(hg19Ideogram)[chrs]
set.seed(1)
nchr <- length(chrs)
nsnps <- 100
gr.snp <- GRanges(rep(chrs,each=nsnps),
                  IRanges(start =
                          do.call(c, lapply(chrs, function(chr){
                            N <- seqlths[chr]
                            runif(nsnps,1,N)
                          })), width = 1),
                  SNP=sapply(1:(nchr*nsnps), function(x) paste("rs",x,sep='')),
                  pvalue =  -log10(runif(nchr*nsnps)),
                  group = sample(c("Normal", "Tumor"), size = nchr*nsnps,
                    replace = TRUE)
                  )

##  shorter
seqlengths(gr.snp)
nms <- seqnames(seqinfo(gr.snp))
nms.new <- gsub("chr", "", nms)
names(nms.new) <- nms
library(GenomeInfoDb)  # for renameSeqlevels() and keepSeqlevels()
gr.snp <- renameSeqlevels(gr.snp, nms.new)
seqlengths(gr.snp)



##  unorder
autoplot(gr.snp, coord = "genome", geom = "point", aes(y = pvalue), space.skip = 0.01)

##  sort
gr.snp <- keepSeqlevels(gr.snp, c(1:22, "X", "Y"))
autoplot(gr.snp, coord = "genome", geom = "point", aes(y = pvalue), space.skip = 0.01)

##  with_seql
names(seqlths) <- gsub("chr", "", names(seqlths))
seqlengths(gr.snp) <- seqlths[names(seqlengths(gr.snp))]
autoplot(gr.snp, coord = "genome", geom = "point", aes(y = pvalue), space.skip = 0.01)

##  line
autoplot(gr.snp, coord = "genome", geom = "line", aes(y = pvalue, group = seqnames,
                                     color = seqnames))



##  plotGrandLinear
plotGrandLinear(gr.snp, aes(y = pvalue))

##  morecolor
plotGrandLinear(gr.snp, aes(y = pvalue, color = seqnames))
plotGrandLinear(gr.snp, aes(y = pvalue), color = c("green", "deepskyblue"))
plotGrandLinear(gr.snp, aes(y = pvalue), color = c("green", "deepskyblue", "red"))
plotGrandLinear(gr.snp, aes(y = pvalue), color = "red")

##  cutoff
plotGrandLinear(gr.snp, aes(y = pvalue), cutoff = 3, cutoff.color = "blue", cutoff.size = 4)

##  cutoff-low
plotGrandLinear(gr.snp, aes(y = pvalue)) + geom_hline(yintercept = 3, color = "blue", size = 4)

##  longer
## let's make a long name
nms <- seqnames(seqinfo(gr.snp))
nms.new <- paste("chr00000", nms, sep = "")
names(nms.new) <- nms
gr.snp <- renameSeqlevels(gr.snp, nms.new)
seqlengths(gr.snp)

##  rotate
plotGrandLinear(gr.snp, aes(y = pvalue)) + theme(axis.text.x=element_text(angle=-90, hjust=0))

##  sessionInfo
sessionInfo()
}
\author{Tengfei Yin}

\name{stat_identity}
\alias{stat_identity}
\alias{stat_identity,ANY-method}
\alias{stat_identity,missing-method}
\alias{stat_identity,uneval-method}
\alias{stat_identity,GRanges-method}
\alias{stat_identity,Rle-method}
\alias{stat_identity,RleList-method}
\title{Transform the data to a data.frame and for multiple geoms.}
\description{
  Transform the data to a suitable data.frame and then one could use
  multiple geom or even stat to re-plot the data.
}
\usage{
\S4method{stat_identity}{ANY}(data, ...)

\S4method{stat_identity}{GRanges}(data, ..., geom = NULL)

\S4method{stat_identity}{Rle}(data, ..., xlab, ylab, main, geom = NULL)

\S4method{stat_identity}{RleList}(data, ..., xlab, ylab, main,
          geom = NULL, indName = "sample")
}
\arguments{
  \item{data}{
    Typically a \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters such as aes() passed to \code{geom_rect},
    \code{geom_alignment}, or \code{geom_segment}.
  }
  \item{geom}{
    The geometric object to use display the data. 
  }
  \item{xlab}{
    x label.
  }
  \item{ylab}{
    y label.
  }
  \item{main}{
    title of graphic..
  }
  \item{indName}{
    sample name.
    }
}
\value{
  A 'Layer'.
}
\examples{
##  load
set.seed(1)
N <- 50

require(GenomicRanges)
##  simul
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))

##  geom_point_start
ggplot() + stat_identity(gr, mapping = aes(x = start, y = value), geom = "point")
## or more formal
ggplot(gr) + stat_identity(mapping = aes(x = start, y = value), geom = "point")

##  geom_point_midpoint
ggplot(gr) + stat_identity(mapping = aes(x = midpoint, y = value), geom = "point")

##  geom_rect_all
ggplot(gr) + stat_identity(mapping = aes(xmin = start, xmax = end,
                                         ymin = value - 0.5, ymax = value + 0.5),
                           geom = "rect")

##  geom_rect_y
ggplot(gr) + stat_identity(mapping = aes(y = value), geom = "rect")

##  geom_line
ggplot(gr) + stat_identity(mapping = aes(x = start, y = value),  geom = "line")

##  geom_segment
ggplot(gr) + stat_identity(mapping = aes(y = value), geom = "segment")

## Rle/RleList
library(IRanges)
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500), 
            seq(10, 0.001, length = 500))
xVector <- rpois(1e4, lambda)
xRle <- Rle(xVector)
xRleList <- RleList(xRle, 2L * xRle)

ggplot(xRle) + stat_identity(geom = "point")
ggplot(xRleList) + stat_identity(geom = "point")
}
\author{Tengfei Yin}

\name{geom_alignment}
\alias{geom_alignment}
\alias{geom_alignment,GRanges-method}
\alias{geom_alignment,GRangesList-method}
\alias{geom_alignment,OrganismDb-method}
\alias{geom_alignment,missing-method}
\alias{geom_alignment,uneval-method}
\alias{geom_alignment,TxDbOREnsDb-method}
\alias{geom_alignment,BamFile-method}
\title{Alignment geoms for GRanges object}
\description{
  Show interval data as alignment.
}
\usage{
% for GRanges
\S4method{geom_alignment}{GRanges}(data, ..., xlab, ylab, main, facets = NULL, stat =
                 c("stepping", "identity"), range.geom = c("rect",
                 "arrowrect"), gap.geom = c("chevron", "arrow",
                 "segment"), rect.height = NULL, group.selfish = TRUE)

\S4method{geom_alignment}{TxDbOREnsDb}(data, ..., which, columns = c("tx_id", "tx_name",
                 "gene_id"), names.expr = "tx_name", facets = NULL,
                 truncate.gaps = FALSE, truncate.fun = NULL, ratio =
                 0.0025)

\S4method{geom_alignment}{GRangesList}(data, ..., which = NULL,
                          cds.rect.h = 0.25,
                          exon.rect.h = cds.rect.h,
                          utr.rect.h = cds.rect.h/2,
                          xlab, ylab, main,
                          facets = NULL, geom = "alignment",
                          stat = c("identity", "reduce"),
                          range.geom = "rect",
                          gap.geom = "arrow",
                          utr.geom = "rect",
                          names.expr = NULL,
                          label = TRUE,
                          label.color = "gray40",
                          label.size = 3,
                          arrow.rate = 0.015,
                          length = unit(0.1, "cm"))

\S4method{geom_alignment}{OrganismDb}(data, ..., which,
                   columns = c("TXNAME", "SYMBOL", "TXID", "GENEID"),
                   names.expr = "SYMBOL",
                   facets = NULL,
                   truncate.gaps = FALSE,
                   truncate.fun = NULL, ratio = 0.0025
                   )
}
\arguments{
  \item{data}{
    A \code{GRanges}, \code{data.frame}, \code{TxDb} or \code{EnsDb} object.
  }
  \item{...}{
    Extra parameters such as aes() passed.
  }
  \item{which}{
    \code{GRanges} object to subset the \code{TxDb} or \code{EnsDb}
    object. For \code{EnsDb}: can also be a single object extending
    \code{\link[AnnotationFilter]{AnnotationFilter}}, an
    \code{\link[AnnotationFilter]{AnnotationFilterList}}
    combining such objects or a filter expression in form of a \code{formula}.
  }
  \item{cds.rect.h}{
    cds heights.
  }
  \item{exon.rect.h}{
    exon heights.
  }
  \item{utr.rect.h}{
    utr heights.
  }
  \item{label.color}{
    label color.
  }
  \item{label.size}{
    label size.
  }
  \item{arrow.rate}{
    arrow rate.
  }
  \item{length}{
    arrow length.
  }
  \item{columns}{
    columns to get from object.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{facets}{
    Faceting formula to use.
  }
  \item{stat}{
    For \code{\linkS4class{GRanges}}:
    Character vector specifying statistics to use. "stepping" with
    randomly assigned stepping levels as y varialbe. "identity" allow
    users to specify \code{y} value in \code{aes}.

    For  \code{\linkS4class{TxDb}}:
    defualt "identity" give full gene model and "reduce" for reduced model.
  }
  \item{gap.geom}{
    Geom for 'gap' computed from the data you passed based on the group information.
  }
  \item{rect.height}{
    Half height of the arrow body.
  }
  \item{group.selfish}{
    Passed to \code{addStepping}, control whether to show each group as
  unique level or not. If set to \code{FALSE}, if two groups are not
  overlapped with each other, they will probably be layout in the same
  level to save space.
}
  \item{truncate.gaps}{
    logical value indicate to truncate gaps or not.
  }
  \item{truncate.fun}{
    shrinkage function. Please see \code{shrinkagefun} in package biovizBase.
  }
  \item{ratio}{
    used in \code{maxGap}.
  }
  \item{geom}{
    geometric object. only support "gene" now.
  }
  \item{range.geom}{
    geom for main intevals or exons.
  }
  \item{utr.geom}{
    geom for utr region.
  }
  \item{names.expr}{
    expression for showing y label.
  }
  \item{label}{
    logical value. Whether to label the intervals with names specified
    by argument \code{names.expr}.
  }
}
\value{
  A 'Layer'.
}
\examples{
set.seed(1)
N <- 100
require(GenomicRanges)
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))


## ======================================================================
##  default
## ======================================================================
ggplot(gr) + geom_alignment()
## or
ggplot() + geom_alignment(gr)

## ======================================================================
##  facetting and aesthetics
## ======================================================================
ggplot(gr) + geom_alignment(facets = sample ~ seqnames, mapping = aes(color = strand, fill = strand))

## ======================================================================
##  stat:stepping
## ======================================================================
ggplot(gr) + geom_alignment(stat = "stepping", mapping = aes(group = pair))

## ======================================================================
##  group.selfish controls when
## ======================================================================
ggplot(gr) + geom_alignment(stat = "stepping", mapping = aes(group = pair), group.selfish = FALSE)

## =======================================
##  main/gap geom
## =======================================
ggplot(gr) + geom_alignment(range.geom = "arrowrect", gap.geom = "chevron")

## =======================================
##  For TxDb
## =======================================
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
data(genesymbol, package = "biovizBase")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
## made a track comparing full/reduce stat.
ggbio() + geom_alignment(data = txdb, which = genesymbol["RBM17"])
p1 <- ggplot(txdb) + geom_alignment(which = genesymbol["RBM17"])
p1
p2 <- ggplot(txdb) + geom_alignment(which = genesymbol["RBM17"], stat = "reduce")
tracks(full = p1, reduce = p2, heights = c(3, 1))
tracks(full = p1, reduce = p2, heights = c(3, 1)) + theme_tracks_sunset()
tracks(full = p1, reduce = p2, heights = c(3, 1)) +
     theme_tracks_sunset(axis.line.color = NA)
## change y labels
ggplot(txdb) + geom_alignment(which = genesymbol["RBM17"], names.expr = "tx_id:::gene_id")
}
\author{Tengfei Yin}

\name{theme}
\alias{theme_null}
\alias{theme_noexpand}
\alias{theme_pack_panels}
\alias{theme_alignment}
\alias{theme_clear}
\alias{theme_tracks_sunset}
\alias{theme_genome}
\title{theme in ggbio}
\description{
  Theme defined in ggbio for plot or tracks. 
}
\details{Themes speciall designed for tracks, are named following naming
schema theme_tracks_*}
\usage{
  theme_null()
  theme_noexpand()    
  theme_alignment(ylabel = FALSE, base_size = 12, base_family = "", 
  axis = TRUE, border = TRUE, grid = TRUE)
  theme_pack_panels(strip.bg = FALSE, strip.text.y = TRUE)
  theme_clear(grid.y = FALSE, grid.x.minor = FALSE, grid.x.major = FALSE,
              panel.background.fill = "white", panel.border.color = NA,
              axis.ticks.x = FALSE, axis.ticks.y = TRUE, grid.color = "gray95",
              axis.line.color = "gray80")
  theme_tracks_sunset(bg = "#fffedb", alpha = 1, ...)
  theme_genome()
}
\arguments{
  
  \item{alpha}{
   alpha blending from 0(transparent) to 1(solid).
 }
  \item{axis}{
    logical value, show axis or not.
  }
 
  \item{axis.line.color}{
    color for axis line .
  }
  \item{axis.ticks.x}{
    show x ticks or not.
  }
  \item{axis.ticks.y}{
    show y ticks or not.
  }
  \item{base_family}{
    family for font.
  }
  
  \item{base_size}{
    size for font.
  }
 
  \item{bg}{
    background color for tracks.
  }
  
  \item{border}{
    logical value, show border or not.
  }
  \item{grid}{
    logical value, show background grid or not.
  }
  \item{grid.color}{
    grid line color.
  }
  \item{grid.x.major}{
    show x major grid line or not.
  }
  \item{grid.x.minor}{
    show x minor grid line or not.
  }
  \item{grid.y}{
    show y grid or not.
  }
  \item{panel.background.fill}{
    panel background fill color.
  }
  \item{panel.border.color}{
    panel border color.
  }
  \item{strip.bg}{
    if strip background is removed.
  }
  \item{strip.text.y}{
    if strip text is removed.
  }
  \item{ylabel}{
    logical value. Show labels or not.
  }
  \item{...}{
    passed to \code{theme_clear}.
  }
}
\value{
  Return a theme.
}
\examples{
##  load
library(ggbio)
p <- qplot(data = mtcars, x = mpg,  y = wt, facets = cyl ~ .)
p + theme_null()
p + theme_clear()
p + theme_pack_panels()
p + theme_alignment()
p1 <- qplot(data = mtcars, x = mpg,  y = wt)
tracks(p1 = p, p2 = p1)
tracks(p1 = p, p2 = p1) + theme_tracks_sunset()
}
\author{Tengfei Yin}

\name{stat_slice}
\alias{stat_slice}
\alias{stat_slice,missing-method}
\alias{stat_slice,uneval-method}
\alias{stat_slice,Rle-method}
\alias{stat_slice,RleList-method}
\title{Slice Rle/RleList to view them as bar or heatmap.}
\description{
  Slice Rle/RleList to different view by set lower or other parameters,
  then view summary for all those viewed region.
}
\usage{
\S4method{stat_slice}{Rle}(data, ...,
          xlab, ylab, main,
          na.rm = FALSE,
          geom = NULL,
          lower=-Inf, upper=Inf,
          includeLower=TRUE, includeUpper=TRUE,
          rangesOnly = FALSE,                                       
          type = c("viewSums","viewMins",
          "viewMaxs", "viewMeans"))

\S4method{stat_slice}{RleList}(data, ...,
          xlab, ylab, main,
          indName = "sample",
          na.rm = FALSE,
          geom = NULL,
          lower=-Inf, upper=Inf,
          includeLower=TRUE, includeUpper=TRUE,
          rangesOnly = FALSE,                                       
          type = c("viewSums","viewMins",
                   "viewMaxs", "viewMeans"))
}
\arguments{
\item{data}{
    a \code{data.frame} or \code{Rle} or \code{RleList} object.
}
\item{...}{
    arguments passed to aesthetics mapping.
}
\item{xlab}{
x label.
}
\item{ylab}{
y label.
}
\item{main}{
title.
}
\item{indName}{
when faceted by a \code{RleList}, name used for labeling faceted
factor. Default is 'sample'.
}
\item{geom}{
geometric types.
}
\item{type}{
statistical summary method used within bins, shown as bar height or
heatmap colors.
}  
\item{na.rm}{
  logical value, default \code{FALSE}, passed to function like
  \code{viewMaxs} for statistical summary computation.
}
\item{lower}{
  passed to \code{\link[IRanges]{slice}}.
}
\item{upper}{
  passed to \code{\link[IRanges]{slice}}.
}
\item{includeLower}{
  passed to \code{\link[IRanges]{slice}}.  
}
\item{includeUpper}{
    passed to \code{\link[IRanges]{slice}}.
}
\item{rangesOnly}{
    passed to \code{\link[IRanges]{slice}}.
}
}
\value{
  a ggplot object.
}
\seealso{
  \code{\link[IRanges]{slice}}
}
\examples{
library(IRanges)
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500), 
            seq(10, 0.001, length = 500))
xVector <- rpois(1e4, lambda)
xRle <- Rle(xVector)
xRleList <- RleList(xRle, 2L * xRle)

ggplot(xRle) + stat_slice(lower = 5)
ggplot(xRle) + stat_slice(lower = 5, geom = "bar")
ggplot(xRle) + stat_slice(lower = 5, geom = "heatmap")

p1 <- ggplot(xRle) + stat_slice(type = "viewMeans", lower = 5,
                            geom = "bar")
p2 <- ggplot(xRle) + stat_slice(type = "viewSums", lower = 5,
                            geom = "bar")
## y scale are different.
tracks(viewMeans = p1, viewSums = p2)

ggplot(xRleList) + stat_slice(lower = 5)
ggplot(xRleList) + stat_slice(lower = 5, geom = "bar")
ggplot(xRleList) + stat_slice(lower = 5, geom = "heatmap")

p1 <- ggplot(xRleList) + stat_slice(type = "viewMeans", lower = 5,
                            geom = "bar")
p2 <- ggplot(xRleList) + stat_slice(type = "viewSums", lower = 5,
                            geom = "bar")
## y scale are different.
tracks(viewMeans = p1, viewSums = p2)
}
\author{Tengfei Yin}

\name{rescale}
\alias{rescale}
\alias{rescale,numeric-method}
\alias{rescale,ggplot-method}
\alias{rescale,gg-method}
\title{rescale ggplot object}
\description{
  Rescale a numeric vector or ggplot object, could be used for static
  zoom-in in ggbio.
}
\usage{
\S4method{rescale}{numeric}(x, to = c(0, 1),
      from = range(x, na.rm = TRUE))

\S4method{rescale}{ggplot}(x, xlim, ylim, sx = 1, sy = 1)
\S4method{rescale}{gg}(x, xlim, ylim, sx = 1, sy = 1)
}
\arguments{
\item{x}{
  A numeric object or ggplot object to be rescaled. 
}
\item{to}{
  For numeric object. it's a vector of two numeric values, specifying
the range to be rescale.
}
\item{from}{
  Range of x. 
}
\item{xlim}{
  For ggplot object. This specify the new limits on x-scale.
}
\item{ylim}{
  For ggplot object. This specify the new limits on y-scale.
}
\item{sx}{
  Scale fold for x-scale. Default is 1, no change.
}
\item{sy}{
  Scale fold for y-scale. Default is 1, no change.
}
}
\value{
  Return the object of the same class as \code{x} after rescaling.
}
\details{
  When \code{x} is numeric value, it's just call scales::rescale, please
refer to the manual page to check more details. If \code{x} is ggplot
object, it first try to estimate current x limits and y limits of the ggplot
object, then rescale based on those information.
}
\examples{
library(ggbio)
head(mtcars)
range(mtcars$mpg)
p <- qplot(data = mtcars, x = mpg, y = disp, geom = "point")
p.new <- rescale(p, xlim = c(20, 25))
p.new
}
\author{Tengfei Yin}

\name{tracks}
\alias{tracks}
\alias{alignPlots}
\alias{align.plots}
\alias{Tracks-class}
\alias{xlim}
\alias{xlim,Tracks-method}
\alias{xlim,numeric-method}
\alias{xlim,IRanges-method}
\alias{xlim,GRanges-method}
\alias{xlim<-}
\alias{xlim<-,Tracks,numeric-method}
\alias{xlim<-,Tracks,IRanges-method}
\alias{xlim<-,Tracks,GRanges-method}
\alias{bgColor}
\alias{bgColor,GGbio-method}
\alias{bgColor,Tracked-method}
\alias{bgColor,gg-method}
\alias{bgColor,gtable-method}
\alias{bgColor<-}
\alias{bgColor<-,GGbio,character-method}
\alias{bgColor<-,Tracked,character-method}
\alias{bgColor<-,gg,character-method}
\alias{bgColor<-,gtable,character-method}
\alias{fixed,GGbio-method}
\alias{fixed,Tracked-method}
\alias{fixed,gg-method}
\alias{fixed<-,GGbio,logical-method}
\alias{fixed<-,Tracked,logical-method}
\alias{fixed<-,gg,logical-method}
\alias{hasAxis}
\alias{hasAxis,GGbio-method}\alias{hasAxis,GGbio-method}
\alias{hasAxis,Tracked-method}
\alias{hasAxis,gg-method}
\alias{hasAxis,Tracked-method}
\alias{hasAxis,gg-method}
\alias{hasAxis<-}
\alias{hasAxis<-,GGbio,logical-method}
\alias{hasAxis<-,Tracked,logical-method}
\alias{hasAxis<-,gg,logical-method}
\alias{height}
\alias{height,GGbio-method}
\alias{height,Tracked-method}
\alias{height,gg-method}
\alias{height<-}
\alias{height<-,GGbio,numericORunit-method}
\alias{height<-,Tracked,numericORunit-method}
\alias{height<-,gg,numericORunit-method}
\alias{labeled}
\alias{labeled,GGbio-method}
\alias{labeled,Ideogram-method}
\alias{labeled,Tracked-method}
\alias{labeled,gTree-method}
\alias{labeled,gg-method}
\alias{labeled,gtable-method}
\alias{labeled,text-method}
\alias{labeled<-}
\alias{labeled<-,GGbio,logical-method}
\alias{labeled<-,Ideogram,logical-method}
\alias{labeled<-,Tracked,logical-method}
\alias{labeled<-,gg,logical-method}
\alias{labeled<-,gtable,logical-method}
\alias{mutable}
\alias{mutable,GGbio-method}
\alias{mutable,Tracked-method}
\alias{mutable,gg-method}
\alias{mutable<-}
\alias{mutable<-,GGbio,logical-method}
\alias{mutable<-,Tracked,logical-method}
\alias{mutable<-,gg,logical-method}
\alias{summary}
\alias{summary,Tracks-method}
\alias{show}
\alias{show,Tracks-method}
\alias{print}
\alias{print,Tracks-method}
\alias{Arith}
\alias{Arith,Tracks,ANY-method}
\alias{+,Tracks,ANY-method}
\alias{+,Tracks,theme-method}
\alias{+,Tracks,zoom-method}
\alias{+,Tracks,position_c-method}
\alias{+,Tracks,cartesian-method}
\alias{+,Tracks,Tracks-method}
\alias{reset}
\alias{reset,Tracks-method}
\alias{backup}
\alias{backup,Tracks-method}
\alias{c,Tracks-method}
\alias{c,PlotList-method}
\alias{cbind,Tracks-method}
\alias{rbind,Tracks-method}
\alias{[,Tracks,numeric,missing,ANY-method}
\alias{[,PlotList,numeric,missing,ANY-method}
\alias{coerce,Tracks,grob-method}
\title{Tracks for genomic graphics}
\usage{
tracks(..., heights, xlim, xlab = NULL, main = NULL,
            title = NULL, theme = NULL, 
            track.plot.color = NULL,
            track.bg.color = NULL,
            main.height = unit(1.5, "lines"),
            scale.height = unit(1, "lines"),
            xlab.height = unit(1.5, "lines"),
            padding = unit(-1, "lines"),
            label.bg.color =  "white",
            label.bg.fill = "gray80",
            label.text.color = "black",
            label.text.cex = 1,
            label.text.angle = 90,
            label.width = unit(2.5, "lines"))

\S4method{+}{Tracks,ANY}(e1, e2)
\S4method{+}{Tracks,theme}(e1, e2)
\S4method{+}{Tracks,zoom}(e1, e2)
\S4method{+}{Tracks,position_c}(e1, e2)
\S4method{+}{Tracks,cartesian}(e1, e2)
\S4method{+}{Tracks,Tracks}(e1, e2)
}
\arguments{
  \item{...}{plots of class ggplot, generated from ggplot2 or ggbio.}
  \item{e1}{a \code{Tracks} object.}
  \item{e2}{an object added to a \code{Tracks} object, such as a theme,
    zoom, coordinate specification, or another \code{Tracks} object.}
  \item{heights}{numeric vector of the same length of passed graphic
    object to indicate the ratio of each track.}
  \item{xlim}{limits on x. could be \code{\linkS4class{IRanges}}, \code{\linkS4class{GRanges}}, \code{numeric} value}
  \item{xlab}{label for x axis.}
  \item{main}{title for the tracks.}
  \item{title}{title for the tracks, alias like main.}
  \item{theme}{theme object used for building tracks, this will
    set to default, which could be reseted later. }
  \item{track.plot.color}{
    Vector of characters of length 1 or the same length of passed plots,
    background color for each track, default is white.
  }
  \item{track.bg.color}{
    background color for the whole tracks.
  }
  \item{main.height}{
    unit. Height to control the title track height.
  }
  \item{scale.height}{
    unit. Height to control the scale track height.
  }
  \item{xlab.height}{
    unit. Height to control the xlab track height.
  }        
  \item{padding}{
    single numeric value or unit, if numeric value, the unit would be
    "lines" by default.
  }          
  \item{label.bg.color}{
    track labeling background rectangle border color.
  }
  \item{label.bg.fill}{
    track labeling background fill color.
  }
  \item{label.text.color}{
    track labeling text color.
  }
  \item{label.text.cex}{
    track labeling text size.
  }
  \item{label.text.angle}{
    angle to rotate the track labels.
  }
  \item{label.width}{
    track labeling size.
  } 
}
\section{Track class}{

  constructor \code{tracks} will return a Tracks object, which has
  following slots.
  \describe{
  \item{\code{grobs}}{
    a \code{ggplotGrobList} object contains a list of \code{ggplot}
  object, which is our passed graphics.
  }
  \item{\code{backup}}{
    a backup of all the slots for holding the original tracks, so users
  could edit it and reset it back at any time later, and \code{backup}
  method will reset the backupped copy.
  }
  \item{\code{ylim}}{
    y limits for each plot.
  }
  \item{\code{labeled}}{
    vector of logical value indicates whether a track is labeled or not,
  for \code{labeled} attributes please check utilities section.
  }
  \item{\code{mutable}}{
    vector of logical value indicates whether a track is mutable for
  theme editing or not, for \code{mutable} attributes please check utilities section.
  }
  \item{\code{hasAxis}}{
    vector of logical value indicates whether a track has axis or  not,
    for \code{hasAxis} attributes please check utilities section.
  }
  \item{\code{heights, xlim, xlab, main, title, theme, fixed, track.plot.color,
    track.bg.color, main.height, scale.height, xlab.height, padding,
    label.bg.color, label.bg.fill, label.text.color, label.text.cex, label.text.angle, label.width}}{
    those slots are described in arguments section for constructor.
  }
  }
}

\section{Utilities}{
  Please check examples for usage.
  \describe{
    \item{\code{summary(object)}}{
      summary information about tracks object.
    }
    \item{\code{fixed(x)}, \code{fixed(x) <- value}}{ \code{x} is the
      ggplot object, this controls if a track has a fixed x scale or not, if the \code{fixed}
      attributes is \code{TRUE}, then when you pass this plot to a
      tracks, this plot won't be re-aligned with other tracks and will
      keep the original x-axis, this allow you to pass some plot like
      ideogram. \code{fixed} function will return a logical value 
    }
    \item{\code{labeled(x), labeled(x) <- value}}{\code{x} is the
      ggplot object,  if you pass named graphics into \code{tracks}, it will create the
      labels on the left for you. Several ways supported to name it. You can
      pass a list of graphics with names. Or you can use
      \code{tracks('name1' = p1, 'name 2' = p2, ...)}  with quotes for
      complicated words or simply \code{tracks(part1 = p1, part = p2, ...)}. 
    }
    \item{\code{mutable(x), mutable(x) <- value}}{
      \code{x} is the ggplot object, this controls whether a plot in the
      tracks mutable to theme changing or not, when you use \code{+}
      method for Tracks object, add-on edit will only be applied to the
      the mutable plots.
    }
    \item{\code{bgColor(x), bgColor(x) <- value}}{
      \code{x} is the ggplot object, this change the background color
      for single plot shown in the tracks.
    }
    \item{\code{xlim(x), xlim(x) <- value}}{
      when \code{x} is the numeric value, it calls
      ggplot2::coord_cartesian(xlim = ...) method, we doesn't use
      ggplot2::xlim() for the reason it will cut data outside the range,
      and we believe the best behavior would be zoom-in/out like
      most browser. when \code{x} is \code{\linkS4class{IRanges}},
      \code{\linkS4class{GRanges}}, it get the range and passed to
      ggplot2::coord_cartesian function.
      
      when \code{x} is Tracks object, \code{xlim(x)} will
      return x limits for that tracks. \code{xlim(x) <- value}
      replace method only works for Tracks object. \code{value} could be
      \code{numeric}, \code{\linkS4class{IRanges}},
	\code{\linkS4class{GRanges}} object. This will change the x
      limits associated with tracks.

      \code{+ xlim(obj)}:\code{obj} is the numeric range, or \code{\linkS4class{IRanges}},
      \code{\linkS4class{GRanges}} object.

      \code{+ coord_cartesian()}:
      please read manual in ggplot2, this controls both xlim an
      ylim, only accept numerical range.
    }
    \item{\code{+}}{
      The most nice features about \code{\linkS4class{Tracks}} object is
      the one inherited from ggplot2's components additive features,
      with \code{+} method you can use any \code{theme} object and
      utilities in ggplot2 package, to add them on a
      \code{\linkS4class{Tracks}} object, for example, if x is our
      \code{\linkS4class{Tracks}} object, \code{x + theme} would  apply
      theme to any plots in the tracks except those are immutable.
    }
    \item{\code{as(x, "grob")}}{Coerces a Tracks object to a grob for
      embedding in a larger figure.
    }
  }
}

\section{Backup and reset}{
  \describe{
    \item{reset(obj)}{
      \code{obj} is the Tracks object, this reset the tracks back to
      original or backuped version.
    }
    \item{backup(obj)}{
      \code{obj} is the Tracks object, this clear previous backup and
      use current setting for a new backup.
    }
  }
}


\description{
  \code{tracks} is a conventient constructor for bindind graphics as trakcs. You dont' have
  to worry about adjusting different graphics, \code{tracks} did that for you. It's NOT
  just limited to bind genomic tracks, you can use this function to bind any
  tracks with the same defination of x axis, for example, sets of time series
  plots you made.

  Tracks view is most common way to viewing genome features and annotation data
  and widely used by most genome browsers. Our assumption is that, most graphics
  you made with ggbio or by yourself using ggplot2, are almost always sitting
  on the genomic coordinates or the same x axis. And to compare annotation
  information along with genome features, we need to align those plots on exactly
  the same x axis in order to form your hypothesis. This function leaves you the
  flexibility to construct each tracks separately with worrying your alignments
  later.
}

\details{
  \code{tracks} did following modification for passed plots.
  \itemize{
    \item Remove x-axis text, ticks, xlab and title for each track and
    add a shared scale at the bottom. We assume a new xlab and title
    will be provided by the \code{tracks} function for the whole
    display, while each plot keeps its own y axis.

    \item Align x-scale limits so every plot sits on exactly the same x
    scale.

    \item Squeeze plots together to some extent.

    \item Label tracks if names are provided; please check the utilities
    section about the \code{labeled} method.

    \item Return a \code{Tracks} object, which enables many of the
    features introduced in this manual.
  }
}


\seealso{\code{\link{align.plots}}}
\value{
 A \code{Tracks} object.
}
\examples{
## make a simulated time series data set
df1 <- data.frame(time = 1:100, score = sin((1:100)/20)*10)
p1 <- qplot(data = df1, x = time, y = score, geom = "line")
df2 <- data.frame(time = 30:120, score = sin((30:120)/20)*10, value = rnorm(120-30 + 1))
p2 <- ggplot(data = df2, aes(x = time, y = score)) + 
  geom_line() + geom_point(size = 4, aes(color = value))
## check p2
p1
## check p2
p2

## binding
tracks(p1, p2)

## or
tks <- tracks(p1, p2)
tks

## combine
c(tks, tks)
tks + tks

cbind(tks, tks)
rbind(tks, tks) ## different wth c()!
library(grid)
x <- as(tks, "grob")
grid.draw(cbind(x, x))


## labeling: default labeling a named graphic
## simply pass a name with it
tracks(time1 = p1, time2 = p2)
## or pass a named list with it
lst <- list(time1 = p1, time2 = p2)
tracks(lst)

## more complicated case please use quotes
tracks(time1 = p1, "second time" = p2)

## set heights
tracks(time1 = p1, time2 = p2, heights = c(1, 3))

## if you want to disable label arbitrarily
## default label is always TRUE
labeled(p2) 
labeled(p2) <- FALSE
## set labeled to FALSE, remove label even the plot has a name
tracks(time1 = p1, time2 = p2)
labeled(p2) <- TRUE

## fix a plot, not synchronize with other plots
p3 <- p1
## default is always FALSE
fixed(p3)
## set to TRUE
fixed(p3) <- TRUE
fixed(p3)

tracks(time1 = p1, time2 = p2, "time3(fixed)" = p3) 


fixed(p3) <- FALSE
## otherwise you could run
%% tracks(time1 = p1, time2 = p2, "time3(fixed)" = p3, fixed = c(FALSE, FALSE, TRUE))


## control axis
hasAxis(p1)
hasAxis(p1) <- TRUE
# ready for weird looking
tracks(time1 = p1, time2 = p2)
# set it back
hasAxis(p1) <- FALSE



## mutable
mutable(p1)
tracks(time1 = p1, time2 = p2) + theme_bw()
mutable(p1) <- FALSE
# mutable for "+" method
tracks(time1 = p1, time2 = p2) + theme_bw()
mutable(p1) <- TRUE

## bgColor
bgColor(p1)
tracks(time1 = p1, time2 = p2)
bgColor(p1) <- "brown"
# mutable for "+" method
tracks(time1 = p1, time2 = p2)
# set it back
bgColor(p1) <- "white"

## apply a theme to each track
tks <- tracks(time1 = p1, time2 = p2) + theme_bw()
tks
reset(tks)

## store it with tracks
tks <- tracks(time1 = p1, time2 = p2, theme = theme_bw())
tks
tks <- tks + theme_gray()
tks
## reset will be introduced later
reset(tks)

## apply a pre-defiend theme for tracks!
tracks(time1 = p1, time2 = p2) + theme_tracks_sunset()
 tracks(p1, p2) + theme_tracks_sunset()

## change limits
tracks(time1 = p1, time2 = p2) + xlim(c(1, 40))
tracks(time1 = p1, time2 = p2) + xlim(1, 40)
tracks(time1 = p1, time2 = p2) + coord_cartesian(xlim = c(1, 40))
# change y
tracks(time1 = p1, time2 = p2) + xlim(1, 40) + ylim(0, 10)
library(GenomicRanges)
gr <- GRanges("chr", IRanges(1, 40))
# GRanges
tracks(time1 = p1, time2 = p2) + xlim(gr)
# IRanges
tracks(time1 = p1, time2 = p2) + xlim(ranges(gr))
tks <- tracks(time1 = p1, time2 = p2)
xlim(tks)
xlim(tks) <- c(1, 35)
xlim(tks) <- gr
xlim(tks) <- ranges(gr)

## xlab, title
tracks(time1 = p1, time2 = p2, xlab = "time")
tracks(time1 = p1, time2 = p2, main = "title")
tracks(time1 = p1, time2 = p2, title = "title")
tracks(time1 = p1, time2 = p2, xlab = "time", title = "title") + theme_tracks_sunset()


## backup and restore
tks <- tracks(time1 = p1, time2 = p2)
tks
tks <- tks + xlim(1, 40)
tks
reset(tks)
tks <- tks + xlim(1, 40)
tks
tks <- backup(tks)
tks <- tks + theme_bw()
tks
reset(tks)

## padding(need to be fixed for more delicate control)
tracks(time1 = p1, time2 = p2, padding = 2)

## track color
tracks(time1 = p1, time2 = p2, track.bg.color = "yellow")
tracks(time1 = p1, time2 = p2, track.plot.color = c("yellow", "brown"))

}
\author{Tengfei Yin}

\name{layout_circle}
\alias{circle}
\alias{layout_circle}
\alias{layout_circle,GRanges-method}
\alias{layout_circle,missing-method}
\alias{layout_circle,uneval-method}
\title{Create a circle layout}
\description{
  Create a circle layout.
}
\usage{
\S4method{layout_circle}{GRanges}(data, ..., geom = c("point", "line", "link", "ribbon",
                 "rect", "bar", "segment", "hist", "scale", "heatmap", "ideogram",
                 "text"), linked.to, radius = 10, trackWidth = 5,
                 space.skip = 0.015, direction = c("clockwise",
                 "anticlockwise"), link.fun = function(x, y, n = 30)
                 bezier(x, y, evaluation = n), rect.inter.n = 60, rank,
                 ylim = NULL,
                 scale.n = 60, scale.unit = NULL, scale.type = c("M",
                 "B", "sci"), grid.n = 5, grid.background = "gray70",
                 grid.line = "white", grid = FALSE, chr.weight = NULL)

\S4method{layout_circle}{missing}(data, ...)
circle(...)
}
\arguments{
  \item{data}{
    A \code{GRanges} object.
  }
  \item{...}{
    Extra parameters such as aesthetics mapping in aes(), or
    \code{color, size}, etc. For circle function, it passed to \code{layout_circle}.
  }
  \item{geom}{
    The geometric object to use display the data.
  }
  \item{linked.to}{
    Character indicates column that specifying end of the linking lines,
    that column should be a \code{GRanges} object.
  }
  \item{radius}{
    Numeric value indicates radius. Default is 10.
  }
  \item{trackWidth}{
    Numeric value indicates the track width.
  }
  \item{space.skip}{
    Numeric value indicates the ratio of skipped region between chunks(chromosomes
    in \code{GRanges}) to the whole track space.
  }
  \item{direction}{
    Space layout orders.
  }
  \item{link.fun}{
    Function used for interpolate the linking lines. Default is Hmisc::bezier.
  }
  \item{rect.inter.n}{
    n passed to interpolate function in rectangle transformation(from a
    rectangle) to a section in circular view.
  }
  \item{rank}{
    For default equal trackWidth, use rank to specify the circle orders.
  }
  \item{ylim}{
    Numeric range to control y limits.
  }
  \item{scale.n}{
    Approximate number of ticks you want to show on the whole
    space. used when scale.unit is \code{NULL}.
  }
  \item{scale.unit}{
    Unit used for computing scale. Default is \code{NULL},
  }
  \item{scale.type}{
    Scale type used for
  }
  \item{grid}{
    logical value indicate showing grid background for track or not.
  }
  \item{grid.n}{
    integer value indicate horizontal grid line number.
  }
  \item{grid.background}{
    grid background color.
  }
  \item{grid.line}{
    grid line color.
  }
  \item{chr.weight}{
    numeric vectors which sum to <1, the names of vectors has to be
  matched with seqnames in seqinfo, and you can only specify part of the
  seqnames, other lengths of chromosomes will be assined proportionally
  to their seqlengths, for example, you could specify chr1 to be 0.5, so
  the chr1 will take half of the space and other chromosomes squeezed to
  take left of the space.
  }

}
\value{
  A 'Layer'.
}
\examples{
N <- 100
library(GenomicRanges)
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))


seqlengths(gr) <- c(400, 500, 700)
values(gr)$to.gr <- gr[sample(1:length(gr), size = length(gr))]

## doesn't pass gr to the ggplot
ggplot() + layout_circle(gr, geom = "ideo", fill = "gray70", radius = 7, trackWidth = 3) +
  layout_circle(gr, geom = "bar", radius = 10, trackWidth = 4, aes(fill = score, y = score)) +
  layout_circle(gr, geom = "point", color = "red", radius = 14,
                trackWidth = 3, grid = TRUE, aes(y = score)) +
    layout_circle(gr, geom = "link", linked.to = "to.gr", radius = 6,
trackWidth = 1)

## more formal API
ggplot(gr) + layout_circle(geom = "ideo", fill = "gray70", radius = 7, trackWidth = 3) +
  layout_circle(geom = "bar", radius = 10, trackWidth = 4, mapping = aes(fill = score, y = score)) +
  layout_circle(geom = "point", color = "red", radius = 14,
                trackWidth = 3, grid = TRUE, mapping = aes(y = score)) +
    layout_circle(geom = "link", linked.to = "to.gr", radius = 6, trackWidth = 1)

}
\author{Tengfei Yin}

\name{geom_rect}
\alias{geom_rect}
\alias{geom_rect,ANY-method}
\alias{geom_rect,GRanges-method}
\alias{geom_rect,missing-method}
\alias{geom_rect,uneval-method}
\title{Rect geoms for GRanges object}
\description{
  Show interval data as rectangle.
}
\usage{
\S4method{geom_rect}{ANY}(data, ...)
\S4method{geom_rect}{GRanges}(data,..., xlab, ylab, main,
          facets = NULL, stat = c("stepping", "identity"),
          rect.height = NULL,
          group.selfish = TRUE)
}
\arguments{
  \item{data}{
    Typically a \code{GRanges} or \code{data.frame} object. When it's
    \code{data.frame}, it's simply calling ggplot2::geom_rect.
  }
  \item{...}{
    Extra parameters such as aes() or \code{color, size} passed.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{facets}{
    Faceting formula to use. 
  }
  \item{stat}{
    Character vector specifying statistics to use. "stepping" with
    randomly assigned stepping levels as y varialbe. "identity" allow
    users to specify \code{y} value in \code{aes}.
  }
  \item{rect.height}{
    Half height of the arrow body. 
  }
  \item{group.selfish}{
    Passed to \code{addStepping}, control whether to show each group as
    unique level or not. If set to \code{FALSE}, if two groups are not
    overlapped with each other, they will probably be layout in the same
    level to save space.
  }  
}
\value{
  A 'Layer'.
}
\examples{
set.seed(1)
N <- 100
require(GenomicRanges)

## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))



## ======================================================================
##  data.frame call ggplot2::geom_rect
## ======================================================================
ggplot() + geom_rect(data = mtcars, mapping = aes(xmin = mpg, ymin = wt, xmax = mpg + 10, ymax = wt + 0.2,
                       fill = cyl))



## ======================================================================
##  default
## ======================================================================
ggplot(gr) + geom_rect()
# or
ggplot() + geom_rect(gr)


## ======================================================================
##  facetting and aesthetics
## ======================================================================
ggplot(gr) + geom_rect(facets = sample ~ seqnames, mapping = aes(color = strand, fill = strand))


## ======================================================================
##  stat:identity
## ======================================================================
ggplot(gr) + geom_rect(stat = "identity", mapping = aes(y = value))


## ======================================================================
##  stat:stepping
## ======================================================================
ggplot(gr) + geom_rect(stat = "stepping", mapping = aes(y = value, group = pair))


## ======================================================================
##  group.selfish controls when 
## ======================================================================
ggplot(gr) + geom_rect(stat = "stepping", mapping = aes(y = value, group = pair), group.selfish = FALSE)
}
\author{Tengfei Yin}

\name{plotRangesLinkedToData}
\alias{plotRangesLinkedToData}
\alias{plotRangesLinkedToData,RangedSummarizedExperiment-method}
\alias{plotRangesLinkedToData,GenomicRanges_OR_GRangesList-method}
\title{Plot Ranges Linked with Data}
\description{
  Plot GRanges object structure and linked to a even spaced paralell
  coordinates plot which represting the data in elementeMetadata.
}
\usage{
\S4method{plotRangesLinkedToData}{RangedSummarizedExperiment}(data, ...,
          stat.y = seq_len(ncol(data)), stat.ylab = names(assays(data)[stat.assay]),
          stat.assay = 1L)

\S4method{plotRangesLinkedToData}{GenomicRanges_OR_GRangesList}(data, ...,
          stat.y = seq_len(ncol(mcols(data))),
          stat.ylab, sig, sig.col = c("black", "red"),
          stat.coord.trans = coord_trans(),
          annotation = list(), width.ratio = 0.8,
          theme.stat = theme_gray(), theme.align = theme_gray(),
          linetype = 3, heights)




}
\arguments{
  \item{data}{
    GRanges object with a DataFrame as elementMetadata.
  }
  \item{...}{
    Parameters passed to control lines in top plot.
  }
  \item{stat.y}{
    integer (variable position starting in DataFrame of data, start from
    1) or strings (variable names) which indicate the column names.
  }
  \item{stat.ylab}{
    y label for stat track(the top track).
  }
  \item{stat.assay}{
    default 1L, element of assays.
  }
  \item{sig}{
    a character of element meta data column of logical value, indicates
    which row is signficant. and will be shown in link lines and rectangle.
  }
  \item{sig.col}{
    colors for significant, valid when you specify "sig" argument, the
    first color indicates \code{FALSE}, non-significant, the second
    color indicates \code{TRUE}.
  }
  \item{stat.coord.trans}{
    transformation used for top plot.
  }
  \item{annotation}{
    A list of ggplot object.
  }
  \item{width.ratio}{
    Control the segment length of statistic layer.
  }
  \item{theme.stat}{
    top plot theme.
  }
  \item{theme.align}{
    alignment themes.
  }
  \item{linetype}{
    linetype
  }
  \item{heights}{
    Heights of each track.
  }
}
\value{
  return a frame grob; side-effect (plotting) if plot=T.
}
\details{
Inspired by some graphics produced in some other packages, for example
in package DEXseq, the author provides graphics with gene
models and linked to an even spaced statistics summary. This is useful
because we always plot everything along the genomic coordinates, but
genomic features like exons are not evenly distributed, so we could
actually treat the statistics associated with exons like categorical
data, and show them as "Paralell Coordinates Plots". This is one
special layout which represent the data in a nice manner and also keep
the genomic structure information. With abliity of \code{tracks},
it's possible to generate such type of a graphic along with other
annotations.

The data we want is a normal \code{GRanges} object, and make sure
the intervals are not overlaped with each other(currently), and you
may have multiple columns which store the statistics for multiple
samples, then we produce the graphic we introduced above and users
could pass other annotation track in the function which will be shown
below the main linked track. 

The reason you need to pass annotation into the function instead of
binding them by \code{tracks} later is because binding manually
with annotation tracks is tricky and this function doesn't return a
ggplot object. 
}
\examples{
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(ggbio)
data(genesymbol, package = "biovizBase")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
model <- exonsBy(txdb, by = "tx")
model17 <- subsetByOverlaps(model, genesymbol["RBM17"])
exons <- exons(txdb)
exon17 <- subsetByOverlaps(exons, genesymbol["RBM17"])
## reduce to make sure there is no overlap
## just for example
exon.new <- reduce(exon17)
## suppose
values(exon.new)$sample1 <- rnorm(length(exon.new), 10, 3)
values(exon.new)$sample2 <- rnorm(length(exon.new), 10, 10)
values(exon.new)$score <- rnorm(length(exon.new))
values(exon.new)$significant <- sample(c(TRUE,FALSE), size = length(exon.new),replace = TRUE)

plotRangesLinkedToData(exon.new, stat.y = c("sample1", "sample2"))
plotRangesLinkedToData(exon.new, stat.y = 1:2)
plotRangesLinkedToData(exon.new, stat.y = 1:2, size = 3, linetype = 4)
plotRangesLinkedToData(exon.new, stat.y = 1:2, size = 3, linetype = 4,
                       sig = "significant")
plotRangesLinkedToData(exon.new, stat.y = 1:2, size = 3, linetype = 4,
                        sig = "significant", sig.col = c("gray90","red"))
}
\author{Tengfei Yin}

\name{geom_arrow}
\alias{geom_arrow}
\alias{geom_arrow,GRanges-method}
\alias{geom_arrow,missing-method}
\alias{geom_arrow,uneval-method}
\title{Arrow geoms for GRanges object}
\description{
  Show interval data as arrows.
}
\usage{
\S4method{geom_arrow}{GRanges}(data, ..., xlab, ylab, main,
          angle = 30, length = unit(0.12, "cm"), type = "open",
          stat = c("stepping", "identity"), facets = NULL,
          arrow.rate = 0.03, group.selfish = TRUE)

}
\arguments{
  \item{data}{
    A \code{GRanges} object.
  }
  \item{...}{
    Extra parameters such as aes() passed.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{angle}{
     The angle of the arrow head in degrees (smaller numbers produce
  narrower, pointier arrows).  Essentially describes the width of the
  arrow head.
  }
  \item{length}{
    A unit specifying the length of the arrow head (from tip to base).
  }
  \item{type}{
  One of "open" or "closed" indicating whether the arrow head should
  be a closed triangle.
  }
  \item{stat}{
    Character vector specifying statistics to use. "stepping" with
    randomly assigned stepping levels as y varialbe. "identity" allow
    users to specify \code{y} value in \code{aes}.
  }
  \item{facets}{
    Faceting formula to use.
  }
  \item{arrow.rate}{
    Arrow density of the arrow body.
  }
  \item{group.selfish}{
    Passed to \code{addStepping}, control whether to show each group as
  unique level or not. If set to \code{FALSE}, if two groups are not
  overlapped with each other, they will probably be layout in the same
  level to save space.
  }  
}
\value{
  A 'Layer'.
}
\examples{
set.seed(1)
N <- 100
require(GenomicRanges)
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))


## ======================================================================
##  default
## ======================================================================
ggplot(gr) + geom_arrow()
# or
ggplot() + geom_arrow(gr)

## ======================================================================
##  facetting and aesthetics
## ======================================================================
ggplot(gr) + geom_arrow(facets = sample ~ seqnames, mapping = aes(color = strand, fill = strand))

## ======================================================================
##  stat:identity
## ======================================================================
ggplot(gr) + geom_arrow(stat = "identity", mapping = aes(y = value))


## ======================================================================
##  stat:stepping
## ======================================================================
ggplot(gr) + geom_arrow(stat = "stepping", mapping = aes(y = value, group = pair))

## ======================================================================
##  group.selfish
## ======================================================================
ggplot(gr) + geom_arrow(stat = "stepping", mapping = aes(y = value, group = pair), group.selfish = FALSE)



## ======================================================================
## other options to control arrow angle, density, ...
## ======================================================================
library(grid)
ggplot(gr) + geom_arrow(stat = "stepping", mapping = aes(y = value, group = pair),
                      arrow.rate = 0.01, length = unit(0.3, "cm"), angle = 45,
                      group.selfish = FALSE)

}
\author{Tengfei Yin}

\name{layout_karyogram}
\alias{layout_karyogram}
\alias{layout_karyogram,GRanges-method}
\title{Create a karyogram layout}
\description{
  Create a karyogram layout.
}
\usage{
\S4method{layout_karyogram}{GRanges}(data, ..., xlab, ylab, main,
          facets = seqnames ~ ., cytobands = FALSE, geom = "rect",
          stat = NULL, ylim = NULL, rect.height = 10)

}
\arguments{
  \item{data}{
    a \code{GRanges} object, which could contain extra
    information about cytobands. If you want an accurate genome mapping, please provide
    \code{seqlengths} with this \code{GRanges} object,otherwise it will
    emit a warning and use data space to estimate the chromosome space
    which is very rough.
  }
  \item{...}{
    Extra parameters such as aes() or arbitrary \code{color} and \code{size}.
  }
  \item{xlab}{
    character vector or expression for x axis label.
  }
  \item{ylab}{
    character vector or expression for y axis label.
  }
  \item{main}{
    character vector or expression for plot title.
  }
  \item{facets}{
    faceting formula to use.
  }
  \item{cytobands}{
    logical value indicate to show the cytobands or not.
  }
  \item{geom}{
    The geometric object to use display the data. 
  }
  \item{stat}{
    character vector specifying statistics to use.
  }
  \item{ylim}{
    limits for y axis, usually the chromosome spaces y limits are from 0
    to rect.height, which 10, so if you wan to stack some data on top of
    it, you can set limits to like c(10, 20).
  }
  \item{rect.height}{
    numreic value indicate half of the rectangle ploting region, used
    for alignment of multiple layers.
  }}
\value{
  A 'Layer'.
}
\examples{
### R code from vignette source 'karyogram.Rnw'

###################################################
### code chunk number 1: loading
###################################################
library(ggbio)
data(hg19IdeogramCyto, package = "biovizBase")
head(hg19IdeogramCyto)
## default pre-set color stored in 
getOption("biovizBase")$cytobandColor


###################################################
### code chunk number 2: default
###################################################
autoplot(hg19IdeogramCyto, layout = "karyogram", cytobands = TRUE)



###################################################
### code chunk number 3: change-order
###################################################
library(GenomeInfoDb)  # for keepSeqlevels()
hg19 <- keepSeqlevels(hg19IdeogramCyto, paste0("chr", c(1:22, "X", "Y")))
head(hg19)
autoplot(hg19, layout = "karyogram", cytobands = TRUE)


###################################################
### code chunk number 4: cyto-normal
###################################################
library(GenomicRanges)
## it's a 'ideogram'
biovizBase::isIdeogram(hg19)
## set to FALSE
autoplot(hg19, layout = "karyogram", cytobands = FALSE, aes(fill = gieStain)) +
  scale_fill_giemsa()


###################################################
### code chunk number 5: load-RNAediting
###################################################
data(darned_hg19_subset500, package = "biovizBase")
dn <- darned_hg19_subset500
head(dn)
## add seqlengths
## we have seqlegnths information in another data set
data(hg19Ideogram, package = "biovizBase")
seqlengths(dn) <- seqlengths(hg19Ideogram)[names(seqlengths(dn))]
## now we have seqlengths
head(dn)
## then we change order
dn <- keepSeqlevels(dn, paste0("chr", c(1:22, "X")))
autoplot(dn, layout = "karyogram")
## this equivalent to 
## autoplot(seqinfo(dn))


###################################################
### code chunk number 6: load-RNAediting-color
###################################################
## since default is geom rectangle, even though it's looks like segment
## we still use both fill/color to map colors
autoplot(dn, layout = "karyogram", aes(color = exReg, fill = exReg))


###################################################
### code chunk number 7: load-RNAediting-color-NA
###################################################
## since default is geom rectangle, even though it's looks like segment
## we still use both fill/color to map colors
autoplot(dn, layout = "karyogram", aes(color = exReg, fill = exReg)) +
  scale_color_discrete(na.value = "brown")


###################################################
### code chunk number 8: load-RNAediting-color-fake
###################################################
dn2 <- dn
seqlengths(dn2) <- rep(max(seqlengths(dn2)), length(seqlengths(dn2)) )
autoplot(dn2, layout = "karyogram", aes(color = exReg, fill = exReg)) 


###################################################
### code chunk number 9: plotKaryogram (eval = FALSE)
###################################################
## plotKaryogram(dn)
## plotKaryogram(dn, aes(color = exReg, fill = exReg))


###################################################
### code chunk number 10: low-default
###################################################
## plot ideogram
p <- ggplot(hg19) + layout_karyogram(cytobands = TRUE)
p
## eqevelant autoplot(hg19, layout = "karyogram", cytobands = TRUE)


###################################################
### code chunk number 11: low-default-addon
###################################################
p <- p + layout_karyogram(dn, geom = "rect", ylim = c(11, 21), color = "red")
## commented line below won't work
## the cytoband fill color has been used already.
## p <- p + layout_karyogram(dn, aes(fill = exReg, color = exReg), geom = "rect")
p


###################################################
### code chunk number 12: edit-space
###################################################
## plot chromosome space
p <- autoplot(seqinfo(dn))
## make sure you pass rect as geom
## otherwise you just get background
p <- p + layout_karyogram(dn, aes(fill = exReg, color = exReg), geom = "rect")
values(dn)$pvalue <- rnorm(length(dn))
p + layout_karyogram(dn, aes(x = start, y = pvalue), ylim = c(10, 30), geom = "line", color = "red")
p


###################################################
### code chunk number 13: sessionInfo
###################################################
sessionInfo()
}
\author{Tengfei Yin}

\name{zoom}
\alias{zoom}
\alias{zoom_in}
\alias{zoom_out}
\alias{nextView}
\alias{prevView}
\title{Simple navigation for ggbio object.}
\description{
  A set of simple navigation API apply to ggbio object, let you move
  along the genome and zoom in/out.
}
\usage{
zoom(fac = 1/2)
zoom_in(fac = 1/2)
zoom_out(fac = 2)
nextView(unit = c("view", "gene", "exon", "utr"))
prevView(unit = c("view", "gene", "exon", "utr"))
}
\arguments{
  \item{fac}{
    numeric value to indicate zoom factor, multiple of current view
    width. If it's smaller than 1, then it's zoom-in operation; if it's bigger
    than 1, then it's zoom-out operation.
  }
  \item{unit}{
    only support 'view' unit now.
  }
}
\value{
  A special class of navigation.
}
\details{
  \code{zoom_in} and \code{zoom_out} are just simple wrapper around
  \code{zoom} function.

  For more convenient, gene features based jumpting we will support it
  in the future.
}
\author{Tengfei Yin}

\name{stat_reduce}
\alias{stat_reduce}
\alias{stat_reduce,missing-method}
\alias{stat_reduce,uneval-method}
\alias{stat_reduce,GRanges-method}
\alias{stat_reduce,IRanges-method}
\alias{stat_reduce,TxDbOREnsDb-method}
\title{Reduce an object.}
\description{
  Reduce \code{GRanges}, \code{IRanges} or \code{TxDb} object.
}
\usage{
\S4method{stat_reduce}{GRanges}(data, ...,
           xlab, ylab, main,
           drop.empty.ranges = FALSE,
           min.gapwidth = 1L,
           facets = NULL, geom = NULL)

\S4method{stat_reduce}{IRanges}(data, ...,
           xlab, ylab, main,
           drop.empty.ranges = FALSE,
           min.gapwidth = 1L,
           with.inframe.attrib=FALSE,
           facets = NULL, geom = NULL)

\S4method{stat_reduce}{TxDbOREnsDb}(data, ...)
}
\arguments{
  \item{data}{
    \code{GRanges}, \code{IRanges} or \code{TxDb} object.
  }
  \item{...}{
    passed to aesthetics mapping.
  }
  \item{xlab}{
    x label.
  }
  \item{ylab}{
    y label.
  }
  \item{main}{
    title.
  }
  \item{drop.empty.ranges}{
    pass to \code{\link[IRanges]{reduce}} function.
  }
  \item{min.gapwidth}{
    pass to \code{\link[IRanges]{reduce}} function.
  }
  \item{with.inframe.attrib}{
    pass to \code{\link[IRanges]{reduce}} function.
  }
  \item{facets}{
    pass to \code{\link[IRanges]{reduce}} function.
  }
  \item{geom}{
    geometric type.
  }
}
\value{
  a ggplot object.
}
\seealso{
  \code{\link[IRanges]{reduce}}.
}
\examples{
set.seed(1)
N <- 1000
library(GenomicRanges)

gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))

ggplot(gr) + stat_reduce()
autoplot(gr, stat = "reduce")
strand(gr) <- "*"
ggplot(gr) + stat_reduce()

library(TxDb.Hsapiens.UCSC.hg19.knownGene)
data(genesymbol, package = "biovizBase")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
## made a track comparing full/reduce stat.
ggplot(txdb) + stat_reduce(which = genesymbol["RBM17"])

}
\author{Tengfei Yin}

\name{stat_coverage}
\alias{stat_coverage}
\alias{stat_coverage,missing-method}
\alias{stat_coverage,uneval-method}
\alias{stat_coverage,GRanges-method}
\alias{stat_coverage,GRangesList-method}
\alias{stat_coverage,BamFile-method}
\title{Calculate coverage}
\description{
  Calculate coverage.
}
\usage{
# for GRanges
\S4method{stat_coverage}{GRanges}(data, ..., xlim, xlab, ylab, main,
              facets = NULL, geom = NULL)
# for GRangesList
\S4method{stat_coverage}{GRangesList}(data, ..., xlim, xlab, ylab, main,
              facets = NULL, geom = NULL)

# for Bamfile
\S4method{stat_coverage}{BamFile}(data, ..., maxBinSize = 2^14,
               xlim, which, xlab, ylab,
               main, facets = NULL, geom = NULL,
               method = c("estimate", "raw"),
               space.skip = 0.1, coord = c("linear", "genome"))
}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters such as aes() passed to \code{geom_rect},
    \code{geom_alignment}, or \code{geom_segment}.
  }
  \item{xlim}{
    Limits for x.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{facets}{
    Faceting formula to use.
  }
  \item{geom}{
    The geometric object to use display the data. 
  }
  \item{maxBinSize}{
    maxBinSize.
  }
  \item{method}{
    'estimate' for parsing estimated coverage(fast), 'raw' is slow and
    parse the accurate coverage.
  }
  \item{which}{
    \code{GRanges} which defines region to subset the results.
  }
  \item{space.skip}{
    used for coordinate genome, skip between chromosomes.
  }
  \item{coord}{
    coordinate system.
  }
}
\value{
  A 'Layer'.
}
\examples{
library(ggbio)
## ======================================================================
##  simmulated GRanges
## ======================================================================
set.seed(1)
N <- 1000
library(GenomicRanges)

gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))

ggplot(gr) + stat_coverage()
ggplot() + stat_coverage(gr)

ggplot(gr) + stat_coverage(geom = "point")
ggplot(gr) + stat_coverage(geom = "area")
ggplot(gr) + stat_coverage(mapping = aes(y = ..coverage..), geom = "bar")

ggplot(gr) + stat_coverage(mapping = aes(y = ..coverage..)) + geom_point()

## for bam file
## TBD
}
\author{Tengfei Yin}

\name{plotFragLength}
\alias{plotFragLength}
\alias{plotFragLength,character,GRanges-method}
\title{Plot estimated fragment length for paired-end RNA-seq data}
\description{
  Plot estimated fragment length for paired-end RNA-seq data against
  single reduced data model. 
}
\usage{
\S4method{plotFragLength}{character,GRanges}(data, model,
               gap.ratio = 0.0025,
               geom = c("segment", "point", "line"),
               type = c("normal", "cut"),
               heights = c(400, 100),
               annotation = TRUE)
}
\arguments{
  \item{data}{
    A character indicate the bam file.
  }
  \item{model}{
    A reduced model to compute estimated fragment length. please see
    details.
  }
  \item{gap.ratio}{
    When type is set to "cut", it will provide a compact view, which cut
    the common gaps in a certain ratio.
  }
  \item{geom}{
    One or all three geoms could be drawn at the same time. y value of
    "point" and "line" indicate the estimated fragment length. and if
    geom is set to "segment", the segment is from the left most position
    to paired right most position, should be equal to "isize".
  }
  \item{type}{
    "normal" return a uncut view, loose but the coordinate is true
    genomic coordinates. "cut" cut the view in a compact way.
  }
  \item{heights}{
    Numeric vector indicate the heights of tracks.
  }
  \item{annotation}{
    A logical value. TRUE shows model, and FALSE shows only fragment
    length with labels.
  }
}
\value{
  A ggplot object when \code{annotation = FALSE} and a frame grob if
  \code{annotation = TRUE}
}
\details{
  We use a easy way to define this estimated fragment length, we
  collect all paired reads and model, reduce model first, then find
  common gaps, remove common gaps between paired-end reads, and compute
  the new estimated fragment length. 
}
\examples{
\dontrun{
data(genesymbol)
bamfile <- system.file("extdata", "SRR027894subRBM17.bam", package="biovizBase")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
model <- exonsBy(txdb, by = "tx")
model.new <- subsetByOverlaps(model, genesymbol["RBM17"])
exons.rbm17 <- subsetByOverlaps(exons(txdb), genesymbol["RBM17"])
exons.new <- reduce(exons.rbm17)
plotFragLength(bamfile, exons.new, geom = "line")
plotFragLength(bamfile, exons.new, geom = c("point","segment"))
plotFragLength(bamfile, exons.new, geom = c("point","segment"), annotation = FALSE)
plotFragLength(bamfile, exons.new, geom = c("point","segment"), type = "cut",
               gap.ratio = 0.001)
}
}
\author{Tengfei Yin}

\name{stat_aggregate}
\alias{stat_aggregate}
\alias{stat_aggregate,GRanges-method}
\alias{stat_aggregate,missing-method}
\alias{stat_aggregate,uneval-method}
\title{Generates summaries on the specified windows}
\description{
Generates summaries on the specified windows  
}
\usage{
% for GRanges
\S4method{stat_aggregate}{GRanges}(data, ..., xlab, ylab, main, by, FUN,
                          maxgap=-1L, minoverlap=0L,
                          type=c("any", "start", "end", "within", "equal"),
                          select=c("all", "first", "last", "arbitrary"),
                          y = NULL, window = NULL, facets = NULL, 
                          method = c("mean", "median","max",
                                   "min", "sum", "count", "identity"),
                          geom = NULL)


}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Arguments passed to plot function. such as aes() and color.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{by}{
    An object with 'start', 'end', and 'width' methods. Passed to \code{aggreagate}.
  }
  \item{FUN}{
    The function, found via 'match.fun', to be applied to each window of
    'x'. Passed to \code{aggreagate}.
  }
  \item{maxgap, minoverlap, type}{
    Used in the internal call to \code{findOverlaps()} to detect overlaps.
    See \code{?\link[IRanges]{findOverlaps}} in the \pkg{IRanges} package
    for a description of these arguments.
  }
  \item{select}{
    It passed to \code{findOverlaps}.
    
    When \code{select} is \code{"all"} (the default), the results are
    returned as a \link{Hits} object. When \code{select} is \code{"first"},
    \code{"last"}, or \code{"arbitrary"} the results are returned as an
    integer vector of length \code{query} containing the first, last,
    or arbitrary overlapping interval in \code{subject}, with \code{NA}
    indicating intervals that did not overlap any intervals in \code{subject}.
 
    If \code{select} is \code{"all"}, a \link{Hits} object is returned.
    For all other \code{select} the return value depends on the \code{drop}
    argument. When \code{select != "all" && !drop}, an \link{IntegerList}
    is returned, where each element of the result corresponds to a space in
    \code{query}. When\code{select != "all" && drop}, an integer vector is
    returned containing indices that are offset to align with the unlisted
    \code{query}.
  }
  \item{y}{
    A character indicate the varialbe column for which aggregation is
    taken on, same as aes(y = ).
  }
  \item{window}{
    Integer value indicate window size. 
  }
  \item{facets}{
    Faceting formula to use.
  }
  
  \item{method}{
    customized method for aggregating, if FUN is not provided. 
  }
  \item{geom}{
    The geometric object to use display the data. 
  }
}
\value{
  A 'Layer'.
}
\examples{
library(GenomicRanges)
set.seed(1)
N <- 1000
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))


ggplot(gr) + stat_aggregate(mapping = aes(y = value))
## or
## ggplot(gr) + stat_aggregate(y = "value")
ggplot(gr) + stat_aggregate(mapping = aes(y = value), window = 36)
ggplot(gr) + stat_aggregate(mapping = aes(y = value), select = "first")
\dontrun{
## no hits 
ggplot(gr) + stat_aggregate(mapping = aes(y = value), select = "first", type = "within")
}
ggplot(gr) + stat_aggregate(window = 30, mapping = aes(y = value),fill = "gray40", geom = "bar")
ggplot(gr) + stat_aggregate(window = 100, fill = "gray40", mapping = aes(y = value),
                           method = "max", geom = "bar")

ggplot(gr) + stat_aggregate(mapping = aes(y = value), geom = "boxplot")
ggplot(gr) + stat_aggregate(mapping = aes(y = value), geom = "boxplot", window = 60)
## now facets need to take place inside stat_* geom_* for an accurate computation
ggplot(gr) + stat_aggregate(mapping = aes(y = value), geom = "boxplot", window = 30,
              facets = sample ~ seqnames)
## FIXME:
## autoplot(gr, stat = "aggregate", aes(y = value), window = 36)
## autoplot(gr, stat = "aggregate", geom = "boxplot", aes(y = value), window = 36)
}
\author{Tengfei Yin}

\name{plotSpliceSum}
\alias{plotSpliceSum}
\alias{plotSpliceSum,character,GRangesList-method}
\alias{plotSpliceSum,character,TxDb-method}
\alias{plotSpliceSum,character,EnsDb-method}
\title{Plot Splice Summary from RNA-seq data}
\description{
  Plot splice summary by simply counting overlaped junction read in
  weighted way or not.
}
\usage{
## For character,GRangesList
\S4method{plotSpliceSum}{character,GRangesList}(data, model, ..., weighted = TRUE)
## For character,TxDb
\S4method{plotSpliceSum}{character,TxDb}(data, model, which,
      ..., weighted = TRUE)
## For character,EnsDb
\S4method{plotSpliceSum}{character,EnsDb}(data, model, which,
      ..., weighted = TRUE)
}
\arguments{
  \item{data}{
    A character specifying the bam file path of RNA-seq data.
  }
  \item{model}{
    A GRangesList which represting different isoforms, a TxDb or an
    \code{\link[ensembldb]{EnsDb}} object. For the latter cases, users
    need to pass "which" argument which, for TxDb, is a GRanges object
    to specify the region and for \code{EnsDb} can be a GRanges object,
    an object extending
    \code{\link[AnnotationFilter]{AnnotationFilter}}, an
    \code{\link[AnnotationFilter]{AnnotationFilterList}} combining such
    filter objects or a filter expression in form of a \code{formula}.
  }
  \item{which}{
    A GRanges object specifying the region you want to get model from
    the TxDb object.
    For \code{\link[ensembldb]{EnsDb}}: can be a GRanges object, an
    object extending \code{\link[AnnotationFilter]{AnnotationFilter}}, an
    \code{\link[AnnotationFilter]{AnnotationFilterList}} combining such
    filter objects or a filter expression in form of a \code{formula}.
  }
  \item{weighted}{
    If \code{TRUE}, weighted by simply add 1/cases matched to each model
    and if \code{FALSE}, simply add 1 to every case.
  }
  \item{...}{
    Extra arugments passed to \code{qplot} function. such as,
    \code{offset} which control the height of chevron.
  }
}
\value{
  A ggplot object.
}
\details{
  Internally we use biovizBase:::spliceSummary for simple counting, but
  we encourage users to use their own robust way to make slicing summary
  and store it as GRangesList, then plot the summary by \code{qplot}
  function.
}
\seealso{
  \code{\link{qplot}}
}
\examples{
\dontrun{
bamfile <- system.file("extdata", "SRR027894subRBM17.bam", package="biovizBase")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
data(genesymbol)
exons <- exonsBy(txdb, by = "tx")
exons.rbm17 <- subsetByOverlaps(exons, genesymbol["RBM17"])
plotSpliceSum(bamfile, exons.rbm17)
plotSpliceSum(bamfile, exons.rbm17, weighted = FALSE, offset = 0.01)
plotSpliceSum(bamfile, txdb, which = genesymbol["RBM17"])
plotSpliceSum(bamfile, txdb, which = genesymbol["RBM17"], offset = 0.01)
plotSpliceSum(bamfile, txdb, which = genesymbol["RBM17"],
              show.label = TRUE,
              label.type = "count")
}
}
\author{Tengfei Yin}

\name{GGbio}
\alias{ggbio}
\alias{GGbio}
\alias{GGbio-class}
\alias{ggbio-class}
\alias{+,GGbio,ANY-method}
\alias{$,GGbio-method}
\alias{$<-,GGbio-method}
\title{class ggbio}
\description{
  a sub class of ggplot and gg class defined in ggplot2 package, used for ggbio specific methods.
}
\usage{
  GGbio(ggplot = NULL, data = NULL, fetchable = FALSE, blank =
                 FALSE, ...)
}
\arguments{
  \item{ggplot}{
    a ggplot or gg object.
  }
  \item{data}{
    raw data
  }
  \item{fetchable}{
    logical value, default \code{FALSE}, is there any fetch method available.
  }
  \item{blank}{
    logical value, default \code{FALSE}, is this plot a blank plot.
  }
  \item{...}{
    More properties passed to class like \code{Cache}.
  }
}
\value{
  a ggbio object.
}
\details{
  This class is defined to facilitate the ggbio-specific visualization
  method, especially when using \code{\link{ggplot}} to construct ggbio
  supported object, that will return a ggbio class. And internals tricks
  will help a lazy evaluation for following \code{+} method.
}
\seealso{
  \code{\link{ggplot}}
}
\examples{
p1 <- qplot()
g1 <- ggbio(p1)
class(g1)
}
\author{Tengfei Yin}

\name{ggplot}
\alias{ggplot.Vector}
\alias{ggplot.Seqinfo}
\alias{ggplot.matrix}
\alias{ggplot.ExpressionSet}
\alias{ggplot.RsamtoolsFile}
\alias{ggplot.character}
\alias{ggplot.TxDbOREnsDb}
\alias{ggplot.BSgenome}
\alias{ggplot.SummarizedExperiment}
\alias{ggplot.GAlignments}
\alias{ggplot.VCF}

\title{ggplot methods}

\description{ These methods extend \code{ggplot} to support several
  types of Bioconductor objects, as well as some base types like
  matrix. They return a \code{ggbio} object, which stores the original data
  object.  Please check the corresponding method for \code{\link{mold}}
  to see how an object is coerced into a data.frame.  }
 
\usage{
\method{ggplot}{Vector}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{Seqinfo}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{ExpressionSet}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{RsamtoolsFile}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{TxDbOREnsDb}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{BSgenome}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{matrix}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{character}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{SummarizedExperiment}(data, mapping = aes(),
                        assay.id = 1L, \dots, environment = parent.frame())
\method{ggplot}{GAlignments}(data, mapping = aes(), \dots,
                        environment = parent.frame())
\method{ggplot}{VCF}(data, mapping = aes(), \dots,
                        environment = parent.frame())
}
\arguments{
  \item{data}{
    original data object.
  }
  \item{mapping}{
    the aesthetic mapping.
  }
  \item{...}{
    other arguments passed to specific methods.
  }
  \item{environment}{
    fall-back environment for evaluation of aesthetic symbols
  }
  \item{assay.id}{
    index of assay you are using when multiple assays exist.
  }
}
\value{
  a return \code{ggbio} object, which is a subclass of \code{ggplot}
  defined in ggplot2 package, but that's more, a '.data' list entry is
  stored with the returned object.
}
\details{
    The biggest difference for objects returned by \code{ggplot} in
    ggbio from ggplot2, is we always keep the original data copy, this
    is useful because in ggbio, our starting point is not always
    data.frame, many special statistical transformation is computed upon
    original data objects instead of coerced data.frame. This is a hack
    to follow ggplot2's API while allow our own defined components to
    trace back to original data copy and do the transformation. For
    objects supported by \code{mold} we transform them to
    data.frame stored along the original data set, for objects which not
    supported by \code{mold} method, we only store the original copy
    for ggbio specific graphics.

    \code{ggplot()} is typically used to construct a plot incrementally,
    using the \code{+} operator to add layers to the existing ggplot object.
    This is advantageous in that the code is explicit about which
    layers are added and the order in which they are added. For
    complex graphics with multiple layers, initialization with
    \code{ggplot} is recommended. You can always call \code{qplot} in
    package ggplot2 or \code{autoplot} in ggbio for convenient usage.

    There are three common ways to invoke \code{ggplot}:
    \itemize{
      \item{}{\code{ggplot(df, aes(x, y, <other aesthetics>))}}
      \item{}{\code{ggplot(df)}}
      \item{}{\code{ggplot()}}
    }

    The first method is recommended if all layers use the same data and
    the same set of aesthetics, although this method can also be used to
    add a layer using data from another data frame.  The second method
    specifies the default data frame to use for the plot, but no
    aesthetics are defined up front.  This is useful when one data frame
    is used predominantly as layers are added, but the aesthetics may
    vary from one layer to another.  The third method initializes a
    skeleton \code{ggplot} object which is fleshed out as layers are
    added. This method is useful when multiple data frames are used to
    produce different layers, as is often the case in complex graphics.

    The examples below illustrate how these methods of invoking
    \code{ggplot} can be used in constructing a graphic.
}
\seealso{\code{\link{mold}}, \code{\link{ggbio}}}
\examples{
set.seed(1)
N <- 100
library(GenomicRanges)
## GRanges
gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))

## automatically facetting and assign y
## this must mean geom_rect support GRanges object
ggplot(gr) + geom_rect()
ggplot(gr) + geom_alignment()
ggplot() + geom_alignment(gr)


## use pure ggplot2's geom_rect, no auto facet
ggplot(gr) + ggplot2::geom_rect(aes(xmin = start, ymin = score,
                               xmax = end, ymax = score + 1))

## GRangesList
grl <- split(gr, values(gr)$pair)
ggplot(grl) + geom_alignment()
ggplot(grl) + geom_rect()
ggplot(grl) + ggplot2::geom_rect(aes(xmin = start, ymin = score,
                               xmax = end, ymax = score + 1))


## IRanges
ir <- ranges(gr)
ggplot(ir) + geom_rect()
ggplot(ir) + layout_circle(geom = "rect")

## Seqinfo
seqlengths(gr) <- c(400, 500, 420)
ggplot(seqinfo(gr)) + geom_point(aes(x = midpoint, y = seqlengths))

## matrix
mx <- matrix(1:12, nrow = 3)
ggplot(mx, aes(x = x, y = y)) + geom_raster(aes(fill = value))
## row is the factor
ggplot(mx, aes(x = x, y = row)) + geom_raster(aes(fill = value))
colnames(mx)
colnames(mx) <- letters[1:ncol(mx)]
mx
## has extra 'colnames'
ggplot(mx, aes(x = x, y = row)) + geom_raster(aes(fill = colnames))
rownames(mx)
rownames(mx) <- LETTERS[1:nrow(mx)]
ggplot(mx, aes(x = x, y = row)) + geom_raster(aes(fill = rownames))
## please check autoplot, matrix for more control

##  Views
% subject <- XInteger(10, 3:-6)
% ## equal width
% v1 <- Views(subject, start=4:1, width = 3)
% ggplot(v1) + geom_tile(aes(x = x, y = row, fill = value))
% ggplot(v1) + geom_tile(aes(x = x, y = factor(1), fill = value)) +
% facet_grid(group ~. )
% ## unequal width
% v2 <- Views(subject, start=4:1, width = 3:6)
% ggplot(v2) + geom_tile(aes(x = x, y = row, fill = value))

## ExpressionSet
library(Biobase)
data(sample.ExpressionSet)
sample.ExpressionSet
set.seed(1)
## select 50 features
idx <- sample(seq_len(dim(sample.ExpressionSet)[1]), size = 50)
eset <- sample.ExpressionSet[idx,]

ggplot(eset) + geom_tile(aes(x = x, y = y, fill = value))
## please check autoplot,matrix method which gives you more control
ggplot(eset) + geom_tile(aes(x = x, y = y, fill = sex))
ggplot(eset) + geom_tile(aes(x = x, y = y, fill = type))

## Rle
library(IRanges)
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500),
            seq(10, 0.001, length = 500))
xVector <- rpois(1e4, lambda)
xRle <- Rle(xVector)
ggplot(xRle) + geom_tile(aes(x = x, y = y, fill = value))

## RleList
xRleList <- RleList(xRle, 2L * xRle)
xRleList
ggplot(xRleList) + geom_tile(aes(x = x, y = y, fill = value)) +
facet_grid(group~.)
names(xRleList) <- c("a" ,"b")
ggplot(xRleList) + geom_tile(aes(x = x, y = y, fill = value)) +
facet_grid(group~.)


## RangedSummarizedExperiment
library(SummarizedExperiment)
nrows <- 200; ncols <- 6
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
counts2 <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
rowRanges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                   IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                   strand=sample(c("+", "-"), 200, TRUE))
colData <- DataFrame(Treatment=rep(c("ChIP", "Input"), 3),
                     row.names=LETTERS[1:6])
sset <- SummarizedExperiment(assays=SimpleList(counts=counts,
                                               counts2 = counts2),
                             rowRanges=rowRanges, colData=colData)
ggplot(sset) + geom_raster(aes(x = x, y = y , fill = value))

}

\author{Tengfei Yin}

\name{Ideogram}
\alias{Ideogram}
\alias{Ideogram-class}
\alias{plotIdeogram}
\alias{+,Ideogram,ANY-method}
\title{Plot single chromosome with cytobands}
\usage{

plotIdeogram(obj, subchr = NULL, zoom.region = NULL, which = NULL, xlab, ylab, main, xlabel =
                 FALSE, color = "red", fill = "red", alpha = 0.7,
                 zoom.offset = 0.2, size = 1,
                 cytobands = TRUE, aspect.ratio = 1/20, genome)

## constructor
Ideogram(obj, subchr = NULL, which = NULL, xlabel = FALSE,
                 cytobands = TRUE, color = "red", fill = "red", alpha =
                 0.7, zoom.region = NULL, zoom.offset = 0.2, size = 1,
                 aspect.ratio = 1/20, ..., genome)
}
\description{
  Plot single chromosome with cytobands.
}
\details{
  User could provide the whole ideogram and use subchr to point to
  particular chromosome.
}
\value{
  A \code{ggplot} object.
}
\author{Tengfei Yin}
\arguments{
  \item{obj}{
    A \code{GenomicRanges} object, which include extra
    information about cytobands, check biovizBase::isIdeogram.
  }
  \item{subchr}{
    A single character of chromosome names to show.
  }
  \item{which}{
    \code{GRanges} object to subset and highlight the ideogram.
  }
  \item{zoom.region}{
    A numeric vector of length 2 indicating zoomed region.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{xlabel}{
    A logical value. Show the x label or not.
  }
  \item{color}{
    color for highlight region.
  }
  \item{fill}{
    fill color for highlight region.
  }
  \item{alpha}{
    alpha for highlight regio.
  }
  \item{zoom.offset}{
    zoomed highlights region offset around chromosome plotting region.
  }
  \item{size}{
    size for zoomed region rectangle boundary.
  }
  \item{cytobands}{
    If FALSE, plot just blank chromosome without cytobands. default is TRUE.
es  }
  \item{aspect.ratio}{
    aspect ratio for the chromosome ideogram plot, default is NULL.
  }
  \item{genome}{
    genome character passed to \code{\link{getIdeogram}}
  }
  \item{...}{
    passed to ggbio constructor.
  }
}
\examples{
\dontrun{
library(biovizBase)
p.ideo <- Ideogram(genome = "hg19")
p.ideo
library(GenomicRanges)
p.ideo + xlim(GRanges("chr2", IRanges(1e8, 1e8+10000)))
Ideogram(genome = "hg19", xlabel = TRUE)
}
}

\name{geom_arch}
\alias{geom_arch}
\alias{geom_arch,data.frame-method}
\alias{geom_arch,GRanges-method}
\alias{geom_arch,missing-method}
\alias{geom_arch,uneval-method}
\title{Arch geoms for GRanges object}
\description{
  Show interval data as arches.
}
\usage{
% for data.frame
\S4method{geom_arch}{data.frame}(data, ..., n = 25, max.height = 10)

% for GRanges
\S4method{geom_arch}{GRanges}(data, ..., xlab, ylab, main, facets = NULL,
                 rect.height = 0, n = 25, max.height = 10)

}
\arguments{
  \item{data}{
    A \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters passed to autoplot function, \code{aes} mapping
    support \code{height, x, xend}.
    \itemize{
      \item \code{x}: start of the arches.
      \item \code{xend}: end of the arches.
      \item \code{height}: height of arches.
    }
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{n}{
    Integer values at which interpolation takes place to create 'n'
    equally spaced points spanning the interval ['min(x)', 'max(x)'].
  }
  \item{facets}{
    Faceting formula to use.
  }
  \item{rect.height}{
    When data is \code{GRanges}, this padding the arches from original y
    value to allow users putting arches 'around' the interval rectangles.
  }
  \item{max.height}{
    Max height of all arches.
  }  
}
\value{
  A 'Layer'.
}
\details{
  To draw a interval data as arches, we need to provide a special geom for
this purpose. Arches is popular in gene viewer or genomoe browser,
when they try to show isoforms or gene model.\code{geom_arch},
just like any other \code{geom_*} function in ggplot2, you can pass
aes() to it to map variable to height of arches.
}

\examples{
set.seed(1)
N <- 100
library(GenomicRanges)

## =======================================
##  simmulated GRanges
## =======================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))

## =======================================
##  default
## =======================================
ggplot(gr) + geom_arch()
# or
ggplot() + geom_arch(gr)

## =======================================
##  facetting and aesthetics
## =======================================
ggplot(gr) + geom_arch(mapping = aes(color = value, height = value, size = value),
                     alpha = 0.2, facets = sample ~ seqnames)


}
\author{Tengfei Yin}

\name{autoplot}

\alias{autoplot}
\alias{autoplot,GRanges-method}
\alias{autoplot,GRangesList-method}
\alias{autoplot,IRanges-method}
\alias{autoplot,Seqinfo-method}
\alias{autoplot,BSgenome-method}
\alias{autoplot,GAlignments-method}
\alias{autoplot,BamFile-method}
\alias{autoplot,BamFileList-method}
\alias{autoplot,TxDbOREnsDb-method}
\alias{autoplot,character-method}
\alias{autoplot,Rle-method}
\alias{autoplot,RleList-method}
\alias{autoplot,matrix-method}
\alias{autoplot,Views-method}
\alias{autoplot,ExpressionSet-method}
\alias{autoplot,RangedSummarizedExperiment-method}
\alias{autoplot,VCF-method}
\alias{autoplot,OrganismDb-method}
\alias{autoplot,VRanges-method}
\alias{autoplot,TabixFile-method}
\alias{+,Bioplot,Any-method}
\title{Generic autoplot function}

\description{

  \code{autoplot} is a generic function to visualize various data
  object, it tries to give better default graphics and customized
  choices for each data type, quick and convenient to explore your
  genomic data compare to low level \code{ggplot} method, it is much
  simpler and easy to produce fairly complicate graphics, though you may
  lose some flexibility for each layer.

}

\usage{
\S4method{autoplot}{GRanges}(object, ..., chr, xlab, ylab, main, truncate.gaps = FALSE,
                 truncate.fun = NULL, ratio = 0.0025, space.skip = 0.1,
                 legend = TRUE, geom = NULL, stat = NULL,
                 chr.weight = NULL,
                 coord = c("default", "genome", "truncate_gaps"),
                 layout = c("linear", "karyogram", "circle"))


\S4method{autoplot}{GRangesList}(object, ..., xlab, ylab, main, indName = "grl_name",
                 geom = NULL, stat = NULL, coverage.col = "gray50",
                 coverage.fill = coverage.col, group.selfish = FALSE)


\S4method{autoplot}{IRanges}(object, ..., xlab, ylab, main)

\S4method{autoplot}{Seqinfo}(object, ideogram = FALSE, ... )

\S4method{autoplot}{GAlignments}(object, ..., xlab, ylab, main, which,
      geom = NULL, stat = NULL)

\S4method{autoplot}{BamFile}(object, ..., which, xlab, ylab, main,
                 bsgenome, geom = "line", stat = "coverage", method = c("raw",
                 "estimate"), coord = c("linear", "genome"),
                 resize.extra = 10, space.skip = 0.1, show.coverage =
                 TRUE)


\S4method{autoplot}{character}(object, ..., xlab, ylab, main, which)

\S4method{autoplot}{TxDbOREnsDb}(object, which, ..., xlab, ylab, main, truncate.gaps =
                 FALSE, truncate.fun = NULL, ratio = 0.0025,
                 mode = c("full", "reduce"),geom =
                 c("alignment"), stat = c("identity", "reduce"),
                 names.expr = "tx_name", label = TRUE)


\S4method{autoplot}{BSgenome}(object, which, ...,
                    xlab, ylab, main, geom = NULL)


\S4method{autoplot}{Rle}(object, ..., xlab, ylab, main, binwidth, nbin = 30,
          geom = NULL, stat = c("bin", "identity", "slice"),
          type = c("viewSums", "viewMins", "viewMaxs", "viewMeans"))

\S4method{autoplot}{RleList}(object, ..., xlab, ylab, main, nbin = 30, binwidth,
         facetByRow = TRUE, stat = c("bin", "identity", "slice"),
         geom = NULL, type = c("viewSums", "viewMins", "viewMaxs", "viewMeans"))

\S4method{autoplot}{matrix}(object, ..., xlab, ylab, main,
              geom = c("tile", "raster"), axis.text.angle = NULL,
              hjust = 0.5, na.value = NULL,
              rownames.label = TRUE, colnames.label = TRUE,
              axis.text.x = TRUE, axis.text.y = TRUE)


\S4method{autoplot}{ExpressionSet}(object, ..., type = c("heatmap", "none",
                 "scatterplot.matrix", "pcp", "MA", "boxplot",
                 "mean-sd"), test.method =
                 "t", rotate = FALSE, pheno.plot = FALSE, main_to_pheno
                 = 4.5, padding = 0.2)


\S4method{autoplot}{RangedSummarizedExperiment}(object, ..., type = c("heatmap", "link", "pcp", "boxplot", "scatterplot.matrix"), pheno.plot = FALSE,
                 main_to_pheno = 4.5, padding = 0.2, assay.id = 1)


\S4method{autoplot}{VCF}(object, ...,
              xlab, ylab, main,
              assay.id,
              type = c("default", "geno", "info", "fixed"),
              full.string = FALSE,
              ref.show = TRUE,
              genome.axis = TRUE,
              transpose = TRUE)

\S4method{autoplot}{OrganismDb}(object, which, ...,
                   xlab, ylab, main,
                   truncate.gaps = FALSE,
                   truncate.fun = NULL,
                   ratio = 0.0025,
                   geom = c("alignment"),
                   stat = c("identity", "reduce"),
                   columns = c("TXNAME", "SYMBOL", "TXID", "GENEID"),
                   names.expr = "SYMBOL",
                   label = TRUE,
                   label.color = "gray40")

\S4method{autoplot}{VRanges}(object, ...,which = NULL,
                             arrow = TRUE, indel.col = "gray30",
                             geom = NULL,
                             xlab, ylab, main)

\S4method{autoplot}{TabixFile}(object, which, ...)
}

\arguments{
  \item{object}{
    object to be plot.
  }
  \item{columns}{
    columns passed to method works for \code{TxDb}, \code{EnsDb} and \code{OrganismDb}.
  }
  \item{label.color}{
    when label turned on for gene model, this parameter controls label color.
  }
  \item{arrow}{
    arrow passed to geome_alignment function to control intron arrow attributes.
  }
  \item{indel.col}{
    indel colors.
  }
  \item{ideogram}{
    Weather to call \code{plotIdeogram} or not, default is \code{FALSE},
  if \code{TRUE}, \code{layout_karyogram} will be called.
  }
  \item{transpose}{
    logical value, defaut TRUE, always make features from VCF as x, so
    we can use it to map to genomic position.
  }
  \item{axis.text.angle}{
    axis text angle.
  }
  \item{axis.text.x}{
    logical value indicates whether to show x axis and labels or not.
  }
  \item{axis.text.y}{
    logical value indicates whether to show y axis and labels or not.
  }
  \item{hjust}{
    horizontal just for axis text.
  }
  \item{rownames.label}{
    logical value indicates whether to show rownames of matrix as y
  label or not.
  }
  \item{colnames.label}{
    logical value indicates whether to show colnames of matrix as y
  label or not.
  }
  \item{na.value}{
    color for NA value.
  }
  \item{rotate}{
    logical value indicating whether to rotate the matrix-style display.
  }
  \item{pheno.plot}{
    show pheno plot or not.
  }
  \item{main_to_pheno}{
    main matrix plot width to pheno plot width ratio.
  }
  \item{padding}{
    padding between plots.
  }
  \item{assay.id}{
    index for assay you are going to use.
  }
  \item{geom}{
    Geom to use (Single character for now). Please see section Geometry
    for details.
  }
  \item{truncate.gaps}{
    logical value indicate to truncate gaps or not.
  }
  \item{truncate.fun}{
    shrinkage function. Please see \code{shrinkagefun} in package biovizBase.
  }
  \item{ratio}{
    used in \code{maxGap}.
  }
  \item{mode}{
    Display mode for genomic features.
  }
  \item{space.skip}{
    space ratio between chromosome spaces in coordate genome.
  }
  \item{coord}{
    Coodinate system.
  }
  \item{chr.weight}{
    numeric vectors which sum to <1, the names of vectors has to be
  matched with seqnames in seqinfo, and you can only specify part of the
  seqnames, other lengths of chromosomes will be assined proportionally
  to their seqlengths, for example, you could specify chr1 to be 0.5, so
  the chr1 will take half of the space and other chromosomes squeezed to
  take left of the space.
  }
  \item{legend}{
    A logical value indicates whether to show legend or not. Default is
    \code{TRUE}
  }

  \item{which}{
    A \code{\link{GRanges}} object to subset the result, usually passed
    to the \code{\link{ScanBamParam}} function.
    For \code{autoplot,EnsDb}, \code{which} can in addition also be an
    object extending \code{\link[AnnotationFilter]{AnnotationFilter}},
    an \code{\link[AnnotationFilter]{AnnotationFilterList}} combining
    such objects or a \code{formula} representing a filter
    expression. See examples below or documentation of
    \code{\link[AnnotationFilter]{AnnotationFilter}} for more details.
  }

  \item{show.coverage}{
    A logical value indicates whether to show coverage or not. This is
  used for geom "mismatch.summary".
}
  \item{resize.extra}{
    A numeric value used to add buffer to intervals to compute stepping
    levels on.
  }
  \item{bsgenome}{
    A BSgenome object. Only need for geom "mismatch.summary".
  }
 \item{xlab}{
    x label.
  }
\item{ylab}{
    y label.
  }
  \item{label}{
    logic value, default TRUE. To show label by the side of features.
  }
\item{facetByRow}{
    A logical value, default is TRUE ,facet RleList by row. If FALSE,
   facet by column.
}
\item{type}{
   For Rle/RleList, "raw" plot everything, so be careful, that would be
  pretty slow if you have too much data. For "viewMins", "viewMaxs",
  "viewMeans", "viewSums", require extra arguments to slice the
  object. so users need to at least provide \code{lower}, more details
  and control please refer the the manual of \code{slice} function in
  IRanges. For "viewMins", "viewMaxs", we use \code{viewWhichMin} and
  \code{viewWhichMax} to get x scale, for "viewMeans", "viewSums", we
  use window midpoint as x.

  For ExpreesionSet, ploting types.
}
\item{layout}{
  Layout including linear, circular and karyogram. for \code{GenomicRangesList}, it only supports circular layout.
}
\item{method}{
  method used for parsing coverage from bam files. 'estimate' use fast
  esitmated method  and 'raw' use relatively slow parsing method.
}
\item{test.method}{
  test method
}
  \item{...}{
    Extra parameters. Usually are those parameters used in autoplot to
    control aesthetics or geometries.
  }
  \item{main}{
    title.
  }
  \item{stat}{
    statistical transformation.
  }
  \item{indName}{
    When coerce \code{GRangesList} to \code{GRanges}, names created for
    each group.
  }
  \item{coverage.col}{
    coverage stroke color.
  }
  \item{coverage.fill}{
    coverage fill color.
  }
  \item{group.selfish}{
        Passed to \code{addStepping}, control whether to show each group as
    unique level or not. If set to \code{FALSE}, if two groups are not
    overlapped with each other, they will probably be layout in the same
    level to save space.
  }
  \item{names.expr}{
    names expression used for creating labels. For
    \code{\link[ensembldb]{EnsDb}} objects either \code{"tx_id"},
    \code{"gene_name"} or \code{"gene_id"}.
  }
  \item{binwidth}{
    width of the bins.
  }
  \item{nbin}{
    number of bins.
  }
  \item{genome.axis}{
    logical value, if TRUE, whenever possible, try to parse genomic postition
    for each column(e.g. RangedSummarizedExperiment), show column as exatcly
    the genomic position instead of showing them side by side and
    indexed from 1.
  }
  \item{full.string}{
    logical value. If TRUE, show full string of indels in plot for VCF.
  }
  \item{ref.show}{
    logical value. If TRUE, show REF in VCF at bottom track.
  }
  \item{chr}{
    characters indicates the seqnames to be subseted.
  }
}
\value{
  A \code{ggplot} object, so you can use common features from ggplot2
  package to manipulate the plot.
}

\section{Introduction}{
  \code{autoplot} is redefined as generic s4 method inside this package,
  user could use \code{autoplot} in the way they are familiar with, and
  we are also setting limitation inside this package, like

  \itemize{
    \item \code{scales}: X scales are genomic coordinates in most cases.
    x can be specified as start/end/midpoint for interval geoms such as
    point and line.

    \item \code{colors}: Try to use the default color scheme defined in
    the biovizBase package whenever possible.
  }
}

\section{Geometry}{
  \describe{
    We have developed new \code{geom} for different objects, some of
  them may require extra parameters you need to provide. Some of the
  geom are more like geom + stat in ggplot2
  package. e.g. "coverage.line" and "coverage.polygon".We simply combine
  them together, but in the future, we plan to make it more general.

  This package is designed for only biological data, especially genomic
  data if users want to explore the data in a more flexible way, you
  could simply coerce the \code{\link{GRanges}} to a data.frame, then
  just use formal \code{autoplot} function in ggplot2, or \code{autoplot}
  generic for \code{data.frame}.

  Some objects share the same geom so we introduce all the geom together
  in this section
  \item{full}{
    Showing all the intervals as stepped rectangle, colored by strand
    automatically.

    For \code{TxDb} or \code{\link[ensembldb]{EnsDb}} objects, showing full model.
  }
  \item{segment}{
    Showing all the intervals as stepped segments, colored by strand
    automatically.

    For object \code{BSgenome}, show nucleotides as colored segment.

    For Rle/RleList, show histogram-like segments.
  }
  \item{line}{
    Showing interval as line, the interval data could also be just
  single position when start = end, x is one of start/end/midpoint, y
  value is unquoted name in elementMetadata column names. y value is
  required.
  }
  \item{point}{
    Showing interval as point, the interval data could also be just
  single position when start = end, x is one of start/end/midpoint, y
  value is unquoted name in elementMetadata column names. y value is
  required.

  For object \code{BSgenome}, show nucleotides as colored point.
  }
  \item{coverage.line}{
    Coverage showing as lines for interval data.
  }
  \item{coverage.polygon}{
    Coverage showing as polygon for interval data.
  }
  \item{splice}{
    Splicing summary. The size and width of the line and rectangle
    should represent the counts in each model. Need to provide model.
  }
  \item{single}{
    For \code{TxDb} or \code{\link[ensembldb]{EnsDb}} objects, showing
    single(reduced) model only.
  }
  \item{tx}{
    For \code{TxDb} or \code{\link[ensembldb]{EnsDb}} objects, showing
    transcirpts isoforms.
  }
\item{mismatch.summary}{
  Showing color coded mismatched stacked bar to indicate the proportion
  of mismatching at each position, the reference is set to gray.
}
  \item{text}{
    For object \code{BSgenome}, show nucleotides as colored text.
  }
  \item{rectangle}{
    For object \code{BSgenome}, show nucleotides as colored rectangle.
  }
}
}

\section{Faceting}{
Faceting in ggbio package is a little differnt from ggplot2 in several ways
\itemize{
  \item The faceted column can only be seqnames or genomic regions. So
  we limit the formula passed to the facet argument. For example,
  \code{something ~ seqnames} is accepted, and you can change
  \code{something} to a variable name in the elementMetadata, but not
  the second part.

  \item Sometimes we need to view different regions, so we also have a
  \code{facet_gr} argument that accepts a \code{GRanges}. If this is
  provided, it overrides the default seqnames and uses the supplied
  regions to facet the graphics, which can be useful for gene-centric
  views.
}
}
\author{Tengfei Yin}
\examples{
set.seed(1)
N <- 1000
library(GenomicRanges)
gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))

idx <- sample(1:length(gr), size = 50)


###################################################
### code chunk number 3: default
###################################################
autoplot(gr[idx])


###################################################
### code chunk number 4: bar-default-pre
###################################################
set.seed(123)
gr.b <- GRanges(seqnames = "chr1", IRanges(start = seq(1, 100, by = 10),
                  width = sample(4:9, size = 10, replace = TRUE)),
                score = rnorm(10, 10, 3), value = runif(10, 1, 100))
gr.b2 <- GRanges(seqnames = "chr2", IRanges(start = seq(1, 100, by = 10),
                  width = sample(4:9, size = 10, replace = TRUE)),
                score = rnorm(10, 10, 3), value = runif(10, 1, 100))
gr.b <- c(gr.b, gr.b2)
head(gr.b)


###################################################
### code chunk number 5: bar-default
###################################################
p1 <- autoplot(gr.b, geom = "bar")
## use value to fill the bar
p2 <- autoplot(gr.b, geom = "bar", aes(fill = value))
tracks(default = p1, fill = p2)


###################################################
### code chunk number 6: autoplot.Rnw:236-237
###################################################
autoplot(gr[idx], geom = "arch", aes(color = value), facets = sample ~ seqnames)


###################################################
### code chunk number 7: gr-group
###################################################
gra <- GRanges("chr1", IRanges(c(1,7,20), end = c(4,9,30)), group = c("a", "a", "b"))
## if you desn't specify group, then group based on stepping levels, and gaps are computed without
## considering extra group method
p1 <- autoplot(gra, aes(fill = group), geom = "alignment")
## when use group method, gaps only computed for grouped intervals.
## default is group.selfish = TRUE, each group keep one row.
## in this way, group labels could be shown as y axis.
p2 <- autoplot(gra, aes(fill = group, group = group), geom = "alignment")
## group.selfish = FALSE, save space
p3 <- autoplot(gra, aes(fill = group, group = group), geom = "alignment", group.selfish = FALSE)
tracks('non-group' = p1,'group.selfish = TRUE' = p2 , 'group.selfish = FALSE' = p3)


###################################################
### code chunk number 8: gr-facet-strand
###################################################
autoplot(gr, stat = "coverage", geom = "area",
         facets = strand ~ seqnames, aes(fill = strand))


###################################################
### code chunk number 9: gr-autoplot-circle
###################################################
autoplot(gr[idx], layout = 'circle')


###################################################
### code chunk number 10: gr-circle
###################################################
seqlengths(gr) <- c(400, 500, 700)
values(gr)$to.gr <- gr[sample(1:length(gr), size = length(gr))]
idx <- sample(1:length(gr), size = 50)
gr <- gr[idx]
ggplot() + layout_circle(gr, geom = "ideo", fill = "gray70", radius = 7, trackWidth = 3) +
  layout_circle(gr, geom = "bar", radius = 10, trackWidth = 4,
                aes(fill = score, y = score)) +
  layout_circle(gr, geom = "point", color = "red", radius = 14,
                trackWidth = 3, grid = TRUE, aes(y = score)) +
  layout_circle(gr, geom = "link", linked.to = "to.gr", radius = 6, trackWidth = 1)


###################################################
### code chunk number 11: seqinfo-src
###################################################
data(hg19Ideogram, package = "biovizBase")
sq <- seqinfo(hg19Ideogram)
sq


###################################################
### code chunk number 12: seqinfo
###################################################
autoplot(sq[paste0("chr", c(1:22, "X"))])


###################################################
### code chunk number 13: ir-load
###################################################
set.seed(1)
N <- 100
ir <-  IRanges(start = sample(1:300, size = N, replace = TRUE),
               width = sample(70:75, size = N,replace = TRUE))
## add meta data
df <- DataFrame(value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))
values(ir) <- df
ir


###################################################
### code chunk number 14: ir-exp
###################################################
p1 <- autoplot(ir)
p2 <- autoplot(ir, aes(fill = pair)) + theme(legend.position = "none")
p3 <- autoplot(ir, stat = "coverage", geom = "line", facets = sample ~. )
p4 <- autoplot(ir, stat = "reduce")
tracks(p1, p2, p3, p4)


###################################################
### code chunk number 15: grl-simul
###################################################
set.seed(1)
N <- 100
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames =
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(30:40, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N,
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"),
                size = N, replace = TRUE),
              pair = sample(letters, size = N,
                replace = TRUE))


grl <- split(gr, values(gr)$pair)


###################################################
### code chunk number 16: grl-exp
###################################################
## default gap.geom is 'chevron'
p1 <- autoplot(grl, group.selfish = TRUE)
p2 <- autoplot(grl, group.selfish = TRUE, main.geom = "arrowrect", gap.geom = "segment")
tracks(p1, p2)


###################################################
### code chunk number 17: grl-name
###################################################
autoplot(grl, aes(fill = ..grl_name..))
## equal to
## autoplot(grl, aes(fill = grl_name))


###################################################
### code chunk number 18: rle-simul
###################################################
library(IRanges)
set.seed(1)
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500),
            seq(10, 0.001, length = 500))

## @knitr create
xVector <- rpois(1e4, lambda)
xRle <- Rle(xVector)
xRle


###################################################
### code chunk number 19: rle-bin
###################################################
p1 <- autoplot(xRle)
p2 <- autoplot(xRle, nbin = 80)
p3 <- autoplot(xRle, geom = "heatmap", nbin = 200)
tracks('nbin = 30' = p1, "nbin = 80" = p2, "nbin = 200(heatmap)" = p3)


###################################################
### code chunk number 20: rle-id
###################################################
p1 <- autoplot(xRle, stat = "identity")
p2 <- autoplot(xRle, stat = "identity", geom = "point", color = "red")
tracks('line' = p1, "point" = p2)


###################################################
### code chunk number 21: rle-slice
###################################################
p1 <- autoplot(xRle, type = "viewMaxs", stat = "slice", lower = 5)
p2 <- autoplot(xRle, type = "viewMaxs", stat = "slice", lower = 5, geom = "heatmap")
tracks('bar' = p1, "heatmap" = p2)


###################################################
### code chunk number 22: rlel-simul
###################################################
xRleList <- RleList(xRle, 2L * xRle)
xRleList


###################################################
### code chunk number 23: rlel-bin
###################################################
p1 <- autoplot(xRleList)
p2 <- autoplot(xRleList, nbin = 80)
p3 <- autoplot(xRleList, geom = "heatmap", nbin = 200)
tracks('nbin = 30' = p1, "nbin = 80" = p2, "nbin = 200(heatmap)" = p3)


###################################################
### code chunk number 24: rlel-id
###################################################
p1 <- autoplot(xRleList, stat = "identity")
p2 <- autoplot(xRleList, stat = "identity", geom = "point", color = "red")
tracks('line' = p1, "point" = p2)


###################################################
### code chunk number 25: rlel-slice
###################################################
p1 <- autoplot(xRleList, type = "viewMaxs", stat = "slice", lower = 5)
p2 <- autoplot(xRleList, type = "viewMaxs", stat = "slice", lower = 5, geom = "heatmap")
tracks('bar' = p1, "heatmap" = p2)


###################################################
### code chunk number 26: txdb
###################################################
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
data(genesymbol, package = "biovizBase")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene


###################################################
### code chunk number 27: txdb-visual
###################################################
p1 <- autoplot(txdb, which = genesymbol["ALDOA"], names.expr = "tx_name:::gene_id")
p2 <- autoplot(txdb, which = genesymbol["ALDOA"], stat = "reduce", color = "brown",
               fill = "brown")
tracks(full = p1, reduce = p2, heights = c(5, 1)) + ylab("")


###################################################
### EnsDb
###################################################
## Fetching gene models from an EnsDb object.
library(EnsDb.Hsapiens.v75)
ensdb <- EnsDb.Hsapiens.v75
## We use a GenenameFilter to specifically retrieve all transcripts for that gene.
p1 <- autoplot(ensdb, which = GeneNameFilter("ALDOA"), names.expr = "gene_name")
## Instead of providing the GenenameFilter, we can also use filter expressions
p2 <- autoplot(ensdb, which = ~ genename == "ALDOA", stat = "reduce",
               color = "brown", fill = "brown")
tracks(full = p1, reduce = p2, heights = c(5, 1)) + ylab("")

## Alternatively, we can specify a GRangesFilter and display all genes
## that are (partially) overlapping with that genomic region:
gr <- GRanges(seqnames=16, IRanges(30768000, 30770000), strand="+")
autoplot(ensdb, GRangesFilter(gr, "any"), names.expr="gene_name")
## Just submitting the GRanges object also works.
autoplot(ensdb, gr, names.expr="gene_name")

## Or genes encoded on both strands.
gr <- GRanges(seqnames = 16, IRanges(30768000, 30770000), strand = "*")
autoplot(ensdb, GRangesFilter(gr), names.expr="gene_name")

## Also, we can spefify directly the gene ids and plot all transcripts of these
## genes (not only those overlapping with the region)
autoplot(ensdb, GeneIdFilter(c("ENSG00000196118", "ENSG00000156873")))

###################################################
### code chunk number 28: ga-load
###################################################
library(GenomicAlignments)
data("genesymbol", package = "biovizBase")
bamfile <- system.file("extdata", "SRR027894subRBM17.bam",
                       package="biovizBase")
library(GenomeInfoDb)  # for keepStandardChromosomes()
which <- keepStandardChromosomes(genesymbol["RBM17"])
## need to set use.names = TRUE
ga <- readGAlignments(bamfile,
                      param = ScanBamParam(which = which),
                      use.names = TRUE)


###################################################
### code chunk number 29: ga-exp
###################################################
p1 <- autoplot(ga)
p2 <- autoplot(ga, geom = "rect")
p3 <- autoplot(ga, geom = "line", stat = "coverage")
tracks(default = p1, rect = p2, coverage = p3)


###################################################
### code chunk number 30: bf-load (eval = FALSE)
###################################################
## library(Rsamtools)
## bamfile <- "./wgEncodeCaltechRnaSeqK562R1x75dAlignsRep1V2.bam"
## bf <- BamFile(bamfile)


###################################################
### code chunk number 31: bf-est-cov (eval = FALSE)
###################################################
## autoplot(bamfile)
## autoplot(bamfile, which = c("chr1", "chr2"))
## autoplot(bf)
## autoplot(bf, which = c("chr1", "chr2"))
##
## data(genesymbol, package = "biovizBase")
## autoplot(bamfile,  method = "raw", which = genesymbol["ALDOA"])
##
## library(BSgenome.Hsapiens.UCSC.hg19)
## autoplot(bf, stat = "mismatch", which = genesymbol["ALDOA"], bsgenome = Hsapiens)


###################################################
### code chunk number 32: char-bam (eval = FALSE)
###################################################
## bamfile <- "./wgEncodeCaltechRnaSeqK562R1x75dAlignsRep1V2.bam"
## autoplot(bamfile)


###################################################
### code chunk number 33: char-gr
###################################################
library(rtracklayer)
test_path <- system.file("tests", package = "rtracklayer")
test_bed <- file.path(test_path, "test.bed")
autoplot(test_bed, aes(fill = name))


###################################################
###  matrix
###################################################
volcano <- volcano[20:70, 20:60] - 150
autoplot(volcano)
autoplot(volcano, xlab = "xlab", main = "main", ylab = "ylab")
## special scale theme for 0-centered values
autoplot(volcano, geom = "raster")+scale_fill_fold_change()

## when a matrix has colnames and rownames label them by default
colnames(volcano) <- sort(sample(1:300, size = ncol(volcano), replace = FALSE))
autoplot(volcano)+scale_fill_fold_change()

rownames(volcano) <- letters[sample(1:24, size = nrow(volcano), replace = TRUE)]
autoplot(volcano)

## even with row/col names, you could also disable it and just use numeric index
autoplot(volcano, colnames.label = FALSE)
autoplot(volcano, rownames.label = FALSE, colnames.label = FALSE)

## don't want the axis has label??
autoplot(volcano, axis.text.x = FALSE)
autoplot(volcano, axis.text.y = FALSE)


# or totally remove axis
colnames(volcano) <- lapply(letters[sample(1:24, size = ncol(volcano),
replace = TRUE)],
function(x){
   paste(rep(x, 7), collapse = "")
})

## Oops, overlapped
autoplot(volcano)
## tweak with it.
autoplot(volcano, axis.text.angle =  -45, hjust = 0)

## when character is the value
x <- sample(c(letters[1:3], NA), size = 100, replace = TRUE)
mx <- matrix(x, nrow = 5)
autoplot(mx)
## tile gives you a white margin
rownames(mx) <- LETTERS[1:5]
autoplot(mx, color = "white")
colnames(mx) <- LETTERS[1:20]
autoplot(mx, color = "white")
autoplot(mx, color = "white", size = 2)
## weird in aes(), though works
## default tile is flexible
autoplot(mx, aes(width = 0.6, height = 0.6))
autoplot(mx, aes(width = 0.6, height = 0.6), na.value = "white")
autoplot(mx,  aes(width = 0.6, height = 0.6)) + theme_clear()

###################################################
### Views
###################################################
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500),
            seq(10, 0.001, length = 500))
xVector <- dnorm(1:5e3, mean = 1e3, sd = 200)
xRle <- Rle(xVector)
v1 <- Views(xRle, start = sample(.4e3:.6e3, size = 50, replace = FALSE), width =1000)
autoplot(v1)
names(v1) <- letters[sample(1:24, size = length(v1), replace = TRUE)]
autoplot(v1)
autoplot(v1, geom = "tile", aes(width = 0.5, height = 0.5))
autoplot(v1, geom = "line")
autoplot(v1, geom = "line", aes(color = row)) + theme(legend.position = "none")
autoplot(v1, geom = "line", facets = NULL)
autoplot(v1, geom = "line", facets = NULL, alpha  = 0.1)


###################################################
### ExpressionSet
###################################################
library(Biobase)
data(sample.ExpressionSet)
sample.ExpressionSet
set.seed(1)
## select 50 features
idx <- sample(seq_len(dim(sample.ExpressionSet)[1]), size = 50)
eset <- sample.ExpressionSet[idx,]
eset
autoplot(as.matrix(pData(eset)))

## default heatmap
p1 <- autoplot(eset)
p2 <- p1 + scale_fill_fold_change()
p2
autoplot(eset)
autoplot(eset, geom = "tile", color = "white", size = 2)
autoplot(eset, geom = "tile", aes(width = 0.6, height = 0.6))

autoplot(eset, pheno.plot = TRUE)
idx <- order(pData(eset)[,1])
eset2 <- eset[,idx]
autoplot(eset2, pheno.plot = TRUE)

## parallel coordainte plot
autoplot(eset, type = "pcp")

## boxplot
autoplot(eset, type = "boxplot")


## scatterplot.matrix
## slow, be carefull
##autoplot(eset[, 1:7], type = "scatterplot.matrix")

## mean-sd
autoplot(eset, type = "mean-sd")




###################################################
### RangedSummarizedExperiment
###################################################
library(SummarizedExperiment)
nrows <- 200; ncols <- 6
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
counts2 <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
rowRanges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                   IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                   strand=sample(c("+", "-"), 200, TRUE))
colData <- DataFrame(Treatment=rep(c("ChIP", "Input"), 3),
                     row.names=LETTERS[1:6])
sset <- SummarizedExperiment(assays=SimpleList(counts=counts,
                                               counts2 = counts2),
                             rowRanges=rowRanges, colData=colData)
autoplot(sset) + scale_fill_fold_change()
autoplot(sset, pheno.plot = TRUE)


###################################################
### pcp
###################################################
autoplot(sset, type = "pcp")


###################################################
### boxplot
###################################################
autoplot(sset, type = "boxplot")


###################################################
### scatterplot matrix
###################################################
##autoplot(sset, type = "scatterplot.matrix")


###################################################
### vcf
###################################################

\dontrun{
library(VariantAnnotation)
vcffile <- system.file("extdata", "chr22.vcf.gz", package="VariantAnnotation")
vcf <- readVcf(vcffile, "hg19")
## default use type 'geno'
## default use genome position
autoplot(vcf)
## or disable it
autoplot(vcf, genome.axis = FALSE)
## not transpose
autoplot(vcf, genome.axis = FALSE, transpose = FALSE, rownames.label = FALSE)
autoplot(vcf)
## use
autoplot(vcf, assay.id = "DS")
## equivalent to
autoplot(vcf, assay.id = 2)
## doesn't work when assay.id cannot find
autoplot(vcf, assay.id = "NO")
## use AF or first
autoplot(vcf, type = "info")
## geom bar
autoplot(vcf, type = "info", aes(y  = THETA))
autoplot(vcf, type = "info", aes(y  = THETA, fill = VT, color = VT))
autoplot(vcf, type = "fixed")
autoplot(vcf, type = "fixed", size = 10) + xlim(c(50310860, 50310890)) + ylim(0.75, 1.25)

p1 <- autoplot(vcf, type = "fixed") + xlim(50310860, 50310890)
p2 <- autoplot(vcf, type = "fixed", full.string = TRUE) + xlim(50310860, 50310890)
tracks("full.string = FALSE" = p1, "full.string = TRUE" = p2)+
  scale_y_continuous(breaks = NULL, limits = c(0, 3))
p3 <- autoplot(vcf, type = "fixed", ref.show = FALSE) + xlim(50310860, 50310890) +
    scale_y_continuous(breaks = NULL, limits = c(0, 2))
p3

}


###################################################
### code chunk number 56: bs-v
###################################################
library(BSgenome.Hsapiens.UCSC.hg19)
data(genesymbol, package = "biovizBase")
p1 <- autoplot(Hsapiens, which = resize(genesymbol["ALDOA"], width = 50))
p2 <- autoplot(Hsapiens, which = resize(genesymbol["ALDOA"], width = 50), geom = "rect")
tracks(text = p1, rect = p2)


###################################################
### code chunk number 57: sessionInfo
###################################################
sessionInfo()
}

\name{geom_arrowrect}
\alias{geom_arrowrect}
\alias{geom_arrowrect,GRanges-method}
\alias{geom_arrowrect,missing-method}
\alias{geom_arrowrect,uneval-method}
\title{Arrowrect geoms for GRanges object}
\description{
  Show interval data as rectangle with a arrow head.
}
\usage{
\S4method{geom_arrowrect}{GRanges}(data, ..., xlab, ylab, main,
              facets = NULL, stat = c("stepping", "identity"),
              rect.height = NULL, arrow.head = 0.06,
              arrow.head.rate = arrow.head,  arrow.head.fix = NULL,
              group.selfish = TRUE)

}
\arguments{
  \item{data}{
    A \code{GRanges} object.
  }
  \item{...}{
    Extra parameters such as aes() passed.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
  \item{facets}{
    Faceting formula to use.
  }
  \item{stat}{
    Character vector specifying statistics to use. "stepping" with
    randomly assigned stepping levels as y varialbe. "identity" allow
    users to specify \code{y} value in \code{aes}.
  }
  \item{rect.height}{
    Half height of the arrow body. 
  }
  \item{arrow.head}{
    Arrow head to body ratio.
  }
  \item{arrow.head.rate}{
    Arrow head to body ratio. same with arrow.head.
  }
  \item{arrow.head.fix}{
    fixed length of arrow head.
  }
  \item{group.selfish}{
    Passed to \code{addStepping}, control whether to show each group as
  unique level or not. If set to \code{FALSE}, if two groups are not
  overlapped with each other, they will probably be layout in the same
  level to save space.
  }  
}
\value{
  A 'Layer'.
}
\examples{
set.seed(1)
N <- 100
require(GenomicRanges)
## ======================================================================
##  simmulated GRanges
## ======================================================================
gr <- GRanges(seqnames = 
              sample(c("chr1", "chr2", "chr3"),
                     size = N, replace = TRUE),
              IRanges(
                      start = sample(1:300, size = N, replace = TRUE),
                      width = sample(70:75, size = N,replace = TRUE)),
              strand = sample(c("+", "-", "*"), size = N, 
                replace = TRUE),
              value = rnorm(N, 10, 3), score = rnorm(N, 100, 30),
              sample = sample(c("Normal", "Tumor"), 
                size = N, replace = TRUE),
              pair = sample(letters, size = N, 
                replace = TRUE))


## ======================================================================
##  default
## ======================================================================
ggplot(gr) + geom_arrowrect()
## or
ggplot() + geom_arrowrect(gr)

## ======================================================================
##  facetting and aesthetics
## ======================================================================
ggplot(gr) + geom_arrowrect(facets = sample ~ seqnames, mapping = aes(color = strand, fill = strand))


## ======================================================================
##  stat:identity
## ======================================================================
ggplot(gr) + geom_arrowrect(stat = "identity", mapping = aes(y = value))


## ======================================================================
##  stat:stepping
## ======================================================================
ggplot(gr) + geom_arrowrect(stat = "stepping", mapping = aes(y = value, group = pair))


## ======================================================================
##  group.selfish controls when 
## ======================================================================
ggplot(gr) + geom_arrowrect(gr, stat = "stepping", mapping = aes(y = value, group = pair), group.selfish = FALSE)
}
\author{Tengfei Yin}

\name{Tracked}
\alias{Tracked}
\alias{Tracked-class}
\title{Tracked class}
\description{
  Create a tracked object, designed for tracks function.
}
\usage{
Tracked(mutable = TRUE, fixed = FALSE, labeled = TRUE,
        hasAxis = FALSE, bgColor = "white", height = unit(1, "null"))
}
\arguments{
  \item{mutable}{
    logical value, default \code{TRUE}. To control whether a track is
    updatable by applying \code{+} on it.
  }
  \item{fixed}{
    logical value, default \code{FALSE}. To control whether the scale
    response to a xlim change or not.
  }
  \item{labeled}{
    logical value, default \code{TRUE}. To control whether to label it
    all not.
  }
  \item{hasAxis}{
    logical value, default \code{FALSE}. To control whether to show axis
    for that track or not.
  }
  \item{bgColor}{
    character to control background color of a track.
  }
  \item{height}{
    unit, to control track height.
  }
}
\value{
  a \code{Tracked} object.
}
\author{Tengfei Yin}

\name{stat_bin}
\alias{stat_bin}
\alias{stat_bin,missing-method}
\alias{stat_bin,uneval-method}
\alias{stat_bin,ANY-method}
\alias{stat_bin,Rle-method}
\alias{stat_bin,RleList-method}
\title{Binning method}
\description{
  Binning method especially for \code{Rle} and \code{RleList}, for
  \code{data.frame} it's just calling \code{ggplot2::stat_bin}. 
}
\usage{
\S4method{stat_bin}{ANY}(data, ...)

\S4method{stat_bin}{Rle}(data, ..., binwidth, nbin = 30,
         xlab, ylab, main, geom = c("bar", "heatmap"),
         type = c("viewSums","viewMins",
                                  "viewMaxs", "viewMeans"))
\S4method{stat_bin}{RleList}(data, ..., binwidth, nbin = 30,
          xlab, ylab, main,
          indName = "sample",
          geom = c("bar", "heatmap"),
          type = c("viewSums","viewMins",
          "viewMaxs", "viewMeans"))
}
\arguments{
\item{data}{
    Typically a \code{data.frame} or \code{Rle} or \code{RleList} object.
}
\item{...}{
    arguments passed to aesthetics mapping.
}
\item{binwidth}{
    width of the bins.
}
\item{nbin}{
    number of bins.
}
\item{xlab}{
x label.
}
\item{ylab}{
y label.
}
\item{main}{
title.
}
\item{indName}{
when faceted by a \code{RleList}, name used for labeling faceted
factor. Default is 'sample'.
}
\item{geom}{
geometric types.
}
\item{type}{
statistical summary method used within bins, shown as bar height or
heatmap colors.
}
}
\value{
a ggplot object.
}
\examples{
library(IRanges)
lambda <- c(rep(0.001, 4500), seq(0.001, 10, length = 500), 
            seq(10, 0.001, length = 500))
xVector <- rpois(1e4, lambda)
xRle <- Rle(xVector)
xRleList <- RleList(xRle, 2L * xRle)

ggplot() + stat_bin(xRle)
ggplot(xRle) + stat_bin()
ggplot(xRle) + stat_bin(nbin = 100)
ggplot(xRle) + stat_bin(binwidth = 200)

p1 <- ggplot(xRle) + stat_bin(type = "viewMeans")
p2 <- ggplot(xRle) + stat_bin(type = "viewSums")
## y scale are different.
tracks(viewMeans = p1, viewSums = p2)

ggplot(xRle) + stat_bin(geom = "heatmap")
ggplot(xRle) + stat_bin(nbin = 100, geom = "heatmap")
ggplot(xRle) + stat_bin(binwidth = 200, geom = "heatmap")

## for RleList
ggplot(xRleList) + stat_bin()
ggplot(xRleList) + stat_bin(nbin = 100)
ggplot(xRleList) + stat_bin(binwidth = 200)

p1 <- ggplot(xRleList) + stat_bin(type = "viewMeans")
p2 <- ggplot(xRleList) + stat_bin(type = "viewSums")
## y scale are different.
tracks(viewMeans = p1, viewSums = p2)

ggplot(xRleList) + stat_bin(geom = "heatmap")
ggplot(xRleList) + stat_bin(nbin = 100, geom = "heatmap")
ggplot(xRleList) + stat_bin(binwidth = 200, geom = "heatmap")
}
\author{Tengfei Yin}

\name{geom_bar}
\alias{geom_bar}
\alias{geom_bar,ANY-method}
\alias{geom_bar,GRanges-method}
\alias{geom_bar,missing-method}
\alias{geom_bar,chevron-method}
\title{Segment geoms for GRanges object}
\description{
  Show interval data as vertical bar, width equals to interval width and
  use 'score' or specified 'y' as y scale. 
}
\usage{
\S4method{geom_bar}{ANY}(data, ...)
\S4method{geom_bar}{GRanges}(data,..., xlab, ylab, main)
}
\arguments{
  \item{data}{
    Typically a \code{GRanges} or \code{data.frame} object.
  }
  \item{...}{
    Extra parameters such as aes() or \code{color, size} passed.
  }
  \item{xlab}{
    Label for x
  }
  \item{ylab}{
    Label for y
  }
  \item{main}{
    Title for plot.
  }
}
\details{
  Useful for showing bed like files, when imported as GRanges, have a
  extra 'score' column, use it as default y, you could also specify y by
  using aes(y = ). 
}
\value{
  A 'Layer'.
}
\examples{
## load
library(GenomicRanges)

## simul
set.seed(123)
gr.b <- GRanges(seqnames = "chr1", IRanges(start = seq(1, 100, by = 10),
                  width = sample(4:9, size = 10, replace = TRUE)),
                score = rnorm(10, 10, 3), value = runif(10, 1, 100))
gr.b2 <- GRanges(seqnames = "chr2", IRanges(start = seq(1, 100, by = 10),
                  width = sample(4:9, size = 10, replace = TRUE)),
                score = rnorm(10, 10, 3), value = runif(10, 1, 100))
gr.b <- c(gr.b, gr.b2)
## default use score as y

## bar
ggplot(gr.b) + geom_bar(mapping = aes(fill = value))
## or
ggplot() + geom_bar(gr.b, mapping = aes(fill = value))
ggplot(gr.b) + geom_bar(mapping = aes(y = value))
## equal to
autoplot(gr.b, geom = "bar")
}
